/*--------------------------------------------------------------------------
 HMG - Harbour Win32 GUI library source code
 Adaptation of FiveWin class TsBrowse
---------------------------------------------------------------------------*/
MEMVAR _HMG_SYSDATA

#include "hmg.ch"
#include "hbclass.ch"
#include "tsbrowse.ch"

//#define HB_C52_STRICT

#xtranslate _DbSkipper => DbSkipper

EXTERN OrdKeyNo, OrdKeyCount, OrdKeyGoto

#define SB_VERT      1
#define PBM_SETPOS   1026

#define VK_CONTEXT         93
#define WM_SETFONT         48    // 0x0030
#define WM_LBUTTONDBLCLK  515    // 0x203
#define WM_INVALID WM_USER + 50  // JP 1.31

#define CW_USEDEFAULT   32768
#define SC_CLOSE   61536

// let's save DGroup space
// ahorremos espacio para DGroup
#define nsCol        asTSB[1]
#define nsWidth      asTSB[2]
#define nsOldPixPos  asTSB[3]
#define bCxKeyNo     asTSB[4]
#define bCmKeyNo     asTSB[5]
#define nGap         asTSB[6]
#define nNewEle      asTSB[7]
#define nKeyPressed  asTSB[8]
#define lNoAppend    asTSB[9]
#define nInstance    asTSB[10]

// api maximal vertical scrollbar position
#define MAX_POS 65535

// mouse wheel Windows message
#define WM_MOUSEWHEEL  522

Static asTSB  := { Nil, Nil, 0, Nil, Nil, 0, 0, Nil, Nil, Nil }
Static nLapsus

*-----------------------------------------------------------------------------*
Function _DefineTBrowse ( ControlName, ParentForm, nCol, nRow, nWidth, nHeight,;
         aHeaders, aWidths, bFields, cField, uVal1, uVal2, value, fontname,fontsize, tooltip, change,;
         bDblclick , aHeadClick , gotfocus , lostfocus , uAlias , Delete, lNogrid,;
         aImages, aJust , HelpId , bold , italic , underline , strikeout , break ,;
         backcolor , fontcolor , lock , cell , nStyle , appendable , readonly ,;
         valid , validmessages , lEdit , aColors , uWhen , nId , aFlds,;
         cMsg, lRePaint, lEnum, lAutoSearch, uUserSearch, lAutoFilter, uUserFilter )
*-----------------------------------------------------------------------------*
Local oBrw ,  cParentForm , mVar , k
Local ControlHandle, FontHandle, aFont, blInit, aBmp := {}
Local bRClick, bLClick, hCursor, update, nLineStyle := 1
Local aTmpColor := Array( 17 )

   Default nRow        := 0, ;
           nCol        := 0, ;
           nHeight     := 120, ;
           nWidth      := 240, ;
           value       := 0, ;
           aImages     := {}, ;
           aHeadClick  := {}, ;
           aFlds       := {},;
           aHeaders    := {},;
           aWidths     := {},;
           aJust       := {},;
           hCursor     := 0, ;
           cMsg        := "", ;
           update      := .f., ;
           lNogrid     := .F.,;
           lock        := .F.,;
           appendable  := .F.,;
           lEdit       := .F.,;
           lEnum       := .F.,;
           lAutoSearch := .F.,;
           lAutoFilter := .F.

   HB_SYMBOL_UNUSED( break )
   HB_SYMBOL_UNUSED( readonly )
   HB_SYMBOL_UNUSED( valid )
   HB_SYMBOL_UNUSED( validmessages )

    if lNogrid
        nLineStyle := 0
    endif

   If aColors != Nil .And. ValType( aColors ) == 'A'
      Aeval(aColors, { | bColor, nEle | aTmpColor[ nEle ] := bColor } )
   EndIf
   IF ValType(fontcolor ) != "U"
      aTmpColor[1] := RGB( fontcolor[1],fontcolor[2],fontcolor[3] )
   endif
   IF ValType( backcolor ) != "U"
      aTmpColor[2] := RGB( backcolor[1],backcolor[2],backcolor[3] )
   endif

    If aImages != Nil .And. ValType( aImages ) == 'A'
        aBmp := Array( Len( aImages ) )
        Aeval( aImages, { | cImage, nEle | aBmp[ nEle ] := LoadImage( cImage ) } )
    EndIf

	if _HMG_SYSDATA [ 264 ] == .T.
		ParentForm := _HMG_SYSDATA [ 223 ]
		if .Not. Empty (_HMG_SYSDATA [ 224 ]) .And. ValType(FontName) == "U"
			FontName := _HMG_SYSDATA [ 224 ]
		EndIf
		if .Not. Empty (_HMG_SYSDATA [ 182 ]) .And. ValType(FontSize) == "U"
			FontSize := _HMG_SYSDATA [ 182 ]
		EndIf
	endif
	if _HMG_SYSDATA [ 183 ] > 0
		IF _HMG_SYSDATA [ 240 ] == .F.
		nCol 	:= nCol + _HMG_SYSDATA [ 334 ] [_HMG_SYSDATA [ 183 ]]
		nRow 	:= nRow + _HMG_SYSDATA [ 333 ] [_HMG_SYSDATA [ 183 ]]
		ParentForm := _HMG_SYSDATA [ 332 ] [_HMG_SYSDATA [ 183 ]]
		ENDIF
	EndIf

	If .Not. _IsWindowDefined (ParentForm)
		MsgHMGError("Window: "+ ParentForm + " is not defined. Program terminated")
	Endif

	If _IsControlDefined (ControlName,ParentForm)
		MsgHMGError ("Control: " + ControlName + " Of " + ParentForm + " Already defined. Program terminated")
	endif

	mVar := '_' + ParentForm + '_' + ControlName

	cParentForm := ParentForm

	ParentForm := GetFormHandle (ParentForm)

        oBrw := TSBrowse():New( ControlName, nRow, nCol, nWidth, nHeight,;
             bFields, aHeaders, aWidths, cParentForm, cField, uVal1, uVal2,;
             change , bDblClick, bRClick, fontname, fontsize, ;
             hCursor, aTmpColor , aBmp, cMsg, update, uAlias, uWhen, value, cell,;
             nStyle, bLClick, aFlds, aHeadClick, nLineStyle, lRePaint,;
             Delete, aJust, lock, appendable, lEdit, lEnum,;
             lAutoSearch, uUserSearch, lAutoFilter, uUserFilter )

        ControlHandle := oBrw:hWnd

        IF ValType(gotfocus) != "U"
            oBrw:bGotFocus := gotfocus
        ENDIF
        IF ValType(lostfocus) != "U"
            oBrw:bLostFocus := lostfocus
        ENDIF
        IF ! lRePaint
            _HMG_SYSDATA [ 41 ] := ControlName
            _HMG_SYSDATA [ 42 ] := ControlHandle
            _HMG_SYSDATA [ 43 ] := .T.
        ENDIF

	if valtype(fontname) != "U" .and. valtype(fontsize) != "U"
		FontHandle := _SetFont (ControlHandle,FontName,FontSize,bold,italic,underline,strikeout)
	Else
		FontHandle := _SetFont (ControlHandle,_HMG_SYSDATA [ 342 ],_HMG_SYSDATA [ 343 ],bold,italic,underline,strikeout)
	endif
	oBrw:hFont := FontHandle

	If _HMG_SYSDATA [ 265 ] == .T.
		aAdd ( _HMG_SYSDATA [ 142 ] , Controlhandle )
	EndIf

	if valtype(tooltip) != "U"
		SetToolTip ( ControlHandle , tooltip , GetFormToolTipHandle (cParentForm) )
	endif

	k := _GetControlFree()

	Public &mVar. := k

	_HMG_SYSDATA [1]  [k] := "TBROWSE" 
	_HMG_SYSDATA [2]  [k] :=  ControlName 
	_HMG_SYSDATA [3]  [k] :=  ControlHandle 
	_HMG_SYSDATA [4]  [k] :=  ParentForm 
	_HMG_SYSDATA [  5 ]  [k] :=  oBrw
	_HMG_SYSDATA [  6 ]  [k] :=  bDblclick
	_HMG_SYSDATA [  7 ]  [k] :=  aHeaders
	_HMG_SYSDATA [  8 ]  [k] :=  Value
	_HMG_SYSDATA [  9 ]  [k] :=  Lock
	_HMG_SYSDATA [ 10 ]  [k] :=  lostfocus 
	_HMG_SYSDATA [ 11 ]  [k] :=  gotfocus 
	_HMG_SYSDATA [ 12 ]  [k] :=  change 
	_HMG_SYSDATA [ 13 ]  [k] :=  .F. 
	_HMG_SYSDATA [ 14 ]  [k] :=  aImages
	_HMG_SYSDATA [ 15 ]  [k] :=  Nil 
	_HMG_SYSDATA [ 16 ]  [k] :=  bDblclick
	_HMG_SYSDATA [ 17 ]  [k] :=  aHeadClick
	_HMG_SYSDATA [ 18 ]  [k] :=  nRow
	_HMG_SYSDATA [ 19 ]  [k] :=  nCol
	_HMG_SYSDATA [ 20 ]  [k] := nWidth
	_HMG_SYSDATA [ 21 ]  [k] := nHeight
	_HMG_SYSDATA [ 22 ]  [k] :=  uAlias
	_HMG_SYSDATA [ 23 ]  [k] :=  iif ( _HMG_SYSDATA [ 183 ] > 0 ,_HMG_SYSDATA [ 333 ] [_HMG_SYSDATA [ 183 ]] , -1 ) 
	_HMG_SYSDATA [ 24 ]  [k] :=  iif ( _HMG_SYSDATA [ 183 ] > 0 ,_HMG_SYSDATA [ 334 ] [_HMG_SYSDATA [ 183 ]] , -1 ) 
	_HMG_SYSDATA [ 25 ]  [k] :=  Delete
	_HMG_SYSDATA [ 26 ]  [k] :=  0 
	_HMG_SYSDATA [ 27 ]  [k] :=  fontname 
	_HMG_SYSDATA [ 28 ]  [k] :=   fontsize 
	_HMG_SYSDATA [ 29 ]  [k] :=  {bold,italic,underline,strikeout} 
	_HMG_SYSDATA [ 30 ]  [k] :=   tooltip  
	_HMG_SYSDATA [ 31 ]  [k] :=   0  
	_HMG_SYSDATA [ 32 ]  [k] :=   {}
	_HMG_SYSDATA [ 33 ]  [k] :=   aHeaders
	_HMG_SYSDATA [ 34 ]  [k] :=  .t.
	_HMG_SYSDATA [ 35 ]  [k] :=  HelpId 
	_HMG_SYSDATA [ 36 ]  [k] :=   FontHandle 
	_HMG_SYSDATA [ 37 ]  [k] :=   0 
	_HMG_SYSDATA [ 38 ]  [k] :=   .T. 
	_HMG_SYSDATA [ 39 ]  [k] := 0
	_HMG_SYSDATA [ 40 ]  [k] := { NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL }

Return oBrw


Function _EndTBrowse ()
Local i, oBrw
    if _HMG_SYSDATA [ 43 ] == .T.
        i := ascan ( _HMG_SYSDATA [ 3 ] , _HMG_SYSDATA [ 42 ] )
        if i > 0
            oBrw := _HMG_SYSDATA [  5 ] [i]
            oBrw:lRePaint := .t.
            oBrw:Display()
            _HMG_SYSDATA [ 41 ] := ""
            _HMG_SYSDATA [ 42 ] := 0
            _HMG_SYSDATA [ 43 ] := .F.
        endif
    endif
Return Nil


Function LoadFields( ControlName, ParentForm, lEdit, aFieldNames)
    Local ix, oBrw
    Default lEdit := .f.
    ix := GetControlIndex (ControlName,ParentForm)
    oBrw := _HMG_SYSDATA [  5 ] [ix]
    oBrw:LoadFields(lEdit, aFieldNames)
Return Nil


Function SetArray( ControlName, ParentForm, Arr, lLbx, lLoadArr)
    Local ix, oBrw
    Default lLbx := .f.,;
            lLoadArr := .f.
    ix := GetControlIndex (ControlName,ParentForm)
    oBrw := _HMG_SYSDATA [  5 ] [ix]
    oBrw:LoadFields(Arr, lLbx, lLoadArr)
Return Nil


* ============================================================================
* TSBrowse.PRG Version 7.0 Jul/15/2004
* ============================================================================

/* This Classs is a recapitulation of the code adapted by Luis Krause Mantilla,
   of FiveWin classes: TCBrowse, TWBrowse, TCColumn and Clipper Wrapers in C
   that support the visual Windows interface.

   Originally TCBrowse was a Sub-Class of TWBrowse, with this work, we have the
   new class "TSBrowse" that is no more a Sub-Class. Now, TSBrowse is an
   independent control that inherits directly from TControl class.

   My work has mainly consisted on putting pieces together with some extra from
   my own crop.

   Credits:
      Luis Krause Mantilla
      Selim Anter
      Stan Littlefield
      Marshall Thomas
      Eric Yang
      John Stolte
      Harry Van Tassell
      Martin Vogel
      Katy Hayes
      Jose Gimenez
      Hernan Diego Ceccarelli ( some ideas taked from his TWBrowse )
      Antonio Carlos Pantaglione ( Toninho@fwi.com.br )
      TSBtnGet is an adaptation of the Ricardo Ramirez TBtnGet Class
      Gianni Santamarina
      Ralph del Castillo
      Daniel Andrade
      Yamil Bracho
      Victor Manuel Toms (VikThor)
      FiveTechSoft (original classes)

      Many thanks to all of them.

      Regards.

      Manuel Mercado.  July 15th, 2004

    Aqu vamos ! |  Here we go !...  */

//----------------------------------------------------------------------------//


CLASS TSBrowse FROM TControl

   CLASSDATA lRegistered AS LOGICAL

   CLASSDATA aProperties AS ARRAY ;
      INIT { "aColumns", "cVarName", "nTop", "nLeft", "nWidth", "nHeight" }

   CLASSDATA lVScroll, lHScroll

   DATA   aActions                                   // actions to be executed on header's click
   DATA   aColors                                    // the whole colors kit
   DATA   aArray        AS ARRAY                     // browsed array
   DATA   aBitmaps      AS ARRAY INIT {}             // array with bitmaps handles
   DATA   aDefault      AS ARRAY INIT {}             // default values in append mode
   DATA   aClipBoard                                 // used by RButtonDown method
   DATA   aColSizes, aColumns, aHeaders              // the core of TSBrowse
   DATA   aDefValue     AS ARRAY INIT {}             // for array in append mode
   DATA   aIcons        AS ARRAY INIT {}             // array with icons names
   DATA   aImages       AS ARRAY INIT {}             // array with bitmaps names
   DATA   aJustify                                   // compatibility with TWBrowse
   DATA   aLine                                      // bLine as array
   DATA   aMsg          AS ARRAY INIT {}             // multi languaje feature
   DATA   aKeyRemap     AS ARRAY INIT {}             // to prevalidate keys at KeyChar method
   DATA   aPostList                                  // used by ComboWBlock function
   DATA   aSelected                                  // selected items in select mode
   DATA   aSuperHead                                 // array with SuperHeads properties

   DATA   bAddRec                                    // custom function for adding record (with your own message)
   DATA   bBitMapH                                   // bitmap handle
   DATA   bContext                                   // evaluates windows keyboard context key
   DATA   bDelete                                    // evaluated after user deletes a row with lCanDelete mode
   DATA   bFileLock                                  // custom function for locking database (with your own message)
   DATA   bGoToPos                                   // scrollbar block
   DATA   bFilter                                    // a simple filter tool
   DATA   bIconDraw, bIconText                       // icons drawing directives
   DATA   bInit                                      // code block to be evaluated on init
   DATA   bLine, bSkip, bGoTop, bGoBottom, ;
          bLogicLen, bChange                         // navigation codeblocks
   DATA   bKeyNo                                     // logical position on indexed databases
   DATA   bOnDraw                                    // evaluated in DrawSelect()
   DATA   bPostDel                                   // evaluated after record deletion
   DATA   bRecLock                                   // custom function for locking record (with your own message)
   DATA   bSeekChange                                // used by seeking feature
   DATA   bSelected                                  // to be evaluated in select mode
   DATA   bSetOrder                                  // used by seeking feature
   DATA   bTagOrder                                  // to restore index on GotFocus
   DATA   bUserSearch                                // user code block for AutoSearch
   DATA   bUserFilter                                // user code block for AutoFilter
   DATA   bUserKeys                                  // user code block to change the
                                                     // behavior of pressed keys
   DATA   cAlias                                     // data base alias or "ARRAY" or "TEXT_"
   DATA   cDriver                                    // RDD in use
   DATA   cField, uValue1, uValue2                   // SetFilter Params
   DATA   cOrderType                                 // index key type for seeking
   DATA   cPrefix                                    // used by TSBrowse search feature
   DATA   cSeek                                      // used by TSBrowse search feature
   DATA   cFont                                      // new
   DATA   cChildControl                              // new
   DATA   cArray                                     // new


   DATA   hBmpCursor    AS NUMERIC                   // bitmap cursor for first column

   DATA   l3DLook       AS LOGICAL INIT .F. READONLY // internally control state of ::Look3D() in "Phantom" column
   DATA   lHitTop, lHitBottom, lCaptured, lMChange   // browsing flags
   DATA   lAppendMode   AS LOGICAL INIT .F. READONLY // automatic append flag
   DATA   lAutoEdit     AS LOGICAL INIT .F.          // activates continuous edition mode
   DATA   lEditable     AS LOGICAL INIT .F.          // activates edition mode on init
   DATA   lAutoSkip     AS LOGICAL INIT .F.          // compatibility with TCBrowse
   DATA   lIconView     AS LOGICAL INIT .F.          // compatibility with TCBrowse
   DATA   lCellStyle    AS LOGICAL INIT .F.          // compatibility with TCBrowse
   DATA   lCanAppend    AS LOGICAL INIT .F. READONLY // activates auto append mode
   DATA   lCanDelete    AS LOGICAL INIT .F. HIDDEN   // activates delete capability
   DATA   lCanSelect    AS LOGICAL INIT .F.          // activates select mode
   DATA   lCellBrw                                   // celled browse flag
   DATA   lChanged      AS LOGICAL INIT .F.          // field has changed indicator
   DATA   lClipMore     AS LOGICAL INIT .F.          // ClipMore RDD
   DATA   lColDrag      AS LOGICAL                   // dragging feature
   DATA   lConfirm      AS LOGICAL INIT .T. HIDDEN   // ask for user confirm to delete a row
   DATA   lDescend      AS LOGICAL INIT .F.          // descending indexes
   DATA   lDestroy                                   // flag to destroy bitmap created for selected records
   DATA   lDrawHeaders  AS LOGICAL INIT .T.          // condition for headers drawing
   DATA   lDrawFooters                               // condition for footers drawing
   DATA   lDrawSuperHd  AS LOGICAL INIT .F.          // condition for SuperHeader drawing
   DATA   lDrawSpecHd   AS LOGICAL INIT .F.          // condition for SpecHeader drawing
   DATA   lEditingHd    AS LOGICAL INIT .F. READONLY // to avoid lost focus at editing time SpecHd
   DATA   lEditableHd   AS LOGICAL INIT .F.          // activates edition mode of SpecHd on init
   DATA   lEditing      AS LOGICAL INIT .F. READONLY // to avoid lost focus at editing time
   DATA   lFilterMode   AS LOGICAL INIT .F. READONLY // index based filters with NTX RDD
   DATA   lAutoSearch   AS LOGICAL INIT .F. READONLY // condition for SuperHeader as AutoSearch
   DATA   lAutoFilter   AS LOGICAL INIT .F. READONLY // condition for SuperHeader as AutoFilter
   DATA   lHasChgSpec   AS LOGICAL INIT .F.          // SpecHeader data has changed flag for further actions
   DATA   lFirstFocus   HIDDEN                       // controls some actions on init
   DATA   lFirstPaint                                // controls some actions on init
   DATA   lFixCaret     AS LOGICAL                   // TSGet fix caret at editing time
   DATA   lFooting      AS LOGICAL                   // indicates footers can be drawn
   DATA   lNoPaint                                   // to avoid unnecessary painting
   DATA   lGrasp        AS LOGICAL INIT .F. READONLY // used by drag & drop feature
   DATA   lHasChanged   AS LOGICAL INIT .F.          // browsed data has changed flag for further actions
   DATA   lHasFocus     AS LOGICAL INIT .F.          // focused flag
   DATA   lIsArr                                     // browsing an array
   DATA   lIsDbf        AS LOGICAL INIT .F. READONLY // browsed object is a database
   DATA   lIsTxt                                     // browsing a text file
   DATA   lLineDrag     AS LOGICAL                   // TSBrowse dragging feature
   DATA   lLockFreeze   AS LOGICAL                   // avoids cursor positioning on frozen columns
   DATA   lMoveCols     AS LOGICAL                   // Choose between moving or exchanging columns (::moveColumn() or ::exchange())
   DATA   lNoChangeOrd  AS LOGICAL                   // avoids changing active order by double clicking on headers
   DATA   lNoExit       AS LOGICAL INIT .F.          // prevents edit exit with arrow keys
   DATA   lNoGrayBar    AS LOGICAL                   // don't show inactive cursor
   DATA   lNoHScroll    AS LOGICAL                   // disables horizontal scroll bar
   DATA   lNoLiteBar    AS LOGICAL                   // no cursor
   DATA   lNoMoveCols   AS LOGICAL INIT .F.          // avoids resize or move columns by the user
   DATA   lNoResetPos   AS LOGICAL                   // prevents to reset record position on gotfocus
   DATA   lNoVScroll    AS LOGICAL                   // disables vertical scroll bar
   DATA   lLogicDrop    AS LOGICAL                   // compatibility with TCBrowse
   DATA   lPageMode     AS LOGICAL INIT .F.          // paging mode flag
   DATA   lPainted      AS LOGICAL                   // controls some actions on init
   DATA   lRePaint      AS LOGICAL                   // bypass paint if false
   DATA   lPostEdit                                  // to detect postediting
   DATA   lUndo         AS LOGICAL INIT .F.          // used by RButtonDown method
   DATA   lUpdated      AS LOGICAL INIT .F.          // replaces lEditCol return value
   DATA   lUpperSeek    AS LOGICAL INIT .T.          // controls if char expresions are seek in uppercase or not
   DATA   lSeek         AS LOGICAL INIT .T.          // activates TSBrowse seeking feature
   DATA   lEnabled      AS LOGICAL INIT .T.          // enable/disable TSBrowse for displaying data    //JP 1.55
   DATA   lPickerMode   AS LOGICAL INIT .T.          // enable/disable DatePicker Mode in inplace Editing  //MWS Sep 20/07
   DATA   lPhantArrRow  AS LOGICAL INIT .F.          // Flag for initial empty row in array
   DATA   lEnum         AS LOGICAL INIT .F.          // activates SpecHeader as Enumerator
   DATA   nAdjColumn    AS NUMERIC                   // column expands to flush table window right
   DATA   nAligBmp      AS NUMERIC INIT 0            // bitmap layout in selected cell
   DATA   nCell         AS NUMERIC                   // actual column
   DATA   nClrHeadBack, nClrHeadFore                 // headers colors
   DATA   nClrFocuBack, nClrFocuFore                 // focused cell colors
   DATA   nClrEditBack, nClrEditFore                 // editing cell colors
   DATA   nClrFootBack, nClrFootFore                 // footers colors
   DATA   nClrSeleBack, nClrSeleFore                 // selected cell no focused
   DATA   nClrOrdeBack, nClrOrdeFore                 // order control column colors
   DATA   nClrSpcHdBack,nClrSpcHdFore,nClrSpcHdActive // special headers colors
   DATA   nClrLine                                   // grid line color
   DATA   nColOrder     AS NUMERIC                   // compatibility with TCBrowse
   DATA   nColSpecHd    AS NUMERIC                   // activatec editing column of SpecHeader
   DATA   nDragCol      AS NUMERIC INIT 0 HIDDEN     // drag & drop  feature
   DATA   nFireKey                                   // key to start edition, defaults to VK_F2
   DATA   nFirstKey     AS NUMERIC INIT 0 HIDDEN     // First logic pos in filtered databases
   DATA   nFreeze       AS NUMERIC                   // 0,1,2.. freezes left most columns
   DATA   nHeightCell   AS NUMERIC INIT 0            // resizable cell height
   DATA   nHeightHead   AS NUMERIC INIT 0            //      "    header  "
   DATA   nHeightFoot   AS NUMERIC INIT 0            //      "    footer  "
   DATA   nHeightSuper  AS NUMERIC INIT 0            //      "    Superhead  "
   DATA   nHeightSpecHd AS NUMERIC INIT 0            //      "    Special header  "
   DATA   nIconPos                                   // compability with TCBrowse
   DATA   nLastPainted  AS NUMERIC INIT 0 HIDDEN     // last painted nRow
   DATA   nLastPos      AS NUMERIC INIT 0 HIDDEN     // last record position before lost focus
   DATA   nLastnAt      AS NUMERIC INIT 0 HIDDEN     // last ::nAt value before lost focus
   DATA   nLineStyle                                 // user definable grid lines style
   DATA   nMaxFilter                                 // maximum number of records to count
                                                     // on index based filters
   DATA   nMemoHE, nMemoWE, nMemoHV, nMemoWV         // memo sizes on edit and view mode
                                                     // Height in lines and Width in pixels
                                                     // default: 3 lines height and 200 pixels width
   DATA   nOldCell      HIDDEN                       // to control column bGotfocus
   DATA   nOffset       AS NUMERIC INIT 0 HIDDEN     // offset marker for text viewer
   DATA   nPhantom      AS NUMERIC INIT PHCOL_GRID   // controls drawing state for "Phantom" column (-1 or -2) inside ::Look3D()
   DATA   nPrevRec                                   // internally used to go previous record back
   DATA   nRowPos, nAt  AS NUMERIC INIT 0            // grid row positions
   DATA   nColPos       AS NUMERIC INIT 0            // grid column position
   DATA   nColSel       AS NUMERIC INIT 0            // column to mark in selected records
   DATA   nLen          AS NUMERIC INIT 0            // total number of browsed items
   DATA   nLenPos       AS NUMERIC INIT 0            // total number of browsed items in Window  JP 1.31
   DATA   nWheelLines                                // lines to scroll with mouse wheel action
   DATA   nFontSize                                  // New from HMG
   DATA   nUserKey                                   // user key to change the
                                                     // behavior of pressed keys
   DATA   nSortColDir   AS NUMERIC INIT 0            // Sorting table columns ascending or descending
   DATA   oGet                                       // get object
   DATA   oPhant                                     // phantom column
   DATA   oTxtFile      AS OBJECT                    // for text files browsing (TTxtFile() class)

   DATA   uBmpSel                                    // bitmap to show in selected records
   DATA   uLastTag                                   // last TagOrder before losing focus

   METHOD New( nRow, nCol, nWidth, nHeigth, bLine, aHeaders, ;
               aColSizes, cParentWnd, cField, uVal1, uVal2, bChange, ;
               bLDblClick, bRClick, cFont, nFontSize, hCursor, aColors, ;
               cMsg, lUpdate, uAlias, bWhen, ;
               cControl, lCellBrw, nStyle, bLClick, aLine, lRePaint,;
               lDelete, aJust, lLock, lAppend, lEdit, lEnum, ;
               lAutoSearch, uUserSearch, lAutoFilter, uUserFilter ) CONSTRUCTOR

//   METHOD ReDefine( nId, bLine, oDlg, aHeaders, aColSizes, cField, uVal1,;
//                    uVal2, bChange, bLDblClick, bRClick, oFont,;
//                    hCursor, nClrFore, nClrBack, cMsg, lUpdate,;
//                    uAlias, bWhen, lCellBrw, bLClick, aLine ) CONSTRUCTOR

   METHOD AddColumn( oColumn )

   METHOD SetColumn( oColumn, nCol )

   METHOD AddSuperHead( nFromCol, nToCol, uHead, nHeight, aColors, l3dLook, ;
                        uFont, uBitMap, lAdjust, lTransp, lGrid, nHAlign, ;
                        nVAlign )

   METHOD BeginPaint() INLINE If( ::lRepaint, Super:BeginPaint(), 0 )

   METHOD BugUp() INLINE ::UpStable()

   METHOD BiClr( uClrOdd, uClrPair )

   METHOD ChangeFont( oFont, nColumn, nLevel )

   METHOD DbSkipper( nToSkip )

   METHOD Default()

   METHOD Del( nItem )

   METHOD DeleteRow( lAll )

   METHOD DelColumn( nPos )

   METHOD Destroy()

   METHOD Display()

   METHOD DrawFooters() INLINE ::DrawHeaders( .T. )

//   MESSAGE DrawIcon METHOD _DrawIcon( nIcon, lFocused )

   METHOD DrawIcons()

   METHOD DrawLine( nRow )

   METHOD DrawPressed( nCell, lPressed )

   METHOD DrawSelect()

   METHOD DrawSuper()

   METHOD DrawHeaders()

   METHOD Edit( uVar, nCol, nKey, nFlags )

   METHOD EditExit( nCol, nKey, uVar, bValid, lLostFocus )

   METHOD EndPaint()   INLINE If( ::lRePaint, Super:EndPaint(), ;
                                  ( ::lRePaint := .T., 0 ) )

   METHOD Excel2( cXlsFile, lActivate, hProgress, cTitle, lSave )

   METHOD ExcelOle( cXlsFile, lActivate, hProgress, cTitle, oFont, lSave )

   METHOD Exchange( nCol1, nCol2 )  INLINE ::SwitchCols( nCol1, nCol2), ;
                                           ::SetFocus()
   METHOD ExpLocate( cExp )

   METHOD ExpSeek( cExp, lSoft )

   METHOD FreezeCol( lNext )

   METHOD GetColSizes() INLINE ;
          If( ValType( ::aColSizes ) == "A", ::aColSizes, Eval( ::aColSizes ) )

   METHOD GetColumn( nCol )

   METHOD GetDlgCode( nLastKey )

   METHOD GetRealPos( nRelPos )

   METHOD GetTxtRow( nRowPix ) INLINE ;
          RowFromPix( ::hWnd, nRowPix, ::nHeightCell, ;
                      If( ::lDrawHeaders, ::nHeightHead, 0 ), ;
                      If( ::lFooting .and. ::lDrawFooters, ::nHeightFoot, 0 ), ;
                      If( ::lDrawHeaders, ::nHeightSuper, 0 ),;
                      If( ::lDrawSpecHd, ::nHeightSpecHd, 0 ))

   METHOD GoBottom()

   METHOD GoDown()

   METHOD GoEnd()

   METHOD GoHome()

   METHOD GoLeft()

   METHOD GoNext()

   METHOD GoPos( nNewRow, nNewCol )

   METHOD GoRight()

   METHOD GotFocus( hCtlLost )

   METHOD GoTop()

   METHOD GoUp()


   METHOD HandleEvent( nMsg, nWParam, nLParam )

   METHOD HiliteCell( nCol, nColPix )

   METHOD HScroll( nWParam, nLParam )

   METHOD HThumbDrag( nNewCol )

//   METHOD Init( hDlg ) INLINE ::Initiate( hDlg )

//   METHOD Initiate( hDlg ) INLINE Super:Initiate( hDlg ), ::Default()

   METHOD InsColumn( nPos, oColumn )

   METHOD Insert( cItem, nAt )

   METHOD AddItem( cItem )

   METHOD IsColVisible( nCol )

   METHOD IsColVis2( nCol )

   METHOD IsEditable( nCol ) INLINE ::lCellBrw .and. ::aColumns[ nCol ]:lEdit .and. ;
                                    ( ::aColumns[ nCol ]:bWhen == Nil .or. ;
                                      Eval( ::aColumns[ nCol ]:bWhen, Self ) )

   METHOD KeyChar( nKey, nFlags )

   METHOD KeyDown( nKey, nFlags )

   METHOD KeyUp( nKey, nFlags )

   METHOD LButtonDown( nRowPix, nColPix, nKeyFlags )

   METHOD LButtonUp( nRowPix, nColPix, nKeyFlags )

   METHOD lCloseArea() INLINE If( ::lIsDbf .and. ! Empty( ::cAlias ), ( ;
                                 ( ::cAlias )->( DbCloseArea() ), ;
                                 ::cAlias := "", .T. ), .F. )

   METHOD LDblClick( nRowPix, nColPix, nKeyFlags )

   METHOD lEditCol( uVar, nCol, cPicture, bValid, nClrFore, nClrBack )

   METHOD lIgnoreKey( nKey, nFlags )

   METHOD LoadFields( lEditable, aNames )

   METHOD LoadRelated( cAlias, lEditable, aNames )

   METHOD Look3D( lOnOff, nColumn, nLevel, lPhantom )

   METHOD LostFocus( hCtlFocus )

   METHOD MButtonDown( nRow, nCol, nKeyFlags )

   METHOD MouseMove( nRowPix, nColPix, nKeyFlags )

   METHOD MouseWheel( nKeys, nDelta, nXPos, nYPos )

   METHOD MoveColumn( nColPos, nNewPos )

   METHOD nAtCol( nColPix, lActual )

   METHOD nAtIcon( nRow, nCol )

   METHOD nColCount() INLINE Len( ::aColumns )

   METHOD nLogicPos()

   METHOD nRowCount() INLINE ;
          CountRows( ::hWnd, ::nHeightCell, If( ::lDrawHeaders, ::nHeightHead, 0 ), ;
                     If( ::lFooting .and. ::lDrawFooters, ::nHeightFoot, 0 ), ;
                     If( ::lDrawHeaders, ::nHeightSuper, 0 ),;
                     If( ::lDrawSpecHd, ::nHeightSpecHd, 0 ))

   METHOD PageUp( nLines )

   METHOD PageDown( nLines )

   METHOD Paint()

   METHOD PanHome()

   METHOD PanEnd()

   METHOD PanLeft()

   METHOD PanRight()

   METHOD PostEdit( uTemp, nCol, bValid )

   METHOD RButtonDown( nRowPix, nColPix, nKeyFlags )

   MESSAGE RecCount METHOD _RecCount( uSeekValue )

   METHOD Refresh( lPaint ) INLINE If( ::lFirstPaint == Nil .or. ::lFirstPaint, 0, ( ;
                                       ::lNoPaint := .F., Super:Refresh( lPaint ) ) )

   METHOD RelPos( nLogicPos )

   METHOD Report( cTitle, aCols, lPreview, lMultiple, lLandscape )

   METHOD Reset( cField, uVal1, uVal2 )

   METHOD ResetBarPos( lInit )

   METHOD ResetSeek()

   METHOD ReSize( nSizeType, nWidth, nHeight )

   METHOD TSBrwScroll( nDir ) INLINE ;
          TSBrwScroll( ::hWnd, nDir, ::hFont, ;
                       ::nHeightCell, If( ::lDrawHeaders, ::nHeightHead, 0 ), ;
                       If( ValType( ::lDrawFooters ) == "L" .and. ;
                           ::lDrawFooters , ::nHeightFoot, 0 ), ;
                           ::nHeightSuper, ::nHeightSpecHd )

   METHOD Seek( nKey )

   METHOD Set3DText( lOnOff, nColumn, nLevel, nClrLight, nClrShadow )

   METHOD SetAlign( nColumn, nLevel, nAlign )

   METHOD SetAppendMode( lMode )

   METHOD SetArray( aArray )

   METHOD SetBtnGet( nCol, cResName, bAction, nBmpWidth )

   METHOD SetColMsg( cMsg, cEditMsg, nCol )

   METHOD SetColor( xColor1, xColor2, nColumn )

   METHOD SetColSize( nCol, nWidth )

   METHOD SetColumns( aData, aHeaders, aColSizes )

   METHOD SetDeleteMode( lOnOff, lConfirm, bDelete, bPostDel )

   METHOD SetHeaders( nHeight, aCols, aTitles, aAlign , al3DLook, aFonts, ;
                      aActions )

   METHOD SetData( nColumn, bData, aList )

   METHOD SetFilter( cField, uVal1, uVal2 )

   METHOD SetFont( hFont )

   METHOD SetIndexCols( aCols )

   METHOD SetItems( aItems ) INLINE ::SetArray( aItems, .T. )

   METHOD SetDBF( )

   METHOD SetOrder( nColumn, cPrefix )

   METHOD SetSelectMode( lOnOff, bSelected, uBmpSel, nColSel, nAlign )

   METHOD SetSpinner( nColumn, lOnOff, bUp, bDown, bMin, bMax )

   METHOD ShowSizes()

   METHOD Skip( n )

   METHOD SortArray( nCol, lDescend )

   METHOD SwitchCols( nCol1, nCol2 )

   METHOD SyncChild( aoChildBrw, abAction )

   METHOD UpStable()

   METHOD Proper( cText )

   METHOD VertLine( nColPos, nColInit, nGapp )

   METHOD VScroll( nWParam, nLParam )

   METHOD Enabled(lEnab)            // JP 1.55

   METHOD HideColumns( nColumn , lHide) //JP 1.58

   METHOD AutoSpec(nCol)

ENDCLASS


* ============================================================================
* METHOD TSBrowse:New() Version 7.0 Jul/15/2004
* ============================================================================

METHOD New( cControlName, nRow, nCol, nWidth, nHeight, bLine, aHeaders, aColSizes, cParentWnd,;
            cField, uVal1, uVal2, bChange, bLDblClick, bRClick,;
            cFont, nFontSize, ;
            hCursor, aColors, aImages, cMsg, lUpdate, uAlias, ;
            bWhen, nValue, lCellBrw, nStyle, bLClick, aLine, ;
            aActions, nLineStyle, lRePaint, lDelete, aJust, ;
            lLock, lAppend, lEdit, lEnum,;
            lAutoSearch, uUserSearch, lAutoFilter, uUserFilter ) CLASS TSBrowse

   Local aSuperHeaders, ParentHandle, aTmpColor := Array( 20 ), cAlias := "", lSuperHeader:= .f.

   If aColors != Nil
      Aeval(aColors, { | bColor, nEle | aTmpColor[ nEle ] := bColor } )
   EndIf

   Default nRow            := 0, ;
           nCol            := 0, ;
           nHeight         := 100, ;
           nWidth          := 100, ;
           nLineStyle      := LINES_ALL, ;
           aLine           := {},;
           aImages         := {},;
           cFont           := _HMG_SYSDATA [ 224 ],;
           nFontSize       := _HMG_SYSDATA [ 182 ],;
           nValue          := 0,;
           lDelete         := .F.

   if _HMG_SYSDATA [ 264 ] == .T.
      cParentWnd := _HMG_SYSDATA [ 223 ]
   endif

   Default aTmpColor[ 1 ]  := GetSysColor( COLOR_WINDOWTEXT ), ; // nClrText
           aTmpColor[ 2 ]  := GetSysColor( COLOR_WINDOW )    , ; // nClrPane
           aTmpColor[ 3 ]  := GetSysColor( COLOR_BTNTEXT )   , ; // nClrHeadFore
           aTmpColor[ 4 ]  := GetSysColor( COLOR_BTNFACE )   , ; // nClrHeadBack
           aTmpColor[ 5 ]  := GetSysColor( COLOR_CAPTIONTEXT ), ; // nClrForeFocu
           aTmpColor[ 6 ]  := GetSysColor( COLOR_ACTIVECAPTION ) // nClrFocuBack

   Default aTmpColor[ 7 ]  := GetSysColor( COLOR_WINDOWTEXT ), ; // nClrEditFore
           aTmpColor[ 8 ]  := GetSysColor( COLOR_WINDOW )    , ; // nClrEditBack
           aTmpColor[ 9 ]  := GetSysColor( COLOR_BTNTEXT )   , ; // nClrFootFore
           aTmpColor[ 10 ] := GetSysColor( COLOR_BTNFACE )   , ; // nClrFootBack
           aTmpColor[ 11 ] := CLR_HGRAY                      , ; // nClrSeleFore inactive focused
           aTmpColor[ 12 ] := CLR_GRAY                       , ; // nClrSeleBack inactive focused
           aTmpColor[ 13 ] := GetSysColor( COLOR_BTNTEXT )   , ; // nClrOrdeFore
           aTmpColor[ 14 ] := GetSysColor( COLOR_BTNFACE )   , ; // nClrOrdeBack
           aTmpColor[ 15 ] := GetSysColor( COLOR_BTNSHADOW ) , ; // nClrLine
           aTmpColor[ 16 ] := GetSysColor( COLOR_BTNTEXT )   , ; // nClrSupHeadFore
           aTmpColor[ 17 ] := GetSysColor( COLOR_BTNFACE )   , ; // nClrSupHeadBack
           aTmpColor[ 18 ] := GetSysColor( COLOR_BTNTEXT )   , ; // nClrSpecHeadFore
           aTmpColor[ 19 ] := GetSysColor( COLOR_BTNFACE )   , ; // nClrSpecHeadBack
           aTmpColor[ 20 ] := CLR_HRED                           // nClrSpecHeadActive

   Default lUpdate         := .F., ;
           aColSizes       := {}, ;
           lCellBrw        := .F.
   Default nStyle := nOr( WS_CHILD, WS_BORDER, WS_VISIBLE,WS_CLIPCHILDREN, WS_TABSTOP, 4)

   IF lAutoFilter
      aTmpColor[ 19 ] := GetSysColor( COLOR_INACTCAPTEXT )
   elseif lAutoSearch
      aTmpColor[ 19 ] := GetSysColor( COLOR_INFOBK  )
   endif
   If ValType( uAlias ) == "A"
      cAlias := "ARRAY"
      ::cArray:= uAlias
      ::aArray:= {}
   ElseIf ValType( uAlias ) == "C" .and. "." $ uAlias
      cAlias := "TEXT_" + AllTrim( uAlias )
   ElseIf ValType( uAlias ) == "C"
      cAlias := Upper( uAlias )
   EndIf

   ParentHandle := GetFormHandle (cParentWnd)

   ::oWnd := Self

   ::cCaption    = ""
   ::nTop        = nRow
   ::nLeft       = nCol
   ::nBottom     = ::nTop + nHeight - 1
   ::nRight      = ::nLeft + nWidth - 1
   ::oWnd:hWnd   = ParentHandle                  //JP
   ::hWndParent  = ParentHandle                  //JP 1.45
   ::cControlName= cControlName                  //JP
   ::cParentWnd  = cParentWnd                    //JP

   ::lHitTop     = .F.
   ::lHitBottom  = .F.
   ::lFocused    = .F.
   ::lCaptured   = .F.
   ::lMChange    = .T.
   ::nRowPos     = 1
   ::nAt         = 1
   ::nColPos     = 1
   ::nStyle      = nStyle
   ::lRePaint    = lRePaint
   ::lNoHScroll  = .F.
   ::lNoVScroll  = .F.
   ::lNoLiteBar  = .F.
   ::lNoGrayBar  = .F.
   ::lLogicDrop  = .T. //1.54
   ::lColDrag    = .F.
   ::lLineDrag   = .F.
   ::nFreeze     = 0
   ::aColumns    = {}
   ::nColOrder   = 0
   ::cOrderType  = ""
   ::lFooting    = .F.
   ::nCell       = 1
   ::lCellBrw    = lCellBrw
   ::lMoveCols   = .F.
   ::lLockFreeze = .F.
   ::lCanAppend  = lAppend
   ::lCanDelete  = lDelete
   ::lAppendMode = .F.
   ::aImages     = aImages
   ::aBitmaps    = aImages              //{} if aImages = array handles !!
   ::nId         = ::GetNewId()
   ::cAlias      = cAlias
   ::bLine       = bLine
   ::aLine       = aLine
   ::lEditable   = lEdit
   ::lAutoEdit   = .F.
   ::lAutoSkip   = .F.
   ::lIconView   = .F.
   ::lCellStyle  = .F.
   ::nIconPos    = 0
   ::lMChange    = .T.
   ::bChange     = bChange
   ::bLClicked   = bLClick
   ::bLDblClick  = bLDblClick
   ::bRClicked   = bRClick
   ::aHeaders    = aHeaders
   ::aColSizes   = aColSizes
   ::aJustify    = aJust
   ::nLen        = 0
   ::lCaptured   = .F.
   ::lPainted    = .F.
   ::lNoResetPos = .T.
   ::hCursor     = hCursor
   ::cMsg        = cMsg
   ::lUpdate     = lUpdate
   ::bWhen       = bWhen
   ::aActions    = aActions
   ::aColors     = aTmpColor
   ::nLineStyle  = nLineStyle
   ::aSelected   = {}
   ::aSuperHead  = {}
   ::lFixCaret   = .F.
   ::cFont       = cFont
   ::nFontSize   = nFontSize
   ::SetColor( , aTmpColor )
   ::bRecLock  := If( lLock, {|| ( ::cAlias )->( RLock() ) } , ::bRecLock )
   ::lEnum        := lEnum
   ::lAutoSearch  := lAutoSearch
   ::lAutoFilter  := lAutoFilter
   ::lEditableHd  := lAutoSearch .or. lAutoFilter
   ::lDrawSpecHd  := lEnum .or. lAutoSearch .or. lAutoFilter
   ::bUserSearch  := If( lAutoSearch, uUserSearch, ::bUserSearch )
   ::bUserFilter  := If( lAutoFilter, uUserFilter, ::bUserFilter )

   ::bBitMapH := &( "{|oBmp|If(oBmp!=Nil,LoWord(oBmp:hBmpPal),0)}" )

   ::lIsDbf := ! EmptyAlias( ::cAlias ) .and. ::cAlias != "ARRAY" .and. ;
               ! ( "TEXT_" $ ::cAlias )

   ::lIsArr := ( ::cAlias == "ARRAY" )  // JP 1.66

   If ::lIsDbf
        ::nLastPos := ( ::cAlias )->( RecNo() )
        ::bKeyNo    := { || ( cAlias )->( Recno() ) }
        ::bLogicLen := { || ( cAlias )->( LastRec() ) }
        ::bGoToPos  := { |n| ( cAlias )->( DbGoTo( n ) ) }
        IF nValue > 0 .AND. nValue <=  Eval(::bLogicLen)    // JP 1.59
             Eval(::bGoToPos,nValue)
        endif
   endif

   ::aMsg := LoadMsg()

   If Valtype( ::oWnd:hWnd ) != 'U'
      ::Create(::cControlName)

      If ::hFont != Nil
            ::SetFont( ::hFont )
      EndIf
      ::nHeightFoot := 0                                   //JP
      ::nHeightCell := ::nHeightHead :=  SBGetHeight( ::hWnd, If( ::hFont != Nil, ;
                                                   ::hFont, 0 ), 0 )     //JP
      ::nHeightSpecHd := IF(::lEditableHd,SBGetHeight( ::hWnd, If( ::hFont != Nil, ;
                                              ::hFont, 0 )),0)

      ::lVisible = .T.
      ::lValidating := .f.
      IF ::lIsArr                // JP 1.66
         ::lFirstPaint := .t.
      endif

      If aHeaders != Nil .And. ValType( aHeaders ) == 'A'
         Aeval( aHeaders, { | cHeader | lSuperHeader := (At('~',cHeader) != 0) .or. lSuperHeader  } )
         IF lSuperHeader
            aSuperHeaders := IdentSuper ( aHeaders )
         endif
      EndIf

      ::Default()

      IF aSuperHeaders != Nil .And. ValType( aSuperHeaders ) == 'A'
         AEval(aSuperHeaders, {| aHead |  ::AddSuperHead( aHead[2], aHead[3], aHead[1], ;
                       ::nHeightSuper, {aTmpColor[ 16 ],aTmpColor[ 17 ],aTmpColor[ 15 ]},;
                       .f.,If( ::hFont != Nil,::hFont, 0 )) }  )

         ::SetColor( , aTmpColor )
      endif
   Else
      If ::hFont != Nil
         ::SetFont( ::hFont )
      EndIf

      ::lVisible = .F.
   EndIf

   If ::lIsDbf                            // JP 1.66
      ::SetFilter( cField, uVal1, uVal2 )
   endif

   IF nValue > 0 .AND. nValue <= ::nLen
      if Len( ::aColumns ) > 0             //JP 1.59
         ::GoPos( nValue )
      else
         ::nRowPos := ::nAt := nValue
      endif
      Super:Refresh( .t. )
   endif

Return Self

* ============================================================================
* METHOD TSBrowse:AddColumn() Version 7.0 Jul/15/2004
* ============================================================================

METHOD AddColumn( oColumn ) CLASS TSBrowse

   Local nHeight, nAt, cHeading, cRest, nOcurs, ;
         hFont := If( ::hFont != Nil, ::hFont, 0 )

   If ::lDrawHeaders
      cHeading := If( Valtype( oColumn:cHeading ) == "B", ;
                      Eval( oColumn:cHeading ), oColumn:cHeading )

      If Valtype( cHeading ) == "C" .and. ( nAt := At( Chr( 13 ), cHeading ) ) > 0
         nOcurs := 1
         cRest := Substr( cHeading, nAt + 2 )

         While ( nAt := At( Chr( 13 ), cRest ) ) > 0
            nOcurs++
            cRest := Substr( cRest, nAt + 2 )
         EndDo

         nHeight := SBGetHeight( ::hWnd, If( oColumn:hFontHead != Nil, ;
                                             oColumn:hFontHead, hFont ), 0 )
         nHeight *= ( nOcurs )

         If ( nHeight + 1 ) > ::nHeightHead
            ::nHeightHead := nHeight + 1
         EndIf

      EndIf

   EndIf

   If ValType( oColumn:cFooting ) $ "CB"
      ::lDrawFooters := If( ::lDrawFooters == Nil, .T., ::lDrawFooters )
      ::lFooting := ::lDrawFooters

      cHeading := If( Valtype( oColumn:cFooting ) == "B", ;
                      Eval( oColumn:cFooting ), oColumn:cFooting )

      If Valtype( cHeading ) == "C" .and. ( nAt := At( Chr( 13 ), cHeading ) ) > 0
         nOcurs := 1
         cRest := Substr( cHeading, nAt + 2 )

         While ( nAt := At( Chr( 13 ), cRest ) ) > 0
            nOcurs++
            cRest := Substr( cRest, nAt + 2 )
         EndDo

         nHeight := SBGetHeight( ::hWnd, If( oColumn:hFontFoot != Nil, ;
                                             oColumn:hFontFoot, hFont ), 0 )
         nHeight *= ( nOcurs + 1 )

         If ( nHeight + 1 ) > ::nHeightHead
            ::nHeightFoot := nHeight + 1
         EndIf

      Else
         nHeight := SBGetHeight( ::hWnd, If( oColumn:hFontFoot != Nil, ;
                                             oColumn:hFontFoot, hFont ), 0 ) + 1
         If nHeight > ::nHeightFoot .and. ::lFooting
            ::nHeightFoot := nHeight
         EndIf

      EndIf

   EndIf

   AAdd( ::aColumns , oColumn )
   AAdd( ::aColSizes, oColumn:nWidth )

   If ::aPostList != Nil // from ComboWBlock function

      If ATail( ::aColumns ):lComboBox

         If ValType( ::aPostList[ 1 ] ) == "A"
            ATail( ::aColumns ):aItems := AClone( ::aPostList[ 1 ] )
            ATail( ::aColumns ):aData := AClone( ::aPostList[ 2 ] )
            ATail( ::aColumns ):cDataType := ValType( ::aPostList[ 2, 1 ] )
         Else
            ATail( ::aColumns ):aItems := AClone( ::aPostList )
         EndIf

      EndIf


      ::aPostList := Nil

   EndIf


Return Self

* ============================================================================
* METHOD TSBrowse:SetColumn() Version 7.0 Oct/10/2007
* ============================================================================

METHOD SetColumn( oColumn, nCol ) CLASS TSBrowse

   Local nHeight, nAt, cHeading, cRest, nOcurs, ;
         hFont := If( ::hFont != Nil, ::hFont, 0 )

   DEFAULT nCol := Len(::aColumns) + 1

   If Len(::aColumns) < nCol
        ::AddColumn( oColumn )
        Return Self
   EndIf

   If ::lDrawHeaders

      cHeading := If( Valtype( oColumn:cHeading ) == "B", ;
                      Eval( oColumn:cHeading ), oColumn:cHeading )

      If Valtype( cHeading ) == "C" .and. ( nAt := At( Chr( 13 ), cHeading ) ) > 0

         nOcurs := 1
         cRest := Substr( cHeading, nAt + 2 )

         While ( nAt := At( Chr( 13 ), cRest ) ) > 0
            nOcurs++
            cRest := Substr( cRest, nAt + 2 )
         EndDo

         nHeight := SBGetHeight( ::hWnd, If( oColumn:hFontHead != Nil, ;
                                             oColumn:hFontHead, hFont ), 0 )
         nHeight *= ( nOcurs + 1 )

         If ( nHeight + 1 ) > ::nHeightHead
            ::nHeightHead := nHeight + 1
         EndIf

      EndIf

   EndIf

   If ValType( oColumn:cFooting ) $ "CB"

      ::lDrawFooters := If( ::lDrawFooters == Nil, .T., ::lDrawFooters )
      ::lFooting := ::lDrawFooters

      cHeading := If( Valtype( oColumn:cFooting ) == "B", ;
                      Eval( oColumn:cFooting ), oColumn:cFooting )

      If Valtype( cHeading ) == "C" .and. ( nAt := At( Chr( 13 ), cHeading ) ) > 0

         nOcurs := 1
         cRest := Substr( cHeading, nAt + 2 )

         While ( nAt := At( Chr( 13 ), cRest ) ) > 0
            nOcurs++
            cRest := Substr( cRest, nAt + 2 )
         EndDo

         nHeight := SBGetHeight( ::hWnd, If( oColumn:hFontFoot != Nil, ;
                                             oColumn:hFontFoot, hFont ), 0 )
         nHeight *= ( nOcurs + 1 )

         If ( nHeight + 1 ) > ::nHeightHead
            ::nHeightFoot := nHeight + 1
         EndIf

      Else

         nHeight := SBGetHeight( ::hWnd, If( oColumn:hFontFoot != Nil, ;
                                             oColumn:hFontFoot, hFont ), 0 ) + 1
         If nHeight > ::nHeightFoot .and. ::lFooting
            ::nHeightFoot := nHeight
         EndIf

      EndIf

   EndIf

   ::aColumns[nCol] := oColumn
   ::aColSizesAddColumn := oColumn:nWidth

   If ::aPostList != Nil // from ComboWBlock function

      If ::aColumns[nCol]:lComboBox

         If ValType( ::aPostList[ 1 ] ) == "A"
            ::aColumns[nCol]:aItems := AClone( ::aPostList[ 1 ] )
            ::aColumns[nCol]:aData := AClone( ::aPostList[ 2 ] )
            ::aColumns[nCol]:cDataType := ValType( ::aPostList[ 2, 1 ] )
         Else
            ::aColumns[nCol]:aItems := AClone( ::aPostList )
         EndIf

      EndIf

      ::aPostList := Nil

   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:AddSuperHead() Version 7.0 Jul/15/2004
* ============================================================================

Method AddSuperHead( nFromCol, nToCol, uHead, nHeight, aColors, l3dLook, ;
                     uFont, uBitMap, lAdjust, lTransp, ;
                     lNoLines, nHAlign, nVAlign ) CLASS TSBrowse

   Local cHeading, nAt, nLheight, nOcurs, cRest, nLineStyle, ;
         nClrText, nClrBack, nClrLine, ;
         hFont := If( ::hFont != Nil, ::hFont, 0 )

   If Empty( ::aColumns )
      Return Nil
   EndIf

   Default lAdjust  := .F., ;
           l3DLook  := ::aColumns[ nFromCol ]:l3DLookHead, ;
           nHAlign  := DT_CENTER, ;
           nVAlign  := DT_CENTER, ;
           lTransp  := .T., ;
           uHead    := ""

   uFont := If( uFont != Nil, If( ValType( uFont ) == "O", uFont:hFont, ;
                uFont ), uFont )

   hFont := If( ValType( ::aColumns[ nFromCol]:hFontHead ) == "O", ;
                ::aColumns[ nFromCol]:hFontHead, ;
            If( ::aColumns[ nFromCol]:hFontHead != Nil, ;
                ::aColumns[ nFromCol]:hFontHead, hFont ) )

   hFont := If( uFont != Nil, uFont, hFont )

   If ValType( aColors ) == "A"
      ASize( aColors, 3 )
      nClrText := If( aColors[ 1 ] != Nil, aColors[ 1 ], ::aColumns[ nFromCol ]:nClrHeadFore )
      nClrBack := If( aColors[ 2 ] != Nil, aColors[ 2 ], ::aColumns[ nFromCol ]:nClrHeadBack )
      nClrLine := If( aColors[ 3 ] != Nil, aColors[ 3 ], ::nClrLine )
   Else
      nClrText := ::aColumns[ nFromCol ]:nClrHeadFore
      nClrBack := ::aColumns[ nFromCol ]:nClrHeadBack
      nClrLine := ::nClrLine
   EndIf

   If uBitMap != Nil .and. ValType( uBitMap ) != "L"

      Default lNoLines := .T.
      cHeading := If( ValType( uBitMap ) == "B", Eval( uBitMap ), uBitMap )
      cHeading := If( ValType( cHeading ) == "O", Eval( ::bBitMapH, cHeading ), cHeading )
      nLheight := SBmpHeight( cHeading )

      If nHeight != Nil
         If nHeight < nLHeight .and. lAdjust
            nLheight := nHeight
         ElseIf nHeight > nLheight
            nLheight := nHeight
         EndIf
      EndIf

      If ( nLheight + 1 ) > ::nHeightSuper
         ::nHeightSuper := nLHeight + 1
      EndIf

   Else
      uBitMap := Nil
   EndIf

   cHeading := If( Valtype( uHead ) == "B", Eval( uHead ), uHead )

   Do Case

      Case Valtype( cHeading ) == "C" .and. ( nAt := At( Chr( 13 ), cHeading ) ) > 0

         Default lNoLines := .F.

         nOcurs := 1
         cRest := Substr( cHeading, nAt + 2 )

         While ( nAt := At( Chr( 13 ), cRest ) ) > 0
            nOcurs++
            cRest := Substr( cRest, nAt + 2 )
         EndDo

         nLheight := SBGetHeight( ::hWnd, hFont, 0 )
         nLheight *= ( nOcurs + 1 )
         nLheight := If( nHeight == Nil .or. nLheight > nHeight, ;
                         nLheight, nHeight )

         If ( nLheight + 1 ) > ::nHeightSuper
            ::nHeightSuper := nLHeight + 1
         EndIf

      Case Valtype( cHeading ) == "C"
         Default lNoLines := .F.

         nLheight := SBGetHeight( ::hWnd, hFont, 0 )
         nLheight := If( nHeight == Nil .or. nLheight > nHeight, ;
                         nLheight, nHeight )

         If ( nLheight + 1 ) > ::nHeightSuper
            ::nHeightSuper := nLHeight + 1
         EndIf

      Case Valtype( cHeading ) == "N" .or. ValType( cHeading ) == "O"
         Default lNoLines := .T.
         uBitMap := uHead

         If ValType( cHeading ) == "O"
            uHead := Eval( ::bBitMapH, cHeading )
         EndIf

         nLheight := SBmpHeight( uHead )
         uHead    := ""

         If nHeight != Nil
            If nHeight < nLHeight .and. lAdjust
               nLheight := nHeight
            ElseIf nHeight > nLheight
               nLheight := nHeight
            EndIf
         EndIf

         If ( nLheight + 1 ) > ::nHeightSuper
            ::nHeightSuper := nLHeight + 1
         EndIf

   EndCase

   nLineStyle := If( lNoLines, 0, 1 )

   AAdd( ::aSuperHead, { nFromCol, nToCol, uHead, nClrText, nClrBack, ;
                         l3dLook, hFont, uBitMap, lAdjust, nLineStyle, ;
                         nClrLine, nHAlign, nVAlign, lTransp } )

   IF Len(::aSuperHead) > 0
      ::lDrawSuperHd := .t.
   endif

Return Self

* ============================================================================
* METHOD TSBrowse:BiClr() Version 7.0 Jul/15/2004
* ============================================================================

METHOD BiClr( uClrOdd, uClrPair ) CLASS TSBrowse

   uClrOdd  := If( ValType( uClrOdd ) == "B", Eval( uClrOdd, Self ), ;
                   uClrOdd )

   uClrPair := If( ValType( uClrPair ) == "B", Eval( uClrPair, Self ), ;
                   uClrPair )

Return If( ::nAt % 2 > 0, uClrOdd, uClrPair )

* ============================================================================
* METHOD TSBrowse:ChangeFont() Version 7.0 Jul/15/2004
* ============================================================================

METHOD ChangeFont( hFont, nColumn, nLevel ) CLASS TSBrowse

   Local nEle, ;
         lDrawFooters := If( ::lDrawFooters != Nil, ::lDrawFooters, .F. )

   Default nColumn := 0   // all columns

   If nColumn == 0

      If nLevel == Nil

         For nEle := 1 TO Len( ::aColumns )
             ::aColumns[ nEle ]:hFont := hFont
         Next

         If ::lDrawHeaders

            For nEle := 1 TO Len( ::aColumns )
               ::aColumns[ nEle ]:hFontHead := hFont
            Next

         EndIf

         If ::lFooting .and. lDrawFooters

            For nEle := 1 TO Len( ::aColumns )
               ::aColumns[ nEle ]:hFontFoot := hFont
            Next

         EndIf

         If ::lDrawSuperHd

            For nEle := 1 TO Len( ::aSuperHead )
               ::aSuperHead[ nEle, 7 ] := hFont
            Next

         EndIf

      Else

         Do Case

            Case nLevel == 1   // nLevel 1 = Cells

               For nEle := 1 TO Len( ::aColumns )
                  ::aColumns[ nEle ]:hFont := hFont
               Next

            Case nLevel == 2  .and. ::lDrawHeaders  // nLevel 2 = Headers

               For nEle := 1 TO Len( ::aColumns )
                  ::aColumns[ nEle ]:hFontHead := hFont
               Next

            Case nLevel == 3 .and. ::lFooting .and. lDrawFooters    // nLevel 3 = Footers

               For nEle := 1 TO Len( ::aColumns )
                  ::aColumns[ nEle ]:hFontFoot := hFont
               Next

            Case nLevel == 4  .and. ::lDrawSuperHd  // nLevel 4 = SuperHeaders

               For nEle := 1 TO Len( ::aSuperHead )
                  ::aSuperHead[ nEle, 7 ] := hFont
               Next

         EndCase

      EndIf

   Else

      If nLevel == Nil

         ::aColumns[ nColumn ]:hFont := hFont

         If ::lDrawHeaders
            ::aColumns[ nColumn ]:hFontHead := hFont
         EndIf

         If ::lFooting .and. lDrawFooters
            ::aColumns[ nColumn ]:hFontFoot := hFont
         EndIf

         If ::lDrawSuperHd
            ::aSuperHead[ nColumn, 7 ] := hFont
         EndIf

      Else

         Do Case

            Case nLevel == 1                                      // nLevel 1 = Cells

               ::aColumns[ nColumn ]:hFont := hFont

            Case nLevel == 2 .and. ::lDrawHeaders                 // nLevel 2 = Headers

               ::aColumns[ nColumn ]:hFontHead := hFont

            Case nLevel == 3 .and. ::lFooting .and. lDrawFooters  // nLevel 3 = Footers

               ::aColumns[ nColumn ]:hFontFoot := hFont

            Case nLevel == 4 .and. ::lDrawSuperHd                 // nLevel 4 = SuperHeaders

               ::aSuperHead[ nColumn, 7 ] := hFont

         EndCase

      EndIf

   EndIf

   If ::lPainted
      SetHeights( Self )
      ::Refresh( .F. )
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:DbSkipper() Version 7.0 Jul/15/2004
* ============================================================================

METHOD DbSkipper( nToSkip ) CLASS TSBrowse

   Local nSkipped := 0

   Default nToSkip := 0, ;
           ::nAt := 1

   If nToSkip == 0 .or. ( ::cAlias )->( LastRec() ) == 0
      ( ::cAlias )->( dbSkip( 0 ) )
   ElseIf nToSkip > 0 .and. ! ( ::cAlias )->( EoF() ) // going down

      While nSkipped < nToSkip

         ( ::cAlias )->( DbSkip( 1 ) )

         If ::bFilter != Nil

            While ! Eval( ::bFilter ) .and. ! ( ::cAlias )->( EoF() )
              ( ::cAlias )->( DbSkip( 1 ) )
            EndDo

         EndIf

         If ( ::cAlias )->( Eof() )

            If ::lAppendMode
               nSkipped ++
            Else
               ( ::cAlias )->( DbSkip( -1 ) )
            EndIf

            Exit

         EndIf

         nSkipped ++

      Enddo

   ElseIf nToSkip < 0 .and. ! ( ::cAlias )->( BoF() )  // going up

      While nSkipped > nToSkip

         ( ::cAlias )->( DbSkip( -1 ) )

         If ::bFilter != Nil

            While ! Eval( ::bFilter ) .and. ! ( ::cAlias )->( BoF() )
               ( ::cAlias )->( DbSkip( -1 ) )
            EndDo

         EndIf

         If ( ::cAlias )->( Bof() )
            ( ::cAlias )->( DbGoTop() )
            Exit
         EndIf

         nSkipped --

      Enddo

   EndIf

   ::nAt += nSkipped

Return nSkipped

* ============================================================================
* METHOD TSBrowse:Default() Version 7.0 Jul/15/2004
* ============================================================================

METHOD Default() CLASS TSBrowse

    Local nI, nTemp, nElements, aFields, nHeight, nMin, nMax, nPage, ;
          bBlock, aJustify, cBlock, nTxtWid , ;
          nWidth    := 0, ;
          nMaxWidth := ::nWidth() - If( ::oVScroll != Nil, 16, 0 ),;
          cAlias    := Alias(), ;
          hFont     := If( ::hFont != Nil, ::hFont, 0 ), ;
          nAdj      := ::nAdjColumn

   Default ::aHeaders  := {}, ;
           ::aColSizes := {}, ;
           ::nOldCell  := 1, ;
           ::lIsTxt    := ( "TEXT_" $ ::cAlias )
           ::lIsArr    := ( ::cAlias == "ARRAY" )

   If ::bLine == Nil .and. Empty( ::aColumns )

      If Empty( ::cAlias )
         ::cAlias := cAlias
      Else
         cAlias := ::cAlias
      EndIf

      If ::lFirstPaint == Nil

         Return Self

      EndIf

      If ! EmptyAlias( ::cAlias )
         If ! ::lIsArr .and. ! ::lIsTxt
            ::LoadFields()
         EndIf

         If ::lIsArr
            If Len( ::cArray ) == 0 .and. ValType( ::aHeaders ) == "A"
               ::cArray := Array( 1, Len( ::aHeaders ) )
               AEval( ::aHeaders, { | cHead, nEle | ::cArray[1, nEle] := "???" ,HB_SYMBOL_UNUSED( cHead ) } )
               ::lPhantArrRow := .T.
            EndIf
            If Len( ::cArray ) > 0 .and. ValType( ::cArray[ 1 ] ) != "A"
               ::SetItems( ::cArray )
            Else
               ::SetArray( ::cArray,,.t. )
            EndIf
            If ::lPhantArrRow
               ::Deleterow(.t.)
            EndIf
         EndIf
      EndIf

   EndIf

   ::lFirstPaint := .F.

   If ::bLine != Nil .and. Empty(::aColumns)

      Default nElements := Len( Eval(::bLine) )

      aJustify := Afill( Array( nElements ), 0 )

      If Len( ::aHeaders ) < nElements
            ::aHeaders := Array( nElements )
            For nI := 1 to nElements
               if At( '->', FieldName( nI ) ) == 0
                  ::aHeaders[ nI ] := ( cAlias )->( FieldName( nI ) )
               else
                  ::aHeaders[ nI ] := FieldName( nI )
               endif
            Next
      EndIf

      If ValType( ::aColSizes ) == "B"
         ::aColSizes := Eval( ::aColSizes )
      EndIf

      aFields := Eval( ::bLine )

      If Len( ::GetColSizes() ) < nElements
         ::aColSizes := Afill( Array( nElements ), 0 )

         nTxtWid := SBGetHeight( ::hWnd, hFont, 1 )

         For nI := 1 TO nElements
            ::aColSizes[ nI ] := If( ValType( aFields[ nI ] ) != "C", 16, ; // Bitmap handle
                                     ( nTxtWid * ;
                                       Max( Len( ::aHeaders[ nI ] ), ;
                                            Len( aFields[ nI ] ) ) + 1 ) )
         Next

      EndIf

      For nI := 1 To nElements
          If ValType( aFields[ nI ] ) == "N" .or. ;
             ValType( aFields[ nI ] ) == "D"

             aJustify[ nI ] := 2

          ElseIf ValType( aFields[ nI ] ) == "B"
             If ValType( Eval( aFields[ nI ] ) ) == "N" .or. ;
                ValType( Eval( aFields[ nI ] ) ) == "D"

                aJustify[ nI ] := 2
             Else
                aJustify[ nI ] := 0
             EndIf
          Else
             aJustify[ nI ] := 0
          EndIf
      Next

      For nI := 1 To nElements

         bBlock := If( ValType( Eval( ::bLine )[ nI ] ) == "B", ;
                       Eval( ::bLine )[ nI ], MakeBlock( Self, nI ) )

         cBlock := If( ValType( Eval( ::bLine )[ nI ] ) == "B", ::aLine[ nI ], ;
                       "{||" + cValToChar( ::aLine[ nI ] ) + "}" )

         ::AddColumn( TSColumn():New( ::aHeaders[ nI ], bBlock,, { ::nClrText, ::nClrPane, ;
                                      ::nClrHeadFore, ::nClrHeadBack, ::nClrFocuFore, ;
                                      ::nClrFocuBack }, ;
                                      {aJustify[ nI ], 1}, ::aColSizes[ nI ],, ;
                                      ValType( Eval( ::bLine )[ nI ] ) == "B",,,,,,, ;
                                      5,, {.F., .T.},, Self, cBlock ) )

         if At( '->', ::aLine[ nI ] ) == 0
            ATail( ::aColumns ):cData := ::cAlias + "->" + ::aLine[ nI ]
         else
            ATail( ::aColumns ):cData := ::aLine[ nI ]
         endif
      Next

   EndIf

   ::lIsDbf := ( ! EmptyAlias( ::cAlias ) .and. ! ::lIsArr .and. ! ::lIsTxt )

   ASize( ::aColSizes, Len( ::aColumns ) ) // make sure they match sizes

   // rebuild build the aColSize, it's needed to Horiz Scroll etc
   // and expand selected column to flush table window right

   For nI := 1 To Len( ::aColumns )

      nTemp := ::aColSizes[ nI ] := IF(::aColumns[ nI ]:lVisible,::aColumns[ nI ]:nWidth,0) //JP 1.58

      If ! Empty( nAdj ) .and. ( nWidth + nTemp > nMaxWidth )

        If nAdj < nI
          ::aColumns[ nAdj ]:nWidth := ;
          ::aColSizes[ nAdj ] += ( nMaxWidth - nWidth )
        EndIf

        nAdj := 0

      EndIf

      nWidth += nTemp

      If ::lIsDbf .and. ! Empty( ::aColumns[ nI ]:cOrder ) .and. ;
         ! ::aColumns[ nI ]:lEdit

         If ::nColOrder == 0
            ::SetOrder( nI )  // establish cOrder as the active index/tag
         EndIf

         ::aColumns[ nI ]:lIndexCol := .T.

      EndIf

      If ValType( ::aColumns[ nI ]:cFooting ) $ "CB" // informs browse that it has footings to display
         ::lDrawFooters := If( ::lDrawFooters == Nil, .T., ::lDrawFooters )
         ::lFooting := ::lDrawFooters
         nHeight := SBGetHeight( ::hWnd, ;
                                 If( ::aColumns[ nI ]:hFontFoot != Nil, ;
                                     ::aColumns[ nI ]:hFontFoot, hFont ), 0 ) + 1
         If nHeight > ::nHeightFoot .and. ::lFooting
            ::nHeightFoot := nHeight
         EndIf

      EndIf

   Next

   // now catch the odd-ball where last column doesn't fill box
   If ! Empty( nAdj ) .and. nWidth < nMaxWidth .and. nAdj < nI

      ::aColumns[ nAdj ]:nWidth := ;
      ::aColSizes[ nAdj ] += ( nMaxWidth - nWidth )

   EndIf

   If ::bLogicLen != Nil
      ::nLen := If( ::lIsDbf, ( ::cAlias )->( Eval( ::bLogicLen ) ), ;
                    Eval( ::bLogicLen ) )
   EndIf

   If ! ::lNoVScroll
      nMin  := Min( 1, ::nLen )
      nMax  := Min( ::nLen, MAX_POS )
      nPage := Min( ::nRowCount(), ::nLen )
      ::oVScroll := TSBScrlBar():WinNew( nMin, nMax, nPage, .T., Self )
   EndIf
   If ::cDriver == Nil
       ::ResetBarPos( .T. )   // first time call inits RDD specific ORD functions
   EndIf
   If ! ::lNoHScroll

      If ! Empty( ::cAlias ) .and. ::lIsTxt
         nTxtWid := Max( 1, GetTextWidth( 0, "B", hFont ) )
         nMin := 1
         nMax := ::oTxtFile:nMaxLineLength - Int( nMaxWidth / nTxtWid )
         ::oHScroll := TSBScrlBar():WinNew( nMin, nMax,, .F., Self )
      Else
         nMin := Min( 1, Len( ::aColumns ) )
         nMax := Len( ::aColumns )
         ::oHScroll := TSBScrlBar():WinNew( nMin, nMax,, .F., Self )
      EndIf

   EndIf

   For nI := 1 To Len( ::aColumns )

      If ::aColumns[ nI ]:hFont == Nil
         ::aColumns[ nI ]:hFont := ::hFont
      EndIf

      If ::aColumns[ nI ]:hFontHead == Nil
         ::aColumns[ nI ]:hFontHead := ::hFont
      EndIf

      If ::aColumns[ nI ]:hFontFoot == Nil
         ::aColumns[ nI ]:hFontFoot := ::hFont
      EndIf

      If ::lLockFreeze .and. ::nFreeze >= nI
         ::aColumns[ nI ]:lNoHilite := .T.
      EndIf

   Next

   ::nHeightHead  := If( ::lDrawHeaders, ::nHeightHead, 0 )
   ::nHeightFoot  := If( ::lFooting .and. ::lDrawFooters, ::nHeightFoot, 0 )
   ::nHeightSpecHd:= IF( ::nHeightSpecHd ==0 , SBGetHeight( ::hWnd, hFont, 0 ),::nHeightSpecHd)
   ::nHeightSpecHd:= If( ::lDrawSpecHd, ::nHeightSpecHd, 0 )

   If ! ::lNoVScroll
      nPage := Min( ::nRowCount(), ::nLen )
      ::oVScroll:SetPage( nPage, .T. )
   EndIf

   If ! ::lNoHScroll
      nPage := 1
      ::oHScroll:SetPage( nPage, .T. )
   EndIf

   If Len( ::aColumns ) > 0
      ::HiliteCell( Max( ::nCell, ::nFreeze + 1 ) )
   EndIf

   ::nOldCell := ::nCell
   nLapsus    := Seconds()

Return Self

* ============================================================================
* METHOD TSBrowse:Del() Version 7.0 Jul/15/2004
* Only for array browse. (ListBox behavior)
* ============================================================================

METHOD Del( nItem ) CLASS TSBrowse

   Default nItem := ::nAt

   If ! ::lIsArr .OR. ::nLen == 0 // Modificado por Carlos   - Erro Keychar
      Return Self
   EndIf

   ADel( ::aArray, nItem )
   ASize( ::aArray, Len( ::aArray ) - 1 )
   ::nLen := Eval( ::bLogicLen )
   ::Refresh()

Return Self

* ============================================================================
* METHOD TSBrowse:DelColumn() Version 7.0 Jul/15/2004
* ============================================================================

METHOD DelColumn( nPos ) CLASS TSBrowse

   Local oCol, nMin, nMax, nI, ;
         nLen := Len( ::aSuperHead )

   Default nPos := 1

    If Len( ::aColumns ) == 1                     // cannot delete last column
        Return Nil                                 // ... or Nil if last column
   EndIf

    If nPos < 1
        nPos := 1
   ElseIf nPos > Len( ::aColumns )
        nPos := Len( ::aColumns )
   EndIf

   oCol := ::aColumns[ nPos ]
   ASize( ADel( ::aColumns, nPos ), Len( ::aColumns ) - 1 )
   ASize( ADel( ::aColSizes, nPos ), Len( ::aColSizes ) - 1 )

   If ::nColOrder == nPos                        // deleting a ::SetOrder() column
        ::nColOrder := 0                           // to avoid runtime error
        ::cOrderType := ""
   ElseIf ::nColOrder != 0 .and. ::nColOrder > nPos .and. ;
          ::nColOrder <= Len( ::aColumns )
        ::nColOrder --
   EndIf

   If ::nCell > Len( ::aColSizes )
      If ! ::IsColVisible( ::nCell - 1 )
         ::GoLeft()
      Else
         ::nCell--
      EndIf
   EndIf

   ::HiliteCell( ::nCell )                       // make sure we have a hilited cell

   If ::lNoHScroll
      nMin := Min( 1, Len( ::aColumns ) )
      nMax := Len( ::aColumns )
      ::oHScroll := TSBScrlBar():WinNew( nMin, nMax,, .F., Self )
      ::oHScroll:SetRange( 1, Len( ::aColumns ) )
      ::oHScroll:SetPage( 1 , .T. )

      If ::nCell == Len( ::aColSizes )
         ::oHScroll:GoBottom()
      Else
         ::oHScroll:SetPos( ::nCell )
      EndIf

   EndIf

   If ! Empty( ::aSuperHead )

      For nI := 1 To nLen

         If nPos >= ::aSuperHead[ nI, 1 ] .and. nPos <= ::aSuperHead[ nI, 2 ]

            ::aSuperHead[ nI, 2 ] --

            If ::aSuperHead[ nI, 2 ] < ::aSuperHead[ nI, 1 ]
               ASize( ADel( ::aSuperHead, nI ), Len( ::aSuperHead ) - 1 )
            EndIf

         ElseIf nPos < ::aSuperHead[ nI, 1 ]
            ::aSuperHead[ nI, 1 ] --
            ::aSuperHead[ nI, 2 ] --
         EndIf

      Next

   EndIf

   ::SetFocus()
   ::Refresh( .F. )

Return oCol

* ============================================================================
* METHOD TSBrowse:DeleteRow() Version 7.0 Jul/15/2004
* ============================================================================

METHOD DeleteRow( lAll ) CLASS TSBrowse

   Local lRecall, lUpStable, nAt, nRowPos, nRecNo, lRefresh, cAlias, ;
         lEval, uTemp

   DEFAULT lAll := .f.

   If ! ::lCanDelete .OR. ::nLen == 0 // Modificado por Carlos - Erro Keychar
      Return Self
   EndIf

   If ::lIsDbf
      cAlias := ::cAlias
   EndIf

   nRecNo := ( cAlias  )->( RecNo() )

   lRecall := ! Set( _SET_DELETED )
   lUpStable := ! lRecall

   If ! ::lIsTxt   //.and. ::oTree == Nil

      If ::lConfirm .and. !lAll .and.;
         ! MsgYesNo( If( ::lIsDbf, ::aMsg[ 37 ], ::aMsg[ 38 ] ), ::aMsg[ 39 ] )
         Return Self
      EndIf

      If ::lAppendMode
         Return Self
      EndIf

      ::SetFocus()

      If ::lIsDbf
         ( cAlias )->( DbGoTo( nRecNo ) )
      EndIf

      Do Case

         Case ::lIsDbf

              lEval := .T.

              If ::bDelete != Nil
                 lEval := Eval( ::bDelete, nRecNo, Self )
              EndIf


              If ValType( lEval ) == "L" .and. ! lEval
                 Return Self
              EndIf

              If ! ( cAlias )->( RLock() )
                 MsgStop( ::aMsg[ 40 ] , ::aMsg[ 28 ] )
                 Return Self
              EndIf

              If ! ( cAlias )->( Deleted() )
                 ( cAlias )->( DbDelete() )
                 ( cAlias )->( DbUnlock() )
                 ::nLen := ( cAlias )->( Eval( ::bLogicLen ) )

                 If lUpStable
                    ( cAlias )->( DbSkip() )
                    lRefresh :=  ( cAlias )->( EoF() )
                    ( cAlias )->( DbSkip( -1 ) )
                    ::nRowPos -= If( lRefresh .and. ;
                                     ! ( cAlias )->( BoF() ), 1, 0 )
                    ::Refresh( .T. )
                 EndIf

              ElseIf lRecall
                 ( cAlias )->( DbRecall() )
                 ( cAlias )->( DbUnlock() )
              EndIf

              If ::lCanAppend .and. ::nLen == 0
                 ::nRowPos := ::nColPos := 1
                 ::PostMsg( WM_KEYDOWN, VK_DOWN, nMakeLong( 0, 0 ) )
              EndIf

              If ::bPostDel != Nil
                 Eval( ::bPostDel , Self )
              EndIf

              ::lHasChanged := .T.

         Case ::lIsArr

              nAt := ::nAt
              nRowPos := ::nRowPos

              lEval := .T.

              If ::bDelete != Nil
                 lEval := Eval( ::bDelete, nAt, Self )
              EndIf

              If ValType( lEval ) == "L" .and. ! lEval
                 Return Self
              EndIf

              If lAll
                 ::aArray := {}
                 ::aSelected := {}
              Else
                 ADel( ::aArray, nAt )
                 ASize( ::aArray, Len( ::aArray ) - 1 )
                 IF ::lCanSelect .and. Len( ::aSelected ) > 0
                    If ( uTemp := AScan( ::aSelected, nAt ) ) > 0
                       ADel( ::aSelected, uTemp )
                       ASize( ::aSelected, Len( ::aSelected ) - 1 )
                    EndIf
                    AEval( ::aSelected, {|x,nEle| ::aSelected[nEle] := IF(x > nAt, x-1, x)} )
                 ENDIF
              EndIf

              If Len( ::aArray ) == 0
                 ::aArray := { AClone( ::aDefValue ) }
                 ::lPhantArrRow := .T.
                 If ::aArray[ 1, 1 ] == Nil
                    ADel( ::aArray[ 1 ], 1 )
                    ASize( ::aArray[ 1 ], Len( ::aArray[ 1 ] ) - 1 )
                 EndIf
              EndIf

              If ::bPostDel != Nil
                 Eval( ::bPostDel , Self )
              EndIf

              ::lHasChanged := .T.
              ::nLen := Len( ::aArray )
              ::nAt := Min( nAt, ::nLen )
              ::nRowPos := Min( nRowPos, ::nLen )
              ::Refresh( .T. )
              ::DrawSelect()

      Endcase

   Else
      ::SetFocus()
      ::DrawSelect()
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:Destroy() Version 7.0 Jul/15/2004
* ============================================================================

METHOD Destroy() CLASS TSBrowse

   Default ::lDestroy := .F.

   If ::uBmpSel != Nil .and. ::lDestroy
      ::uBmpSel:End()
   EndIf

   If ::oTxtFile != Nil
      ::oTxtFile:Close()
   EndIf
/*
   If ::oVScroll != Nil
      ::oVScroll:Destroy()
   EndIf

   If ::oHScroll != Nil
      ::oHScroll:Destroy()
   EndIf
*/
Return 0

* ============================================================================
* METHOD TSBrowse:Display() Version 7.0 Jul/15/2004
* ============================================================================

METHOD Display() CLASS TSBrowse

   Local nTxtWid, nMin, nMax, nPage, ;
         nMaxWidth := ::nWidth() - If( ::oVScroll != Nil, 16, 0 ),;
         hFont     := If( ::hFont != Nil, ::hFont, 0 )
   If Empty( ::aColumns )
      Return 0
   EndIf

   ::BeginPaint()

   If ::oVScroll != Nil .and. ::nLen > ::nRowCount() .and. ;
      ::oVScroll:nMax != Min( ::nLen, MAX_POS )

         nMin  := Min( 1, ::nLen )
         nMax  := Min( ::nLen, MAX_POS )
         nPage := Min( ::nRowCount(), ::nLen )
         ::oVScroll := TSBScrlBar():WinNew( nMin, nMax, nPage, .T., Self )
         ::ResetBarPos()

   EndIf

   If ::oHScroll != Nil

      If ::lIsTxt
             nTxtWid := Max( 1, GetTextWidth( 0, "B", hFont ) )
            ::oHScroll:SetRange( 1, ::oTxtFile:nMaxLineLength - Int( nMaxWidth / nTxtWid ) )
        Else
            ::oHScroll:SetRange( 1, Len( ::aColumns ) )
      EndIf

   EndIf

   ::Paint()
   ::EndPaint()

Return 0

* ============================================================================
* METHOD TSBrowse:DrawHeaders() Version 7.0 Jul/15/2004
* ============================================================================

METHOD DrawHeaders( lFooters ) CLASS TSBrowse

   Local nI, nJ, nBegin, nStartCol, oColumn, l3DLook, nClrFore, lAdjBmp, ;
         nAlign, nClrBack, hFont, cFooting, cHeading, hBitMap, nLastCol, ;
         lMultiLine, nVertText, nClrTo, lOpaque, lBrush, nClrToS, nClrBackS,;
         nMaxWidth    := ::nWidth() , ;
         aColSizes    := AClone( ::aColSizes ), ;   // use local copies for speed
         nHeightHead  := ::nHeightHead, ;
         nHeightFoot  := ::nHeightFoot, ;
         nHeightSpecHd:= ::nHeightSpecHd

   Local nHeightSuper := ::nHeightSuper, ;
         nVAlign      := 1, ;
         l3DText, nClr3dL, nClr3dS

   Local hWnd         := ::hWnd, ;
         hDC          := ::hDc, ;
         nClrText     := ::nClrText, ;
         nClrPane     := ::nClrPane, ;
         nClrHeadFore := ::nClrHeadFore, ;
         nClrHeadBack := ::nClrHeadBack, ;
         nClrFootFore := ::nClrFootFore, ;
         nClrFootBack := ::nClrFootBack, ;
         nClrOrdeFore := ::nClrOrdeFore, ;
         nClrOrdeBack := ::nClrOrdeBack, ;
         nClrSpcHdFore:= IF(::lEnum,::nClrHeadFore,::nClrText),;
         nClrSpcHdBack:= IF(::lEnum,::nClrHeadBack,::nClrPane),;
         nClrSpcHdAct := ::nClrSpcHdActive,;
         nClrLine     := ::nClrLine

   Default lFooters := .F.

   If Empty( ::aColumns )
      Return Self
   EndIf

   If ::aColSizes == Nil .or. Len( ::aColSizes ) < Len( ::aColumns )
      ::aColSizes := {}
      For nI := 1 To Len( ::aColumns )
         AAdd( ::aColSizes, IF(::aColumns[ nI ]:lVisible,::aColumns[ nI ]:nWidth,0) )   //JP 1.58
      Next
   EndIf

   nClrBack := If( ::nPhantom == -1, ATail( ::aColumns ):nClrHeadBack, nClrPane )
   nClrBack := If( ValType( nClrBack ) == "B", Eval( nClrBack ), nClrBack )
   nClrFore := If( ::nPhantom == -1, ATail( ::aColumns ):nClrFootBack, nClrPane )
   nClrFore := If( ValType( nClrFore ) == "B", Eval( nClrFore ), nClrFore )
   l3DLook  := If( ::nPhantom == -1, ATail( ::aColumns ):l3DLookHead, .F. )

   If ::oPhant == Nil
      // "Phantom" column; :nPhantom hidden IVar
      ::oPhant := TSColumn():New(   "", ; // cHeading
                              {|| "" }, ; // bdata
                                   nil, ; // cPicture
                 { nClrText, nClrPane,, ;
              nClrBack,,,,,,nClrFore }, ; // aColors
                                   nil, ; // aAlign
                            ::nPhantom, ; // nWidth
                                   nil, ; // lBitMap
                                   nil, ; // lEdit
                                   nil, ; // bValid
                                   .T., ; // lNoLite
                                   nil, ; // cOrder
                                   nil, ; // cFooting
                                   nil, ; // bPrevEdit
                                   nil, ; // bPostEdit
                                   nil, ; // nEditMove
                                   nil, ; // lFixLite
                  { l3DLook, l3DLook }, ;
                                   nil, ;
                                  Self  )
   Else
      ::oPhant:nClrFore := nClrText
      ::oPhant:nClrBack := nClrBack
      ::oPhant:nWidth   := ::nPhantom
      ::oPhant:l3DLookHead := l3DLook
   EndIf

   nLastCol := Len( ::aColumns ) + 1
   AAdd( aColSizes, ::nPhantom )

   nJ := nStartCol := 0

   nBegin := Min( If( ::nColPos <= ::nFreeze, ( ::nColPos := ::nFreeze + 1, ;
                      ::nColPos - ::nFreeze ), ::nColPos - ::nFreeze ), nLastCol )

   If Empty( ::aColumns )
      Return Self
   EndIf

   If ! Empty( ::aSuperHead ) .and. ! lFooters
      ::DrawSuper()
   EndIf

   For nI := nBegin To nLastCol

      If nStartCol > nMaxWidth
         Exit
      EndIf

      nJ := If( nI < ::nColPos, nJ + 1, nI )

      oColumn := If( nJ > Len( ::aColumns ), ::oPhant, ::aColumns[ nJ ] )

      If ::lDrawHeaders .and. ! lFooters

         nVertText := 0

         If LoWord( oColumn:nHAlign ) == DT_VERT
            cHeading := "Arial"
//            nAlign   := -11
//            nVAlign  := 0

            hFont :=InitFont ( cHeading, -11, .f., .f., .f. , .f. , 900 )

            nVAlign   := 2
//            nAlign    :=  1
            nVertText := 1

         Else
            hFont    := If( oColumn:hFontHead == Nil, ::hFont, oColumn:hFontHead )
            hFont    := If( ValType( hFont ) == "B", Eval( hFont, 0, nJ, Self ), ;
                           hFont )
         EndIf

         l3DLook := oColumn:l3DLookHead
         nAlign  := If( ValType( oColumn:nHAlign ) == "B", ;
                       Eval( oColumn:nHAlign ), oColumn:nHAlign )

         If ( nClrFore := If( ::nColOrder == nI, oColumn:nClrOrdeFore, ;
                                oColumn:nClrHeadFore ) ) == Nil
            nClrFore := If( ::nColOrder == nI, nClrOrdeFore, ;
                            nClrHeadFore )
         EndIf

         nClrFore := If( ValType( nClrFore ) == "B", Eval( nClrFore ), ;
                         nClrFore )

         If ( nClrBack := If( ::nColOrder == nI, oColumn:nClrOrdeBack, ;
                              oColumn:nClrHeadBack ) ) == Nil
            nClrBack := If( ::nColOrder == nI, nClrOrdeBack, ;
                            nClrHeadBack )
         EndIf

         nClrBack := If( ValType( nClrBack ) == "B", Eval( nClrBack ), ;
                         nClrBack )
         lBrush := ( Valtype( nClrBack ) == "O" )

         If ValType( nClrBack ) == "A"
            nClrTo   := nClrBack[ 2 ]
            nClrBack := nClrBack[ 1 ]
            nClrTo := If( ValType( nClrTo ) == "B", Eval( nClrTo ), nClrTo )
            nClrBack := If( ValType( nClrBack ) == "B", ;
                            Eval( nClrBack ), nClrBack )
         Else
            nClrTo := nClrBack
         EndIf

         cHeading   := If( Valtype( oColumn:cHeading ) == "B", ;
                           Eval( oColumn:cHeading ), oColumn:cHeading )

         hBitMap    := If( ValType( oColumn:uBmpHead ) == "B", ;
                           Eval( oColumn:uBmpHead ), oColumn:uBmpHead )
         hBitMap    := If( ValType( hBitMap ) == "O", ;
                           Eval( ::bBitMapH, hBitMap ), hBitMap )
         lAdjBmp    := oColumn:lAdjBmpHead
         lOpaque    := .t. //oColumn:nOpaque == 2         //lAnd( oColumn:nOpaque, 2 )
         lMultiLine := Valtype( cHeading ) == "C" .and. At( Chr( 13 ), cHeading ) > 0
         Default hBitMap := 0

         If lMultiLine
            nVAlign := DT_TOP
         EndIf

         If oColumn:l3DTextHead != Nil
            l3DText := oColumn:l3DTextHead
            nClr3dL := oColumn:nClr3DLHead
            nClr3dS := oColumn:nClr3DSHead
            nClr3dL := If( ValType( nClr3dL ) == "B", ;
                           Eval( nClr3dL, 0, nJ ), nClr3dL )
            nClr3dS := If( ValType( nClr3dS ) == "B", ;
                           Eval( nClr3dS, 0, nJ ), nClr3dS )
         Else
            l3DText := nClr3dL := nClr3dS := Nil
         EndIf

         TSDrawCell(      hWnd, ;  // 1
                           hDC, ;  // 2
                             0, ;  // 3
                     nStartCol, ;  // 4
               aColSizes[ nJ ], ;  // 5
                      cHeading, ;  // 6
                        nAlign, ;  // 7
                      nClrFore, ;  // 8
                      nClrBack, ;  // 9
                         hFont, ;  // 10
                       hBitMap, ;  // 11
                   nHeightHead, ;  // 12
                       l3DLook, ;  // 13
                             1, ;  // 14 nLineStyle
                      nClrLine, ;  // 15
                             1, ;  // 16 1=Header 2=Footer 3=Super 4=Special
                   nHeightHead, ;  // 17
                   nHeightFoot, ;  // 18
                  nHeightSuper, ;  // 19
                 nHeightSpecHd, ;  // 20
                       lAdjBmp, ;  // 21
                    lMulTiLine, ;  // 22
                       nVAlign, ;  // 23
                     nVertText, ;  // 24
                        nClrTo, ;  // 25
                       lOpaque, ;  // 26
                    If( lBrush, ;
          nClrBack:hBrush, 0 ), ;  // 27
                       l3DText, ;  // 28  3D text
                       nClr3dL, ;  // 29  3D text light color
                       nClr3dS )   // 30  3D text shadow color

         nVAlign := 1

         If LoWord( oColumn:nHAlign ) == DT_VERT
            DeleteObject( hFont )
         EndIf

      EndIf

      IF ::lDrawSpecHd


         hFont    := If( oColumn:hFontSpcHd == Nil, ::hFont, oColumn:hFontSpcHd )
         hFont    := If( ValType( hFont ) == "B", Eval( hFont, 0, nJ, Self ), ;
                           hFont )

         l3DLook := oColumn:l3DLookHead
         nAlign  := If( ValType( oColumn:nSAlign ) == "B", ;
                       Eval( oColumn:nSAlign ), oColumn:nSAlign )

         If ( nClrFore := If( ::nColOrder == nI, oColumn:nClrOrdeFore, ;
                                oColumn:nClrSpcHdFore ) ) == Nil
            nClrFore := If( ::nColOrder == nI, nClrOrdeFore, ;
                            nClrSpcHdFore )
         EndIf

         nClrFore := If( ValType( nClrFore ) == "B", Eval( nClrFore ), ;
                         nClrFore )

         nClrBackS := ::nClrSpcHdBack
         nClrBackS := If( ValType( nClrBackS ) == "B", Eval( nClrBackS ), nClrBackS )
         lBrush := Valtype( nClrBackS ) == "O"

         If ValType( nClrBackS ) == "A"
            nClrToS   := nClrBackS[ 2 ]
            nClrBackS := nClrBackS[ 1 ]
            nClrToS := If( ValType( nClrToS ) == "B", Eval( nClrToS ), nClrToS )
            nClrBackS := If( ValType( nClrBackS ) == "B", ;
                            Eval( nClrBackS ), nClrBackS )
         Else
            nClrToS := nClrBackS
         EndIf
         if ::lEnum
            cHeading   := AllTrim(Str(nI))
         else
            cHeading   := If( Valtype( oColumn:cSpcHeading ) == "B", ;
                           Eval( oColumn:cSpcHeading ), oColumn:cSpcHeading )
            If Empty( oColumn:cPicture  )
               cHeading := If( Valtype( cHeading ) != "C", cValToChar( cHeading ), cHeading )
            Else
               cHeading := If( cHeading == NIL, "", Transform( cHeading, oColumn:cPicture ) )
            EndIf

            nAlign := oColumn:nAlign
            nClrBackS := If(Empty(cHeading),nClrBackS,CLR_HRED)
            nClrBackS := IF(oColumn:lEditSpec,nClrBackS,nClrBack)
            nClrToS   := IF(oColumn:lEditSpec,nClrToS  ,nClrTo)
         ENDIF

         hBitMap    := If( ValType( oColumn:uBmpSpcHd ) == "B", ;
                           Eval( oColumn:uBmpSpcHd ), oColumn:uBmpSpcHd )
         hBitMap    := If( ValType( hBitMap ) == "O", ;
                           Eval( ::bBitMapH, hBitMap ), hBitMap )
         lAdjBmp    := oColumn:lAdjBmpSpcHd
         lOpaque    := .t.
         Default hBitMap := 0

         If oColumn:l3DTextHead != Nil
            l3DText := oColumn:l3DTextSpcHd
            nClr3dL := oColumn:nClr3DLSpcHd
            nClr3dS := oColumn:nClr3DSSpcHd
            nClr3dL := If( ValType( nClr3dL ) == "B", ;
                           Eval( nClr3dL, 0, nJ ), nClr3dL )
            nClr3dS := If( ValType( nClr3dS ) == "B", ;
                           Eval( nClr3dS, 0, nJ ), nClr3dS )
         Else
            l3DText := nClr3dL := nClr3dS := Nil
         EndIf

         TSDrawCell(     hWnd, ;  // 1
                          hDC, ;  // 2
                            0, ;  // 3
                    nStartCol, ;  // 4
                aColSizes[nJ], ;  // 5
                     cHeading, ;  // 6
                       nAlign, ;  // 7
                     nClrFore, ;  // 8
                    nClrBackS, ;  // 9
                        hFont, ;  // 10
                      hBitMap, ;  // 11
                  nHeightFoot, ;  // 12
                      l3DLook, ;  // 13
                            1, ;  // 14  nLineStyle
                     nClrLine, ;  // 15
                            4, ;  // 16  1=Header 2=Footer 3=Super  4=Special
                  nHeightHead, ;  // 17
                  nHeightFoot, ;  // 18
                 nHeightSuper, ;  // 19
                nHeightSpecHd, ;  // 20
                      lAdjBmp, ;  // 21
                          .f., ;  // 22
                      nVAlign, ;  // 23
                            0, ;  // 24 nVertText
                      nClrToS, ;  // 25
                      lOpaque, ;  // 26
                   If( lBrush, ;
        nClrBackS:hBrush, 0 ), ;  // 27
                      l3DText, ;  // 28  3D text
                      nClr3dL, ;  // 29  3D text light color
                      nClr3dS )   // 30  3D text shadow color


      endif

      If ::lFooting .and. ::lDrawFooters

         hFont   := If( oColumn:hFontFoot == Nil, ::hFont, oColumn:hFontFoot )
         hFont   := If( ValType( hFont ) == "B", Eval( hFont, 0, nJ, Self ), ;
                        hFont )
         l3DLook := oColumn:l3DLookFoot

         ::oPhant:l3DLookFoot := l3DLook

         nAlign := If( ValType( oColumn:nFAlign ) == "B", ;
                       Eval( oColumn:nFAlign ), oColumn:nFAlign )

         nClrFore := If( oColumn:nClrFootFore != Nil, oColumn:nClrFootFore , ;
                         nClrFootFore )
         nClrFore := If( ValType( nClrFore ) == "B", Eval( nClrFore ), nClrFore )

         nClrBack := If( oColumn:nClrFootBack != Nil, oColumn:nClrFootBack, ;
                         nClrFootBack )

         nClrBack := If( ValType( nClrBack ) == "B", Eval( nClrBack ), nClrBack )

         lBrush := Valtype( nClrBack ) == "O"

         If ValType( nClrBack ) == "A"
            nClrTo   := nClrBack[ 2 ]
            nClrBack := nClrBack[ 1 ]
            nClrTo   := If( ValType( nClrTo ) == "B", Eval( nClrTo ), nClrTo )
            nClrBack := If( ValType( nClrBack ) == "B", ;
                            Eval( nClrBack ), nClrBack )
         Else
            nClrTo := nClrBack
         EndIf

         cFooting := If( Valtype( oColumn:cFooting ) == "B", ;
                           Eval( oColumn:cFooting ), oColumn:cFooting )

         If ValType( cFooting ) == "O"
            oColumn:uBmpFoot := cFooting
            cFooting := ""
         EndIf

         hBitMap    := If( ValType( oColumn:uBmpFoot ) == "B", ;
                           Eval( oColumn:uBmpFoot ), oColumn:uBmpFoot )
         hBitMap    := If( ValType( hBitMap ) == "O", ;
                           Eval( ::bBitMapH, hBitMap ), hBitMap )
         lOpaque    :=  .t. //oColumn:nOpaque == 4        //lAnd( oColumn:nOpaque, 4 )
         lAdjBmp    := oColumn:lAdjBmpFoot
         lMultiLine := Valtype( cFooting ) == "C" .and. At( Chr( 13 ), cFooting ) > 0
         Default hBitMap := 0

         If oColumn:l3DTextFoot != Nil
            l3DText := oColumn:l3DTextFoot
            nClr3dL := oColumn:nClr3DLFoot
            nClr3dS := oColumn:nClr3DSFoot
            nClr3dL := If( ValType( nClr3dL ) == "B", ;
                           Eval( nClr3dL, 0, nJ ), nClr3dL )
            nClr3dS := If( ValType( nClr3dS ) == "B", ;
                           Eval( nClr3dS, 0, nJ ), nClr3dS )
         Else
            l3DText := nClr3dL := nClr3dS := Nil
         EndIf

         TSDrawCell(     hWnd, ;  // 1
                          hDC, ;  // 2
                ::nRowCount(), ;  // 3
                    nStartCol, ;  // 4
                aColSizes[nJ], ;  // 5
                     cFooting, ;  // 6
                       nAlign, ;  // 7
                     nClrFore, ;  // 8
                     nClrBack, ;  // 9
                        hFont, ;  // 10
                      hBitMap, ;  // 11
                  nHeightFoot, ;  // 12
                      l3DLook, ;  // 13
                            1, ;  // 14  nLineStyle
                     nClrLine, ;  // 15
                            2, ;  // 16  1=Header 2=Footer 3=Super
                  nHeightHead, ;  // 17
                  nHeightFoot, ;  // 18
                 nHeightSuper, ;  // 19
                nHeightSpecHd, ;  // 20
                      lAdjBmp, ;  // 21
                   lMultiLine, ;  // 22
                      nVAlign, ;  // 23
                            0, ;  // 24 nVertText
                       nClrTo, ;  // 25
                      lOpaque, ;  // 26
                   If( lBrush, ;
         nClrBack:hBrush, 0 ), ;  // 27
                      l3DText, ;  // 28  3D text
                      nClr3dL, ;  // 29  3D text light color
                      nClr3dS )   // 30  3D text shadow color
      EndIf

      nStartCol += aColSizes[nJ]

   Next

Return Self

* ============================================================================
* METHOD TSBrowse:DrawIcons() Version 7.0 Jul/15/2004
* ============================================================================

METHOD DrawIcons() CLASS TSBrowse

   Local cText,  ;
         nWidth := ::nWidth(), ;
         nHeight := ::nHeight(), ;
         nRow := 10, ;
         nCol := 10, ;
         n := 1

   Local nIcons := Int( nWidth / 50 ) * Int( nHeight / 50 ), ;
         hIcon := ExtractIcon( "user.exe", 0 )

   SetBkColor( ::hDC, CLR_BLUE )
   SetTextColor( ::hDC, CLR_WHITE )

   While n <= nIcons .and. ! ( ::cAlias )->( EoF() )
      If ::bIconDraw != nil .and. ::aIcons != nil
         hIcon := ::aIcons[ Eval( ::bIconDraw, Self ) ]
      EndIf

      DrawIcon( ::hDC, nRow, nCol, hIcon )

      If ::bIconText != nil
         cText := cValToChar( Eval( ::bIconText, Self ) )
      Else
         cText := Str( ( ::cAlias )->( RecNo() ) )
      EndIf

      DrawText( ::hDC, cText, { nRow + 35, nCol - 5, nRow + 48, nCol + 40 }, 1 )

      nCol += 50

      If nCol >= nWidth - 32
         nRow += 50
         nCol := 10
      EndIf

      ( ::cAlias )->( DbSkip() )
      n ++

   Enddo

   ( ::cAlias )->( DbSkip( 1 - n ) )

Return Nil

* ============================================================================
* METHOD TSBrowse:DrawLine() Version 7.0 Jul/15/2004
* ============================================================================

METHOD DrawLine( xRow ) CLASS TSBrowse

   Local nI, nJ, nBegin, nStartCol, oColumn, hBitMap, cPicture, hFont, nClrTo, ;
         nClrFore, nClrBack, uData, nLastCol, lAdjBmp, lMultiLine, nAlign, ;
         lOpaque, lBrush, lCheck, uBmpCell, ;
         nVertText , ;
         nVAlign     := 1, ;
         lSelected   , ;
         nMaxWidth   := ::nWidth(), ;
         nClrText    := ::nClrText, ;
         nClrPane    := ::nClrPane

   Local l3DText, nClr3dL, nClr3dS, l3DLook

   Local aColSizes   := AClone( ::aColSizes ), ;
         hWnd        := ::hWnd, ;
         hDC         := ::hDC, ;
         nLineStyle  := ::nLineStyle, ;
         nClrLine    := ::nClrLine, ;
         nHeightCell := ::nHeightCell, ;
         nHeightHead := If( ::lDrawHeaders, ::nHeightHead, 0 ), ;
         nHeightFoot := If( ::lDrawFooters != Nil .and. ::lDrawFooters, ;
                            ::nHeightFoot, 0 ), ;
         nHeightSuper := If( ::lDrawHeaders, ::nHeightSuper, 0 ), ;
         nHeightSpecHd:= If( ::lDrawSpecHd, ::nHeightSpecHd, 0 )

   Default xRow := If( ::lDrawHeaders, Max( 1, ::nRowPos ), ::nRowPos )

   IF !::lEnabled
      RETURN SELF
   endif

   lSelected := ::lCanSelect .and. ( AScan( ::aSelected, ;
                If( ::lIsDbf, ( ::cAlias )->( RecNo() ), ::nAt ) ) ) > 0
   nClrBack := If( ::nPhantom = -1, ATail( ::aColumns ):nClrBack, nClrPane )
   nClrBack := If( ValType( nClrBack ) == "B", ;
                   Eval( nClrBack, ::nAt, Len( ::aColumns ), Self ), nClrBack )
   l3DLook  := If( ::nPhantom == -1,ATail( ::aColumns ):l3DLook, .F. )

   If ::nLen > 0

      If ::oPhant == Nil
         //  "Phantom" column; :nPhantom hidden IVar
         ::oPhant := TSColumn():New(        "", ; // cHeading
                                 {|| "" }, ; // bdata
                                      Nil, ; // cPicture
                   { nClrText, nClrBack }, ; // aColors
                                      Nil, ; // aAlign
                               ::nPhantom, ; // nWidth
                                      Nil, ; // lBitMap
                                      Nil, ; // lEdit
                                      Nil, ; // bValid
                                      .T., ; // lNoLite
                                      Nil, ; // cOrder
                                      Nil, ; // cFooting
                                      Nil, ; // bPrevEdit
                                      Nil, ; // bPostEdit
                                      Nil, ; // nEditMove
                                      Nil, ; // lFixLite
                              { l3DLook }, ;
                                      Nil, ;
                                     Self )
      Else
         ::oPhant:nClrFore := nClrText
         ::oPhant:nClrBack := nClrBack
         ::oPhant:nWidth   := ::nPhantom
         ::oPhant:l3DLook  := l3DLook
      EndIf

      AAdd( aColSizes, ::nPhantom )

      nJ := nStartCol := 0
      nLastCol := Len( ::aColumns ) + 1
      nBegin := Min( If( ::nColPos <= ::nFreeze, ( ::nColPos := ::nFreeze + 1, ;
                  ::nColPos - ::nFreeze ), ::nColPos - ::nFreeze ), nLastCol )

      For nI := nBegin To nLastCol

         If nStartCol > nMaxWidth
            Exit
         EndIf

         nJ := If( nI < ::nColPos, nJ + 1, nI )

         lSelected := If( nJ == nLastCol, .F., lSelected )
         oColumn  := If( nJ > Len( ::aColumns ), ::oPhant, ::aColumns[ nJ ] )
         cPicture := oColumn:cPicture
         lCheck   := oColumn:lCheckBox
//         lAdjBmp  := oColumn:lAdjBmp
         hFont    := If( oColumn:hFont == Nil, ::hFont, oColumn:hFont )
         hFont    := If( ValType( hFont ) == "B", Eval( hFont, ::nAt, nJ, Self ), ;
                        hFont )
         hFont    := If( hFont == Nil, 0, hFont )

         If ::lIsArr .and. ( ::lAppendMode .or. ::nAt > Len( ::aArray ) )
            uData := ""                     // append mode for arrays
         Else
            uData := Eval( oColumn:bData )
         EndIf

         nVertText := 0

         If lCheck .and. ValType( uData ) == "L"
            nVertText := If( uData, 3, 4 )
         EndIf

         nAlign := oColumn:nAlign

            uBmpCell := oColumn:uBmpCell

            If nJ == ::nColSel .and. ::uBmpSel != Nil .and. lSelected
               uBmpCell := ::uBmpSel
               nAlign   := nMakeLong( LoWord( nAlign ), ::nAligBmp )
            ElseIf oColumn:lBitMap .and. Valtype( uData ) == "N" .and. ! Empty( ::aBitMaps )
               IF uData > 0 .and. uData <= Len(::aBitMaps)
                  uBmpCell := ::aBitMaps[ uData ]
               endif
               nAlign := nMakeLong( oColumn:nAlign, oColumn:nAlign )
               uData    := ""
            ElseIf Empty( cPicture  )
               uData := If( Valtype( uData ) != "C", cValToChar( uData ), uData )
            Else
               uData := If( uData == NIL, "", Transform( uData, cPicture ) )
            EndIf

            nAlign := If( ValType( nAlign ) == "B", Eval( nAlign ), nAlign )

         If ( nClrFore := oColumn:nClrFore ) == Nil .or. ;
            ( lSelected .and. ::uBmpSel == Nil )
            nClrFore := If( ! lSelected, nClrText, ::nClrSeleFore )
         EndIf

         nClrFore := If( Valtype( nClrFore ) == "B", ;
                         Eval( nClrFore, ::nAt, nJ, Self ), nClrFore )

         If ( nClrBack := oColumn:nClrBack ) == Nil .or. ;
            ( lSelected .and. ::uBmpSel == Nil )
            nClrBack := If( ! lSelected, nClrPane, ::nClrSeleBack )
         EndIf

         nClrBack := If( Valtype( nClrBack ) == "B", ;
                         Eval( nClrBack, ::nAt, nJ, Self ), nClrBack )

         lBrush := Valtype( nClrBack ) == "O"

         If ValType( nClrBack ) == "A"
            nClrTo   := nClrBack[ 2 ]
            nClrBack := nClrBack[ 1 ]
            nClrTo := If( ValType( nClrTo ) == "B", Eval( nClrTo ), nClrTo )
            nClrBack := If( ValType( nClrBack ) == "B", ;
                            Eval( nClrBack ), nClrBack )
         Else
            nClrTo := nClrBack
         EndIf

         hBitMap := If( ValType( uBmpCell ) == "B", Eval( uBmpCell ), uBmpCell )
         hBitMap := If( ValType( hBitMap ) == "O", ;
                           Eval( ::bBitMapH, hBitMap ), hBitMap )
         Default hBitMap := 0
         lAdjBmp := oColumn:lAdjBmp
         lOpaque := .t. //oColumn:nOpaque == 1     // lAnd( oColumn:nOpaque, 1 ) //JP
         lMultiLine := Valtype( uData ) == "C" .and. At( Chr( 13 ), uData ) > 0

         If oColumn:l3DTextCell != Nil
            l3DText := oColumn:l3DTextCell
            nClr3dL := oColumn:nClr3DLCell
            nClr3dS := oColumn:nClr3DSCell
            nClr3dL := If( ValType( nClr3dL ) == "B", ;
                           Eval( nClr3dL, ::nAt, nJ ), nClr3dL )
            nClr3dS := If( ValType( nClr3dS ) == "B", ;
                           Eval( nClr3dS, ::nAt, nJ ), nClr3dS )
         Else
            l3DText := nClr3dL := nClr3dS := Nil
         EndIf

         TSDrawCell(                    hWnd, ; // 1
                                         hDC, ; // 2
                                        xRow, ; // 3
                                  nStartCol , ; // 4
                             aColSizes[ nJ ], ; // 5
                                       uData, ; // 6
                                     nAlign , ; // 7
                                    nClrFore, ; // 8
                                    nClrBack, ; // 9
                                       hFont, ; // 10
                                     hBitMap, ; // 11
                                 nHeightCell, ; // 12
                             oColumn:l3DLook, ; // 13
                                  nLineStyle, ; // 14
                                    nClrLine, ; // 15
                                           0, ; // 16 header/footer/super
                                 nHeightHead, ; // 17
                                 nHeightFoot, ; // 18
                                nHeightSuper, ; // 19
                               nHeightSpecHd, ; // 20
                                     lAdjBmp, ; // 21
                                  lMultiline, ; // 22
                                     nVAlign, ; // 23
                                   nVertText, ; // 24
                                      nClrTo, ; // 25
                                     lOpaque, ; // 26
            If( lBrush, nClrBack:hBrush, 0 ), ; // 27
                                    l3DText, ;  // 28  3D text
                                    nClr3dL, ;  // 29  3D text light color
                                    nClr3dS )   // 30  3D text shadow color
         nStartCol += aColSizes[ nJ ]

      Next

   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:DrawPressed() Version 7.0 Jul/15/2004
* Header pressed effect
* ============================================================================

METHOD DrawPressed( nCell, lPressed ) CLASS TSBrowse

   Local nI, nLeft, nTop, nBottom, nRight, hOldPen
   Local hDC       := GetDC( ::hWnd ), ;
         hGrayPen  := CreatePen( PS_SOLID, 1, ::nClrLine ), ;
         hWhitePen := CreatePen( PS_SOLID, 1, GetSysColor( COLOR_BTNHIGHLIGHT ) )

   Default lPressed := .T.

   nKeyPressed := Nil

   If Empty( nCell ) .or. nCell > Len( ::aColumns ) .or. ! ::lDrawHeaders
      Return Self
   ElseIf ! lPressed .and. ! ::aColumns[ nCell ]:l3DLookHead
      ::DrawHeaders()
      Return Self
   EndIf

   nLeft := 0

   If ::nFreeze > 0
      For nI := 1 To Min( ::nFreeze , nCell - 1 )
         nLeft += ::GetColSizes()[ nI ]
      Next
   EndIf

   For nI := ::nColPos To nCell - 1
      nLeft += ::GetColSizes()[ nI ]
   Next

   nTop    := ::nHeightSuper
   nTop    -= If( nTop > 0, 1, 0 )
   nRight  := nLeft + ::aColSizes[ nCell ]
   nBottom := nTop + ::nHeightHead
   hOldPen := SelectObject( hDC, If( lPressed, hGrayPen, hWhitePen ) )

   MoveTo( hDC, nLeft, nBottom )
    LineTo( hDC, nLeft, nTop )
    LineTo( hDC, nRight , nTop )
   SelectObject( hDC, If( lPressed, hWhitePen, hGrayPen ) )
   MoveTo( hDC, nLeft, nBottom - 1 )
    LineTo( hDC, nRight - 1, nBottom - 1 )
    LineTo( hDC, nRight - 1, nTop - 1 )
   SelectObject( hDC, hOldPen )
   DeleteObject( hGrayPen )
   DeleteObject( hWhitePen )
   ReleaseDC( ::hWnd, hDC )

   If lPressed
      nKeyPressed := nCell
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:DrawSelect() Version 7.0 Jul/15/2004
* ============================================================================

METHOD DrawSelect() CLASS TSBrowse

   Local nI, nJ, nBegin, nStartCol, oColumn, nLastCol, hBitMap, hFont, nAlign, ;
         cPicture, nClrFore, nClrBack, lNoLite, uData, l3DLook, lMulti, ;
         nClrTo, lOpaque, lBrush, nCursor, lCheck, uBmpCell, cMsg, ;
         nVertText  := 0, ;
         lAdjBmp    , ;
         lSelected  , ;
         nMaxWidth  := ::nWidth(), ;     // use local copies for speed
         nRowPos    := ::nRowPos, ;
         aColSizes  := AClone( ::aColSizes ), ;
         hWnd       := ::hWnd, ;
         hDC        := ::hDc, ;
         lFocused   := ::lFocused, ;
         nVAlign    := 1

   Local l3DText, nClr3dL, nClr3dS

   Local nClrText     := ::nClrText, ;
         nClrPane     := ::nClrPane, ;
         nClrFocuFore := ::nClrFocuFore, ;
         nClrFocuBack := ::nClrFocuBack, ;
         nClrLine     := ::nClrLine, ;
         nLineStyle   := ::nLineStyle, ;
         nClrSeleBack := ::nClrSeleBack, ;
         nClrSeleFore := ::nClrSeleFore, ;
         nHeightCell  := ::nHeightCell, ;
         nHeightHead := If( ::lDrawHeaders, ::nHeightHead, 0 ), ;
         nHeightFoot := If( ::lDrawFooters != Nil .and. ::lDrawFooters, ;
                            ::nHeightFoot, 0 ), ;
         nHeightSuper := If( ::lDrawHeaders, ::nHeightSuper, 0 ),;
         nHeightSpecHd:= If( ::lDrawSpecHd, ::nHeightSpecHd, 0 )

   If Empty( ::aColumns )
      Return Self
   EndIf
   IF !::lEnabled
      RETURN SELF
   endif

   lSelected := ::lCanSelect .and. ( AScan( ::aSelected, ;
                If( ::lIsDbf, ( ::cAlias )->( RecNo() ), ::nAt ) ) ) > 0

   If ( ::lNoLiteBar .or. ( ::lNoGrayBar .and. ! ::lFocused ) )
      ::DrawLine()   // don't want no hilited cursor bar of any color
   ElseIf ::nLen > 0

      nClrBack := If( ::nPhantom = -1 .and. ! Empty( ::aColumns ), ;
                      ATail( ::aColumns ):nClrBack, nClrPane )
      nClrBack := If( ValType( nClrBack ) == "B", ;
                      Eval( nClrBack, ::nAt, Len( ::aColumns ), Self ), nClrBack )
      l3DLook  := If( ::nPhantom = -1 .and. ! Empty( ::aColumns ), ;
                      ATail( ::aColumns ):l3DLook, .F. )

      If ::oPhant == Nil
         // "Phantom" column; :nPhantom hidden IVar
         ::oPhant := TSColumn():New(        "", ; // cHeading
                                 {|| "" }, ; // bdata
                                      nil, ; // cPicture
                   { nClrText, nClrBack }, ; // aColors
                                      nil, ; // aAlign
                               ::nPhantom, ; // nWidth
                                      nil, ; // lBitMap
                                      nil, ; // lEdit
                                      nil, ; // bValid
                                      .T., ; // lNoLite
                                      nil, ; // cOrder
                                      nil, ; // cFooting
                                      nil, ; // bPrevEdit
                                      nil, ; // bPostEdit
                                      nil, ; // nEditMove
                                      nil, ; // lFixLite
                                {l3DLook}, ;
                                      nil, ;
                                     Self )
      Else
         ::oPhant:nClrFore := nClrText
         ::oPhant:nClrBack := nClrBack
         ::oPhant:nWidth   := ::nPhantom
         ::oPhant:l3DLook  := l3DLook
      EndIf

      AAdd( aColSizes, ::nPhantom )
      nJ := nStartCol := 0
      nLastCol := Len( ::aColumns ) + 1
      nBegin := Min( If( ::nColPos <= ::nFreeze, ( ::nColPos := ::nFreeze + 1, ;
                  ::nColPos - ::nFreeze ),::nColPos - ::nFreeze ), nLastCol )

      For nI := nBegin To nLastCol

         If nStartCol > nMaxWidth
            Exit
         EndIf

         nJ := If( nI < ::nColPos, nJ + 1, nI )
         oColumn := If( nJ > Len( ::aColumns ), ::oPhant, ::aColumns[ nJ ] )

         hFont    := If( oColumn:hFont == Nil, ::hFont, oColumn:hFont )
         hFont    := If( ValType( hFont ) == "B", Eval( hFont, ::nAt, nI, Self ), ;
                        hFont )
         hFont    := If( hFont == Nil, 0, hFont )
//         uBmpCell := oColumn:uBmpCell
         lAdjBmp  := oColumn:lAdjBmp
         nAlign   := oColumn:nAlign
         lOpaque  := .t.

         If nJ == 1 .and. ! Empty( ::hBmpCursor )
            uBmpCell := ::hBmpCursor
            uData    := ""
            nAlign   := nMakeLong( oColumn:nAlign, oColumn:nAlign )
            lNoLite := .T.
            lAdjBmp := .F.
         Else
            If ::lIsArr .and. ( ::lAppendMode .or. ::nAt > Len( ::aArray ) )
               uData := ""                         // append mode for arrays
            Else
               uData := Eval( oColumn:bData )
            EndIf

            cPicture := oColumn:cPicture
            lCheck   := oColumn:lCheckBox
            lNoLite  := oColumn:lNoLite
            nVertText := 0

            If lCheck .and. ValType( uData ) == "L"
               nVertText := If( uData, 3, 4 )
            EndIf

               uBmpCell := oColumn:uBmpCell

               If nJ == ::nColSel .and. ::uBmpSel != Nil .and. lSelected
                  uBmpCell := ::uBmpSel
                  nAlign   := nMakeLong( LoWord( nAlign ), ::nAligBmp )
               ElseIf oColumn:lBitMap .and. Valtype( uData ) == "N" .and. ! Empty( ::aBitMaps )
                  IF uData > 0 .and. uData <= Len(::aBitMaps)
                     uBmpCell := ::aBitMaps[ uData ]
                     nAlign := nMakeLong( LoWord( nAlign ), nAlign )
                     uData    := ""
                  EndIf
               ElseIf Empty( cPicture )
                  uData := If( Valtype( uData ) != "C", cValToChar( uData ), uData )
               Else
                  uData := If( uData == NIL, "", Transform( uData, cPicture ) )
               EndIf
         EndIf

         nAlign := If( ValType( nAlign ) == "B", Eval( nAlign ), nAlign )

         If lNoLite
            If ( nClrFore := oColumn:nClrFore ) == Nil
               nClrFore := nClrText
            EndIf

            nClrFore := If( Valtype( nClrFore ) == "B", ;
                            Eval( nClrFore, ::nAt, nJ, Self ), nClrFore )

            If ( nClrBack := oColumn:nClrBack ) == Nil
               nClrBack := nClrPane
            EndIf

            nClrBack := If( Valtype( nClrBack ) == "B", ;
                            Eval( nClrBack, ::nAt, nJ, Self ), nClrBack )

            nCursor := 0
         Else
            If ( nClrFore := If( lFocused, oColumn:nClrFocuFore, ;
                 oColumn:nClrSeleFore ) ) == Nil
                 nClrFore := If( lFocused, nClrFocuFore, nClrSeleFore )
            EndIf

            nClrFore := If( Valtype( nClrFore ) == "B", ;
                            Eval( nClrFore, ::nAt, nJ, Self ), nClrFore )

            If ( nClrBack := If( lFocused, oColumn:nClrFocuBack, ;
                 oColumn:nClrSeleBack ) ) == Nil
                 nClrBack := If( lFocused, nClrFocuBack, nClrSeleBack )
            EndIf

            nClrBack := If( Valtype( nClrBack ) == "B", ;
                            Eval( nClrBack, ::nAt, nJ, Self ), nClrBack )

            If ValType( nClrBack ) == "N" .and. nClrBack < 0

               nCursor := Abs( nClrBack )

               If ( nClrBack := oColumn:nClrBack ) == Nil
                  nClrBack := nClrPane
               EndIf

               nClrBack := If( Valtype( nClrBack ) == "B", ;
                               Eval( nClrBack, ::nAt, nJ, Self ), nClrBack )
            Else
               nCursor := 0
            EndIf

         EndIf

         lBrush := Valtype( nClrBack ) == "O"

         If ValType( nClrBack ) == "A"
            nClrTo   := nClrBack[ 2 ]
            nClrBack := nClrBack[ 1 ]
            nClrTo := If( ValType( nClrTo ) == "B", Eval( nClrTo ), nClrTo )
            nClrBack := If( ValType( nClrBack ) == "B", ;
                            Eval( nClrBack ), nClrBack )
         Else
            nClrTo := nClrBack
         EndIf

         l3DLook := oColumn:l3DLook

         hBitMap := If( ValType( uBmpCell ) == "B", Eval( uBmpCell ), uBmpCell )
         hBitMap := If( ValType( hBitMap ) == "O", ;
                        Eval( ::bBitMapH, hBitMap ), hBitMap )
         Default hBitMap := 0
         lMulti  := Valtype( uData ) == "C" .and. At( Chr( 13 ), uData ) > 0

         If oColumn:l3DTextCell != Nil
            l3DText := oColumn:l3DTextCell
            nClr3dL := oColumn:nClr3DLCell
            nClr3dS := oColumn:nClr3DSCell
            nClr3dL := If( ValType( nClr3dL ) == "B", ;
                           Eval( nClr3dL, ::nAt, nJ ), nClr3dL )
            nClr3dS := If( ValType( nClr3dS ) == "B", ;
                           Eval( nClr3dS, ::nAt, nJ ), nClr3dS )
         Else
            l3DText := nClr3dL := nClr3dS := Nil
         EndIf

         TSDrawCell(            hWnd, ; //  1
                                 hDC, ; //  2
                             nRowPos, ; //  3
                           nStartCol, ; //  4
                     aColSizes[ nJ ], ; //  5
                               uData, ; //  6
                              nAlign, ; //  7
                            nClrFore, ; //  8
                            nClrBack, ; //  9
                               hFont, ; // 10
                             hBitMap, ; // 11
                         nHeightCell, ; // 12
                             l3DLook, ; // 13
                          nLineStyle, ; // 14
                            nClrLine, ; // 15
                                   0, ; // 16 Header/Footer/Super
                         nHeightHead, ; // 17
                         nHeightFoot, ; // 18
                        nHeightSuper, ; // 19
                       nHeightSpecHd, ; // 20
                             lAdjBmp, ; // 21
                              lMulti, ; // 22 Multiline text
                             nVAlign, ; // 23
                           nVertText, ; // 24
                              nClrTo, ; // 25
                             lOpaque, ; // 26
                          If( lBrush, ;
                nClrBack:hBrush, 0 ), ;  // 27
                            l3DText, ;  // 28  3D text
                            nClr3dL, ;  // 29  3D text light color
                            nClr3dS, ;  // 30  3D text shadow color
                            nCursor )   // 31  Rect cursor

         nStartCol += aColSizes[ nJ ]

      Next

   EndIf

   If ::bOnDraw != Nil
      Eval( ::bOnDraw )
   EndIf

   If ::lCellBrw
      cMsg := If( ! Empty( ::AColumns[ ::nCell ]:cMsg ), ;
                    ::AColumns[ ::nCell ]:cMsg, ::cMsg )
      cMsg := If( ValType( cMsg ) == "B", Eval( cMsg, Self, ::nCell ), cMsg )

      If ! Empty( cMsg )
         ::SetMsg( cMsg )
      EndIf

   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:DrawSuper() Version 7.0 Jul/15/2004
* ============================================================================

METHOD DrawSuper() CLASS TSBrowse

   Local nI, nJ, nBegin, nStartCol, l3DLook, nClrFore, lAdjBmp, nClrTo, lOpaque, ;
         nClrBack, hFont, cHeading, hBitMap, lMulti, ;
         nHAlign, nVAlign, nWidth, nS, nLineStyle, lBrush, ;
         nMaxWidth    := ::nWidth() , ;
         aColSizes    := AClone( ::aColSizes ), ;   // use local copies for speed
         aSuperHead   := AClone( ::aSuperHead ), ;
         nHeightHead  := ::nHeightHead, ;
         nHeightFoot  := ::nHeightFoot, ;
         nHeightSuper := ::nHeightSuper, ;
         nHeightSpecHd:= ::nHeightSpecHd

   Local hWnd         := ::hWnd, ;
         hDC          := ::hDc, ;
         nClrText     , ;
         nClrPane     := ::nClrPane, ;
         nClrLine

   Local l3DText, nClr3dL, nClr3dS

   If Empty( ::aColumns )
       Return Nil
   EndIf

//   nLastCol := Len( ::aColumns )

   nClrText   := aSuperHead[ 1, 4 ]
   nClrBack   := aSuperHead[ 1, 5 ]
   l3DLook    := aSuperHead[ 1, 6 ]
   hFont      := aSuperHead[ 1, 7 ]
   nLineStyle := aSuperHead[ 1, 10 ]
   nClrLine   := aSuperHead[ 1, 11 ]

   nBegin := nI := 1

   While nI <= Len( aSuperHead )

      If aSuperHead[ nI, 1 ] > nBegin
         nJ := aSuperHead[ nI, 1 ] - 1
         ASize( aSuperHead, Len( aSuperHead ) + 1 )
         AIns( aSuperHead, nI )
         aSuperHead[ nI ] := { nBegin, nJ, "", nClrText, nClrBack, ;
                               l3DLook , hFont, .F., .F., nLineStyle, ;
                               nClrLine, 1, 1, .F. }
         nBegin := nJ + 1
      Else
         nBegin := aSuperHead[ nI++, 2 ] + 1
      EndIf

   EndDo

   nI := Len( aSuperHead )
   nClrText   := aSuperHead[ nI, 4 ]
   nClrBack   := aSuperHead[ nI, 5 ]
   l3DLook    := aSuperHead[ nI, 6 ]
   hFont      := aSuperHead[ nI, 7 ]
   nLineStyle := aSuperHead[ nI, 10 ]
   nClrLine   := aSuperHead[ nI, 11 ]

   If ( nI := ATail( aSuperHead )[  2 ] ) < Len( ::aColumns )
        AAdd( aSuperHead, { nI + 1, Len( ::aColumns ), "", nClrText, nClrBack, ;
                            l3DLook, hFont, .F., .F., nLineStyle, ;
                            nClrLine, 1, 1, .F. } )
   EndIf

   nStartCol := nWidth := 0

   nBegin := If( ::nColPos == ::nFreeze + 1, ::nColPos - ::nFreeze, ::nColPos )

   For nS := 1 To Len( aSuperHead )

      If nBegin >= aSuperHead[ nS, 1 ] .and. nBegin <= aSuperHead[ nS, 2 ]
         Do Case
            Case nBegin > aSuperHead[ nS, 1 ] .and. nS == 1
               For nJ := aSuperHead[ nS, 1 ] To nBegin - 1
                  nStartCol -= ::aColSizes[ nJ ]
               Next

               For nJ := aSuperHead[ nS, 1 ]  To aSuperHead[ nS, 2 ]
                  nWidth += aColSizes[ nJ ]
               Next

            Case nBegin > aSuperHead[ nS, 1 ] .and. nS > 1
               For nJ := 1 To ::nFreeze
                  nStartCol += ::aColSizes[ nJ ]
               Next

               For nJ := nBegin  To aSuperHead[ nS, 2 ]
                   nWidth += aColSizes[ nJ ]
               Next

            OtherWise
               If nBegin > 1
                  For nJ := 1 To ::nFreeze
                     nStartCol += ::aColSizes[ nJ ]
                  Next
               EndIf

               For nJ := aSuperHead[ nS, 1 ]  To aSuperHead[ nS, 2 ]
                  nWidth += aColSizes[ nJ ]
               Next

         EndCase

         Exit

      EndIf

   Next

   For nI := nS To Len( aSuperHead ) + 1

      If nStartCol > nMaxWidth
         Exit
      EndIf

      If nI <= Len( aSuperHead )
         nClrFore := If( ValType( aSuperHead[ nI, 4 ] ) == "B", ;
                         Eval( aSuperHead[ nI, 4 ] ), aSuperHead[ nI, 4 ] )
         nClrBack := If( ValType( aSuperHead[ nI, 5 ] ) == "B", ;
                         Eval( aSuperHead[ nI, 5 ] ), aSuperHead[ nI, 5 ] )

         lBrush := Valtype( nClrBack ) == "O"

         If ValType( nClrBack ) == "A"
            nClrTo   := nClrBack[ 2 ]
            nClrBack := nClrBack[ 1 ]
            nClrTo   := If( ValType( nClrTo ) == "B", Eval( nClrTo ), nClrTo )
            nClrBack := If( ValType( nClrBack ) == "B", ;
                            Eval( nClrBack ), nClrBack )
         Else
            nClrTo   := nClrBack
         EndIf

         cHeading := aSuperHead[ nI, 3 ]
         cHeading := If( Valtype( cHeading ) == "B", Eval( cHeading ), cHeading )
         lMulti   := Valtype( cHeading ) == "C" .and. At( Chr( 13 ), cHeading ) > 0

         l3DLook    := aSuperHead[ nI, 6 ]
         hFont      := aSuperHead[ nI, 7 ]
         hBitMap    := aSuperHead[ nI, 8 ]
         hBitMap    := If( ValType( hBitMap ) == "B", Eval( hBitMap ), hBitMap )
         hBitMap    := If( ValType( hBitMap ) == "O", Eval( ::bBitMapH, hBitMap ), hBitMap )
         lAdjBmp    := aSuperHead[ nI, 9 ]
         nLineStyle := aSuperHead[ nI, 10 ]
         nClrLine   := aSuperHead[ nI, 11 ]
         nHAlign    := aSuperHead[ nI, 12 ]
         nVAlign    := aSuperHead[ nI, 13 ]
         lOpaque    := aSuperHead[ nI, 14 ]

         Default hBitMap := 0, ;
                 lOpaque := .T.
         lOpaque := ! lOpaque
      Else
         cHeading := ""
         nWidth   := ::nPhantom
         hBitmap  := 0
         lOpaque  := .F.
         nClrBack := If( ::nPhantom == -2, nClrPane, nClrBack )
         nClrBack := If( ValType( nClrBack ) == "B", ;
                         Eval( nClrBack ), nClrBack )
         nClrTo   := nClrBack
      EndIf

      If nI <= Len( aSuperHead ) .and. ::aColumns[ aSuperHead[ nI, 1 ] ]:l3DTextHead != Nil
         l3DText := ::aColumns[ aSuperHead[ nI, 1 ] ]:l3DTextHead
         nClr3dL := ::aColumns[ aSuperHead[ nI, 1 ] ]:nClr3DLHead
         nClr3dS := ::aColumns[ aSuperHead[ nI, 1 ] ]:nClr3DSHead
         nClr3dL := If( ValType( nClr3dL ) == "B", ;
                        Eval( nClr3dL, 0, nStartCol ), nClr3dL )
         nClr3dS := If( ValType( nClr3dS ) == "B", ;
                        Eval( nClr3dS, 0, nStartCol ), nClr3dS )
      Else
         l3DText := nClr3dL := nClr3dS := Nil
      EndIf

      TSDrawCell(      hWnd, ;  // 1
                        hDC, ;  // 2
                          0, ;  // 3
                  nStartCol, ;  // 4
                     nWidth, ;  // 5
                   cHeading, ;  // 6
                    nHAlign, ;  // 7
                   nClrFore, ;  // 8
                   nClrBack, ;  // 9
                      hFont, ;  // 10
                    hBitMap, ;  // 11
                nHeightHead, ;  // 12
                    l3DLook, ;  // 13
                 nLineStyle, ;  // 14
                   nClrLine, ;  // 15
                          3, ;  // 16 1=Header 2=Footer 3=Super
                nHeightHead, ;  // 17
                nHeightFoot, ;  // 18
               nHeightSuper, ;  // 19
              nHeightSpecHd, ;  // 20
                    lAdjBmp, ;  // 21
                     lMulTi, ;  // 22 Multiline text
                    nVAlign, ;  // 23
                          0, ;  // 24 nVertLine
                     nClrTo, ;  // 25
                    lOpaque, ;  // 26
                 If( lBrush, ;
       nClrBack:hBrush, 0 ), ;  // 27
                    l3DText, ;  // 28  3D text
                    nClr3dL, ;  // 29  3D text light color
                    nClr3dS )   // 30  3D text shadow color

      nStartCol += nWidth

      nWidth := 0

      If nI < Len( aSuperHead )
         For nJ := aSuperHead[ nI + 1, 1 ] To aSuperHead[ nI + 1, 2 ]
            nWidth += aColSizes[ nJ ]
         Next
      EndIf

   Next

Return Nil

* ============================================================================
* METHOD TSBrowse:Edit() Version 7.0 Jul/15/2004
* ============================================================================

METHOD Edit( uVar, nCell, nKey, nKeyFlags, cPicture, bValid, nClrFore, ;
             nClrBack ) CLASS TSBrowse

   Local nRow, nHeight, cType, uValue, nI, aGet, oCol, cMsg, aRct, ;
         bChange, lSpinner, bUp, bDown, bMin, bMax, nStartX, ;
         nWidth, lCombo, lMulti, nCol, lLogicDrop, lPicker, nTxtHeight, hFont, ix
   Local cWnd := ::cControlName

   Default nCell       := ::nCell, ;
           ::lPostEdit := .F., ;
           ::lNoPaint  := .F.

   If ::lPhantArrRow
      Return Nil
   EndIf

   oCol := ::aColumns[ nCell ]

   Default ::nHeightSuper := 0, ;
           nKey           := VK_RETURN, ;
           nKeyFlags      := 0, ;
           uVar           := Eval( oCol:bData ), ;
           cPicture       := oCol:cPicture, ;
           bValid         := oCol:bValid, ;
           nClrFore       := oCol:nClrEditFore, ;
           nClrBack       := oCol:nClrEditBack

   uValue   := uVar
   cType    := If( Empty( oCol:cDataType ), ValType( uValue ), oCol:cDataType )
   If ::lIsArr .and. oCol:cDataType # ValType( uValue )  // GF 15/07/2009
      cType := ValType( uValue )
      oCol:cDataType := cType
   EndIf
   cMsg     := oCol:cMsgEdit
   bChange  := oCol:bChange
   lSpinner := oCol:lSpinner
   bUp      := oCol:bUp
   bDown    := oCol:bDown
   bMin     := oCol:bMin
   bMax     := oCol:bMax
   nStartX  := 0
   lCombo   := lMulti := .F.
   ::oGet   := ::bValid    //JP
   ::bValid := { || ! ::lEditing }
// JP 1.58
   If !oCol:lVisible
      ::lChanged := .F.
      ::lPostEdit := .F.
      ::oWnd:nLastKey := VK_RIGHT
      ::PostEdit( uVar, nCell, bValid )
      Return Nil
   EndIf
//End
   If oCol:bPassWord != Nil
      If ! Eval( oCol:bPassWord, uValue, nCell, ::nAt, Self )
         Return Nil
      EndIf
   EndIf

   lLogicDrop   := ::lLogicDrop
   lPicker      := ::lPickerMode   //MWS Sep 20/07
   ::lEditing   := .T.
   ::lHitBottom := .F.

   If ::nLen > 0
      ::lNoPaint := .T.
   EndIf

   If oCol:bPrevEdit != Nil
      If ::lIsArr .and. ( ::lAppendMode .or. ::nAt > Len( ::aArray ) ) // append mode for arrays
      Else // GF 16-05-2008
         Eval( oCol:bPrevEdit, uValue, Self )
      EndIf
   EndIf

   cMsg := If( ValType( cMsg ) == "B", Eval( cMsg, Self, nCell ), cMsg )

   If cType == "L" .and. oCol:lCheckBox

      If nKey != VK_RETURN

         If Upper( Chr( nKey ) ) $ "YCST1"
            ::lChanged := uVar == .F.
            uVar := .T.
         ElseIf Upper( Chr( nKey ) ) $ "FN0"
            ::lChanged := uVar == .T.
            uVar := .F.
         ElseIf nKey == VK_SPACE
            uVar := ! uVar
            ::lChanged := .T.
         Else
            Return 0
         EndIf

         ::lHasChanged := If( ::lChanged, .T., ::lHasChanged )
         ::oWnd:nLastKey := VK_RETURN
         ::PostEdit( uVar, nCell )
         ::lPostEdit := .F.
         Return 0

      Else

         ::lPostEdit := .T.
         ::lChanged := .F.
         ::oWnd:nLastKey := nKey
         ::PostEdit( uVar, nCell )
         ::lPostEdit := .F.
         Return 0

      EndIf

   EndIf

   If oCol:bExtEdit != Nil  // external edition

      ::lNoPaint := ::lEditing := .F.
      uVar := Eval( oCol:bExtEdit, uValue, Self )
      ::lChanged := ValType( uVar ) != ValType( uValue ) .or. uVar != uValue
      ::lPostEdit := .T.
      ::oWnd:nLastKey := VK_RETURN
      ::PostEdit( uVar, nCell, bValid )
      Return Nil

   EndIf

   hFont := If( oCol:hFontEdit != Nil, oCol:hFontEdit, ;
                If( oCol:hFont != Nil, oCol:hFont, ::hFont ) )

   If oCol:oEdit != Nil
      oCol:oEdit:End()
      oCol:oEdit := Nil
    Endif

   If ::nFreeze > 0
      For nI := 1 To Min( ::nFreeze , nCell - 1 )
         nStartX += ::GetColSizes()[ nI ]
      Next
   EndIf

   For nI := ::nColPos To nCell - 1
      nStartX += ::GetColSizes()[ nI ]
   Next

   nClrFore := If( ValType( nClrFore ) == "B", ;
                   Eval( nClrFore, ::nAt, nCell, Self ), nClrFore )

   nClrBack := If( ValType( nClrBack ) == "B", ;
                   Eval( nClrBack, ::nAt, nCell, Self ), nClrBack )

   IF ::nColSpecHd != 0
      nRow    := ::nHeightHead + ::nHeightSuper + If( oCol:l3DLook, 2, 0 )
      nCol    := nStartX + If( oCol:l3DLook, 2, 0 )
      nWidth  := ::GetColSizes()[ nCell ] - If( oCol:l3DLook, 2, 1 )
      nHeight := ::nHeightSpecHd - If( oCol:l3DLook, 1, -1 )
   else
      nRow    := ::nRowPos - 1
      nRow    := ( nRow * ::nHeightCell ) + ::nHeightHead + ;
                 ::nHeightSuper + ::nHeightSpecHd + If( oCol:l3DLook, 2, 0 )
      nCol    := nStartX + If( oCol:l3DLook, 2, 0 )
      nWidth  := ::GetColSizes()[ nCell ] - If( oCol:l3DLook, 2, 0 )
      nHeight := ::nHeightCell - If( oCol:l3DLook, 1, -1 )
   endif

   If oCol:cResName != Nil  .or. oCol:lBtnGet

      ::cChildControl := GetUniqueName( "BtnBox" )

      oCol:oEdit := TBtnBox():New( nRow, nCol, bSETGET( uValue ), Self, nWidth, nHeight, ;
                       cPicture, nClrFore, nClrBack, hFont, ::cChildControl, cWnd, ;
                       cMsg, bChange, bValid, oCol:cResName,oCol:bAction, ;
                       lSpinner .and. cType $ "ND", bUp, bDown, ;
                       bMin, bMax , oCol:nBmpWidth, nCell )

      oCol:oEdit:lAppend := ::lAppendMode
      oCol:oEdit:Hide()

   ElseIf ( cType == "C" .and. Chr( 13 ) $ uValue ) .or. cType == "M"

      Default uValue := ""

      If ::nMemoHE == Nil

         If ! Empty( uValue )
            nHeight := Max( 5, StrCharCount( uValue, Chr( 10 ) ) )
         Else
            nHeight := 5
         EndIf

      Else
         nHeight := ::nMemoHE
      EndIf

      aRct := ::GetCliRect( ::hWnd )
      If ::nMemoWE == Nil .or. Empty( ::nMemoWE )
         nWidth := Max( nWidth, GetTextWidth( 0, SubStr( uValue, 1, ;
                                              At( Chr( 13 ), uValue ) - 1 ), ;
                                              If( hFont != Nil, hFont, 0 ) ) )
         nWidth := Min( nWidth, Int( aRct[ 3 ] * .8 ) )
      Else
         nWidth := ::nMemoWE
      EndIf

      nTxtHeight := SBGetHeight( ::hWnd, If( hFont != Nil, hFont, 0 ), 0 )

      While ( nRow + ( nTxtHeight * nHeight ) ) > aRct[ 4 ]
         nRow -= nTxtHeight
      EndDo

      nI := nCol + nWidth - aRct[ 3 ]
      nCol -= If( nI <= 0, 0, nI )
      nCol := Max( 10, nCol )
      nHeight *= nTxtHeight
      ::cChildControl := GetUniqueName( "EditBox" )

      oCol:oEdit := TSMulti():New( nRow, nCol, bSETGET( uValue ), Self, nWidth, nHeight, ;
                                   hFont, nClrFore, nClrBack, ::cChildControl, cWnd )
      oCol:oEdit:bGotFocus := { || oCol:oEdit:HideSel(), oCol:oEdit:SetPos( 0 ) }
      lMulti := .T.
      oCol:oEdit:Hide()

   ElseIf ( cType == "L" .and. lLogicDrop ) .or. oCol:lComboBox

      lCombo := .T.

      If oCol:lComboBox

         aGet := oCol:aItems
         If Empty( aGet )
            Return Nil
         EndIf

         If nKey == VK_RETURN
            If oCol:cDataType != Nil .and. oCol:cDataType == "N"
               If oCol:aData <> NIL
                  uValue := Max( 1, AScan( aGet, uValue ) )
               Else
                  uValue := IIf(uValue < 1 .OR. uValue > Len(aGet), 1, uValue)
               EndIf
            Else
               uValue := Max( 1, AScan( aGet, uValue ) )
            EndIf
         Else
            uValue := Max( 1, AScan( aGet, Upper( Chr( nKey ) ) ) )
         EndIf

         If oCol:cDataType != Nil .and. oCol:cDataType == "N"
            nWidth := 0; Aeval(aGet, {|x| nWidth := Max(Len(x), nWidth) } )
            nWidth := Max( GetTextWidth( 0, Replicate('B', nWidth), hFont ), oCol:nWidth )
         EndIf

         nHeight := Max( 10, Min( 10, Len( aGet ) ) ) * ::nHeightCell

      Else

         aGet := { ::aMsg[ 1 ], ::aMsg[ 2 ] }

         If nKey == VK_RETURN
            uValue := IIf( uValue, 1, 2 )
         Else
            uValue := Max( 1, AScan( aGet, Upper( Chr( nKey ) ) ) )
         EndIf

         nHeight := ::nHeightCell * 4 //1.54

      EndIf

      ::cChildControl := GetUniqueName( "ComboBox" )

      oCol:oEdit := TComboBox():New( nRow , nCol , bSETGET( uValue ), aGet, ;
                                    nWidth, nHeight, Self, bChange, nClrFore, ;
                                   nClrBack, hFont, cMsg, ::cChildControl, cWnd )

//      oCol:oEdit:bCloseUp := {|o| o:PostMsg( WM_KEYDOWN, VK_RETURN, 0 )} //1.54
      oCol:oEdit:lAppend := ::lAppendMode

   ElseIf ( cType == "D" ) .and. lPicker     // MWS Sep 20/07

      nRow -= 2
      nHeight := Max( ::nHeightCell, 19 )
      ::cChildControl := GetUniqueName( "DatePicker" )

      oCol:oEdit := TDatePicker():New( nRow, nCol , bSETGET( uValue ), Self, nWidth, nHeight, ;
                                 cPicture,, nClrFore, nClrBack, hFont,::cChildControl,,cWnd , ;
                                 cMsg,,,,, bChange,,, .T. )
      oCol:oEdit:Hide()

   Else

      nRow    += ::nTop - 1
      nCol    += ::nLeft
      ::cChildControl := GetUniqueName( "GetBox" )

      oCol:oEdit := TGetBox():New( nRow, nCol, bSETGET( uValue ), Self, nWidth+2, nHeight+2, ;
                       cPicture,, nClrFore, nClrBack, hFont, ::cChildControl, cWnd, ;
                       cMsg,,,,, bChange, .T.,, lSpinner .and. cType $ "ND", bUp, bDown, ;
                       bMin, bMax )

   EndIf

   If oCol:oEdit != Nil

      oCol:oEdit:bLostFocus := { | nKey | ::EditExit( nCell, nKey, uValue, ;
                               bValid, .F. ) }

      oCol:oEdit:bKeyDown   := { | nKey, nFlags, lExit | ;
                              If( lExit != Nil .and. lExit, ;
                                  ::EditExit( nCell, nKey, uValue, bValid ), ;
                                  Nil ), HB_SYMBOL_UNUSED( nFlags ) }
      DO CASE
         CASE "TBTNBOX" $ Upper( oCol:oEdit:ClassName() )
            oCol:oEdit:bLostFocus := Nil

         CASE "TGETBOX" $ Upper( oCol:oEdit:ClassName() )
            ix := GetControlIndex ( ::cChildControl, ::cParentWnd )
            _HMG_SYSDATA [ 252 ] := .T.
            if ix > 0
               _HMG_SYSDATA [ 10 ] [ix] := { | nKey | ::EditExit( nCell, nKey, uValue, ;
                        bValid, .F. ) }
            endif

      ENDCASE

      oCol:oEdit:SetFocus()

      If nKey != Nil .and. nKey > 31

         If ! lCombo .and. ! lMulti
//            oCol:oEdit:lRightLeftExit := .T.
              ::KeyChar( nKey, nKeyFlags )    //1.53
         EndIf

      Endif

      oCol:oEdit:Show()
      ::SetMsg( oCol:cMsgEdit )

      If oCol:bEditing != Nil
         Eval( oCol:bEditing, uVar, Self )
      EndIf

   EndIf

Return Nil

* ============================================================================
* METHOD TSBrowse:EditExit() Version 7.0 Jul/15/2004
* ============================================================================

METHOD EditExit( nCol, nKey, uVar, bValid, lLostFocus ) CLASS TSBrowse

   Local uValue, cType, oCol, lCombo, cMsg, ix, lSpinner

   Default lLostFocus  := .F., ;
           ::lPostEdit := .F., ;
           nCol        := ::nCell,;
           nKey        := 0

   oCol     := ::aColumns[ nCol ]
   lSpinner := oCol:lSpinner
   lCombo   := ValType( oCol:oEdit ) == "O" .and. "COMBO" $ Upper( oCol:oEdit:ClassName() )

   IF  ValType( oCol:oEdit ) == "O"

      if "TGETBOX" $ Upper( oCol:oEdit:ClassName() )
//         ix := GetControlIndex (::cChildControl, ::cParentWnd)
//         nKey := _HMG_aControlMiscData1 [ix,3]
         SetFocus( ::hWnd )    // JP 1.59
      endif

      if "TBTNBOX" $ Upper( oCol:oEdit:ClassName() ) //.and. lSpinner
         if oCol:oEdit:hWndChild != Nil
            PostMessage( oCol:oEdit:hWndChild, WM_CLOSE )
         endif
         SetFocus( ::hWnd )
      endif
   ENDIF
   if nKey == 0
        lLostFocus  := .T.
   endif

   If ! lLostFocus .and. nKey > 0 .and. (nKey != VK_ESCAPE .or. ::nColSpecHd != 0) .and. ;
      ValType( oCol:oEdit ) == "O"

      ::lPostEdit := .T.
      HideCaret( oCol:oEdit:hWnd )

      If lCombo

         cType := If( oCol:cDataType != Nil, oCol:cDataType, ValType( uVar ) )

         If cType == "L"
            uValue := ( oCol:oEdit:nAt == 1 )
            uVar := If( ValType( uVar ) == "C", ( AScan( oCol:aItems, uVar ) == 1 ), ;
                    If( ValType( uVar ) == "N", ( uVar == 1 ), uVar ) )
         Else
            If oCol:aData != Nil
               If ValType( uValue ) == "N" .and. ValType( uVar ) == "C"
                  uVar := AScan( oCol:aData, uVar )
               EndIf
               ::lChanged := ( oCol:oEdit:nAt != uVar )    //JP 69
               uValue := oCol:aData[ oCol:oEdit:nAt ]
            Else
               If cType == "N"
                  uValue := oCol:oEdit:nAt
               Else
                  uValue := oCol:oEdit:aItems[ oCol:oEdit:nAt ]
                  uVar := Substr(oCol:oEdit:aItems[uVar],1,Len(uValue)) //1.54
               EndIf
               ::lChanged := ( uValue != uVar )            //JP 69
            EndIf
            ::lHasChanged := If( ::lChanged, .T., ::lHasChanged )
         EndIf

         ::oWnd:nLastKey := nKey

         If oCol:bEditEnd != Nil
            Eval( oCol:bEditEnd, uValue, Self, .T. )
         EndIf

         IF ::nColSpecHd != 0
            ::aColumns[ nCol ]:cSpcHeading := uValue
            oCol:oEdit:End()
            oCol:oEdit := Nil
/*
            IF ::lChanged
               IF ::lAutoSearch

               ELSEIF ::lAutoFilter
               endif
            ENDIF
*/
            ::lEditing  := ::lPostEdit := ::lNoPaint := .F.
            ::nColSpecHd := 0
            Return Nil
         EndIf

         ::lAppendMode := oCol:oEdit:lAppend
         oCol:oEdit:Move( 1500,0 )
         oCol:oEdit:End()
         oCol:oEdit := Nil
         ::PostEdit( uValue, nCol, bValid )
         ::oWnd:bValid := ::oGet
         cMsg := If( ! Empty( oCol:cMsg ), oCol:cMsg, ::cMsg )
         cMsg := If( Valtype( cMsg ) == "B", Eval( cMsg, Self, ::nCell ), cMsg )
         ::SetMsg( cMsg )
         Return Nil

      EndIf

      uValue := oCol:oEdit:VarGet()
      if ::nColSpecHd != 0
         uValue := IF(nKey != VK_ESCAPE, uValue, "")
         ::aColumns[ nCol ]:cSpcHeading := uValue
         ::lChanged := ValType( uValue ) != ValType( uVar ) .or. uValue != uVar
         oCol:oEdit:End()
         oCol:oEdit := Nil
         ::lEditing  := ::lPostEdit := ::lNoPaint := .F.
         ::nColSpecHd := 0
         ::lHasChgSpec := ::lChanged
         ::AutoSpec(nCol)
         Return Nil
      else
         If oCol:bCustomEdit != Nil
            uValue := Eval( oCol:bCustomEdit, uValue, oCol:oEdit, Self )
         EndIf

         If ::lAppendMode .and. Empty( oCol:oEdit:VarGet() ) .and.  nKey != VK_RETURN
            bValid := {||.F.}
            IF ::nLenPos > ::nRowCount()   //JP 1.50
               ::nLenPos--
            Endif
            ::nRowPos := ::nLenPos       //JP 1.31
         EndIf

         If oCol:bEditEnd != Nil
            Eval( oCol:bEditEnd, uValue, Self, .T. )
         EndIf

         ::lChanged := ValType( uValue ) != ValType( uVar ) .or. uValue != uVar
         ::lHasChanged := If( ::lChanged, .T., ::lHasChanged )
         ::oWnd:nLastKey := nKey

         oCol:oEdit:End()
         oCol:oEdit := Nil
         ::oWnd:bValid := ::oGet
         ::PostEdit( uValue, nCol, bValid )

         cMsg := If( ! Empty( oCol:cMsg ), oCol:cMsg, ::cMsg )
         cMsg := If( Valtype( cMsg ) == "B", Eval( cMsg, Self, ::nCell ), cMsg )
         ::SetMsg( cMsg )
      endif
   Else
      If ::lPostEdit
         Return Nil
      EndIf

      If oCol:bEditEnd != Nil .and. ValType( oCol:oEdit ) == "O"
         Eval( oCol:bEditEnd, uValue, Self, .F. )
      EndIf

      If lCombo
         ::lAppendMode := oCol:oEdit:lAppend
      EndIf

      If ValType( oCol:oEdit ) == "O"
         oCol:oEdit:End()
         oCol:oEdit := Nil
      EndIf

      ::oWnd:nLastKey := VK_ESCAPE
      ::lChanged := .F.
      ::SetMsg( oCol:cMsg )
      ::lEditing := .F.

      If ::lAppendMode
         If ::lIsArr .and.  ::nAt > Len( ::aArray )    //JP 74
            ::nAt--
            ::Refresh( .T. )
            ::HiliteCell( ::nCell )
         EndIf

         ::lAppendMode := .F.
         ::lHitBottom  := .F.
         ::lNoPaint    := .F.

         If ::nLen <= ::nRowCount()
            ::Refresh( .T. )
         ElseIf ! ::lCanAppend
            ::GoBottom()
         EndIf

      EndIf
      cMsg := If( ! Empty( oCol:cMsg ), oCol:cMsg, ::cMsg )
      cMsg := If( Valtype( cMsg ) == "B", Eval( cMsg, Self, ::nCell ), cMsg )
      ::SetMsg( cMsg )
   EndIf

Return Nil

* ============================================================================
* METHOD TSBrowse:AutoSpec() Version 1.83 Adaption HMG  01/01/2010
* ============================================================================

METHOD AutoSpec(nCol)

   Local cExp, uExp, nPos, acSpecHdr := {}
   Local bError := ErrorBlock( { | x | Break( x ) } )

   IF ::lAutoSearch
      If ::bUserSearch != Nil
         AEval( ::aColumns, {|x| AAdd(acSpecHdr, x:cSpcHeading)} )
         Eval( ::bUserSearch, nCol, acSpecHdr, Self )
      else
         cExp :=BuildAutoSeek( Self )
         IF ! Empty(cExp)
            Begin Sequence
               uExp := &( cExp )
            Recover
               ErrorBlock( bError )
               Return Nil
            End Sequence
            IF ::lIsArr
               If (nPos := Eval(uExp,Self)) != 0
                  ::nAt := nPos
                  ::Refresh(.t.)
               ELSE
                  Tone( 500, 1 )
               ENDIF
            ENDIF
            IF ::lIsDbf
               IF ::lHasChgSpec
                  Eval( ::bGoTop )
               endif
               IF ::ExpLocate( cExp )
                  ::Refresh(.t.)
               ELSE
                  Tone( 500, 1 )
               ENDIF
            ENDIF
         ENDIF
      endif
   ELSEIF ::lAutoFilter
      If ::bUserFilter != Nil
         AEval( ::aColumns, {|x| AAdd(acSpecHdr, x:cSpcHeading)} )
         cExp := Eval( ::bUserFilter, nCol, acSpecHdr, Self )
      else
         cExp := BuildAutoFilter( Self )
      endif
      if ! Empty(cExp)
            Begin Sequence
               uExp := &( "{||(" + Trim( cExp ) + ")}" )
            Recover
               ErrorBlock( bError )
               Return Nil
            End Sequence
            IF ::lIsDbf
               ::bFilter := uExp
               DbSetFilter( uExp, cExp )
               ( ::cAlias )->( DbGoTop() )
               ::GoTop()
               ::lHitBottom := .F.
               ::nRowPos    := ::nAt := ::nLastnAt := 1
               ::lHitTop    := .T.
               ::Refresh(.t.)
            ENDIF
     else
            DbClearFilter()
            ::bFilter := Nil
            ::GoTop()
            ::UpStable()
            ::Refresh(.t.)
     endif

   ENDIF
   ::lHasChgSpec := .f.

Return Nil

* ============================================================================
* METHOD TSBrowse:Excel2() Version 7.0 Jul/15/2004
* ============================================================================

METHOD Excel2( cFile, lActivate, hProgress, cTitle, lSave ) CLASS TSBrowse

   Local i,nRow, uData, nAlign, nEvery, nPic, nFont, cWork, aFontTmp, nHandle, nTotal, nSkip, nCol, ;
         hFont  := If( ::hFont != Nil, ::hFont, 0 ), ;
         nLine  := 1, ;
         nCount := 0, ;
         aLen   := {}, ;
         aPic   := {}, cPic, anPic := {}, cType, cc, ;
         aFont  := {}, ;
         nRecNo := IF( ::lIsDbf, ( ::cAlias )->( RecNo() ), 0), ;
         nAt    := ::nAt,;
         nOldRow := ::nLogicPos(), ;
         nOldCol := ::nCell

   Default nInstance := 0

   Default cFile     := "Book1.xls", ;
           lActivate := .T., ;
           cTitle    := "", ;
           lSave     := .F.

   CursorWait()

   ::lNoPaint := .F.
   nInstance ++
   cWork := GetStartupFolder() + "\Book" + LTrim( Str( nInstance ) ) + ".xls"
   ::SetFocus()
   cFile  := ::Proper( StrTran( AllTrim( Upper( cFile ) ), ".XLS" ) + ".XLS" )
   cTitle := AllTrim( cTitle )

   For nCol := 1 To Len( ::aColSizes )

      AAdd( aLen, Max( 1, Round( ::aColSizes[ nCol ] / ;
                                  GetTextWidth( 0, "B", hFont ), 0 ) ) )

      cPic := ''
      cType := If( Empty( ::aColumns[ nCol ]:cDataType ), ValType(Eval(::aColumns[ nCol ]:bData)), ::aColumns[ nCol ]:cDataType )
      if cType == 'N' .and.  !Empty( ::aColumns[ nCol ]:cPicture )
         for i := 1 to LEN( ::aColumns[ nCol ]:cPicture )
           cc := substr( ::aColumns[ nCol ]:cPicture, i, 1 )
           if cc=='9';   cc := '0';   endif
           if !Empty(cPic);   cPic += cc
           elseif cc # '0';   cPic += ('#0'+cc)
           endif
         next
         if Empty(cPic);   cPic := '#0';   endif
      endif
      nPic := IIf(!Empty(cPic), AScan( aPic,{|x| x==cPic }), 0 )
      if nPic == 0
         AAdd( aPic, cPic );  nPic := LEN(aPic)
      EndIf
      AADD( anPIC, nPic )
   Next

   If ( nHandle := FCreate( cWork, 0 ) ) < 0
      MsgStop( "Can't create XLS file", cWork )
      Return Nil
   EndIf

   FWrite( nHandle, BiffRec( 9 ) )
   //  set CodePage
   FWrite( nHandle, BiffRec( 66, GetACP() ) )
   FWrite( nHandle, BiffRec( 12 ) )
   FWrite( nHandle, BiffRec( 13 ) )
/*
   If ::hFont != Nil
      AAdd( aFont,  GetFontParam(::hFont) )
   else
      if ( hFont := GetFontHandle( ::cFont ) ) != 0
         AAdd(aFont , GetFontParam(hFont))
      endif
   EndIf

   For nCol := 1 To Len( ::aColumns )

      If Empty( ::aColumns[ nCol ]:hFont ) .and. Empty( ::aColumns[ nCol ]:hFontHead )
         Loop
      EndIf

      hFont := ::aColumns[ nCol ]:hFont

      If hFont != Nil
         aFontTmp := GetFontParam(hFont)
         IF AScan( aFont, {|e| e[ 1 ] == aFontTmp[ 1 ] .and. e[ 2 ] == aFontTmp[ 2 ] .and. ;
                            e[ 3 ] == aFontTmp[ 3 ] .and. e[ 4 ] == aFontTmp[ 4 ] .and. ;
                            e[ 5 ] == aFontTmp[ 5 ] .and. e[ 6 ] == aFontTmp[ 6 ] } ) == 0

            AAdd( aFont,  aFontTmp )
         endif

      EndIf

      hFont := ::aColumns[ nCol ]:hFontHead

      If hFont != Nil
         aFontTmp := GetFontParam(hFont)
         IF AScan( aFont, {|e| e[ 1 ] == aFontTmp[ 1 ] .and. e[ 2 ] == aFontTmp[ 2 ] .and. ;
                            e[ 3 ] == aFontTmp[ 3 ] .and. e[ 4 ] == aFontTmp[ 4 ] .and. ;
                            e[ 5 ] == aFontTmp[ 5 ] .and. e[ 6 ] == aFontTmp[ 6 ] } ) == 0

            AAdd( aFont, aFontTmp )
         endif

      EndIf

   Next

   If Len( aFont ) > 4
      ASize( aFont, 4 )
   EndIf
*/
   If ! Empty( aFont )

      For nCol := 1 To Len( aFont )
         FWrite( nHandle, BiffRec( 49, aFont[ nCol ] ) )
      Next

   EndIf

   FWrite( nHandle, BiffRec( 31, 1 ) )
   FWrite( nHandle, BiffRec( 30, "General" ) )

   If ! Empty( aPic )
      AEval( aPic, {|e| FWrite( nHandle, BiffRec( 30, e ) ) } )
   EndIf

   AEval( aLen, { |e,n| FWrite( nHandle, BiffRec( 36, e, n - 1, n - 1 ) ) } )
   If hProgress != Nil
      nTotal := ( ::nLen + 1 ) * Len( ::aColumns )
      SetProgressBarRange ( hProgress , 1 , nTotal )
      SendMessage(hProgress, PBM_SETPOS,0,0)
      nEvery := Max( 1, Int( nTotal * .02 ) ) // refresh hProgress every 2 %
   EndIf

   IF ::lIsDbf
      ( ::cAlias )->( Eval( ::bGoTop ) )
   EndIf

   For nRow := 1 To ( ::nLen )

      If nRow == 1

         If ! Empty( cTitle )
            cTitle := StrTran( cTitle, CRLF, Chr( 10 ) )
            nAlign := If( Chr( 10 ) $ cTitle, 5, 1 )
            FWrite( nHandle, BiffRec( 4, cTitle, 0, 0,, nAlign ) )
            nLine := 3
         EndIf

         For nCol := 1 To Len( ::aColumns )

            uData := If( ValType( ::aColumns[ nCol ]:cHeading ) == "B", ;
                         Eval( ::aColumns[ nCol ]:cHeading ), ;
                         ::aColumns[ nCol ]:cHeading )

            If ValType( uData ) != "C"
               Loop
            EndIf
// no tested
//            if IsOemText(uData)
//               uData:=hb_oemtoansi(uData)
//            endif

            uData  := Trim( StrTran( uData, CRLF, Chr( 10 ) ) )
            nAlign := Min( LoWord( ::aColumns[ nCol ]:nHAlign ), 2 )
            nAlign := If( Chr( 10 ) $ uData, 4, nAlign )
/*
            hFont  := ::aColumns[ nCol ]:hFontHead
            aFontTmp := GetFontParam( hFont )
            nFont  := AScan( aFont, {|e| e[ 1 ] == aFontTmp[ 1 ] .and. e[ 2 ] == aFontTmp[ 2 ] .and. ;
                            e[ 3 ] == aFontTmp[ 3 ] .and. e[ 4 ] == aFontTmp[ 4 ] .and. ;
                            e[ 5 ] == aFontTmp[ 5 ] .and. e[ 6 ] == aFontTmp[ 6 ] } )

            FWrite( nHandle, BiffRec( 4, uData, nLine - 1, nCol - 1, .T., nAlign + 1,, ;
                                      Max( 0, nFont - 1 ) ) )
*/
            If hProgress != Nil

               If nCount % nEvery == 0
                  SendMessage(hProgress, PBM_SETPOS, nCount, 0)
               EndIf

               nCount ++

            EndIf

         Next

         ++nLine

      EndIf

      For nCol := 1 To Len( ::aColumns )

         If ::aColumns[ nCol ]:lBitMap
            Loop
         EndIf

         uData  := Eval( ::aColumns[ nCol ]:bData )
         nAlign := LoWord( ::aColumns[ nCol ]:nAlign )
         hFont  := ::aColumns[ nCol ]:hFont
//         aFontTmp := GetFontParam( hFont )
         nFont  := AScan( aFont, {|e| e[ 1 ] == aFontTmp[ 1 ] .and. e[ 2 ] == aFontTmp[ 2 ] .and. ;
                            e[ 3 ] == aFontTmp[ 3 ] .and. e[ 4 ] == aFontTmp[ 4 ] .and. ;
                            e[ 5 ] == aFontTmp[ 5 ] .and. e[ 6 ] == aFontTmp[ 6 ] } )

         nPic := If( ! Empty( ::aColumns[ nCol ]:cPicture ), anPIC[ nCol ], Nil )

         If ValType( uData ) == "N"
            FWrite( nHandle, BiffRec( 3, uData, nLine - 1, nCol - 1,, nAlign + 1, nPic, ;
                                      Max( 0, nFont - 1 ) ) )
         Else
            uData := Trim( StrTran( cValToChar( uData ), CRLF, Chr( 10 ) ) )
            nAlign := If( Chr( 10 ) $ uData, 4, nAlign )
            FWrite( nHandle, BiffRec( 4, uData, nLine - 1, nCol - 1,, nAlign + 1, nPic, ;
                                      Max( 0, nFont - 1 ) ) )
         EndIf

         If hProgress != Nil

            If nCount % nEvery == 0
               SendMessage(hProgress, PBM_SETPOS, nCount, 0)
            EndIf

            nCount ++

         EndIf

      Next

      nSkip := ::Skip( 1 )

      ++nLine
      SysRefresh()
      IF nSkip ==0
         EXIT
      ENDIF
   Next

   FWrite( nHandle, BiffRec( 10 ) )
   FClose( nHandle )

   If hProgress != Nil
      SendMessage(hProgress, PBM_SETPOS, nTotal, 0)
   EndIf

   If lSave
      FileRename( Self, cWork, cFile )
   EndIf

   CursorArrow()

   If ::lIsDbf
      ( ::cAlias )->( DbGoTo( nRecNo ) )
      ::GoPos(nOldRow, nOldCol)
   EndIf

   ::nAt := nAt

   If lActivate
      ShellExecute( 0, "Open", If( lSave, cFile, cWork ),,, 3 )
   EndIf

   ::Display()

Return Nil

* ============================================================================
* METHOD TSBrowse:ExcelOle() Version 7.0 Jul/15/2004
* Many thanks to Victor Manuel Toms for the core of this method
* ============================================================================

METHOD ExcelOle( cXlsFile, lActivate, hProgress, cTitle, ;
                 hFont, lSave ) CLASS TSBrowse

   Local oExcel, oBook, oSheet, nRow, nCol, uData, nEvery, oRange, cRange, cCell, ;
         bError, cText, nStart, nTotal, aFont, nSkip, ;
         nLine  := 1, ;
         nCount := 0, ;
         nRecNo := IF( ::lIsDbf, ( ::cAlias )->( RecNo() ), 0), ;
         nAt    := ::nAt,;
         nOldRow := ::nLogicPos(), ;
         nOldCol := ::nCell

   Default lActivate := Empty( cXlsFile ), ;
           cTitle    := "", ;
           lSave     := .F.

   CursorWait()

   ::lNoPaint := .F.

   If hProgress != Nil
      nTotal := ( ::nLen + 1 ) * Len( ::aColumns ) + 30
      SetProgressBarRange ( hProgress , 1 , nTotal )
      SendMessage(hProgress, PBM_SETPOS, 0, 0)
      nEvery := Max( 1, Int( nTotal * .02 ) ) // refresh hProgress every 2 %
   EndIf

   cXlsFile := AllTrim( StrTran( Upper( cXlsFile ), ".XLS" ) )
   cTitle   := AllTrim( cTitle )
   bError   := ErrorBlock( { | x | Break( x ) } )

   Begin Sequence
      oExcel := CreateObject( "Excel.Application" )
   Recover
      ErrorBlock( bError )
      CursorArrow()
      MsgStop( "Ole.lib is not found", "Error" )
      Return Nil
   End Sequence

   ErrorBlock( bError )

   If hProgress != Nil
      nCount -= 15
      SendMessage(hProgress, PBM_SETPOS, nCount, 0)
   EndIf

   oExcel:WorkBooks:Add()
   oBook  := oExcel:Get( "ActiveWorkBook")
   oSheet := oExcel:Get( "ActiveSheet" )

   If hProgress != Nil
      nCount -= 15
      SendMessage(hProgress, PBM_SETPOS, nCount, 0)
   EndIf

   IF ::lIsDbf
      ( ::cAlias )->( Eval( ::bGoTop ) )
   EndIf

   cText := ""

   For nRow := 1 To ::nLen

      If nRow == 1

         If ! Empty( cTitle )
            oSheet:Cells( nLine++, 1 ):Value := AllTrim( cTitle )
            oSheet:Range( "A1:" + Chr( 64 + Len( ::aColumns ) ) + ;
                          "1" ):Set( "HorizontalAlignment", 7 )
            ++nLine
            nStart := nLine
         Else
            nStart := 1
         EndIf

         For nCol := 1 To Len( ::aColumns )
            uData := If( ValType( ::aColumns[ nCol ]:cHeading ) == "B", ;
                         Eval( ::aColumns[ nCol ]:cHeading ), ;
                         ::aColumns[ nCol ]:cHeading )

            If ValType( uData ) != "C"
               Loop
            EndIf

            uData := StrTran( uData, CRLF, Chr( 10 ) )

            cText += uData + Chr( 9 )

            If hProgress != Nil

               If nCount % nEvery == 0
                  SendMessage(hProgress, PBM_SETPOS,nCount,0)
               EndIf

               nCount ++

            EndIf

         Next

         cText += Chr( 13 )

      EndIf

      For nCol := 1 To Len( ::aColumns )

         If ::aColumns[ nCol ]:lBitMap
            Loop
         EndIf

         uData := Eval( ::aColumns[ nCol ]:bData )

         If ValType( uData ) == "C"
            uData := StrTran( uData, CRLF, Chr( 10 ) )
         EndIf

         If ::aColumns[ nCol ]:cPicture != Nil
            uData := Transform( uData, ::aColumns[ nCol ]:cPicture )
         EndIf

         uData  :=  IIF( ValType( uData )=="D", DtoC( uData ), ;
                    IIF( ValType( uData )=="N", Str( uData ) , ;
                    IIF( ValType( uData )=="L", IIF( uData, ".T." ,".F." ), uData ) ) )

         cText += alltrim( uData ) + Chr( 9 )

         If hProgress != Nil

            If nCount % nEvery == 0
               SendMessage(hProgress, PBM_SETPOS, nCount, 0)
            EndIf

            nCount ++

         EndIf

      Next

      nSkip := ::Skip( 1 )

      cText += Chr( 13 )

      ++nLine

      IF nSkip ==0
         EXIT
      ENDIF

      /*
         Cada 20k volcamos el texto a la hoja de Excel , usando el portapapeles , algo muy rapido y facil ;-)
         Every 20k set text into excel sheet , using Clipboard , very easy and faster.
      */

      IF Len( cText ) > 20000
         SetClipboard( cText )
         cCell := "A" + Alltrim( Str( nStart ) )
         oRange := oSheet:Range( cCell )
         oRange:Select()
         oSheet:Paste()
         cText := ""
         nStart := nLine + 1

      EndIf

   Next

   If ::lIsDbf
      ( ::cAlias )->( DbGoTo( nRecNo ) )
      ::GoPos(nOldRow, nOldCol)

   EndIf

   ::nAt := nAt

   If Len( cText ) > 0
      SetClipboard( cText )
      cCell := "A" + Alltrim( Str( nStart ) )
      oRange := oSheet:Range( cCell )
      oRange:Select()
      oSheet:Paste()
      cText := ""
   EndIf

   cRange := "A3:" + Chr( 64 + Len( ::aColumns ) ) + ;
             Alltrim( Str( oSheet:UsedRange:Rows:Count() ) )
   oRange := oSheet:Range( cRange )
/*
   If hFont != NIL  // let the programmer to decide the font he wants, otherwise use Excel's default
         aFont := GetFontParam(hFont)
         oRange:Font:Name := aFont[1]
         oRange:Font:Size := aFont[2]
         oRange:Font:Bold := aFont[3]
   EndIf
*/
   oRange:Borders():LineStyle := 1
   oRange:Columns:AutoFit()

   If hProgress != Nil
      SendMessage(hProgress, PBM_SETPOS, nCount, 0)
   EndIf

   If cXlsFile != Nil .and. lSave
      oBook:SaveAs( cXlsFile, -4143 )   // -4143 = Normal
   EndIf

   oSheet:Range( "A1" ):Select()

   CursorArrow()

   If lActivate
      oExcel:Visible := .T.
   EndIf
   If hProgress != Nil
      SendMessage(hProgress, PBM_SETPOS, 0, 0)
   EndIf

   ::Display()

Return Nil

* ============================================================================
* METHOD TSBrowse:ExpLocate() Version 7.0 Jul/15/2004
* ============================================================================

METHOD ExpLocate( cExp ) CLASS TSBrowse

   Local uExp, bExp, ;
         nLines := ::nRowCount(), ;
         nRecNo := ( ::cAlias )->( RecNo() ), ;
         bError := ErrorBlock( { | x | Break( x ) } )

   ::lValidating := .T.

   Begin Sequence
      uExp := &( cExp )
   Recover
      ErrorBlock( bError )
      Return .F.
   End Sequence

   ErrorBlock( bError )

   bExp := &( "{||(" + Trim( cExp ) + ")}" )

   If Eval( bExp )
      ::Skip( 1 )
   EndIf
   if ::cDriver == "ADO"
      uExp := "HB_AdoSetLocateFor"
      ( &uExp( cExp ) )
   endif

   ( ::cAlias )->( __dbLocate( bExp,cExp,,, .T. ) )

   If ( ::cAlias )->( EoF() )
      ( ::cAlias)->( DbGoTo( nRecNo ) )
      Return .F.
   EndIf

   If nRecNo != ( ::cAlias )->( RecNo() ) .and. ::nLen > nLines

         nRecNo := ( ::cAlias )->( RecNo() )
         ( ::cAlias )->( DbSkip( nLines - ::nRowPos ) )

         If ( ::cAlias )->( EoF() )

            Eval( ::bGoBottom )
            ::nRowPos := nLines
            ::nAt := ::nLogicPos()

            While ::nRowPos > 1 .and. ( ::cAlias )->( RecNo() ) != nRecNo
               ::Skip( -1 )
               ::nRowPos --
            EndDo
         Else
            ( ::cAlias )->( DbGoTo( nRecNo ) )
            ::nAt := ::nLogicPos()
         EndIf

         ::Refresh( .F. )
         ::ResetBarPos()
      ElseIf nRecNo != ( ::cAlias )->( RecNo() )
         nRecNo := ( ::cAlias )->( RecNo() )
         Eval( ::bGoTop )
         ::nAt := ::nRowPos := 1

         While nRecNo != ( ::cAlias )->( RecNo() )
            ::Skip( 1 )
            ::nRowPos++
         EndDo
         ::Refresh( .F. )
         ::ResetBarPos()
   EndIf

   If ::bChange != Nil
      Eval( ::bChange, Self, 0 )
   EndIf

   If ::lIsArr .and. ::bSetGet != Nil
      If ValType( Eval( ::bSetGet ) ) == "N"
         Eval( ::bSetGet, ::nAt )
      ElseIf ::nLen > 0
         Eval( ::bSetGet, ::aArray[ ::nAt, 1 ] )
      Else
         Eval( ::bSetGet, "" )
      EndIf
   EndIf

Return .T.

* ============================================================================
* METHOD TSBrowse:ExpSeek() Version 7.0 Jul/15/2004
* ============================================================================

METHOD ExpSeek( cExp, lSoft ) CLASS TSBrowse

   Local nQuote, uExp, ;
         nRecNo := ( ::cAlias )->( RecNo() ), ;
         nLines := ::nRowCount(), ;
         cType  := ValType( Eval( &("{||" + ;
                                  ( ::cAlias )->( IndexKey() ) + "}") ) ), ;
         bError := ErrorBlock( { | x | Break( x ) } )

   ::lValidating := .T.

   nQuote := At( '"', cExp )
   nQuote := If( nQuote == 0, At( "'", cExp ), nQuote )

   cExp := If( cType == "C" .and. nQuote == 0, '"' + Trim( cExp ) + '"', ;
           If( cType == "D" .and. At( "CTOD", Upper( cExp ) ) == 0, ;
               'CtoD( "' + AllTrim( cExp ) + '")', ;
           If( cType == "N", AllTrim( cExp ), ;
           If( cType == "L", If( AllTrim( cExp ) == "T", ".T.", ".F." ), ;
               AllTrim( cExp ) ) ) ) )

   Begin Sequence
      uExp := &( cExp )
   Recover
      ErrorBlock( bError )
      Return .F.
   End Sequence

   ErrorBlock( bError )

   ( ::cAlias )->( DbSeek( uExp, lSoft ) )

   If ( ::cAlias )->( EoF() )
      ( ::cAlias )->( DbGoTo( nRecNo ) )
      Return .F.
   EndIf

   If nRecNo != ( ::cAlias )->( RecNo() ) .and. ::nLen > nLines

         nRecNo := ( ::cAlias )->( RecNo() )
         ( ::cAlias )->( DbSkip( nLines - ::nRowPos ) )

         If ( ::cAlias )->( EoF() )

            Eval( ::bGoBottom )
            ::nRowPos := nLines
            ::nAt := ::nLogicPos()

            While ::nRowPos > 1 .and. ( ::cAlias )->( RecNo() ) != nRecNo
               ::Skip( -1 )
               ::nRowPos --
            EndDo
         Else
            ( ::cAlias )->( DbGoTo( nRecNo ) )
            ::nAt := ::nLogicPos()
         EndIf

         ::Refresh( .F. )
         ::ResetBarPos()

      ElseIf nRecNo != ( ::cAlias )->( RecNo() )

         nRecNo := ( ::cAlias )->( RecNo() )
         Eval( ::bGoTop )
         ::nAt := ::nRowPos := 1

         While nRecNo != ( ::cAlias )->( RecNo() )
            ::Skip( 1 )
            ::nRowPos ++
         EndDo

         ::Refresh( .F. )
         ::ResetBarPos()

   EndIf

   If ::bChange != Nil
      Eval( ::bChange, Self, 0 )
   EndIf

   If ::lIsArr .and. ::bSetGet != Nil
      If ValType( Eval( ::bSetGet ) ) == "N"
         Eval( ::bSetGet, ::nAt )
      ElseIf ::nLen > 0
         Eval( ::bSetGet, ::aArray[ ::nAt, 1 ] )
      Else
         Eval( ::bSetGet, "" )
      EndIf
   EndIf

Return .T.

* ============================================================================
* METHOD TSBrowse:FreezeCol() Version 7.0 Jul/15/2004
* ============================================================================

METHOD FreezeCol( lNext ) CLASS TSBrowse

   Local nFreeze := ::nFreeze

   Default lNext := .T.

    If lNext                                      // freeze next available column
        ::nFreeze := Min( nFreeze + 1, Len( ::aColumns ) )
    Else                                          // unfreeze previous column
        ::nFreeze := Max( nFreeze - 1, 0 )
   EndIf

   If ::nFreeze != nFreeze                        // only update if necessary
      If( ! lNext, ::PanHome(), Nil )
        ::HiliteCell( ::nFreeze + 1 )
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:GetColumn() Version 7.0 Jul/15/2004
* ============================================================================

METHOD GetColumn( nCol ) CLASS TSBrowse

    Default nCol := 1

    If nCol < 1
        nCol := 1
   ElseIf nCol > Len( ::aColumns )
        nCol := Len( ::aColumns )
   EndIf

Return ::aColumns[ nCol ]                       // returns a Column object

* ============================================================================
* METHOD TSBrowse:GetDlgCode() Version 7.0 Jul/15/2004
* ============================================================================

METHOD GetDlgCode( nLastKey ) CLASS TSBrowse

   // This method is very similar to TControl:GetDlgCode() but it is
   // necessary to have WHEN working
   If ! ::oWnd:lValidating
      If nLastKey == VK_UP .or. nLastKey == VK_DOWN ;
         .or. nLastKey == VK_RETURN .or. nLastKey == VK_TAB
         ::oWnd:nLastKey := nLastKey
      Else
         ::oWnd:nLastKey := 0
      EndIf
   EndIf

Return If( IsWindowEnabled( ::hWnd ) .and. nLastKey != VK_ESCAPE, ;
           DLGC_WANTALLKEYS, 0 )

* ============================================================================
* METHOD TSBrowse:GetRealPos() Version 7.0 Jul/15/2004
* ============================================================================

METHOD GetRealPos( nRelPos ) CLASS TSBrowse

   Local nLen

   If ::nLen == 0
      ::nLen := If( ::lIsDbf, ( ::cAlias )->( Eval( ::bLogicLen ) ), ;
                    Eval( ::bLogicLen ) )
   EndIf

   nLen := ::nLen

   nRelPos := If( nLen > MAX_POS, Int( ( nRelPos / MAX_POS ) * nLen ), nRelPos )

Return nRelPos

* ============================================================================
* METHOD TSBrowse:GoBottom() Version 7.0 Jul/15/2004
* ============================================================================

METHOD GoBottom() CLASS TSBrowse

   Local nLines := ::nRowCount()

   If ::nLen == 0
      ::nLen := If( ::lIsDbf, ( ::cAlias )->( Eval( ::bLogicLen ) ), ;
                    Eval( ::bLogicLen ) )
   EndIf
   IF ::nLenPos ==0
      ::nLenPos := Min( nLines, ::nLen )
   endif
   If ::nLen < 1
      Return Self
   EndIf

   ::lAppendMode := .F.
    ::ResetSeek()

   If ! ::lHitBottom

      Eval( ::bGoBottom )
      ::lHitBottom := .T.
      ::lHitTop    := .F.
      ::nRowPos    := Min( nLines, ::nLen )
      ::nRowPos    := Min( nLines, ::nLenPos ) //JP 1.31
      ::nAt        := ::nLastnAt := ::nLogicPos()
      ::nLenPos := ::nRowPos

      If ::lIsDbf
         ::nLastPos := ( ::cAlias )->( RecNo() )
      EndIf

      If ::bChange != Nil
         Eval( ::bChange, Self, ::oWnd:nLastKey )
      EndIf

      If ::oVScroll != Nil
         ::oVScroll:SetPos( ::oVScroll:nMax )
      EndIf

      ::Refresh( ::nLen < nLines )

      If ::lIsArr .and. ::bSetGet != Nil
         If ValType( Eval( ::bSetGet ) ) == "N"
            Eval( ::bSetGet, ::nAt )
         ElseIf ::nLen > 0
            Eval( ::bSetGet, ::aArray[ ::nAt, 1 ] )
         Else
            Eval( ::bSetGet, "" )
         EndIf
      EndIf

   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:GoDown() Version 7.0 Jul/15/2004
* ============================================================================

METHOD GoDown() CLASS TSBrowse

   Local nFirst, ;
         nLines    := ::nRowCount(), ;
         lRePaint  , ;
         lEditable := .F.
   If ::nLen < 1       // for empty dbfs or arrays
        If ::lCanAppend
            ::nRowPos := 1
        Else
          Return Self
      EndIf
   EndIf

   ::ResetSeek()

   If ::nLen <= nLines .and. ::lNoLiteBar
      Return Self
   EndIf

   If ::lNoLiteBar
      nFirst := nLines - ::nRowPos
      ::Skip( nFirst )
      ::nRowPos := nLines
   EndIf

   ::nRowPos := Max( 1, ::nRowPos )
   AEval( ::aColumns, { |o| If( ::lCanAppend .and. ;
                                  o:lEdit, lEditable := .T., Nil ) } )

   If ! ::lAppendMode
      ::nPrevRec := If( ::lIsDbf, ( ::cAlias )->( RecNo() ), ::nAt )
   EndIf

   If ! ::lHitBottom

      If ! ::lAppendMode .and. ! ::lIsTxt
         ::DrawLine()
      EndIf

      If ::Skip( 1 ) == 1
         ::lHitTop := .F.

         If ::nRowPos < nLines
            ::nRowPos++
         Else
            If ::lPageMode
               lRePaint := If( ( ::nLogicPos + nLines - 1 ) > ::nLen, .T., .F. )
               ::nRowPos := 1
               ::Refresh( lRePaint )
            Else
               ::nRowPos := nLines
               ::lRePaint := .F.
               ::TSBrwScroll( 1 )
            EndIf

         EndIf

      Else
         Eval( ::bGoBottom )
         ::lHitBottom := .T.
      EndIf

      If ! ::lAppendMode .and. ! ::lEditing
         ::DrawSelect()
      EndIf

      If ::oVScroll != Nil .and. ! ::lAppendMode
         ::oVScroll:SetPos( ::RelPos( ::nLogicPos() ) )
      EndIf

      If ! ::lHitBottom .and. ! ::lAppendMode .and. ::bChange != nil
         Eval( ::bChange, Self, ::oWnd:nLastKey )
      EndIf
   EndIf

   If ::lHitBottom .AND. ::lCanAppend .and. lEditable .and. ! ::lAppendMode  //JP 1.31

      ::lAppendMode := .T.
      nFirst := 0
      Aeval( ::aColumns, { | oCol, nCol | nFirst := If( ::IsEditable( nCol ) .and. ;
                                        nFirst == 0, nCol, nFirst ),HB_SYMBOL_UNUSED( oCol ) } )
      If nFirst == 0
         ::lAppendMode := .F.
         ::lHitTop := ::lHitBottom := .F.
         Return Self
      EndIf

      If ::nCell != nFirst .and. ! ::IsColVisible( nFirst )

         While ! ::IsColVisible( nFirst )
            ::nColPos += If( nFirst < ::nCell, -1, 1 )
         EndDo

      EndIf

      ::lHitTop := ::lHitBottom := .F.
      ::nCell := nFirst
      ::nLenPos := ::nRowPos   //JP 1.31
      If ::lIsArr
         ::lAppendMode := .F.
         ::DrawLine()
         ::lAppendMode := .T.
      Else
         ::DrawLine()
      EndIf

      ::GoDown()                // recursive call to force entry to itself
      ::nLastKey := ::oWnd:nLastKey := VK_RETURN
      ::DrawLine()
      ::PostMsg( WM_KEYDOWN, VK_RETURN, nMakeLong( 0, 0 ) )

   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:GoEnd() Version 7.0 Jul/15/2004
* ============================================================================

METHOD GoEnd() CLASS TSBrowse

   Local nTxtWid, nI, nLastCol, nBegin, ;
         nWidth   := ::nWidth() - If( ::oVScroll != Nil, 16, 0 ), ;
         nWide    := 0, ;
         nCols    := Len( ::aColumns ), ;
         nPos     := ::nColPos

   If ::lIsTxt
      nTxtWid := Max( 1, GetTextWidth( 0, "B", If( ::hFont != Nil, ::hFont, 0 ) ) )

      If ::nAt < ::oTxtFile:nMaxLineLength - Int( nWidth / nTxtWid )
            ::nAt := ::oTxtFile:nMaxLineLength - Int( nWidth / nTxtWid )
         ::Refresh( .F. )
         If ::oHScroll != Nil
                ::oHScroll:SetPos( ::nAt )
         EndIf
      EndIf

      Return Self
   EndIf

   nLastCol := Len( ::aColumns )
   nBegin := Min( If( ::nColPos <= ::nFreeze, ( ::nColPos := ::nFreeze + 1,;
                  ::nColPos - ::nFreeze ), ::nColPos - ::nFreeze ), nLastCol )

   nWide := 0

   For nI := nBegin To nPos
       nWide += ::aColSizes[ nI ]
   Next

   nBegin := ::nCell

   For nI := nPos + 1 To nCols
      If nWide + ::aColSizes[ nI ] <= nWidth    // only if column if fully visible
         nWide += ::aColSizes[ nI ]
         ::nCell := nI
        Else
            Exit
      EndIf
    Next

   If nBegin == ::nCell
      Return Self
   EndIf

   If ::lCellBrw

      If ::aColumns[ ::nCell ]:bGotFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nCell ]:bGotFocus, ::nOldCell, ::nCell, Self )
      EndIf

      If ::aColumns[ ::nOldCell ]:bLostFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nOldCell ]:bLostFocus, ::nCell, ::nOldCell, Self )
      EndIf

   EndIf

   ::Refresh( .F. )

   If ::oHScroll != Nil
        ::oHScroll:SetPos( ::nCell )
   EndIf

   ::nOldCell := ::nCell
   ::HiliteCell( ::nCell )

Return Self

* ============================================================================
* METHOD TSBrowse:GoHome() Version 7.0 Jul/15/2004
* ============================================================================

METHOD GoHome() CLASS TSBrowse

   ::nOldCell := ::nCell

   If ::lIsTxt

      If ::nAt > 1
         ::nAt := 1
         ::Refresh( .F. )
         If ::oHScroll != Nil
            ::oHScroll:SetPos( ::nAt )
         EndIf
      EndIf
      Return Self
   EndIf

   ::nCell := ::nColPos

   If ::nCell == ::nOldCell
      Return Self
   EndIf

   If ::lCellBrw

      If ::aColumns[ ::nCell ]:bGotFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nCell ]:bGotFocus, ::nOldCell, ::nCell, Self )
      EndIf

      If ::aColumns[ ::nOldCell ]:bLostFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nOldCell ]:bLostFocus, ::nCell, ::nOldCell, Self )
      EndIf

   EndIf

   ::Refresh( .F. )

   If ::oHScroll != Nil
        ::oHScroll:SetPos( ::nCell )
   EndIf

   If ::aColumns[ ::nCell ]:lVisible == .F.
      ::GoRight()
   EndIf

   ::nOldCell := ::nCell
   ::HiliteCell( ::nCell )

Return Self

* ============================================================================
* METHOD TSBrowse:GoLeft() Version 7.0 Jul/15/2004
* ============================================================================

METHOD GoLeft() CLASS TSBrowse

   Local nCell, nSkip, ;
         lLock := ::nFreeze > 0 .and. ::lLockFreeze, ;
         lDraw := .F.

   ::nOldCell := ::nCell

   If ::lIsTxt
      If ::nOffset > 5
         ::nOffset -= 5
      Else
         ::nOffset := 1
      EndIf
      ::Refresh( .F. )

      If ::oHScroll != Nil
         ::oHScroll:SetPos( ::nOffset )
      EndIf
      Return Self
   EndIf

   ::ResetSeek()

   If ::lCellBrw

      nCell := ::nCell
      nSkip := 0

      While nCell > ( If( lLock, ::nFreeze + 1, 1 ) )

         nCell --
         nSkip ++

         If ! ::aColumns[ nCell ]:lNoHilite
            Exit
         EndIf

      EndDo

      If nSkip == 0
         Return Self
      EndIf

      While ::nColPos > ( ::nFreeze + 1 ) .and. ! ::IsColVisible( nCell )
         lDraw := .T.
         ::nColPos --
      EndDo

      ::nCell := nCell

      If lDraw
         ::Refresh( .F. )
      EndIf

      If ::aColumns[ ::nCell ]:bGotFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nCell ]:bGotFocus, ::nOldCell, ::nCell, Self )
      EndIf

      If ::aColumns[ ::nOldCell ]:bLostFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nOldCell ]:bLostFocus, ::nCell, ::nOldCell, Self )
      EndIf

      If( ::oHScroll != Nil, ::oHScroll:SetPos( ::nCell ), Nil )
      ::nOldCell := ::nCell
      ::HiliteCell( ::nCell )
      ::DrawSelect()
      If ::aColumns[ ::nCell ]:lVisible == .F.
         If ::nCell == 1
            ::GoRight()
         Else
            ::GoLeft()
         Endif
      endif

    Else

      If ::nCell > ( ::nFreeze + 1 )

         ::nColPos := ::nCell := ::nFreeze + 1
         ::Refresh( .F. )

         If ::oHScroll != Nil
            ::oHScroll:GoTop()
         EndIf

      EndIf

   EndIf

Return Self

// ============================================================================
// METHOD TSBrowse:GoNext() Version 7.0 Jul/15/2004
// Post-edition cursor movement.  Cursor goes to next editable cell, right
// or first-down according to the position of the last edited cell.
// This method is activated when the MOVE clause of ADD COLUMN command is
// set to 5 ( DT_MOVE_NEXT )
// ============================================================================

METHOD GoNext() CLASS TSBrowse

   Local nEle, ;
         nFirst   := 0

   ::nOldCell   := ::nCell
   ::lHitBottom := ::lHitTop := .F.

   For nEle := ( ::nCell  + 1 ) To Len( ::aColumns )

      If ::IsEditable( nEle ) .and. ! ::aColumns[ nEle ]:lNoHiLite .and. ::aColumns[ nEle ]:lVisible

         nFirst := nEle
         Exit

      EndIf

   Next

   If nFirst > 0

      If ::IsColVisible( nFirst )

         ::nCell := nFirst
         ::HiLiteCell( ::nCell )

         If ! ::lAutoEdit
            ::DrawSelect()
         Else
            ::DrawLine()
         EndIf

      Else

         While ! ::IsColVisible( nFirst ) .and. ::nColPos < nFirst
            ::nColPos ++
         EndDo

         ::lNoPaint := .F.
         ::nCell := nFirst
         ::HiliteCell( nFirst )
         ::Refresh( .F. )

      EndIf

      If ::oHScroll != Nil
         ::oHScroll:SetPos( ::nCell )
      EndIf

      If ::aColumns[ ::nCell ]:bGotFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nCell ]:bGotFocus, ::nOldCell, ::nCell, Self )
      EndIf

      If ::aColumns[ ::nOldCell ]:bLostFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nOldCell ]:bLostFocus, ::nCell, ::nOldCell, Self )
      EndIf

      ::nOldCell := ::nCell
      Return Self

   EndIf

   Aeval( ::aColumns, { | oCol, nCol | ;
                        nFirst := If( ::IsEditable( nCol ) .and. nFirst == 0, ;
                                      nCol, nFirst ),HB_SYMBOL_UNUSED( oCol ) } )

   If nFirst == 0
      Return Self
   EndIf

   If ::IsColVisible( nFirst )
      ::nCell := nFirst
   Else

      ::nColPos := Min( nFirst, ::nFreeze + 1 )
      ::nCell   := nFirst

      While ::nColPos < ::nCell .and. ! ::IsColVisible( ::nCell )
         ::nColPos ++
      EndDo

      ::lNoPaint := .F.
      ::Refresh( .F. )

   EndIf

   ::HiliteCell( ::nCell )

   If( ::oHScroll != Nil, ::oHScroll:SetPos( ::nCell ), Nil )

   If ::aColumns[ ::nCell ]:bGotFocus != Nil .and. ::nOldCell != ::nCell
      Eval( ::aColumns[ ::nCell ]:bGotFocus, ::nOldCell, ::nCell, Self )
   EndIf

   If ::aColumns[ ::nOldCell ]:bLostFocus != Nil .and. ::nOldCell != ::nCell
      Eval( ::aColumns[ ::nOldCell ]:bLostFocus, ::nCell, ::nOldCell, Self )
   EndIf

   If ::lAutoEdit
      SysRefresh()
   EndIf

   ::nOldCell := ::nCell
   ::GoDown()

Return Self

// ============================================================================
// METHOD TSBrowse:GoPos() Version 7.0 Jul/15/2004
// ============================================================================

METHOD GoPos( nNewRow, nNewCol ) CLASS TSBrowse

   Local nSkip, cAlias, nRecNo, ;
         nTotRow := ::nRowCount(), ;
         nOldRow := ::nLogicPos(), ;
         nOldCol := ::nCell

   Default nNewRow := ::nLogicPos, ;
           nNewCol := ::nCell

   ::lNoPaint := ::lFirstFocus := .F.

   If ValType( nNewRow ) != "N" .or. ValType( nNewCol ) != "N" .or. ;
      nNewCol > Len( ::aColumns ) .or. nNewRow > ::nLen .or. ;
      nNewCol <= 0 .or. nNewRow <= 0

      Tone ( 500, 1 )
      Return Nil

   EndIf

   cAlias := ::cAlias

   nSkip := nNewRow - nOldRow

   If ( ::nRowPos + nSkip ) <= nTotRow .and. ( ::nRowPos + nSkip ) >= 1

      ::Skip( nSkip )
      ::nRowPos += nSkip

   ElseIf ! ::lIsDbf
      ::nAt := nNewRow
   ElseIf Empty( ::nLogicPos() )

      While ::nAt != nNewRow

         If ::nAt < nNewRow
            ::Skip( 1 )
         Else
            ::Skip( -1 )
         EndIf

      EndDo

   ElseIf ! Empty( ::nLogicPos() )

      ( cAlias )->( DbSkip( nSkip ) )
      ::nAt := ::nLogicPos()

   Else
      ( cAlias )->( Eval( ::bGoToPos, nNewRow ) )
      ::nAt := ::nLogicPos()
   EndIf

   If nNewRow != nOldRow .and. ::nLen > nTotRow .and. nNewRow > nTotRow

      If ::lIsDbf

         nRecNo := ( cAlias )->( RecNo() )

         ( cAlias )->( DbSkip( nTotRow - ::nRowPos ) )

         If ( cAlias )->( EoF() )

            Eval( ::bGoBottom )
            ::nRowPos := nTotRow

            While ::nRowPos > 1 .and. ( cAlias )->( RecNo() ) != nRecNo
               ::Skip( -1 )
               ::nRowPos --
            EndDo

         Else
            ( cAlias )->( DbGoTo( nRecNo ) )
         EndIf

      Else

         If ( ::nAt + nTotRow - ::nRowPos ) > ::nLen

            Eval( ::bGoBottom )
            ::nRowPos := nTotRow

            While ::nRowPos > 1 .and. ::nAt != nNewRow
               ::Skip( -1 )
               ::nRowPos --
            EndDo

         EndIf

      EndIf

   ElseIf nNewRow != nOldRow .and. ::nLen > nTotRow

      If ::lIsDbf

         nRecNo := ( cAlias )->( RecNo() )
         Eval( ::bGoTop )
         ::nRowPos := ::nAt := 1

         While ::nRowPos < nTotRow .and. ( cAlias )->( RecNo() ) != nRecNo
            ::Skip( 1 )
            ::nRowPos ++
         EndDo

      Else

         Eval( ::bGoTop )
         ::nRowPos := ::nAt := 1

         While ::nRowPos < nTotRow .and. ::nAt != nNewRow
            ::Skip( 1 )
            ::nRowPos ++
         EndDo

      EndIf

   EndIf

   If nNewCol != nOldCol

      While ! ::IsColVisible( nNewCol ) .and. ::nColpos >= 1 .and. ::nColPos < Len( ::aColumns )

         If nNewCol < ::nCell
            ::nColPos --
         Else
            ::nColPos ++
         EndIf

      EndDo

   EndIf

   ::nCell := nNewCol
   ::HiliteCell( ::nCell )
   ::Refresh( .F. )

   If ::bChange != Nil .and. nNewRow != nOldRow
      Eval( ::bChange, Self, 0 )
   EndIf

   If ::oVScroll != Nil .and. nNewRow != nOldRow
      ::oVScroll:SetPos( ::RelPos( ::nLogicPos() ) )
   EndIf

   If ::oHScroll != Nil .and. nNewCol != nOldCol
      ::oHScroll:SetPos( nNewCol )
   EndIf

   ::lHitTop := ::nAt == 1

   If ::lIsArr .and. ::bSetGet != Nil
      If ValType( Eval( ::bSetGet ) ) == "N"
         Eval( ::bSetGet, ::nAt )
      ElseIf ::nLen > 0
         Eval( ::bSetGet, ::aArray[ ::nAt, 1 ] )
      Else
         Eval( ::bSetGet, "" )
      EndIf
   EndIf

Return Nil

* ============================================================================
* METHOD TSBrowse:GoRight() Version 7.0 Jul/15/2004
* ============================================================================

METHOD GoRight() CLASS TSBrowse

   Local nTxtWid, nWidth, nCell, nSkip, ;
         lRefresh := .F.

   ::nOldCell := ::nCell
   nWidth   := ::nWidth() - If( ::oVScroll != Nil, 16, 0 )

   If ::lIsTxt
      nTxtWid := Max( 1, GetTextWidth( 0, "B", If( ::hFont != nil, ::hFont, 0 ) ) )
      If ::nOffset < ::oTxtFile:nMaxLineLength - Int( nWidth / nTxtWid )
         ::nOffset += 5
         ::Refresh( .F. )
         If ::oHScroll != Nil
            ::oHScroll:SetPos( ::nOffset )
         EndIf
      EndIf
        Return Self
   EndIf

   ::ResetSeek()

   If ::lCellBrw

      If ::nCell == Len( ::aColumns ) .and. ;  // avoid undesired displacement  //::GetColSizes()
         ::IsColVisible( ::nCell )
         Return Self
      EndIf

      nCell := ::nCell
      nSkip := 0

      While nCell < Len( ::aColumns )
         nCell ++
         nSkip ++
         If nCell <= Len( ::aColumns ) .and. ! ::aColumns[ nCell ]:lNoHilite
            Exit
         EndIf
      EndDo

      If nCell > Len( ::aColumns )
         Return Self
      EndIf

      While nSkip > 0
         ::nCell ++
         nSkip --
      EndDo

      While ! ::IsColVisible( ::nCell ) .and. ::nColPos < ::nCell
         ::nColPos ++
         lRefresh := .T.
      EndDo

      ::HiliteCell( ::nCell )

      If ::aColumns[ ::nCell ]:bGotFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nCell ]:bGotFocus, ::nOldCell, ::nCell, Self )
      EndIf

      If ::aColumns[ ::nOldCell ]:bLostFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nOldCell ]:bLostFocus, ::nCell, ::nOldCell, Self )
      EndIf

      If lRefresh
         ::lNoPaint := .F.
         ::Refresh( .F. )
      ElseIf ! ::lEditing
         ::DrawSelect()
      EndIf

      If( ::oHScroll != Nil, ::oHScroll:SetPos( ::nCell ), Nil )

      ::nOldCell := ::nCell
      If ::aColumns[ ::nCell ]:lVisible == .F.
         If ::nCell == Len( ::aColumns )
            ::GoLeft()
         Else
            ::GoRight()
         EndIf
      endif

   Else

      If ::nCell == Len( ::aColumns ) .and. ;  // avoid undesired displacement  //::GetColSizes()
         ::IsColVisible( ::nCell )
         Return Self
      EndIf

      If ::oHScroll != Nil
         ::HScroll( SB_PAGEDOWN )
      EndIf

   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:GotFocus() Version 7.0 Jul/15/2004
* ============================================================================

METHOD GotFocus( hCtlLost ) CLASS TSBrowse

   Local cMsg

   Default ::lPostEdit   := .F., ;
           ::lFirstFocus := .T., ;
           ::lNoPaint   := .F.

   If ::lEditing .or. ::lPostEdit
      Return 0
   EndIf

   ::lFocused       := .T.

   ::oWnd:hCtlFocus := ::hWnd

   If ::bGotFocus != nil
      Eval( ::bGotFocus, Self, hCtlLost )
   EndIf

   If ::lIsDbf .and. ::lPainted .and. ! ::lFirstFocus .and. ! ::lNoResetPos .and. ;
      ! ::lValidating .and. ! ::lNoPaint .and. ! ::lCanAppend

      If ::uLastTag != Nil
         ( ::cAlias )->( Eval( ::bTagOrder, ::uLastTag ) )
      EndIf

      ( ::cAlias )->( DbGoTo( ::nLastPos ) )
      ::nAt := ::nLastnAt

   ElseIf ::lIsDbf .and. ::lFirstFocus .and. ! ::lNoResetPos .and. ! ::lValidating

      If ::lPainted
         ::GoTop()
      Else
         ( ::cAlias )->( Eval( ::bGoTop ) )
      EndIf

      ::nLastPos := ( ::cAlias )->( RecNo() )
      ::nAt := ::nLastnAt := 1

   ElseIf ::lFirstFocus .and. ! ::lValidating  .and. ! ::lNoResetPos    //JP 1.70

      If ::lPainted
         ::GoTop()
      Else
         If ::lIsDbf
            ( ::cAlias )->( Eval( ::bGoTop ) )
         Else
            Eval( ::bGoTop )
         EndIf
      EndIf

   EndIf

   ::lFirstFocus := .F.

   If ::nLen > 0 .and. ! EmptyAlias( ::cAlias ) .and. ! ::lIconView .and. ;
      ::lPainted .and. ! ::lNoPaint
      ::DrawSelect()
   EndIf

   ::lHasFocus   := .T.
   ::lValidating := .F.

   If ::lCellBrw .and. ::lPainted
      cMsg := If( ! Empty( ::AColumns[ ::nCell ]:cMsg ), ;
                  ::AColumns[ ::nCell ]:cMsg, ::cMsg )
      cMsg := If( ValType( cMsg ) == "B", Eval( cMsg, Self, ::nCell ), cMsg )
      ::SetMsg( cMsg )
   EndIf

Return 0

* ============================================================================
* METHOD TSBrowse:GoTop() Version 7.0 Jul/15/2004
* ============================================================================

METHOD GoTop() CLASS TSBrowse

   Local nAt     := ::nAt, ;
         nLines  := ::nRowCount

   If ::nLen == 0
      ::nLen := If( ::lIsDbf, ( ::cAlias )->( Eval( ::bLogicLen ) ), ;
                    Eval( ::bLogicLen ) )
   EndIf

   If ::nLen < 1
      Return Self
   EndIf

   ::lAppendMode := .F.
   ::ResetSeek()

   If ! ::lHitTop

      If ::lPainted .and. nAt < nLines
         ::DrawLine()
      EndIf

      Eval( ::bGoTop )

      ::lHitBottom := .F.
      ::nRowPos    := ::nAt := ::nLastnAt := 1
      ::lHitTop    := .T.

      If ::lIsDbf
         ::nLastPos := ( ::cAlias )->( RecNo() )
      EndIf

      If ::lPainted
         If nAt < nLines
            ::DrawSelect()
         Else
            ::Refresh( ::nLen < nLines )
         EndIf
      EndIf

      If ::oVScroll != Nil
         ::oVScroll:GoTop()
      EndIf

      If ::lPainted .and. ::bChange != Nil
         Eval( ::bChange, Self, VK_UP )
      EndIf

      If ::lIsArr .and. ::bSetGet != Nil
         If ValType( Eval( ::bSetGet ) ) == "N"
            Eval( ::bSetGet, ::nAt )
         ElseIf ::nLen > 0
            Eval( ::bSetGet, ::aArray[ ::nAt, 1 ] )
         Else
            Eval( ::bSetGet, "" )
         EndIf
      EndIf

        ::HiliteCell( ::nCell )

   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:GoUp() Version 7.0 Jul/15/2004
* ============================================================================

METHOD GoUp() CLASS TSBrowse

   Local nSkipped, ;
         nLines := ::nRowCount()

   If ::nLen < 1

      If ::lCanAppend .and. ::lAppendMode        // append mode being canceled
         ::lAppendMode := ::lHitBottom := .F.
            ::nRowPos--                             // for empty dbfs
      Else
          Return Self
      EndIf

   EndIf

   ::ResetSeek()

   If ::nLen <= nLines .and. ::lNoLiteBar
      Return Self
   EndIf

   If ::lNoLiteBar
      nSkipped := 1 - ::nRowPos
      ::Skip( nSkipped )
      ::nRowPos := 1
   EndIf

   If ::lAppendMode .and. ::lFilterMode .and. ::nPrevRec != Nil
      ( ::cAlias )->( DbGoTo( ::nPrevRec ) )
   EndIf

   If ! ::lHitTop

      If ! ::lAppendMode

         ::DrawLine()
      EndIf

      If ::Skip( -1 ) == -1

         ::lHitBottom := .F.

         If ::nRowPos > 1

            If ! ::lAppendMode .or. ( ::lAppendMode .and. ::nLen < nLines )
               ::nRowPos--
            EndIf

            If ::lAppendMode

               If ::lFilterMode
                  ::Skip( 1 )
               EndIf

               ::Refresh( If( ::nLen < nLines, .T., .F. ) )
               ::HiliteCell( ::nCell )

            EndIf

         Else

            If ::lPageMode
               ::nRowPos := nLines
               ::Refresh( .F. )
            Else
               ::lRePaint := .F.
               ::TSBrwScroll( -1 )
            EndIf

         EndIf

      ElseIf ! ::lAppendMode
         ::lHitTop := .T.
      EndIf

      ::DrawSelect()

      If ::oVScroll != Nil .and. ! ::lAppendMode
         ::oVScroll:SetPos( ::RelPos( ::nLogicPos() ) )
      EndIf

      If ::bChange != Nil
         Eval( ::bChange, Self, VK_UP )
      EndIf

   EndIf

   ::lAppendMode := .F.
   ::nPrevRec := Nil

Return Self

* ==============================================================================
* METHOD TSBrowse:KeyChar()  Version 7.0 Jul/15/2004
* ==============================================================================

METHOD KeyChar( nKey, nFlags )  CLASS TSBrowse

   /* Next lines were added to filter keys according with
      the data type of columns to start editing cells. Also were defined
      two static functions IsChar() and IsNumeric() to do the job */

   Local cComp, lProcess, cTypeCol
   Local ix, uVal

   Default ::nUserKey := nKey

   If ::nUserKey == 255  // from KeyDown() method
      Return 0
   EndIf

   If ::lAppendMode
      Return 0
   EndIf

   ::lNoPaint := .F.
   cTypeCol := iif( ::nLen == 0, "U", ValType( Eval( ::aColumns[ ::nCell ]:bData ) ) ) // Modificado por Carlos

   If Upper( ::aMsg[ 1 ] ) == "YES"
      cComp := "TFYN10"
   else
      cComp := "TF10" + SubStr( ::aMsg[ 1 ], 1, 1 ) + SubStr( ::aMsg[ 2 ], 1, 1 )
   EndIf

   lProcess := IF(( cTypeCol == "C" .or. cTypeCol == "M") .and. _IsChar( nKey ), .T., ;
               IF(( cTypeCol == "N" .or. cTypeCol == "D") .and. _IsNumeric( nKey ), .T., ;
               IF( ( cTypeCol == "L" .and. Upper( Chr( nKey ) ) $ cComp ) .or. ;
                   ( cTypeCol == "L" .and. ::aColumns[ ::nCell ]:lCheckBox .and. nKey == VK_SPACE ), .T., .F. ) ) )

   // here we process direct cell editing with keyboard, not just the Enter key !
   If lProcess .and. ::IsEditable( ::nCell ) .and. ! ::aColumns[ ::nCell ]:lSeek

      If ::aColumns[ ::nCell ]:bPrevEdit != Nil

         uVal := Eval( ::aColumns[ ::nCell ]:bData )
         uVal := Eval( ::aColumns[ ::nCell ]:bPrevEdit, uVal )

         If ValType( uVal ) == "L" .and. ! uVal
            Return 0
         EndIf

      EndIf

      If ::aColumns[ ::nCell ]:oEdit == Nil
         ::Edit( , ::nCell, nKey, nFlags )
      Else

         ix := ::aColumns[ ::nCell ]:oEdit:Atx
         IF ix > 0
            PostMessage( _HMG_SYSDATA [ 3 ] [ix], WM_CHAR, nKey, nFlags )
         endif

      EndIf

   ElseIf ::aColumns[ ::nCell ]:lSeek .and. ( nKey >= 32 .or. nKey == VK_BACK )
      ::Seek( nKey )
   ElseIf lProcess .and. ::lEditableHd .and. nKey >= 32
      If ::aColumns[ ::nCell ]:oEditSpec == Nil
         IF ::IsEditable( ::nCell )
            ::Edit( , ::nCell, nKey, nFlags )
         endif
      Else
         ix := ::aColumns[ ::nCell ]:oEditSpec:Atx
         IF ix > 0
            PostMessage( _HMG_SYSDATA [ 3 ] [ix], WM_CHAR, nKey, nFlags )
         endif
      EndIf
   Else
      Super:KeyChar( nKey, nFlags )
   EndIf

Return 0

* ============================================================================
* METHOD TSBrowse:KeyDown() Version 7.0 Jul/15/2004
* ============================================================================

METHOD KeyDown( nKey, nFlags ) CLASS TSBrowse

   Local uTemp, uVal, uReturn, cType, ;
         lEditable := .F., ;
         nFireKey  := ::nFireKey, ;
         nCol      := ::nCell

   Default nFireKey := VK_F2

   ::lNoPaint := .F.
   ::oWnd:nLastKey := ::nLastKey := ::nUserKey := nKey

   If ::bUserKeys != Nil

      uReturn := Eval( ::bUserKeys, nKey, nFlags, Self )

      If uReturn != Nil .and. ValType( uReturn ) == "N" .and. ;
         uReturn < 200      // interpreted as a virtual key code to change
         nKey := uReturn    // the original key pressed
      ElseIf uReturn != Nil .and. ValType( uReturn ) == "L" .and. ;
             ! uReturn
                            // want to inhibit the KeyDown and KeyChar
         ::nUserKey := 255  // Methods for key pressed
         Return 0

      EndIf

   EndIf

   lEditable := ::IsEditable( nCol )

   If ! lEditable .and. ::lCanAppend
      AEval( ::aColumns, { |o,n| If( ::IsEditable( n ), lEditable := .T., Nil ),HB_SYMBOL_UNUSED( o ) } )
   EndIf

   Do Case                                       // Maintain Clipper behavior for key navigation
      Case ::lIgnoreKey( nKey, nFlags )          // has to go before any other case statement

           ::SuperKeyDown( nKey, nFlags )

      Case _GetKeyState( VK_CONTROL ) .and. ;     // Ctrl+Shift+key
            _GetKeyState( VK_SHIFT )

         If nKey == VK_RIGHT                     // Ctrl+Shift+Right Arrow
            ::aColumns[ nCol ]:nEditMove := DT_MOVE_RIGHT
         ElseIf nKey == VK_DOWN                  // Ctrl+Shift+Down Arrow
            ::aColumns[ nCol ]:nEditMove := DT_MOVE_DOWN
         ElseIf nKey == VK_UP                    // Ctrl+Shift+Up Arrow
            ::aColumns[ nCol ]:nEditMove := DT_MOVE_UP
         ElseIf nKey == VK_LEFT                  // Ctrl+Shift+Left Arrow
            ::aColumns[ nCol ]:nEditMove := DT_MOVE_LEFT
         EndIf

      Case _GetKeyState( VK_CONTROL )

         If nKey == VK_HOME                      // Ctrl+Home
               ::GoTop()
                ::PanHome()
         ElseIf nKey == VK_END                   // Ctrl+End
            If ::lHitBottom
               ::PanEnd()
            Else
               ::GoBottom()
            EndIf
         ElseIf nKey == VK_PRIOR                 // Ctrl+PgUp
              ::GoTop()
         ElseIf nKey == VK_NEXT                  // Ctrl+PgDn
              ::GoBottom()
         ElseIf nKey == VK_LEFT                  // Ctrl+Left
                ::PanLeft()
         ElseIf nKey == VK_RIGHT                 // Ctrl+Right
                ::PanRight()
            Else
                ::SuperKeyDown( nKey, nFlags )
         EndIf

      Case _GetKeyState( VK_SHIFT ) .and. nKey < 48 .and. nKey != VK_SPACE

         If nKey == VK_HOME                      // Shift+Home
                ::PanHome()
         ElseIf nKey == VK_END                   // Shift+End
                ::PanEnd()

         ElseIf ( nKey == VK_DOWN .or. nKey == VK_UP ) .and. ::lCanSelect

            uVal := If( ::lIsDbf, ( ::cAlias )->( RecNo() ), ::nAt )

            If ( uTemp := AScan( ::aSelected, uVal ) ) > 0
               ADel( ::aSelected, uTemp )
               ASize( ::aSelected, ( Len( ::aSelected ) - 1 ) )
               ::DrawSelect()
               If ::bSelected != Nil
                  Eval( ::bSelected, Self, uVal, .F. )
               EndIf
            Else
               AAdd( ::aSelected, uVal )
               ::DrawSelect()
               If ::bSelected != Nil
                  Eval( ::bSelected, Self, uVal, .T. )
               EndIf
            EndIf

            If nKey == VK_UP
               ::GoUp()
            ElseIf nKey == VK_DOWN
               ::GoDown()
            EndIf

         Else
            ::SuperKeyDown( nKey, nFlags )
         EndIf

      Case nKey == VK_HOME

         ::GoHome()

      Case nKey == VK_END

         ::GoEnd()

      Case ::lEditableHd .and. ( nKey == VK_RETURN .or. nKey == nFireKey ) .and. ::nColSpecHd != 0

         uVal  := ::aColumns[ ::nColSpecHd ]:cSpcHeading
         uTemp := ::aColumns[ ::nColSpecHd ]:cSpcHeading

         nCol := ::nColSpecHd
         If Empty(uTemp)
            cType := ValType( Eval( ::aColumns[ nCol ]:bData ) )
            If cType $ "CM"
               uTemp := Space( Len( Eval( ::aColumns[ nCol ]:bData ) ) )
            ElseIf cType == "N"
               uTemp := 0
            ElseIf cType == "D"
               uTemp := CToD( "" )
            ElseIf cType == "L"
               uTemp := .F.
            EndIf
         endif

         If Empty(uTemp) .and. .f.
            IF ::lIsArr

               If ::aDefault != Nil

                  If Len( ::aDefault ) < Len( ::aColumns )
                     ASize( ::aDefault, Len( ::aColumns ) )
                  EndIf

                  uTemp := If( ::aDefault[ nCol ] == Nil, ;
                            If( ::aDefValue[ 1 ] == Nil, ;
                                ::aDefValue[ nCol + 1 ], ;
                                ::aDefValue[ nCol ] ), ;
                        If( ValType( ::aDefault[ nCol ] ) == "B", ;
                           Eval( ::aDefault[ nCol ] ), ::aDefault[ nCol ] ) )
               Else
                  uTemp := If( nCol <= Len( ::aDefValue ), ;
                            ::aDefValue[ nCol ], Space( 10 ) )
                  cType := ValType( Eval( ::aColumns[ nCol ]:bData ) )
                  If cType $ "CM"
                     uTemp := Space( Len( Eval( ::aColumns[ nCol ]:bData ) ) )
                  ElseIf cType == "N"
                     uTemp := 0
                  ElseIf cType == "D"
                      uTemp := CToD( "" )
                  ElseIf cType == "L"
                      uTemp := .F.
                  EndIf
               EndIf

            ELSE
               IF ::aDefault != Nil

                  If Len( ::aDefault ) < Len( ::aColumns )
                     ASize( ::aDefault, Len( ::aColumns ) )
                  EndIf

                  uTemp := If( ::aDefault[ nCol ] != Nil, ;
                     If( ValType( ::aDefault[ nCol ] ) == "B", ;
                         Eval( ::aDefault[ nCol ] ), ::aDefault[ nCol ] ), ;
                         Eval( ::aColumns[ nCol ]:bData ) )
               ELSE
                  cType := ValType( Eval( ::aColumns[ nCol ]:bData ) )
                  If cType $ "CM"
                     uTemp := Space( Len( Eval( ::aColumns[ nCol ]:bData ) ) )
                  ElseIf cType == "N"
                     uTemp := 0
                  ElseIf cType == "D"
                      uTemp := CToD( "" )
                  ElseIf cType == "L"
                      uTemp := .F.
                  EndIf

               ENDIF
            endif
         EndIf
         If  ::nColSpecHd != 0
            ::Edit( uTemp, nCol, nKey, nFlags )
         endif

      Case lEditable .and. ( nKey == VK_RETURN .or. nKey == nFireKey )

         If nKey == nFireKey
            nKey := VK_RETURN
         EndIf

         IF ::nColSpecHd != 0
            RETURN 0
         ENDIF

         If ::nRowPos == 0

            If ::nLen == 0 .and. ! ::lCanAppend
               Return 0
            EndIf

         EndIf

         ::oWnd:nLastKey := nKey

         If ::aColumns[ nCol ]:bPrevEdit != Nil

            If ::lIsArr .and. ( ::lAppendMode .or. ::nAt > Len( ::aArray ) ) // append mode for arrays
            Else  // GF 16-05-2008
               uVal := Eval( ::aColumns[ nCol ]:bData )
               uVal := Eval( ::aColumns[ nCol ]:bPrevEdit, uVal )

               If ValType( uVal ) == "L" .and. ! uVal
                  Return 0
               EndIf
            EndIf

         EndIf

         If ::lAppendMode .and. ::lIsArr

            If ::aDefault != Nil

               If Len( ::aDefault ) < Len( ::aColumns )
                  ASize( ::aDefault, Len( ::aColumns ) )
               EndIf

               uTemp := If( ::aDefault[ nCol ] == Nil, ;
                            If( ::aDefValue[ 1 ] == Nil, ;
                                ::aDefValue[ nCol + 1 ], ;
                                ::aDefValue[ nCol ] ), ;
                        If( ValType( ::aDefault[ nCol ] ) == "B", ;
                           Eval( ::aDefault[ nCol ] ), ::aDefault[ nCol ] ) )
            Else
               uTemp := If( nCol <= Len( ::aDefValue ), ;
                            ::aDefValue[ nCol ], Space( 10 ) )
            EndIf

         ElseIf ::lAppendMode .and. ::aDefault != Nil

            If Len( ::aDefault ) < Len( ::aColumns )
               ASize( ::aDefault, Len( ::aColumns ) )
            EndIf

            uTemp := If( ::aDefault[ nCol ] != Nil, ;
                     If( ValType( ::aDefault[ nCol ] ) == "B", ;
                         Eval( ::aDefault[ nCol ] ), ::aDefault[ nCol ] ), ;
                         Eval( ::aColumns[ nCol ]:bData ) )
         Else
            uTemp := Eval( ::aColumns[ nCol ]:bData )
         EndIf

         If  ::IsEditable( nCol )        // JP v.1.1
            ::Edit( uTemp, nCol, nKey, nFlags )
         endif

      Case nKey == VK_UP

           ::GoUp()

      Case nKey == VK_DOWN

           ::GoDown()

      Case nKey == VK_LEFT

           ::GoLeft()

      Case nKey == VK_RIGHT

           ::GoRight()

      Case nKey == VK_PRIOR
           nKeyPressed := .T.
           ::PageUp()

        Case nKey == VK_NEXT

           nKeyPressed := .T.
           ::PageDown()

      Case nKey == VK_DELETE .and. ::lCanDelete

           ::DeleteRow()

      Case nKey == VK_CONTEXT .and. nFlags == 22872065

           If ::bContext != Nil
              Eval( ::bContext, ::nRowPos, ::nColPos, Self )
           EndIf

      Otherwise

           ::SuperKeyDown( nKey, nFlags )

   EndCase

Return 0

* ============================================================================
* METHOD TSBrowse:KeyUp() Version 7.0 Jul/15/2004
* ============================================================================

METHOD KeyUp( nKey, nFlags ) CLASS TSBrowse

   If lNoAppend != Nil
      ::lCanAppend := .T.
      lNoAppend := Nil
   EndIf

   If nKeyPressed != Nil

      ::Refresh( .F. )
      nKeyPressed := Nil

      If ::bChange != Nil
         Eval( ::bChange, Self, nKey )
      EndIf

   EndIf

Return  Super:KeyUp( nKey, nFlags )

* ============================================================================
* METHOD TSBrowse:LButtonDown() Version 7.0 Jul/15/2004
* ============================================================================

METHOD LButtonDown( nRowPix, nColPix, nKeyFlags ) CLASS TSBrowse

   Local nClickRow, nSkipped, nI, lHeader, lFooter, nIcon, nAtCol, bLClicked, lMChange, lSpecHd, ;
         nColPixPos := 0, ;
         uPar1    := nRowPix, ;
         uPar2    := nColPix, ;
         nColInit := ::nColPos - 1, ;
         lDrawRow := .F., ;
         lDrawCol := .F., ;
         nLines   := ::nRowCount(), ;
         nCol     := 0, ;
         oCol, nKey, ix

   ::lNoPaint := .F.

   If ::nFreeze > 0

      For nI := 1 To ::nFreeze
         nColPixPos += ::GetColSizes()[ nI ]
      Next

   EndIf

   nClickRow := ::GetTxtRow( nRowPix )
   nAtCol    := Max( ::nAtCol( nColPix ), 1 )   // JP 1.31
   lHeader   := ( nClickRow == 0 .and. ::lDrawHeaders )
   lFooter   := nClickRow == -1 .and. If( ::lDrawFooters != Nil, ::lDrawFooters, .F. )
   lSpecHd   := nClickRow == -2 .and. if( ::lDrawSpecHd != Nil, ::lDrawSpecHd , .F. )
   ::oWnd:nLastKey := 0
   If ::oWnd:hCtlFocus != Nil .and. ::oWnd:hCtlFocus != ::hWnd
      If  nClickRow == -2 .and. ::nColSpecHd > 0
         oCol := ::oWnd:aColumns[ ::nColSpecHd ]
      else
         oCol := ::oWnd:aColumns[ ::oWnd:nCell ]
      endif
      If oCol:oEdit != Nil
// JP 1.40-64
         IF (nClickRow  == ::nRowPos .AND. nAtCol == ::oWnd:nCell) .or. ;
             (nClickRow == -2 .and. ::lDrawSpecHd .AND. nAtCol == ::nColSpecHd )

            DO CASE
            CASE "TSMULTI" $ Upper( oCol:oEdit:ClassName() )
               RETURN 0
            CASE "TCOMBOBOX" $ Upper( oCol:oEdit:ClassName() )
               PostMessage( ::oWnd:hCtlFocus, WM_LBUTTONDOWN, nKeyFlags, nMakeLong( nColPix - nCol, nRowPix ) )
               RETURN 0
            CASE "TBTNBOX" $ Upper( oCol:oEdit:ClassName() )       // JP 1.64
               PostMessage( ::oWnd:hCtlFocus, WM_LBUTTONDOWN, nKeyFlags, nMakeLong( nColPix - nCol, nRowPix ) )
               RETURN 0
            OTHERWISE
               ix := GetControlIndex ( ::cChildControl, ::cParentWnd )
               IF ix > 0
                  nCol := _HMG_SYSDATA [ 19 ] [ix]
               endif
               IF nCol > nColPix
                   nCol := 0
               endif
               PostMessage( ::oWnd:hCtlFocus, WM_LBUTTONDOWN, nKeyFlags, nMakeLong( nColPix - nCol, nRowPix)  )
               RETURN 0
            ENDCASE
         Else
            DO case
            CASE  "TSMULTI" $ Upper( oCol:oEdit:ClassName() )
               nKey := VK_ESCAPE
/* Remark 1.43
               IF oCol:oEdit:lChanged
                  If MsgYesNo( ::aMsg[ 39 ],  ::aMsg[ 32 ] )
                     nKey :=  VK_RETURN
                  ENDIF
               ENDIF
*/
               Eval( oCol:oEdit:bLostFocus , nKey )
            CASE  "TBTNBOX" $ Upper( oCol:oEdit:ClassName() )
               If oCol:oEdit:bLostFocus != Nil
                  Eval( oCol:oEdit:bLostFocus , VK_ESCAPE )
               Else
                  Eval( oCol:oEdit:bKeyDown , VK_ESCAPE, 0, .t. )
               EndIf
            OTHERWISE
               If oCol:oEdit:bLostFocus != Nil
                  Eval( oCol:oEdit:bLostFocus , VK_ESCAPE )
               EndIf
            ENDCASE
            SetFocus( ::hWnd )
            ::Refresh( .T. )
         ENDIF
//end
      EndIf
   EndIf

   If ::lIconView

      If ( nIcon := ::nAtIcon( nRowPix, nColPix ) ) != 0
         ::DrawIcon( nIcon )
      EndIf

      Return Nil

   EndIf

   ::SetFocus()
   If ::nLen < 1 .or. ::lIsTxt

      If ! ::lCanAppend .or. ::lIsTxt
         Return 0
      ElseIf nClickRow > 0
         ::PostMsg( WM_KEYDOWN, VK_DOWN, nMakeLong( 0, 0 ) )
         Return 0
      EndIf

   EndIf

   If lHeader  .and. Valtype( nKeyFlags ) == "N"

      lMChange   := ::lMChange
      ::lMChange := .F.

      If ::nHeightSuper == 0 .or. ( ::nHeightSuper > 0 .and. nRowPix >= ::nHeightSuper )
         ::DrawPressed( nAtCol )
      EndIf

      If ::aActions != Nil .and. nAtCol <= Len( ::aActions )

         If ::aActions[ nAtCol ] != nil
            ::DrawHeaders()
            Eval( ::aActions[ nAtCol ], Self, uPar1, uPar2 )

            If ::oWnd:hCtlFocus != Nil .and. ::oWnd:hCtlFocus != ::hWnd
               Return 0
            EndIf

            ::DrawHeaders()
         EndIf

      EndIf
/*
      If ::aColumns[ nAtCol ]:bHLClicked != Nil
         ::DrawHeaders()
         Eval( ::aColumns[ nAtCol ]:bHLClicked, uPar1, uPar2, ::nAt )

         If ::oWnd:hCtlFocus != Nil .and. ::oWnd:hCtlFocus != ::hWnd
//            ReleaseCapture()
//            CursorArrow()
            Return 0
         EndIf

         ::DrawHeaders()
      EndIf
*/
      ::lMChange := lMChange

   ElseIf lFooter

      lMChange   := ::lMChange
      ::lMChange := .F.

      If ::aColumns[ nAtCol ]:bFLClicked != Nil

         Eval( ::aColumns[ nAtCol ]:bFLClicked, uPar1, uPar2, ::nAt )

         If ::oWnd:hCtlFocus != Nil .and. ::oWnd:hCtlFocus != ::hWnd
//            ReleaseCapture()
//            CursorArrow()
            Return 0
         EndIf

      EndIf

      ::lMChange := lMChange
      ::DrawFooters()

//  EndIf

   ELSEIF lSpecHd  .and. ::lEditableHd

      lMChange   := ::lMChange
      ::lMChange := .F.
      If ::aColumns[ nAtCol ]:bSLClicked != Nil

         Eval( ::aColumns[ nAtCol ]:bSLClicked, uPar1, uPar2, ::nAt )

         If ::oWnd:hCtlFocus != Nil .and. ::oWnd:hCtlFocus != ::hWnd
            Return 0
         EndIf
      Else
         IF ::lEditingHd
            oCol := ::oWnd:aColumns[ ::oWnd:nCell ]
            If oCol:oEditSpec != Nil
               ix := GetControlIndex ( ::cChildControl, ::cParentWnd )
               IF ix > 0
                  nCol := _HMG_SYSDATA [ 19 ] [ix]
               ENDIF
               IF nCol > nColPix
                   nCol := 0
               ENDIF
               PostMessage( ::oWnd:hCtlFocus, WM_LBUTTONDOWN, nKeyFlags, nMakeLong( nColPix - nCol, nRowPix) )
               RETURN 0
            EndIf
         endif
      EndIf

      ::lMChange := lMChange
      ::DrawHeaders()

   EndIf

   If ::lMChange .and. nClickRow == 0 .and. ! ::lNoMoveCols

      If AScan( ::GetColSizes(),;
                { | nColumn | nColPixPos += nColumn,;
                  nColInit++,;
                  nColPix >= nColPixPos - 2 .and. ;
                  nColPix <= nColPixPos + 2 }, ::nColPos ) != 0

         ::lLineDrag := .T.
         ::VertLine( nColPixPos, nColInit, nColPixPos - nColPix )

      Else
         ::lColDrag := .T.
         ::nDragCol := ::nAtCol( nColPix )
      EndIf

      If ! ::lCaptured
         ::lCaptured := .T.
         ::Capture()
      EndIf

   EndIf

   If nClickRow > 0 .and. nClickRow != ::nRowPos .and. ;
                          nClickRow < ( nLines + 1 )

      ::ResetSeek()
      ::DrawLine()

      nSkipped  := ::Skip( nClickRow - ::nRowPos )
      ::nRowPos += nSkipped

      If ::oVScroll != Nil
         ::oVScroll:SetPos( ::RelPos( ::nLogicPos() ) )
      EndIf

      lDrawRow      := .T.
      ::lHitTop     := .F.
      ::lHitBottom  := .F.
      ::lAppendMode := .F.

      If ::bChange != Nil
         Eval( ::bChange, Self, ::oWnd:nLastKey )  //oWnd
      EndIf

   EndIf

   If nClickRow > 0
      bLClicked := If( ::aColumns[ nAtCol ]:bLClicked != Nil, ;
                       ::aColumns[ nAtCol ]:bLClicked, ::bLClicked )

      If ! ( ::lLockFreeze .and. ::nAtCol( nColPix, .T. ) <= ::nFreeze )
         lDrawCol := ::HiliteCell( ::nCell, nColPix )
      EndIf

      If bLClicked != Nil
         Eval( bLClicked, uPar1, uPar2, nKeyFlags, Self )
      EndIf

      If ! ::lNoHScroll .and. ::oHScroll != Nil .and. lDrawCol
         ::oHScroll:SetPos( ::nCell )
      EndIf

   EndIf

   If lDrawRow .or. lDrawCol
      ::DrawSelect()
   EndIf

   If ::lCellBrw

      If ::aColumns[ ::nCell ]:bGotFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nCell ]:bGotFocus, ::nOldCell, ::nCell, Self )
      EndIf

      If ::aColumns[ ::nOldCell ]:bLostFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nOldCell ]:bLostFocus, ::nCell, ::nOldCell, Self )
      EndIf

      ::nOldCell := ::nCell

   EndIf

   ::lGrasp := ! lHeader   //.and. ! Empty( ::bDragBegin )

   If ::oWnd:hCtlFocus != Nil .and. ::oWnd:hCtlFocus == ::hWnd
      ::lMouseDown := .T.
   EndIf

Return 0

* ============================================================================
* METHOD TSBrowse:LButtonUp() Version 7.0 Jul/15/2004
* ============================================================================

METHOD LButtonUp( nRowPix, nColPix, nFlags ) CLASS TSBrowse

   Local nClickRow, nDestCol

   If nKeyPressed != Nil
      ::DrawPressed( nKeyPressed, .F. )
   EndIf

   If ::lCaptured

      ::lCaptured := .F.
      ReleaseCapture()

      If ::lLineDrag
        ::lLineDrag := .F.
        ::VertLine()
      Else
         ::lColDrag := .F.
         nClickRow := ::GetTxtRow( nRowPix )

         nDestCol := ::nAtCol( nColPix )

         // we gotta be on header row within listbox and not same colm
         If nClickRow == 0 .or. nClickRow == -2
            if  nColPix > ::nLeft .and. ;
                ::nDragCol != nDestCol

                If ::lMoveCols
                   ::MoveColumn( ::nDragCol, nDestCol )
                Else
                   ::Exchange( ::nDragCol, nDestCol )
                EndIf
            elseif ::nDragCol = nDestCol
                If ::aColumns[ nDestCol ]:bHLClicked != Nil
                   ::DrawHeaders()
                   Eval( ::aColumns[ nDestCol ]:bHLClicked, nRowPix, nColPix, ::nAt )
                   ::DrawHeaders()
               EndIf
            Endif
         EndIf
      EndIf
   EndIf

   ::lGrasp := .F.
   Super:LButtonUp( nRowPix, nColPix, nFlags )

Return 0

* ============================================================================
* METHOD TSBrowse:LDblClick() Version 7.0 Jul/15/2004
* ============================================================================

METHOD LDblClick( nRowPix, nColPix, nKeyFlags ) CLASS TSBrowse

   Local uTemp, uVal, ;
         nClickRow := ::GetTxtRow( nRowPix ), ;
         nCol      := Max(::nAtCol( nColPix ),1), ;
         uPar1     := nRowPix, ;
         uPar2     := nColPix

   ::oWnd:nLastKey := 0

   IF !::lEnabled
      RETURN Self
   endif

   If ( nClickRow == ::nRowPos .and. nClickRow > 0 ) .or. ;
      ( nClickRow == ::nRowPos .and. ! ::lDrawHeaders )

      If ::lCellBrw .and. ::IsEditable( nCol )

            ::nColSpecHd := 0
            If ValType( Eval( ::aColumns[ nCol ]:bData ) ) == "L" .and. ;
               ::aColumns[ nCol ]:lCheckBox  // virtual checkbox
               ::PostMsg( WM_CHAR, VK_SPACE, 0 )
            Else
               ::PostMsg( WM_KEYDOWN, VK_RETURN, 0 )
            EndIf

            Return 0

      ElseIf ::lCanSelect

         uVal := If( ::lIsDbf, ( ::cAlias )->( RecNo() ), ::nAt )

         If ( uTemp := AScan( ::aSelected, uVal ) ) > 0

            ADel( ::aSelected, uTemp )
            ASize( ::aSelected, ( Len( ::aSelected ) - 1 ) )
            ::DrawSelect()

            If ::bSelected != Nil
               Eval( ::bSelected, Self, uVal, .F. )
            EndIf

         Else

            AAdd( ::aSelected, uVal )
            ::DrawSelect()

            If ::bSelected != Nil
               Eval( ::bSelected, Self, uVal, .T. )
            EndIf

         EndIf

         If ::bLDblClick != Nil
            Eval( ::bLDblClick, uPar1, uPar2, nKeyFlags )
         EndIf

      ElseIf ::bLDblClick != Nil
         Eval( ::bLDblClick, uPar1, uPar2, nKeyFlags )
      EndIf

   ElseIf nClickRow == 0 .and. ::lDrawHeaders .and. ! ::lNoChangeOrd  // GF 1.71
      If ::bLDblClick != Nil .and. ::aActions == Nil
         Eval( ::bLDblClick, uPar1, uPar2, nKeyFlags )
      else
         ::SetOrder( ::nAtCol( nColPix, .T. ) )
      EndIf
   ElseIf nClickRow == -2 .and. ::lDrawSpecHd .and. ::aColumns[ nCol ]:lEditSpec
      If ::lAutoSearch .or. ::lAutoFilter
         ::nColSpecHd := nCol
         ::PostMsg( WM_KEYDOWN, VK_RETURN, 0 )
         Return 0
      EndIf
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:LoadFields() Version 7.0 Jul/15/2004
* ============================================================================

METHOD LoadFields( lEditable, aNames ) CLASS TSBrowse

   Local n, nE, cHeading, nAlign, nSize, aColSizes, cData, cType, nDec, hFont, ;
         cBlock, ;
         aAlign := { "LEFT", "CENTER", "RIGHT", "VERT" }, ;
         aStru  := ( ::cAlias )->( DbStruct() )

   Default lEditable := .T.

   aColSizes := If( Len( ::aColumns )  ==  Len( ::aColSizes ), ;
                    Nil, ::aColSizes )

   For n := 1 To ( If( aNames == Nil, ( ::cAlias )->( FCount() ), ;
                       Len( aNames ) ) )

      nE := If( aNames == Nil, n, FieldPos( aNames[ n ] ) )

      cHeading := If( ! ::aHeaders == Nil .and. Len( ::aHeaders ) >= nE, ;
                      ::aHeaders[ nE ], ;
                      ::Proper( ( ::cAlias )->( Field( nE ) ) ) )

      nAlign := If( ::aJustify != Nil .and. Len( ::aJustify ) >= nE, ;
                    ::aJustify[ nE ], ;
                    If( ( ::cAlias )->( ValType( FieldGet( nE ) ) ) == "N", 2, ;
                    If( ( ::cAlias )->( ValType( FieldGet( nE ) ) ) == "L", ;
                          1, 0 ) ) )

      nAlign := If( ValType( nAlign ) == "L", If( nAlign, 2, 0 ), ;
                If( ValType( nAlign ) == "C", AScan( aAlign, nAlign ) - 1, ;
                    nAlign ) )

      nSize := If( ! aColSizes == Nil .and. Len( aColsizes ) >= nE, ;
                     aColSizes[ nE ], Nil )

      If nSize == Nil
         cData := ( ::cAlias )->( FieldGet( nE ) )
         cType := aStru[ nE, 2 ]
         nSize := aStru[ nE, 3 ]
         nDec  := aStru[ nE, 4 ]
         hFont := If( ::hFont != Nil, ::hFont, 0 )

         If cType == "C"
            cData := PadR( Trim( cData ), nSize, "B" )
            nSize := GetTextWidth( 0, cData, hFont )
         ElseIf cType == "N"
            cData := StrZero( cData, nSize, nDec )
            nSize := GetTextWidth( 0, cData, hFont )
         ElseIf cType == "D"
            cData := cValToChar( If( ! Empty( cData ), cData, Date() ) )
            nSize := Int( GetTextWidth( 0, cData, hFont ) * 1.20 )  //1.15 )
         ElseIf cType == "M"
//            cData := cValToChar( cData )
            nSize := If( ::nMemoWV == Nil, 200, ::nMemoWV )
         Else
            cData := cValToChar( cData )
            nSize := GetTextWidth( 0, cData, hFont )
         EndIf

         nSize := Max( GetTextWidth( 0, Replicate( "B", Len( cHeading ) ), ;
                                     hFont ), nSize )

      EndIf

      cBlock := 'FieldWBlock("' + aStru[ nE, 1 ] + '",Select("' + ::cAlias + '"))'
      ::AddColumn( TSColumn():New( cHeading, ;
                                   FieldWBlock( aStru[ nE, 1 ], Select( ::cAlias ) ),, ;
                                   { ::nClrText, ::nClrPane }, { nAlign, DT_CENTER }, ;
                                   nSize,, lEditable,,,,,,, 5,,,, Self, cBlock ) )

      ATail( ::aColumns ):cData := ::cAlias + "->" + FieldName( nE )

   Next

   If ::nLen == 0
      ::nLen := Eval( ::bLogicLen )
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:nAtCol() Version 7.0 Jul/15/2004
* ============================================================================

METHOD nAtCol( nColPixel, lActual ) CLASS TSBrowse

   Local nColumn := ::nColPos - 1, ;
         aSizes  := ::GetColSizes(), ;
         nI      , ;
         nPos    := 0

   Default lActual := .F.

   If ::nFreeze > 0

      If lActual
         nColumn := 0
      Else
         For nI := 1 To ::nFreeze
            nPos += aSizes[ nI ]
         Next
      EndIf

   EndIf

   While nPos < nColPixel .and. nColumn < Len( aSizes )
      IF  ::aColumns[ nColumn+1 ]:lVisible
         nPos += aSizes[ nColumn + 1 ]
      endif
      nColumn++
   Enddo

Return nColumn

* ============================================================================
* METHOD TSBrowse:nAtIcon() Version 7.0 Jul/15/2004
* ============================================================================

METHOD nAtIcon( nRow, nCol ) CLASS TSBrowse

   Local nIconsByRow := Int( ::nWidth() / 50 )

   nRow -= 9
   nCol -= 1

   If ( nCol % 50 ) >= 9 .and. ( nCol % 50 ) <= 41
      return Int( ( nIconsByRow * Int( nRow / 50 ) ) + Int( nCol / 50 ) ) + 1
   Else
      return 0
   EndIf

Return Nil

* ============================================================================
* METHOD TSBrowse:nLogicPos() Version 7.0 Jul/15/2004
* ============================================================================

METHOD nLogicPos() CLASS TSBrowse

   Local cAlias, cOrderName, nLogicPos


   If ! ::lIsDbf

      If ::lIsTxt
         ::nAt := ::oTxtFile:RecNo()
      EndIf

      Return ::nAt

   EndIf

   cAlias := ::cAlias

   cOrderName := If( ::bTagOrder != Nil, ( cAlias )->( Eval( ::bTagOrder ) ), Nil )
   nLogicPos  := ( cAlias )->( Eval( ::bKeyNo, cOrderName ) )

   If ::lFilterMode
      nLogicPos := nLogicPos - ::nFirstKey
   EndIf

   nLogicPos := If( nLogicPos <= 0, ::nLen + 1, nLogicPos )

Return nLogicPos

* ============================================================================
* METHOD TSBrowse:HandleEvent() Version 7.0 Jul/15/2004      //JP
* ============================================================================

METHOD HandleEvent( nMsg, nWParam, nLParam ) CLASS TSBrowse

   Local nDelta, ix

   Default ::lNoPaint := .F.
   If nMsg == WM_SETFOCUS .and. ::lNoPaint
      Return 0
   ElseIf nMsg == WM_GETDLGCODE
      return ::GetDlgCode( nWParam )
   ElseIf nMsg == WM_KEYDOWN
      return ::KeyDown( nWParam, nLParam )
   ElseIf nMsg == WM_CHAR .and. ::lEditing
      Return 0
   ElseIf nMsg == WM_CHAR
      return ::KeyChar( nWParam, nLParam )
   ElseIf nMsg == WM_KEYUP
      Return ::KeyUp( nWParam, nLParam )
   Elseif nMsg == WM_HSCROLL
      Return ::HScroll( Loword( nWParam ), HiWord( nWParam ) )
   ElseIf nMsg == WM_VSCROLL
      if nLParam == 0
         Return ::VScroll( Loword( nWParam ), HiWord( nWParam ) )
      endif
   ElseIf nMsg == WM_ERASEBKGND .and. ! ::lEditing
      ::lNoPaint := .F.
   ElseIf nMsg == WM_DESTROY .and. ! Empty( ::aColumns ) .and. ;
      ::aColumns[ ::nCell ]:oEdit != Nil
      ix := ::aColumns[ ::nCell ]:oEdit:Atx
      IF ix > 0
         PostMessage( _HMG_SYSDATA [ 3 ]  [ix], WM_KEYDOWN, VK_ESCAPE, 0 )
      endif
   ElseIf nMsg == WM_LBUTTONDBLCLK
       Return ::LDblClick( HiWord( nLParam ), LoWord( nLParam ), nWParam )
   ElseIf nMsg == WM_MOUSEWHEEL
       If  ::hWnd != 0
           nDelta := Bin2I( I2Bin( HiWord( nWParam ) ) ) / 120
           ::MouseWheel( nMsg, nDelta, LoWord( nLParam ), HiWord( nLParam ) )
        EndIf

      Return 0

   EndIf

Return Super:HandleEvent( nMsg, nWParam, nLParam )

* ============================================================================
* METHOD TSBrowse:HiliteCell() Version 7.0 Jul/15/2004
* ============================================================================

METHOD HiliteCell( nCol, nColPix ) CLASS TSBrowse

   Local nI, nAbsCell, nRelCell, nNowPos, nOldPos, nLeftPix, ;
         lDraw := .F.,;
         lMove := .T.

    Default nCol := 1

   If ! ::lCellBrw .and. nColPix == Nil          // if not browsing cell-style AND no nColPix, ignore call.
      Return lDraw                               // nColPix NOT nil means called from ::LButtonDown()
   EndIf

   If nCol < 1
      nCol := 1
   ElseIf nCol > Len( ::aColumns )
      nCol := Len( ::aColumns )
   EndIf

    If Len( ::aColumns ) > 0

      If nColPix != Nil                           // used internally by ::LButtonDown() only
         nAbsCell := ::nAtCol( nColPix, .F. )
         nRelCell := ::nAtCol( nColPix, .T. )

         If nAbsCell >= ::nFreeze .and. nRelCell <= ::nFreeze
            nNowPos := nRelCell
         Else
            nNowPos := nAbsCell
         EndIf

         nOldPos := ::nCell

         If ::nFreeze > 0 .and. nOldPos < nNowPos  // frozen col and going right
            nNowPos := nAbsCell
            lMove := ( nOldPos > ::nFreeze )
         EndIf

         If nOldPos < nNowPos                    // going right
            nLeftPix := 0

            For nI := nOldPos To nNowPos - 1
               lDraw := .T.
               ::nCell ++
               nLeftPix += ::aColSizes[ nI ]       // we need to know pixels left of final cell...
            Next

            ::nCell := If( ::nCell > Len(::aColumns), Len(::aColumns), ::nCell )

            If ::nWidth() < nLeftPix + ::aColSizes[ ::nCell ] .and. ;  // ...and set ::nColPos accordingly
                  ::nColPos < Len( ::aColumns ) .and. lMove            //::GetColSizes()
                 ::nColPos ++
               ::Refresh( .F. )
            EndIf

         ElseIf nNowPos < nOldPos                // going left

            For nI := nNowPos To nOldPos - 1
               lDraw := .T.
               ::nCell --
            Next

            ::nCell := If( ::nCell < 1, 1, ::nCell )

         EndIf

         nCol := ::nCell

      Else

         lDraw := ! ( ::nCell == nCol )

         ::nColPos := Max( ::nFreeze + 1, ::nColPos )

         If ::nFreeze > 0 .and. ::lLockFreeze
            ::nCell := Max( nCol, ::nFreeze + 1 )
         ElseIf ::nCell != nCol
            ::nCell := nCol
         EndIf

         If ! ::lNoHScroll .and. ::oHScroll != Nil .and. lDraw

            ::oHScroll:SetPos( nCol )

            If ::lPainted
               ::Refresh( .F. )
            EndIf

         EndIf

      EndIf

      If ::lCellBrw
         // unhilite all columns EXCEPT those with "double cursor" (permanent) efect
         AEval( ::aColumns, { |oColumn| oColumn:lNoLite := ! oColumn:lFixLite } ) // allways .T. if no double cursor
         ::aColumns[ nCol ]:lNoLite := .F.
      EndIf

   EndIf

Return lDraw

* ============================================================================
* METHOD TSBrowse:HScroll() Version 7.0 Jul/15/2004
* ============================================================================

METHOD HScroll( nWParam, nLParam ) CLASS TSBrowse

   Local nCol

   ::lNoPaint := .F.

   If GetFocus() != ::hWnd
      SetFocus( ::hWnd )
   EndIf

    Do Case
    Case nWParam == SB_LINEUP
        ::GoLeft()

    Case nWParam == SB_LINEDOWN
        ::GoRight()

    Case nWParam == SB_PAGEUP
      ::PanLeft()

    Case nWParam == SB_PAGEDOWN
        nCol := ::nColPos + 1

        While ::IsColVisible( nCol ) .and. nCol <= Len( ::aColumns )
           ++nCol
        EndDo

        If nCol < Len ( ::aColumns )
           ::nColPos := ::nCell := nCol
           ::Refresh( .F. )
           ::oHScroll:SetPos( nCol )
        Else
           nCol := Len( ::aColumns )
           While ! ::IsColVisible( nCol ) .and. ::nColPos < nCol
              ::nColPos++
           EndDo
           ::nCell := nCol
           ::oHScroll:GoBottom()
           ::Refresh( .F. )
        EndIf

        If ::lCellBrw
           ::HiLiteCell( ::nCell )
        EndIf

   Case nWParam == SB_TOP
        ::PanHome()

    Case nWParam == SB_BOTTOM
        ::PanEnd()

    Case nWParam == SB_THUMBPOSITION
        ::HThumbDrag( nLParam )

    Endcase

Return 0

* ============================================================================
* METHOD TSBrowse:HThumbDrag() Version 7.0 Jul/15/2004
* ============================================================================

METHOD HThumbDrag( nNewCol ) CLASS TSBrowse

   Local nI, nLeftPix, nColPos,;
         nWidth := ::nWidth() - If( ::oVScroll != Nil, 16, 0 )

   If ::oHScroll != Nil .and. ! Empty( nNewCol )

      If nNewCol >= Len( ::aColumns )
         If ::IsColVisible( Len( ::aColumns ) )
            ::nCell := Len( ::aColumns )
            ::HiliteCell( ::nCell )
            ::Refresh( .F. )
         Else
            ::PanEnd()
         EndIf
         ::oHScroll:GoBottom()
         Return Self
      EndIf

      If ::lIsTxt
            ::oHScroll:SetPos( ::nAt := nNewCol )
        Else
         If ::lLockFreeze .and. nNewCol <= ::nFreeze  // watch out for frozen columns
                ::oHScroll:SetPos( ::nCell := ::nFreeze + 1 )
            Else
            ::oHScroll:SetPos( ::nCell := Min( nNewCol, Len( ::aColumns ) ) )
         EndIf

         nLeftPix := 0                              // check for frozen columns,

         For nI := 1 To ::nFreeze                   // if any
            nLeftPix += ::aColSizes[ nI ]
            Next
            nColPos := ::nCell
            For nI := ::nCell To 1 Step - 1            // avoid extra scrolling
                If nLeftPix + ::aColSizes[nI] < nWidth  // to the right of the
                    nLeftPix += ::aColSizes[nI]          // last cell (column)
                    nColPos := nI
                Else
                    Exit
            EndIf
            Next
            ::nColPos := nColPos
            ::HiliteCell( ::nCell )
      EndIf
      ::Refresh( .F. )

   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:Inspect() Version 7.0 Jul/15/2004
* ============================================================================
/*
METHOD Inspect( cData ) CLASS TSBrowse

   Do case
   Case cData == "aColumns"
           Return { | aColumns | Tone(500,1), aColumns }
   Endcase

Return Nil
*/
* ============================================================================
* METHOD TSBrowse:InsColumn() Version 7.0 Jul/15/2004
* ============================================================================

METHOD InsColumn( nPos, oColumn ) CLASS TSBrowse

   Local nI, nCell := ::nCell

    Default nPos := 1

    If oColumn == Nil                             // if no Column object supplied
        Return Nil                                 // return nil insted of reference to object
   EndIf

    If nPos < 1
        nPos := 1
   ElseIf nPos > Len( ::aColumns ) + 1
        nPos := Len( ::aColumns ) + 1
   EndIf

   ASize( ::aColumns, Len( ::aColumns ) + 1 )
   aIns( ::aColumns, nPos )
   ::aColumns[ nPos ] := oColumn

   ASize( ::aColSizes, Len( ::aColSizes ) + 1 )
   aIns( ::aColSizes, nPos )
   ::aColsizes[ nPos ] := IF(oColumn:lVisible,oColumn:nWidth,0)

   If( nCell != nPos, ::nCell := If( ::lPainted, nPos, nCell ), Nil )

   If ! Empty( oColumn:cOrder )                       // if column has a TAG, we
      ::SetOrder( nPos )                              // set it as controling order
   ElseIf ::nColOrder != 0 .and. nPos <= ::nColOrder  // if left of current order
      ::nColOrder ++                                  // adjust position
   EndIf

   If ::lPainted
      ::HiliteCell( ::nCell )

      If ::oHScroll != Nil
         ::oHScroll:SetRange( 1, Len( ::aColumns ) )
         ::oHScroll:SetPos( ::nCell )
      EndIf

      If ! Empty( ::aSuperHead )

         For nI := 1 To Len( ::aSuperHead )

            If nPos >= ::aSuperHead[ nI, 1 ] .and. ;
               nPos <= ::aSuperHead[ nI, 2 ]

               ::aSuperHead[ nI, 2 ] ++

            ElseIf nPos < ::aSuperHead[ nI, 1 ]
               ::aSuperHead[ nI, 1 ] ++
               ::aSuperHead[ nI, 2 ] ++
            EndIf

         Next

      EndIf

      ::Refresh( .F. )
      ::SetFocus()

   EndIf

Return oColumn                                   // returns reference to Column object

* ============================================================================
* METHOD TSBrowse:IsColVisible() Version 7.0 Jul/15/2004
* ============================================================================

METHOD IsColVisible( nCol ) CLASS TSBrowse

   Local nCols, nFirstCol, nLastCol, nWidth, nBrwWidth, xVar, ;
         aColSizes := ::GetColSizes()

   nCols     := Len( aColSizes )
   nFirstCol := ::nColPos
   nLastCol  := nFirstCol
   nWidth    := 0
   nBrwWidth := ::nWidth() - If( ::oVScroll != Nil, 16, 0 )

   If nCol < ::nColPos .or. ::nColPos <= 0
      Return .F.
   EndIf

   xVar := 1

   While xVar <= ::nFreeze
      nWidth += aColSizes[ xVar++ ]
   EndDo

   While nWidth < nBrwWidth .and. nLastCol <= nCol .and. nLastCol <= nCols
      nWidth += aColSizes[ nLastCol ]
      nLastCol++
   Enddo

   If nCol <= --nLastCol
      Return ! nWidth > nBrwWidth
   EndIf

Return .F.

* ============================================================================
* METHOD TSBrowse:IsColVis2() Version 7.0 Jul/15/2004
* ============================================================================

METHOD IsColVis2( nCol ) CLASS TSBrowse

   Local nCols, nFirstCol, nLastCol, nBrwWidth, ;
         nWidth := 0, ;
         aColSizes := ::GetColSizes()

   nCols     := Len( aColSizes )
   nFirstCol := ::nColPos
   nLastCol  := nFirstCol

   // mt differs from iscolvisible here - allows for frozen column
   If ::nFreeze > 0
        AEval( aColSizes, {|nSize| nWidth += nSize }, 1, ::nFreeze )
   EndIf

   nBrwWidth := ::nWidth() - If( ::oVScroll != Nil, 16, 0 )

   If nCol < ::nColPos
      Return .F.
   EndIf

   Do While nWidth < nBrwWidth .and. nLastCol <= nCols
      nWidth += aColSizes[ nLastCol ]
      nLastCol++
   Enddo

   If nCol <= --nLastCol
      // mt differs from new iscolvisible here
      Return .T.
   EndIf

Return .F.

* ============================================================================
* METHOD TSBrowse:Insert() Version 7.0 Jul/15/2004
* ============================================================================

METHOD Insert( cItem, nAt ) CLASS TSBrowse

   Default nAt := ::nAt, ;
           cItem := AClone( ::aDefValue )

   If ! ::lIsArr
      Return Nil
   EndIf

   If ValType( cItem ) == "A" .and. cItem[ 1 ] == Nil
      ADel( cItem, 1 )
      ASize( cItem, Len( cItem ) - 1 )
   EndIf

   ASize( ::aArray, Len( ::aArray ) + 1 )
   AIns( ::aArray, nAt )
   ::aArray[ nAt ] := If( Valtype( cItem ) == "A", cItem, {cItem} )
   ::nLen := Eval( ::bLogicLen )
   ::Refresh( .T. )

Return Self

* ============================================================================
* METHOD TSBrowse:AddItem() Version 7.0 Oct/10/2007
* ============================================================================

METHOD AddItem( cItem ) CLASS TSBrowse

   Local nMin, nMax, nPage

   Default cItem := AClone( ::aDefValue )

   If ! ::lIsArr
      Return Nil
   EndIf

   If ValType( cItem ) == "A" .and. cItem[ 1 ] == Nil
      ADel( cItem, 1 )
      ASize( cItem, Len( cItem ) - 1 )
   EndIf

   cItem := If( Valtype( cItem ) == "A", cItem, {cItem} )

   If ::lPhantArrRow .and. Len(::aArray) == 1
      ::SetArray( {cItem},,.t. )
      ::lPhantArrRow := .F.
   ElseIf  Len(::aArray) == 0
      ::SetArray( {cItem},,.t. )
   Else
      AAdd(::aArray,  cItem )
   EndIf

   ::nLen := Eval( ::bLogicLen )
   If ::lNoVScroll
      If ::nLen > ::nRowCount
        ::lNoVScroll := .F.
      EndIf
   EndIf

   If ! ::lNoVScroll
      nMin  := Min( 1, ::nLen )
      nMax  := Min( ::nLen, MAX_POS )
      nPage := Min( ::nRowCount(), ::nLen )
      ::oVScroll := TSBScrlBar():WinNew( nMin, nMax, nPage, .T., Self )
   EndIf

   ::Refresh( .T. )

Return Self

* ============================================================================
* METHOD TSBrowse:lEditCol() Version 7.0 Jul/15/2004
* ============================================================================

METHOD lEditCol( uVar, nCol, cPicture, bValid, nClrFore, nClrBack ) CLASS TSBrowse

// just for compatibility
Return ::Edit( uVar, nCol,,, cPicture, bValid, nClrFore, nClrBack )

* ============================================================================
* METHOD TSBrowse:lIgnoreKey() Version 7.0 Jul/15/2004
* Checks if any of the predefined navigation keys has been remapped so as to
* ignore its default behavior and forward it to TWindow class in case a new
* behavior has been defined in ::bKeyDown. Uses the new nested array IVar
* ::aKeyRemap which has the following structure (data type in parens):
*
* { { VK_ to ignore(n), alone(l), ctrl(l), shift(l), alt(l), ctrl+shift(l), bBlock }, ... }
*
* Example:  AAdd( ::aKeyRemap, { VK_END, .T., .F., .T., .F., .F., { || Tone(600) } } )
*           will ignore End key alone and with shift+end combinations
*
* It's the programmer's (ie you!) responsibility to make sure each subarray
* has 6 elements of the specified data type or kaboom!
* This method is called by ::KeyDown() which provides nKey and nFlags.
* If called directly, you must specify the parameter nKey (nFlags is always ignored)
* ============================================================================

METHOD lIgnoreKey( nKey, nFlags ) CLASS TSBrowse

   Local lIgnore := .F., ;
         nAsync := 2, ;                // key by itself
         nIgnore := AScan( ::aKeyRemap, {|aRemap| aRemap[1] == nKey } )

   HB_SYMBOL_UNUSED( nFlags )

   If nIgnore > 0

      If _GetKeyState( VK_CONTROL ) .and. _GetKeyState( VK_SHIFT )
         nAsync := 6
      ElseIf _GetKeyState( VK_CONTROL )
         nAsync := 3
      ElseIf _GetKeyState( VK_SHIFT )
         nAsync := 4
      ElseIf _GetKeyState( VK_MENU )                    // alt key
         nAsync := 5
      EndIf

      lIgnore := ::aKeyRemap[ nIgnore, nAsync ]

      If lIgnore .and. ValType( ::aKeyRemap[ nIgnore, 7 ] ) == "B"
         Eval( ::aKeyRemap[ nIgnore, 7 ] )
      EndIf

   EndIf

Return lIgnore

* ============================================================================
* METHOD TSBrowse:LoadRelated() Version 7.0 Jul/15/2004
* ============================================================================

METHOD LoadRelated( cAlias, lEditable, aNames, aHeaders ) CLASS TSBrowse

   Local n, nE, cHeading, nAlign, nSize, cData, cType, nDec, ;
         hFont, aStru, nArea, nFields, cBlock

   Default lEditable := .F.

   If Empty( cAlias )
      Return Self
   EndIf

   cAlias  := AllTrim( cAlias )
   nArea   := Select( cAlias )
   aStru   := ( cAlias )->( DbStruct() )
   nFields := If( aNames == Nil, ( cAlias )->( FCount() ), Len( aNames ) )

   For n := 1 To nFields

      nE := If( aNames == Nil, n, ( cAlias )->( FieldPos( aNames[ n ] ) ) )

      cHeading := If( aHeaders != Nil .and. Len( aHeaders ) >= n, ;
                      aHeaders[ n ], cAlias + "->" + ;
                      ::Proper( ( cAlias )->( Field( nE ) ) ) )

//      cHeading := cAlias + "->" + ::Proper( ( cAlias )->( Field( nE ) ) )

      nAlign := If( ( cAlias )->( ValType( FieldGet( nE ) ) ) == "N", 2, ;
                If( ( cAlias )->( ValType( FieldGet( nE ) ) ) == "L", ;
                          1, 0 ) )

      cData := ( cAlias )->( FieldGet( nE ) )
      cType := ValType( cData )
      nSize := aStru[ nE, 3 ]
      nDec  := aStru[ nE, 4 ]
      hFont := If( ::hFont != Nil, ::hFont, 0 )

      If cType == "C"
         cData := PadR( Trim( cData ), nSize, "B" )
         nSize := GetTextWidth( 0, cData, hFont )
      ElseIf cType == "N"
         cData := StrZero( cData, nSize, nDec )
         nSize := GetTextWidth( 0, cData, hFont )
      ElseIf cType == "D"
         cData := cValToChar( If( ! Empty( cData ), cData, Date() ) )
         nSize := Int( GetTextWidth( 0, cData, hFont ) * 1.15 )
      Else
         cData := cValToChar( cData )
         nSize := GetTextWidth( 0, cData, hFont )
      EndIf

      nSize := Max( GetTextWidth( 0, Replicate( "B", Len( cHeading ) ), ;
                                  hFont ), nSize )
      cBlock := 'FieldWBlock( "' + ( cAlias )->( Field( nE ) ) + '", Select( "' + ;
                cAlias + '" ) )'
      ::AddColumn( TSColumn():New( cHeading, ;
                                   FieldWBlock( ( cAlias )->( Field( nE ) ), nArea ),, ;
                                   { ::nClrText, ::nClrPane }, { nAlign, DT_CENTER }, ;
                                   nSize,, lEditable,,,,,,, 5,,,, Self, cBlock ) )

      ATail( ::aColumns ):cAlias := cAlias
      ATail( ::aColumns ):cData  := cAlias + "->" + FieldName( nE )

   Next

Return Self

* ============================================================================
* METHOD TSBrowse:Look3D() Version 7.0 Jul/15/2004
* ============================================================================

METHOD Look3D( lOnOff, nColumn, nLevel, lPhantom ) CLASS TSBrowse

   Default lOnOff   := .T., ;
           nColumn  :=  0 , ;
           lPhantom := .T., ;
           nLevel   :=  0

   ::l3DLook := lOnOff                              // used internally

   If nColumn > 0
      If nLevel = 1 .or. nLevel = 0
         ::aColumns[ nColumn ]:l3DLook := lOnOff
      EndIf

      If nLevel = 2 .or. nLevel = 0
         ::aColumns[ nColumn ]:l3DLookHead := lOnOff
      EndIf

      If nLevel = 3 .or. nLevel = 0
         ::aColumns[ nColumn ]:l3DLookFoot := lOnOff
      EndIf
   Else
      If nLevel > 0
         AEval( ::aColumns, { | oCol | If( nLevel = 1, oCol:l3DLook := lOnOff, ;
                                       If( nLevel = 2, oCol:l3DLookHead := lOnOff, ;
                                           oCol:l3DLookFoot := lOnOff ) ) } )
      Else
         AEval( ::aColumns, { | oCol | oCol:l3DLook := lOnOff, ;
                                       oCol:l3DLookHead := lOnOff, ;
                                       oCol:l3DLookFoot := lOnOff } )
      EndIf
   EndIf

   If lPhantom
      ::nPhantom := PHCOL_GRID
   Else
      ::nPhantom := PHCOL_NOGRID
   EndIf

   ::Refresh( .T. )

Return Self

* ============================================================================
* METHOD TSBrowse:LostFocus() Version 7.0 Jul/15/2004
* ============================================================================

METHOD LostFocus( hCtlFocus ) CLASS TSBrowse

   Local nRecNo, uTag

   Default ::oWnd:aControls := {}
   If ::lEditing .and. Len( ::aControls ) > 0 .and. ;
      hCtlFocus == ::aControls[ 1 ]
      Return 0

   EndIf

   If ::lEditing

      If ::aColumns[ ::nCell ]:oEdit != Nil
         IF IsControlDefined (::cChildControl, ::cParentWnd )
            ::aColumns[ ::nCell ]:oEdit:End()
            ::aColumns[ ::nCell ]:oEdit := Nil
         endif
      EndIf

      ::lEditing := ::lPostEdit := .F.

   EndIf

   ::lNoPaint := .F.

   ::lFocused = .F.

   If ! Empty( ::bLostFocus )
      Eval( ::bLostFocus, hCtlFocus )
   EndIf

   If ::nLen > 0 .and. ! EmptyAlias( ::cAlias ) .and. ! ::lIconView

      If ::lIsDbf .and. ( ::cAlias )->( RecNo() ) != ::nLastPos

         If ::bTagOrder != Nil .and. ::uLastTag != Nil
            uTag := ( ::cAlias )->( Eval( ::bTagOrder ) )
            ( ::cAlias )->( Eval( ::bTagOrder, ::uLastTag ) )
         EndIf

         nRecNo := ( ::cAlias )->( RecNo() )
         ( ::cAlias )->( DbGoTo( ::nLastPos ) )

      EndIf

      ::DrawSelect()

      If nRecNo != Nil

         If uTag != Nil
            ( ::cAlias )->( Eval( ::bTagOrder, uTag ) )
         EndIf

         ( ::cAlias )->( DbGoTo( nRecNo ) )

      EndIf

   EndIf

   ::lHasFocus := .F.

Return 0

* ============================================================================
* METHOD TSBrowse:MButtonDown() Version 7.0 Jul/15/2004
* ============================================================================

METHOD MButtonDown( nRow, nCol, nKeyFlags ) CLASS TSBrowse

   If ::bMButtonDown != Nil
      Eval( ::bMButtonDown, nRow, nCol, nKeyFlags )
   EndIf

Return 0

* ============================================================================
* METHOD TSBrowse:MouseMove() Version 7.0 Jul/15/2004
* ============================================================================

METHOD MouseMove( nRowPix, nColPix, nKeyFlags ) CLASS TSBrowse

   Local nI, nIcon, lHeader, lMChange, nFirst, nLast, nDestCol, ;
         cMsg       := ::cMsg, ;
         nColPixPos := 0, ;
         lFrozen    := .F.


   Default ::lMouseDown := .F.

   If ::lIconView
      If ( nIcon := ::nAtIcon( nRowPix, nColPix ) ) != 0
         If ::nIconPos != 0 .and. ::nIconPos != nIcon
            ::DrawIcon( ::nIconPos )
         EndIf
         ::nIconPos := nIcon
         ::DrawIcon( nIcon, .T. )
         CursorHand()
         Return 0
      EndIf
   EndIf

   lHeader := ::GetTxtRow( nRowPix ) == 0 .or. ::GetTxtRow( nRowPix ) == -2

   If ::nFreeze > 0
      For nI := 1 To ::nFreeze
         nColPixPos += ::GetColSizes()[ nI ]
      Next

      If nColPix < nColPixPos
         lFrozen := .T.
      EndIf
   EndIf

   If ! ::lGrasp .and. ( lFrozen .or. ! lHeader .or. ! ::lMChange )
       // don't allow MouseMove to drag/resize columns
       // unless in header row and not in frozen zone
      CursorArrow()

      If ::lCaptured
         If ::lLineDrag
            ::VertLine()
            ::lLineDrag := .F.
         EndIf

         ReleaseCapture()
         ::lColDrag := ::lCaptured := ::lMouseDown := .F.
      EndIf

      lMChange := ::lMChange  // save it for restore
      ::lMChange := .F.

      If ::lCellBrw .and. ! Empty( ::aColumns[ Max( 1, ::nAtCol( nColPix ) ) ]:cMsg )
         ::cMsg := ::aColumns[ Max( 1, ::nAtCol( nColPix ) ) ]:cMsg
      Else
         ::cMsg := cMsg
      EndIf

      ::cMsg := If( ValType( ::cMsg ) == "B", ;
                    Eval( ::cMsg, Self, Max( 1, ::nAtCol( nColPix ) ) ), ::cMsg )
      Super:MouseMove( nRowPix, nColPix, nKeyFlags )
      ::lMChange := lMChange

      ::cMsg := cMsg

      Return 0

   EndIf

   If ::lMChange
      If lHeader
         If ! Empty( ::aSuperHead )  .and. !::lLineDrag

            nFirst := 0
            nLast  := 0
            Aeval( ::aSuperHead, { | aSup, nCol | nFirst := If( ::nDragCol >= aSup[1] .and. ::nDragCol <= aSup[ 2 ],nCol,nFirst ), ;
                           nLast := max(nLast,aSup[ 2 ])} )

            nDestCol := ::nAtCol( nColPix )
            if nLast < nDestCol
               nLast := nFirst+1
            else
               Aeval( ::aSuperHead, { | aSup, nCol | nlast := If( nDestCol >= aSup[1] .and. nDestCol <= aSup[ 2 ],nCol,nlast )} )
            endif
            If nLast != nFirst
               ::lGrasp := .F.
               CursorHand()
               ::lColDrag := ::lCaptured := ::lMouseDown := .F.
            endif
         endif
         If ::lGrasp             // avoid dragging between header & rows
            ::lGrasp := .F.
            CursorArrow()        // restore default cursor
         EndIf

         If ::lColDrag
            CursorSize()
         Else
            If ::lLineDrag
               ::VertLine( nColPix )
               CursorWE()
            Else
               If AScan( ::GetColSizes(),;
                         { | nColumn | nColPixPos += nColumn, ;
                           nColPix >= nColPixPos - 2 .and. ;
                           nColPix <= nColPixPos + 2 }, ::nColPos ) != 0
                  CursorWE()
               Else
                  CursorHand()
               EndIf
            EndIf
         EndIf
      ElseIf ::lGrasp
         ::lCaptured := ::lColDrag := .F.     // to avoid collision with header/column dragging
         ::lMouseDown := .T.                  // has to be down until dragging finishes
         Super:MouseMove( nRowPix, nColPix, nKeyFlags )
      Else
         CursorArrow()
      EndIf
   Else
      CursorArrow()
   EndIf

Return 0

* ============================================================================
* METHOD TSBrowse:MouseWheel() Version 7.0 Jul/15/2004
* ============================================================================

METHOD MouseWheel( nKeys, nDelta, nXPos, nYPos ) CLASS TSBrowse

   Local nWParam, aCoors := {0,0,0,0}

   HB_SYMBOL_UNUSED( nKeys )

   GetWindowRect(::hWnd,aCoors)

   If nYPos >= aCoors[ 2 ] .and. nXPos >= aCoors[ 1 ] .and. ;
         nYPos <= ( aCoors[ 4 ] )  .and.  nXPos <= ( aCoors[ 3 ]  )

      If ( nDelta ) > 0

         If ::nWheelLines != Nil
            nWParam := SB_LINEUP
            nDelta  := ::nWheelLines * nDelta
         Else
            nWParam := SB_PAGEUP
         EndIf

      Else

         If ::nWheelLines != Nil
            nWParam := SB_LINEDOWN
            nDelta  := ::nWheelLines * Abs( nDelta )
         Else
            nWParam := SB_PAGEDOWN
            nDelta := Abs( nDelta )
         EndIf

      EndIf

      While nDelta > 1
         ::VScroll( nWParam, 0 )
         nDelta--
      EndDo
   ENDIF

Return ::VScroll( nWParam, 0 )

* ============================================================================
* METHOD TSBrowse:MoveColumn() Version 7.0 Jul/15/2004
* ============================================================================

METHOD MoveColumn( nColPos, nNewPos ) CLASS TSBrowse

   Local oCol, cOrder, ;
         nMaxCol   := Len( ::aColumns ), ;
         nOrder    := ::nColOrder, ;
         lCurOrder := ( ::nColOrder == nColPos )

   Local lSetOrder := ;
      ( nOrder != nColPos .and. nOrder != nNewPos .and. ::nColOrder == nNewPos )

   If ! Empty( nColPos ) .and. ! Empty( nNewPos ) .and. ;
   nColPos > ::nFreeze .and. nNewPos > ::nFreeze .and. ;
   nColPos <= nMaxCol .and. nNewPos <= nMaxCol

      oCol   := ::aColumns[ nColPos ]
      cOrder := oCol:cOrder
      oCol:cOrder := Nil                         // avoid ::InsColumn() from seting order...

      ::DelColumn( nColPos )
      ::InsColumn( nNewPos, oCol )
      ::aColumns[ nNewPos ]:cOrder := cOrder     // ...restore ::cOrder (if any)

      If lSetOrder
         ::SetOrder( nNewPos - 1 )

      ElseIf lCurOrder
         ::SetOrder( nNewPos )

      ElseIf nOrder != 0
         // check if current order is in between moving columns
         If nOrder >= nColPos .and. nOrder <= nNewPos      // left to right movement
                nOrder --
         ElseIf nOrder <= nColPos .and. nOrder >= nNewPos  // right to left movement
                nOrder ++
         EndIf

         ::SetOrder( nOrder )

      EndIf

   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:PageDown() Version 7.0 Jul/15/2004
* ============================================================================

METHOD PageDown( nLines ) CLASS TSBrowse

   Local nSkipped, nI, ;
         lPageMode := ::lPageMode, ;
         nTotLines := ::nRowCount()

   Default nLines := nTotLines

   ::lAppendMode := .F.
   ::ResetSeek()

   If ::nLen == 0
      ::nLen := If( ::lIsDbf, ( ::cAlias )->( Eval( ::bLogicLen ) ), ;
                    Eval( ::bLogicLen ) )
   EndIf

   If ::nLen < 1
      Return Nil
   EndIf

   If ! ::lHitBottom

      ::nPrevRec := If( ::lIsDbf, ( ::cAlias )->( RecNo() ), ::nAt )

      If lPageMode .and. ::nRowPos < nLines
         nSkipped := ::Skip( nLines - ::nRowPos )
         lPageMode := .F.
      Else
         nSkipped = ::Skip( ( nLines * 2 ) - ::nRowPos )
      EndIf

      If nSkipped != 0
         ::lHitTop = .F.
      EndIf

      Do Case

         Case nSkipped == 0
            ::lHitBottom := .T.
         Case nSkipped < nLines .and. ! lPageMode

            nI := If( ::lIsDbf, ( ::cAlias )->( RecNo() ), ::nAt )

            If ::lIsDbf
               ( ::cAlias )->( DbGoTo( ::nPrevRec ) )
            Else
               ::nAt := ::nPrevRec
            EndIf

            ::DrawLine()

            If ::lIsDbf
               ( ::cAlias )->( DbGoTo( nI ) )
            Else
               ::nAt := nI
            EndIf

            If nLines - ::nRowPos < nSkipped

               nKeyPressed := Nil
               ::Skip( -( nLines ) )

               For nI = 1 To ( nLines - 1 )
                  ::Skip( 1 )
                  ::DrawLine( nI )
               Next

               ::Skip( 1 )

            EndIf

            ::nRowPos = Min( ::nRowPos + nSkipped, nTotLines )

         Case nSkipped < nLines .and. lPageMode
            ::Refresh( .T. )
         Otherwise

            For nI = nLines To 1 Step -1
               ::Skip( -1 )
            Next

            ::Skip( ::nRowPos )
            ::lRepaint := .T.       // JP 1.31
      Endcase

      If nKeyPressed == Nil
         ::Refresh( ::nLen < nTotLines )
         If ::bChange != Nil
            Eval( ::bChange, Self, VK_NEXT )
         EndIf
      ElseIf nSkipped >= nLines
         ::DrawSelect()
      Else
         nKeyPressed := Nil
         ::DrawSelect()
      EndIf

      If ::oVScroll != Nil
         If ! ::lHitBottom
            ::oVScroll:SetPos( ::RelPos( ::nLogicPos() ) )
         Else
            ::oVScroll:GoBottom()
         EndIf
      EndIf

      If ::lRepaint .and. ::nRowPos == nTotLines
         If ::bChange != Nil
            Eval( ::bChange, Self, VK_NEXT )   // GF 15/01/2009
         EndIf
      EndIf

   EndIf

Return Nil

* ============================================================================
* METHOD TSBrowse:PageUp() Version 7.0 Jul/15/2004
* ============================================================================

METHOD PageUp( nLines ) CLASS TSBrowse

   Local nSkipped, nRecNo

   Default nLines := ::nRowCount()

   ::lHitBottom := .F.
   ::lAppendMode := .F.
   ::ResetSeek()

   If ::lPageMode .and. ::nRowPos > 1

      ::DrawLine()
//      nSkipped := ::Skip( -( ::nRowPos - 1 ) )
      ::nRowPos := 1
      ::Refresh( .F. )

      If ::oVScroll != Nil
         ::oVScroll:SetPos( ::RelPos( ::nLogicPos() ) )
      EndIf

      If ::bChange != Nil
         Eval( ::bChange, Self, VK_PRIOR )
      EndIf

      Return Self

   EndIf

   ::nPrevRec := If( ::lIsDbf, ( ::cAlias )->( RecNo() ), ::nAt )
   nSkipped := ::Skip( -nLines )

   If ::nLen == 0
      ::nLen := If( ::lIsDbf, ( ::cAlias )->( Eval( ::bLogicLen ) ), ;
                    Eval( ::bLogicLen ) )
   EndIf

   If ::nLen < 1
      Return Nil
   EndIf

   If ! ::lHitTop

      If nSkipped == 0
         ::lHitTop := .T.
      Else

         If -nSkipped < nLines

            nRecNo := If( ::lIsDbf, ( ::cAlias )->( RecNo() ), ::nAt )

            If ::lIsDbf
               ( ::cAlias )->( DbGoto( ::nPrevRec ) )
            Else
               ::nAt := ::nPrevRec
            EndIf

            ::DrawLine()
            ::nRowPos := 1
            ::Refresh( .F. )   // GF 14/01/2009

            If ::lIsDbf
               ( ::cAlias )->( DbGoto( nRecNo ) )
            Else
               ::nAt := nRecNo
            EndIf

            If ::oVScroll != Nil
               ::oVScroll:SetPos( 1 )
            EndIf

         Else

            If ::oVScroll != nil
               ::oVScroll:SetPos( ::RelPos( ::nLogicPos() ) )
            EndIf

         EndIf

         If nKeyPressed == Nil

            ::Refresh( .F. )

            If ::bChange != Nil
               Eval( ::bChange, Self, VK_PRIOR )
            EndIf

         Else

            ::DrawSelect()

            If -nSkipped < nLines
               nKeyPressed := Nil

               If ::bChange != Nil
                  Eval( ::bChange, Self, VK_PRIOR )   // GF 15/01/2009
               EndIf

            EndIf

         EndIf

      EndIf

   Else

      If ::oVScroll != Nil
         ::oVScroll:GoTop()
      EndIf

   EndIf

Return Nil

* ============================================================================
* METHOD TSBrowse:Paint() Version 7.0 Jul/15/2004
* ============================================================================

METHOD Paint() CLASS TSBrowse

   Local lAppendMode, nRecNo, uTag, ;
         nColPos := ::nColPos, ;
         nI      := 1, ;
         nLines  := Min( ( ::nLen + If( ::lAppendMode .and. ! ::lIsArr, ;
                           1, 0 ) ), ::nRowCount() ), ;
         nSkipped := 1

   Default ::lPostEdit   := .F., ;
           ::lFirstPaint := .T., ;
           ::lNoPaint    := .F.

   If ! ::lRepaint
      Return 0
   EndIf

   If ::lEditing .and. ! ::lPostEdit .and. ::nLen > 0
      Return 0
   ElseIf ::lEditing .or. ::lNoPaint

      If ::lDrawHeaders
         ::DrawHeaders()
      EndIf
      ::DrawSelect()
      Return 0

   EndIf

   If ::lFirstPaint
      ::Default()
   EndIf

   ::nRowPos := If( ::lDrawHeaders, Max( 1, ::nRowPos ), ::nRowPos )

   If ::lIconView
      ::DrawIcons()
      Return 0
   EndIf

   If ! ::lPainted

      SetHeights( Self )

      nLines  := Min( ( ::nLen + If( ::lAppendMode .and. ! ::lIsArr, ;
                        1, 0 ) ), ::nRowCount() )
      If ::nLen <= nLines .and. ::nAt > ::nRowPos
         ::nRowPos := ::nAt
      EndIf

   EndIf

   If ::lDrawHeaders .and. ::nHeightSuper > 0
      ::nColPos := ::nFreeze + 1
      ::DrawSuper()
      ::nColPos := nColPos
   EndIf

   If ::lDrawHeaders
      ::nRowPos := Max( 1, ::nRowPos )
      ::DrawHeaders()
   EndIf

   If ::lIsDbf .and. ! ::lFocused .and. ( ::cAlias )->( RecNo() ) != ::nLastPos

      If ::bTagOrder != Nil .and. ::uLastTag != Nil
         uTag := ( ::cAlias )->( Eval( ::bTagOrder ) )
         ( ::cAlias )->( Eval( ::bTagOrder, ::uLastTag ) )
      EndIf

      nRecNo := ( ::cAlias )->( RecNo() )
      ( ::cAlias )->( DbGoTo( ::nLastPos ) )

   EndIf

   If ::lAppendMode .and. ::lFilterMode
      Eval( ::bGoBottom )
   EndIf

   ::Skip( 1 - ::nRowPos )

   If ::lIsArr
      lAppendMode := ::lAppendMode
      ::lAppendMode := .F.
   EndIf

   ::nLastPainted := 0

   While nI <= nLines .and. nSkipped == 1

      If ::nRowPos == nI
         ::DrawSelect()
      Else
         ::DrawLine( nI )
      EndIf

      ::nLastPainted := nI
      nSkipped := ::Skip( 1 )

      If nSkipped == 1
         nI++
      EndIf

   Enddo
   ::nLenPos:=nI  //JP 1.31
   If ::lIsArr
      ::lAppendMode := lAppendMode
   EndIf

   If ::lAppendMode
      nI := Max( 1, --nI )
   EndIf

   ::Skip( ::nRowPos - nI )

   If ::nLen < ::nRowPos
      ::nRowPos := ::nLen
   EndIf

   If ::lAppendMode .and. ::nLen == ::nRowPos .and. ::nRowPos < nLines
      ::DrawLine( ++ ::nRowPos )
   EndIf

   If ! ::lPainted

      If ::bInit != Nil
         Eval( ::bInit, Self )
      EndIf

      If Upper( ::oWnd:ClassName() ) == "TDIALOG" .and. ! ::lNoVScroll
         ::oVScroll := TSBScrlBar():WinNew( 1, Min( ::nLen, MAX_POS ), ;
                       Min( nLines, ::nLen ), .T., Self )
      EndIf

      If ::bChange != Nil
         Eval( ::bChange, Self, 0 )
      EndIf

      If ::lIsDbf .and. ! ::lNoResetPos

         If ::bTagOrder != Nil
            ::uLastTag := ( ::cAlias )->( Eval( ::btagOrder ) )
         EndIf

         ::nLastPos := ( ::cAlias )->( RecNo() )

      EndIf

      If ::lCanAppend .and. ::lHasFocus .and. ! ::lAppendMode .and. ::nLen == 0
         ::lHitBottom := .T.
         ::PostMsg( WM_KEYDOWN, VK_DOWN, 0 )
      Else
         ::lNoPaint := .T.
      EndIf

   EndIf

   ::lPainted := .T.

   If nRecNo != Nil

      If uTag != Nil
         ( ::cAlias )->( Eval( ::bTagOrder, uTag ) )
      EndIf

      ( ::cAlias )->( DbGoTo( nRecNo ) )

   EndIf

Return 0

* ============================================================================
* METHOD TSBrowse:PanEnd() Version 7.0 Jul/15/2004
* ============================================================================

METHOD PanEnd() CLASS TSBrowse

   Local nI, nTxtWid, ;
         nWidth   := ::nWidth() - If( ::oVScroll != Nil, 16, 0 ), ;
         nWide    := 0, ;
         nCols    := Len( ::aColumns )

   ::nOldCell := ::nCell

   If ::lIsTxt
        nTxtWid := Max( 1, GetTextWidth( 0, "B", If( ::hFont != nil, ::hFont, 0 ) ) )
        ::nAt := ::oTxtFile:nMaxLineLength - Int( nWidth / nTxtWid )
      ::Refresh( .F. )

      If ::oHScroll != Nil
            ::oHScroll:setPos( ::nAt )
      EndIf

      Return Self
   EndIf

   ::nColPos := nCols
    ::nCell := nCols
    nWide := ::aColSizes[nCols]

   For nI := nCols - 1 To 1 Step - 1
        If nWide + ::aColSizes[nI] <= nWidth
            nWide += ::aColSizes[nI]
            ::nColPos--
        Else
            Exit
      EndIf
    Next

   If ::lCellBrw

      If ::aColumns[ ::nCell ]:bGotFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nCell ]:bGotFocus, ::nOldCell, ::nCell, Self )
      EndIf

      If ::aColumns[ ::nOldCell ]:bLostFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nOldCell ]:bLostFocus, ::nCell, ::nOldCell, Self )
      EndIf

      ::nOldCell := ::nCell

   EndIf

   ::Refresh( .F. )

   If ::oHScroll != Nil
      If ::oHScroll:nMax != nCols
         ::oHScroll:SetRange( 1, nCols )
      EndIf
      ::oHScroll:GoBottom()
   EndIf

    ::HiliteCell( nCols )

Return Self

* ============================================================================
* METHOD TSBrowse:PanHome() Version 7.0 Jul/15/2004
* ============================================================================

METHOD PanHome() CLASS TSBrowse

   Local nColChk, nEle

   ::nOldCell := ::nCell

   If ::lIsTxt

        ::nAt := 1
      ::Refresh( .F. )

      If ::oHScroll != Nil
            ::oHScroll:setPos( ::nAt )
      EndIf

      Return Self
   EndIf

   For nEle := 1 To Len( ::aColumns )
      If ! ::aColumns[ nEle ]:lNoHilite
         nColChk := nEle
         Exit
      EndIf
   Next

   ::nColPos := 1
   ::nCell := nColChk

   If ::lCellBrw

      If ::aColumns[ ::nCell ]:bGotFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nCell ]:bGotFocus, ::nOldCell, ::nCell, Self )
      EndIf

      If ::aColumns[ ::nOldCell ]:bLostFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nOldCell ]:bLostFocus, ::nCell, ::nOldCell, Self )
      EndIf

      ::nOldCell := ::nCell

   EndIf

   If ! ::lEditing
      ::Refresh( .F. )
   Else
      ::Paint()
   EndIf

   If ::oHScroll != Nil
      ::oHScroll:SetPos( ::nCell )
   EndIf

   ::HiliteCell( ::nCell )

Return Self

* ============================================================================
* METHOD TSBrowse:PanLeft() Version 7.0 Jul/15/2004
* ============================================================================

METHOD PanLeft() CLASS TSBrowse

   Local nI,;
         nWidth := ::nWidth() - If( ::oVScroll != Nil, 16, 0 ),;
         nWide := 0,;
         nCols := Len( ::aColumns ),;
         nPos := ::nColPos,;
         nFirst := If( ::lLockFreeze .and. ::nFreeze > 0, ::nFreeze + 1, 1 )

   ::nOldCell := ::nCell

   If ::lIsTxt
        If ::nAt > 11
            ::nAt := ::nAt - 10
        Else
            ::nAt := 1
      EndIf
      If ::oHScroll != Nil
            ::oHScroll:SetPos( ::nAt )
      EndIf
      ::Refresh( .F. )
        Return Self
   EndIf

   If ::nFreeze >= nCols
      Return Self
   EndIf

   AEval( ::aColSizes, { | nSize | nWide += nSize } )

   If  nWide <= nWidth                           // browse fits all inside
        ::nCell := nFirst                          // window or dialog
        ::nColPos := 1
    Else
        nWide := ::aColSizes[nPos]
        For nI := nPos - 1 To nFirst Step - 1
            If nWide <= nWidth
            nWide += ::aColSizes[ nI ]
                ::nCell := nI
            Else
                Exit
         EndIf
        Next
        ::nColPos := ::nCell                       // current column becomes first in offset
   EndIf

   If ! ::lCellBrw .and. ! ::lLockFreeze .and. ;  // for frozen columns
         ::nFreeze > 0 .and. ::nCell - 1 == 1
        ::nCell := ::nColPos := ::nFreeze
   EndIf

   If ::nCell != ::nOldCell
      ::Refresh( .F. )
   EndIf

   If ::lCellBrw

      If ::aColumns[ ::nCell ]:bGotFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nCell ]:bGotFocus, ::nOldCell, ::nCell, Self )
      EndIf

      If ::aColumns[ ::nOldCell ]:bLostFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nOldCell ]:bLostFocus, ::nCell, ::nOldCell, Self )
      EndIf

      ::nOldCell := ::nCell

   EndIf

   If ::oHScroll != Nil
        ::oHScroll:SetPos( ::nCell )
   EndIf

   If ::lCellBrw
      ::HiliteCell( ::nCell )
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:PanRight() Version 7.0 Jul/15/2004
* ============================================================================

METHOD PanRight() CLASS TSBrowse

   Local nTxtWid, nI,;
         nWidth := ::nWidth() - If( ::oVScroll != Nil, 16, 0 ),;
         nWide := 0,;
         nCols := Len( ::aColumns ),;
         nPos := ::nColPos

   ::nOldCell := ::nCell

   If ::lIsTxt

      nTxtWid := Max( 1, GetTextWidth( 0, "B", If( ::hFont != nil, ::hFont, 0 ) ) )

      If ::nAt < ::oTxtFile:nMaxLineLength - 21 - Int( nWidth / nTxtWid )
          ::nAt := ::nAt + 20
      Else
          ::nAt := ::oTxtFile:nMaxLineLength - Int( nWidth / nTxtWid )
      EndIf

      If ::oHScroll != Nil
          ::oHScroll:SetPos( ::nAt )
      EndIf

      ::Refresh( .F. )
      Return Self
   EndIf

   If ::nFreeze >= nCols
      Return Self
   EndIf

   AEval( ::aColSizes, {|nSize| nWide += nSize }, nPos )

   If ::nFreeze > 0
        AEval( ::aColSizes, {|nSize| nWide += nSize }, 1, ::nFreeze )
   EndIf

   If nWide <= nWidth     // we're in last columns (including the current one),
      ::nCell := nCols    // so just ::nCell changes, not ::nColPos
   Else
      nWide := 0
      AEval( ::aColSizes, {|nSize| nWide += nSize }, nPos + 1 )

      If ::nFreeze > 0
            AEval( ::aColSizes, {|nSize| nWide += nSize }, 1, ::nFreeze )
      EndIf

      If nWide <= nWidth .and. nPos < nCols      // the remaining columns are added
            ::nCell := nPos + 1                  // the last in the browse
            nPos := nCols                        // so as to avoid For..Next
      EndIf

      nWide := ::aColSizes[nPos]

      For nI := nPos + 1 To nCols
         If ( nWide + ::aColSizes[nI] <= nWidth ) .or. ;
               ( nI - nPos < 2 .and. nWide + ::aColSizes[nI] > nWidth )  // two consecutive very wide columns
                nWide += ::aColSizes[nI]
                ::nCell := nI
            Else
                Exit
         EndIf
        Next
        ::nColPos := ::nCell                    // last column becomes first in offset
   EndIf

   If ! ::lCellBrw .and. ;                      // for frozen columns
       If( ::nFreeze > 0, ::IsColVis2( nCols ), ::IsColVisible( nCols ) )
       ::nCell := nCols
   EndIf

   If ::nCell != ::nOldCell
      ::Refresh( .F. )
   EndIf

   If ::lCellBrw

      If ::aColumns[ ::nCell ]:bGotFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nCell ]:bGotFocus, ::nOldCell, ::nCell, Self )
      EndIf

      If ::aColumns[ ::nOldCell ]:bLostFocus != Nil .and. ::nOldCell != ::nCell
         Eval( ::aColumns[ ::nOldCell ]:bLostFocus, ::nCell, ::nOldCell, Self )
      EndIf

      ::nOldCell := ::nCell

   EndIf

   If ::oHScroll != Nil
        ::oHScroll:SetPos( ::nCell )
   EndIf

    ::HiliteCell( ::nCell )

Return Self

* ============================================================================
* METHOD TSBrowse:Proper() Version 7.0 Jul/15/2004
* ============================================================================

METHOD Proper( cString ) CLASS TSBrowse

   Local nPos, cChr, cTxt, cAnt, nLen := Len( cString )

   cString := Lower( Trim( cString ) ) + " "

   nPos := 1
   cAnt := "."
   cTxt := ""

   While nPos <= Len( cString )
      cChr := SubStr( cString, nPos, 1 )
      cTxt += If( cAnt $ '".,-/ (', Upper( cChr ), ;
                  If( Asc( cChr ) == 209, Chr( 241 ), cChr ) )
      cAnt := cChr
      nPos++
   EndDo

   cTxt := StrTran( cTxt, ::aMsg[ 51 ], Lower( ::aMsg[ 51 ] ) )
   cTxt := StrTran( cTxt, ::aMsg[ 52 ], Lower( ::aMsg[ 52 ] ) )
   cTxt := StrTran( cTxt, ::aMsg[ 53 ], Lower( ::aMsg[ 53 ] ) )
   cTxt := StrTran( cTxt, ::aMsg[ 54 ], Lower( ::aMsg[ 54 ] ) )
   cTxt := StrTran( cTxt, ::aMsg[ 55 ], Lower( ::aMsg[ 55 ] ) )

Return PadR( cTxt, nLen )

* ============================================================================
* METHOD TSBrowse:PostEdit() Version 7.0 Jul/15/2004
* ============================================================================

METHOD PostEdit( uTemp, nCol, bValid ) CLASS TSBrowse

   Local aMoveCell, bRecLock, bAddRec, cAlias, uRet, ;
         nLastKey := ::nLastKey, ;
         lAppend  := ::oWndlAppendMode     //oWnd

   cAlias := If( ::lIsDbf .and. ::aColumns[ nCol ]:cAlias != Nil, ;
                 ::aColumns[ nCol ]:cAlias, ::cAlias )

   aMoveCell := { {|| ::GoRight() }, {|| ::GoDown() }, ;
                  {|| ::GoLeft() },  {|| ::GoUp() }, ;
                  {|| ::GoNext() } }

   bRecLock := If( ! Empty( ::bRecLock ), ::bRecLock, ;
                   {|| ( cAlias )->( RLock() ) } )

   bAddRec := If( ! Empty( ::bAddRec ), ::bAddRec, ;
                  {|| ( cAlias )->( dbAppend() ), ! NetErr() } )

   SysRefresh()
   If bValid != Nil

      uRet := Eval( bValid, uTemp, Self )

      If ValType( uRet ) == "B"
         uRet := Eval( uRet, uTemp, Self )
      EndIf

      If ! uRet

         Tone( 500, 1 )
         ::lEditing  := ::lPostEdit := ::lNoPaint := .F.

         If ::lAppendMode
            ::lAppendMode := .F.
            ::lHitBottom  := .F.
            ::GoBottom()
            ::HiliteCell( nCol )
            lNoAppend := .T.
            ::lCanAppend := .F.
         Else

            ::DrawSelect()
         EndIf

         Return Nil

      EndIf

   EndIf

   If ::lIsDbf

      If Eval( If( ! ::lAppendMode, bRecLock, bAddRec ), uTemp )

         Eval( ::aColumns[ nCol ]:bData, uTemp, Self )

         If ::lAppendMode

            If ! Empty( ::aDefault )
               ASize( ::aDefault, Len( ::aColumns ) )
               AEval( ::aDefault, { | e, n | If( e != Nil .and. ;
               n != nCol, If( Valtype( e ) == "B", ;
               Eval( ::aColumns[ n ]:bData, Eval( e, Self ) ), ;
               Eval( ::aColumns[ n ]:bData, e ) ), Nil ) } )
               ::DrawLine()
            EndIf

            If ::lFilterMode .and. ::aColumns[ nCol ]:lIndexCol

               If &( ( cAlias )->( IndexKey() ) ) >= ::uValue1 .and. ;
                  &( ( cAlias )->( IndexKey() ) ) <= ::uValue2

                  ::nLen := ( cAlias )->( Eval( ::bLogicLen() ) )
                  ::nRowPos := ::nAt := Min( ::nRowCount, ::nLen )
               Else
                  ::lChanged := .F.
                  ( cAlias )->( DbGoTo( ::nPrevRec ) )
                  ::Refresh( .F. )
               EndIf

            Else
               ::nLen++
            EndIf

            ::lAppendMode := .F.

            If ::nRowPos == 0 .and. ::lDrawHeaders
               ::nRowPos := ::nAt := 1
            EndIf

            If ::oVScroll != Nil
               ::oVScroll:SetRange( 1, Max( 1, ::nLen ) )
               ::oVScroll:SetPos( ::RelPos( ::nLogicPos() ) )
            EndIf

            ::DrawLine( ::nRowPos )

         EndIf

         If ::aColumns[ nCol ]:bPostEdit != Nil
            Eval( ::aColumns[ nCol ]:bPostEdit, uTemp, Self, lAppend )
         EndIf

         ::lEditing  := .F.
         ::lPostEdit := .F.
         ::lUpdated  := .T.
         ( cAlias )->( DbUnLock() )

         If lAppend

            If ::bChange != Nil
               Eval( ::bChange, Self, ::oWnd:nLastKey )  //oWnd
            EndIf

            lAppend := .F.
            AEval( ::aColumns, { |oC| lAppend := If( oC:lIndexCol, ;
                                      .T., lAppend ) } )
         EndIf

         If ( ::aColumns[ nCol ]:lIndexCol .and. ::lChanged ) .or. lAppend

            ::lNoPaint := .F.

            If ::lFilterMode

               If &( ( cAlias )->( IndexKey() ) ) >= ::uValue1 .and. ;
                  &( ( cAlias )->( IndexKey() ) ) <= ::uValue2

                  ::UpStable()

               Else
                  ::Reset()
               EndIf

            Else
               ::UpStable()
            EndIf

         EndIf

         ( cAlias )->( DbGoTo( ( cAlias )->( RecNo() ) ) )  // refresh relations just in case that
                                                            // a relation field changes
         If nLastKey == VK_UP
            ::GoUp()
         ElseIf nLastkey == VK_RIGHT
            ::GoRight()
         ElseIf nLastkey == VK_LEFT
            ::GoLeft()
         ElseIf nLastkey == VK_DOWN
            ::GoDown()
         ElseIf ::aColumns[ nCol ]:nEditMove >= 1 .and. ;
            ::aColumns[ nCol ]:nEditMove <= 5  // excel-like behavior post-edit movment
            Eval( aMoveCell[ ::aColumns[ nCol ]:nEditMove] )
         ElseIf ::aColumns[ nCol ]:nEditMove == 0 .and. ! ::lAutoEdit
            ::DrawSelect()
         EndIf

         ::oWnd:nLastKey := Nil

         If ::lAutoEdit .and. ! lAppend
            SysRefresh()

            If ! ::aColumns[ ::nCell ]:lCheckBox
               ::PostMsg( WM_KEYDOWN, VK_RETURN, nMakeLong( 0, 0 ) )
            EndIf

            Return Nil
         Endif

      Else
         If ! ::lAppendMode .and. Empty( ::bRecLock )
            MsgStop( ::aMsg[ 3 ], ::aMsg[ 4 ] )
         ElseIf ::lAppendMode .and. Empty( ::bAddRec )
            MsgStop( ::aMsg[ 5 ], ::aMsg[ 4 ] )
         EndIf
      EndIf

   Else

      If ::lAppendMode .and. ::lIsArr
         // when ::aDefValue[1] == Nil, it flags this element
         // as the equivalent of the "record no" for the array
         // this is why ::aDefValue will have one more element
         // than Len( ::aArray )
         ::lAppendMode := .F.
         AAdd( ::aArray, ;
               Array( Len( ::aDefValue ) - ;
                      If( ::aDefValue[ 1 ] == Nil, 1, 0 ) ) )
         ::nAt := ::nLen := Len( ::aArray )

         If ::oVScroll != Nil
            ::oVScroll:SetRange( 1, Max( 1, ::nLen ) )
            ::oVScroll:GoBottom()
         EndIf

         AEval( ATail( ::aArray ), { | uVal, n | ::aArray[ ::nAt, n ] := ;
                ::aDefValue[ n + If( ::aDefValue[ 1 ] == Nil, 1, 0 ) ],HB_SYMBOL_UNUSED( uVal ) } )

      EndIf

      Eval( ::aColumns[ nCol ]:bData, uTemp )

      If ::aColumns[ nCol ]:bPostEdit != Nil
         Eval( ::aColumns[ nCol ]:bPostEdit, uTemp, Self, lAppend )
      EndIf

      ::lEditing  := .F.
      ::lPostEdit := .F.

      If lAppend .and. ! Empty( ::aDefault )
         ASize( ::aDefault, Len( ::aColumns ) )
         AEval( ::aDefault, { | e, n | If( e != Nil .and. ;
                n != nCol, If( Valtype( e ) == "B", ;
                Eval( ::aColumns[ n ]:bData, Eval( e, Self ) ), ;
                Eval( ::aColumns[ n ]:bData, e ) ), Nil ) } )
         ::DrawLine()
      EndIf

      If lAppend .and. ::nLen <= ::nRowCount()
         ::Refresh( .T. )
         ::nRowPos := Min( ::nRowCount, ::nLen )
      EndIf

      If lAppend .and. ::bChange != Nil
         Eval( ::bChange, Self, ::oWnd:nLastKey )
      EndIf

      If nLastKey == VK_UP
         ::GoUp()
      ElseIf nLastkey == VK_RIGHT
         ::GoRight()
      ElseIf nLastkey == VK_LEFT
         ::GoLeft()
      ElseIf nLastkey == VK_DOWN
         ::GoDown()
      ElseIf ::aColumns[ nCol ]:nEditMove >= 1 .and. ;
         ::aColumns[ nCol ]:nEditMove <= 5  // excel-like behaviour post-edit movment
         Eval( aMoveCell[ ::aColumns[ nCol ]:nEditMove ] )
      ElseIf ::aColumns[ nCol ]:nEditMove == 0
         ::DrawSelect()
      EndIf

      ::oWnd:nLastKey := Nil
      If ::lAutoEdit .and. ! lAppend
         SysRefresh()  //1.50
         ::DrawLine()
         If ! ::aColumns[ ::nCell ]:lCheckBox
            ::PostMsg( WM_KEYDOWN, VK_RETURN, nMakeLong( 0, 0 ) )
         EndIf
         Return Nil
      Endif

   EndIf

Return Nil

* ============================================================================
* METHOD TSBrowse:RButtonDown() Version 7.0 Jul/15/2004
* ============================================================================

METHOD RButtonDown( nRowPix, nColPix, nFlags ) CLASS TSBrowse

   Local nRow, nCol, nSkipped, bRClicked, lHeader, lFooter, lSpecHd, ;
         uPar1 := nRowPix, ;
         uPar2 := nColPix

   HB_SYMBOL_UNUSED( nFlags )

   ::lNoPaint := .F.

   ::SetFocus()
   ::oWnd:nLastKey := 0
   If ::nLen < 1
      Return 0
   EndIf

   nRow    := ::GetTxtRow( nRowPix )
   nCol    := ::nAtCol( nColPix )
   lHeader := ( nRow == 0 )
   lFooter := ( nRow == -1 )
   lSpecHd := ( nRow == -2 )

   If nRow > 0

      If nCol <= ::nFreeze .and. ::lLockFreeze
         Return 0
      EndIf

      If ::lNoMoveCols
         Return 0
      EndIf

      ::ResetSeek()
      ::DrawLine()

      nSkipped  := ::Skip( nRow - ::nRowPos )
      ::nRowPos += nSkipped
      ::nCell := nCol

      If ! ::lNoVScroll
         ::oVScroll:SetPos( ::RelPos( ::nLogicPos() ) )
      EndIf

      If ! ::lNoHScroll
         ::oHScroll:SetPos( ::nCell )
      EndIf

      If nSkipped != 0 .and. ::bChange != Nil
         Eval( ::bChange, Self, ::oWnd:nLastKey )   //oWnd
      Endif

      If ::lCellBrw

         If ::aColumns[ ::nCell ]:bGotFocus != Nil .and. ::nOldCell != ::nCell
            Eval( ::aColumns[ ::nCell ]:bGotFocus, ::nOldCell, ::nCell, Self )
         EndIf

         If ::aColumns[ ::nOldCell ]:bLostFocus != Nil .and. ::nOldCell != ::nCell
            Eval( ::aColumns[ ::nOldCell ]:bLostFocus, ::nCell, ::nOldCell, Self )
         EndIf

         ::nOldCell := ::nCell
         ::HiliteCell( ::nCell )

      EndIf

      ::DrawSelect()
      bRClicked := If( ::aColumns[ nCol ]:bRClicked != Nil, ;
                       ::aColumns[ nCol ]:bRClicked, ::bRClicked )

      If bRClicked != Nil
         Return Eval( bRClicked, uPar1, uPar2, ::nAt )
      EndIf

   ElseIf lHeader
      If ::aColumns[ nCol ]:bHRClicked != Nil
         Eval( ::aColumns[ nCol ]:bHRClicked, uPar1, uPar2, ::nAt )
      EndIf
   ElseIf lSpecHd
      If ::aColumns[ nCol ]:bSRClicked != Nil
         Eval( ::aColumns[ nCol ]:bSRClicked, uPar1, uPar2, ::nAt )
      EndIf
   ElseIf lFooter
      If ::aColumns[ nCol ]:bFRClicked != Nil
         Eval( ::aColumns[ nCol ]:bFRClicked, uPar1, uPar2, ::nAt )
      EndIf
   EndIf

Return 0

* ============================================================================
* METHOD TSBrowse:_RecCount() Version 7.0 Jul/15/2004
* ============================================================================

METHOD _RecCount() CLASS TSBrowse

   Local nLen := 0, ;
         nRecNo := ( ::cAlias )->( RecNo() )

   ::nFirstKey := 0

   Eval( ::bGoTop )

   If ! ( ::cAlias )->( EoF() ) .and.  ( If( ! ::lDescend, ;
                       ( &( ( ::cAlias )->( IndexKey() ) ) <= ::uValue2 ), ;
                       ( &( ( ::cAlias )->( IndexKey() ) ) >= ::uValue2 ) ) )

      While ::bFilter != Nil .and. ! Eval( ::bFilter ) .and. ! ( ::cAlias )->( EoF() )
         ( ::cAlias )->( DbSkip( 1 ) )
      EndDo

      ::nFirstKey := ( ::cAlias )->( Eval( ::bKeyNo ) ) - 1
      ( ::cAlias )->( DbGoBottom() )
      Eval( ::bGoBottom() )
      nLen := ( ::cAlias )->( Eval( ::bKeyNo ) ) - ::nFirstKey

   EndIf

   ( ::cAlias )->( DbGoTo( nRecNo ) )

Return nLen

* ============================================================================
* METHOD TSBrowse:RelPos() Version 7.0 Jul/15/2004
* Calculates the relative position of vertical scroll box in huge databases
* ============================================================================

METHOD RelPos( nLogicPos ) CLASS TSBrowse

   Local nRet

   If ::nLen > MAX_POS
      nRet := Int( nLogicPos * ( MAX_POS / ::nLen ) )
   Else
      nRet := nLogicPos
   EndIf

Return nRet

* ============================================================================
* METHOD TSBrowse:Report() Version 7.0 Jul/15/2004
* ============================================================================

METHOD Report( cTitle, aCols, lPreview, lMultiple, lLandscape, lFromPos ) CLASS TSBrowse

   Local nI, nSize, cAlias, cFilterBlock, ;
         aHeader1 := {}, ;
         aHeader2 := {}, ;
         aFields  := {}, ;
         aWidths  := {}, ;
         hFont    := ::hFont

   Default cTitle     := ::oWnd:GetText(), ;
           lPreview   := .T., ;
           lMultiple  := .F., ;
           lLandscape := .F., ;
           lFromPos   := .F.

   ::lNoPaint := .F.

   If aCols == Nil

      aCols := {}

      For nI := 1 To Len( ::aColumns )
         AAdd( aCols, nI )
      Next

   EndIf

   If ::lIsDbf
      cAlias := ::cAlias
   EndIf

   if lFromPos
      ::lNoResetPos := .F.
   else
      ::GoTop()
   endif
   Eval( ::bGoTop )

   For nI := 1 To Len( aCols )

      If ! ::aColumns[ aCols[ nI ] ]:lBitMap
         nSize := Max( 1, Round( ::aColSizes[ aCols[ nI ] ] / ;
                                 GetTextWidth( 0, "b", If( hFont != Nil, ;
                                                           hFont, ::hFont ) ), 0 ) )
         AAdd (aWidths, nSize)
         AAdd (aHeader1 ,"")
         AAdd (aHeader2 ,::aColumns[ aCols[ nI ] ]:cHeading )
         AAdd (AFields  ,::aColumns[ aCols[ nI ] ]:cData )

      EndIf

   Next

   If ::lIsDbf .AND. ::lFilterMode

      cFilterBlock := BuildFiltr( ::cField, ::uValue1, ::uValue2, SELF )

      ( cAlias )->( DbSetFilter( &(cFilterBlock) , cFilterBlock ) )
      ( cAlias )->( DbGoTop() )

   endif

   easyreport ( cTitle +"|"+ ::aMsg[ 20 ] + Space( 1 ) + ;
      DToC( Date() ) + " - " + ::aMsg[ 22 ] + ;
      Space( 1 ) + Time() , ;
      aHeader1 , aHeader2 , ;
      aFields , aWidths , , ,.F. , lPreview ,,,,,, ;
      lMultiple ,,,     ;
      lLandscape ,,.t., ;
      cAlias ,,, ;
      DMPAPER_A4 , )

   If ::lIsDbf .AND. ::lFilterMode
      ( cAlias )->( DbClearFilter() )
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:Reset() Version 7.0 Jul/15/2004
* ============================================================================

METHOD Reset( cField, uVal1, uVal2 ) CLASS TSBrowse

   Local nMin, nMax, nPage

   Default cField := ::cField, ;
           uVal1  := ::uValue1, ;
           uVal2  := uVal1

   ::nRowPos := 1
   ::nColPos := 1
   ::lHitBottom := .F.
   ::lHitTop := .F.
   ::lAppendMode := .F.

   If ::lIsDbf
      If cField != Nil
         ::SetFilter( cField, uVal1, uVal2 )
      Else
         ::nLen := ( ::cAlias )->( Eval( ::bLogicLen ) )
      EndIf
   Else
      ::nLen := Eval( ::bLogicLen )
   EndIf

   If ! ::lNoVScroll
      If ::nLen <= ::nRowCount .and. ::oVScroll != Nil
         ::oVScroll:nMax := -1
      Else
         nMin  := Min( 1, ::nLen )
         nMax  := Min( ::nLen, MAX_POS )
         nPage := Min( ::nRowCount(), ::nLen )
         ::oVScroll := TSBScrlBar():WinNew( nMin, nMax, nPage, .T., Self )
//         ::oVScroll:SetPage( nPage, .T. )
      EndIf

   EndIf

   ::Refresh( .T. )

Return Self

* ============================================================================
* METHOD TSBrowse:ResetBarPos() Version 7.0 Jul/15/2004
* ============================================================================

METHOD ResetBarPos( lInit ) CLASS TSBrowse

   Local cRDDName, cType, cOrderName, cAlias, nLogicPos, nMin, nMax, nPage

   Default lInit := .F., ;
           ::lIsArr := ::cAlias == "ARRAY", ;
           ::lIsTxt := "TEXT_" $ ::cAlias

   If lInit
      ::cDriver   := "NONE"          // anything different from a database
      ::lClipMore := .F.
   EndIf

   If ! Empty( ::cAlias ) .and. ! ::lIsArr .and. ! ::lIsTxt

      cAlias := ::cAlias

      If lInit .and. ( ( cAlias )->( RddName() ) == 'ADORDD' .or. ! Empty( ( cAlias )->( IndexKey() ) ) )

         If ( cAlias )->( Used() )
                cRddName := ( cAlias )->( RddName() )
            Else
                cRddName := RddSetDefault()
         EndIf

         #ifdef __HARBOUR__
            cRddName := If( cRddName == "DBF", "DBFNTX", cRddName )
         #endif

         If cRDDName == "COMIX"
               ::cDriver := "COMIX"
            ::bTagOrder := &( "{|uTag|OrdSetFocus(uTag)}" )
            cType := Type( "cmKeyNo()" )
            If ( ::lClipMore := ( cType == "C" .or. cType == "UI" ) )
               ::bKeyNo    := &( "{|cTag|cmKeyNo(cTag) }" )
               ::bLogicLen := If( ::lFilterMode,;
                                  {||(::cAlias)->(Self:RecCount(::uValue1))}, ;
                                  &( "{|cTag| cmKeyCount( cTag ) }" ) )
               ::bGoToPos  := &( "{|n| cmKeyGoTo( n ) }" )
            Else
               ::bKeyNo    := &( "{|cTag|cmxKeyNo(cTag)}" )
               ::bLogicLen := If( ::lFilterMode,;
                                  {||(::cAlias)->(Self:RecCount(::uValue1))}, ;
                                  &( "{|cTag| cmxKeyCount( cTag ) }" ) )
               ::bGoToPos  := &( "{|n| cmxKeyGoTo( n ) }" )
            EndIf
         Elseif cRDDName $ "DBFCDX_DBFCDX"
               ::cDriver   := "CDX"
            ::bKeyNo    := &( "{|uTag|OrdKeyNo(uTag)}" )
            ::bLogicLen := If( ::lFilterMode,;
                               {||(::cAlias)->(Self:RecCount(::uValue1))}, ;
                               &( "{|cTag|OrdKeyCount(cTag)}" ) )
            ::bGoToPos  := &( "{|n|OrdKeyGoTo(n) }" )
            ::bTagOrder := &( "{|uTag|OrdSetFocus(uTag)}" )
         Elseif "XAX" $ cRDDName
            ::cDriver   := "ADS"
            ::bKeyNo    := &( "{||AX_KeyNo()}" )
            ::bLogicLen := If( ::lFilterMode,;
                               {||(::cAlias)->(Self:RecCount(::uValue1))}, ;
                               &( "{|cTag| AX_KeyCount( cTag ) }" ) )
            ::bTagOrder := &( "{|uTag|OrdSetFocus(uTag)}" )
         Elseif "ADS" $ cRDDName
            ::cDriver   := "ADS"
            ::bKeyNo    := &( "{||ADSKeyNo()}" )
            ::bLogicLen := If( ::lFilterMode,;
                               {||(::cAlias)->(Self:RecCount(::uValue1))}, ;
                               &( "{|cTag| ADSKeyCount( cTag,, 1 ) }" ) )
            ::bTagOrder := &( "{|uTag|OrdSetFocus(uTag)}" )
         Elseif cRDDName $ "DBFNSX_SIXCDX_SIXNSX_SIXMDX"
               ::cDriver   := "NSX"
            ::bKeyNo    := &( "{||sx_KeyNo()}" )
            ::bLogicLen := If( ::lFilterMode,;
                               {||(::cAlias)->(Self:RecCount(::uValue1))}, ;
                               &( "{|cTag| Sx_KeyCount(cTag)}" ) )
            ::bGoToPos  := &( "{|n| sx_KeyGoTo( n ) }" )
            cType := Type( "sx_SetTagO()" )

            If cType == "C" .or. cType == "UI"
               ::bTagOrder := &( "{|cTag| sx_SetTagOrder( cTag ) }" )
            Else
               ::bTagOrder := &( "{|cTag| OrdSetFocus(cTag) }" )
            EndIf

         Elseif "ADORDD" $ cRDDName
            ::cDriver   :=  "ADO"
            ::bGoToPos  := Nil
            ::bLogicLen := If( ::lFilterMode,;
                               {||(::cAlias)->(Self:RecCount(::uValue1))}, ;
                               {||(::cAlias)->(LastRec())} )
            ::bTagOrder := &( "{|nTag| OrdSetFocus(nTag) }" )
            ::bKeyNo    := { || ( cAlias )->( Recno() ) }

         Else                                    // DBFNTX considered default RDD
            ::cDriver   := "NTX"
            ::bGoToPos  := Nil
            ::bLogicLen := If( ::lFilterMode,;
                               {||(::cAlias)->(Self:RecCount(::uValue1))}, ;
                               {||(::cAlias)->(LastRec())} )
#ifndef HB_C52_STRICT
            ::bKeyNo := &( "{|uTag|OrdKeyNo(If(uTag==Nil,IndexOrd(),uTag))}" )
            ::bTagOrder := &( "{|uTag|If(uTag==Nil,IndexOrd(),OrdSetFocus(uTag))}" )
#else
            ::bTagOrder := &( "{|nTag|If(nTag==Nil,IndexOrd(),DbSetOrder(nTag))}" )
            ::bKeyNo := {||(cAlias)->(OrdKeyNo(IndexOrd()))}
#endif
         EndIf

      Elseif lInit .and. Empty( ( cAlias )->( IndexKey() ) )
        ::bKeyNo    := { || ( cAlias )->( Recno() ) }
        ::bLogicLen := { || ( cAlias )->( LastRec() ) }
        ::bGoToPos  := { |n| ( cAlias )->( DbGoTo( n ) ) }
      EndIf

      cOrderName := If( ::bTagOrder != Nil, ( cAlias )->( Eval( ::bTagOrder ) ), Nil )  // only used by Comix/ClipMore RDD
      nLogicPos  := ( cAlias )->( Eval( ::bKeyNo, cOrderName ) )

      If ::nLen == 0
         ::nLen := ( cAlias )->( Eval( ::bLogicLen ) )
      EndIf

      If lInit .and. ! ::lNoVScroll .and. ::lFilterMode
         nMin  := Min( 1, ::nLen )
         nMax  := Min( ::nLen, MAX_POS )
         nPage := Min( ::nRowCount(), ::nLen )
         ::oVScroll := TSBScrlBar():WinNew( nMin, nMax, nPage, .T., Self )
         ::oVScroll:SetPos( ::RelPos( nLogicPos ) )
      ElseIf ::oVScroll != Nil
         ::oVScroll:SetRange( 1, Max( 1, Min( ::nLen, MAX_POS ) ) )
         ::oVScroll:SetPos( ::RelPos( nLogicPos ) )
         ::oVScroll:SetPage( Min( ::nRowCount(), ::nLen ), .T. )
      EndIf

      If nLogicPos > 0 .and. nLogicPos < ::nRowPos
         ::nRowPos := nLogicPos
      EndIf

   Else
      If lInit .and. ! ::lNoVScroll
         nMin  := Min( 1, ::nLen )
         nMax  := Min( ::nLen, MAX_POS )
         nPage := Min( ::nRowCount(), ::nLen )
         ::oVScroll := TSBScrlBar():WinNew( nMin, nMax, nPage, .T., Self )
         ::oVScroll:SetPos( ::RelPos( ::nLogicPos() ) )
      ElseIf ::oVScroll != Nil
         ::oVScroll:SetRange( 1, Max( 1, Min( ::nLen, MAX_POS ) ) )
         ::oVScroll:SetPos( ::RelPos( ::nLogicPos() ) )
         ::oVScroll:SetPage( Min( ::nRowCount(), ::nLen ), .T. )
      EndIf
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:ResetSeek() Version 7.0 Jul/15/2004
* ============================================================================

METHOD ResetSeek() CLASS TSBrowse

   If ::nColOrder > 0
      If ::cOrderType == "D"
         ::cSeek := "  /  /    "
      Else
         ::cSeek := ""
      EndIf
   EndIf

   If ::bSeekChange != Nil
      Eval( ::bSeekChange )
   EndIf

   nNewEle := 0

Return ::cSeek

* ============================================================================
* METHOD TSBrowse:ReSize() Version 7.0 Jul/15/2004
* ============================================================================

METHOD ReSize( nSizeType, nWidth, nHeight ) CLASS TSBrowse

   Local nMin, nMax, nPage, ;
         nTotPix := 0

   AEval( ::aColSizes, {|n| nTotPix += n } )

   If ::lEditing .and. ::aColumns[ ::nCell ]:oEdit != Nil
      SendMessage( ::aColumns[ ::nCell ]:oEdit:hWnd, WM_KEYDOWN, VK_ESCAPE, 0 )
   EndIf

   If ! Empty( ::nAdjColumn )
      ::nAdjColumn := Min( Len( ::aColumns ), ::nAdjColumn )
   EndIf

   ::nRowPos := Min( ::nRowPos, Max( ::nRowCount(), 1 ) )

   If ! Empty( ::nAdjColumn ) .and. nTotPix != nWidth
      ::aColumns[ ::nAdjColumn ]:nWidth := ;
      ::aColSizes[ ::nAdjColumn ] += ( nWidth - nTotPix )
   EndIf

   If ! ::lNoVScroll

      nMin  := Min( 1, ::nLen )
      nMax  := Min( ::nLen, MAX_POS )
      nPage := Min( ::nRowCount(), ::nLen )

      If ::oVScroll == Nil
         ::oVScroll := TSBScrlBar():WinNew( nMin, nMax, nPage, .T., Self )
      EndIf

      ::oVScroll:SetRange( 1, nMax )
      ::oVScroll:SetPage( nPage, .T. )

   EndIf

Return Super:ReSize( nSizeType, nWidth, nHeight )

* ============================================================================
* METHOD TSBrowse:Seek() Version 7.0 Jul/15/2004
* ============================================================================

METHOD Seek( nKey ) CLASS TSBrowse

    Local nIdxLen, cPrefix, ;
          nLines    := ::nRowCount(), ;
          lFound    , ;
          lEoF      , ;
          lTrySeek  := .T., ;
          nRecNo    , ;
          cSeek     := ::cSeek, ;
          xSeek

   If ( Seconds() - nLapsus ) > 3 .or. ( Seconds() - nLapsus ) < 0
      ::cSeek := cSeek := ""
   EndIf

   nLapsus := Seconds()

   cPrefix := If( ::cPrefix == Nil, "", If( ValType( ::cPrefix ) == "B", ;
                  Eval( ::cPrefix, Self ), ::cPrefix ) )

   If ::nColOrder > 0 .and. ::lIsDbf

      lTrySeek := .T.

      If ::cOrderType == "C"

         nIdxLen := ( ::cAlias )->( Len( Eval( &( "{||" + IndexKey() + "}" ) ) ) )

      EndIf

      If nKey == VK_BACK
         If ::cOrderType == "D"
            cSeek := DateSeek( cSeek, nKey )
         Else
            cSeek := Left( cSeek, Len( cSeek ) - 1 )
         EndIf
      Else
         If ::cOrderType == "D"
            cSeek := DateSeek( cSeek, nKey )
         ElseIf ::cOrderType == "N"
            /* only  0..9, minus and dot*/
            If ( nKey >= 48 .and. nKey <= 57 ) .or. ( nKey >= 45 .or. ;
                 nKey <= 46 )
                cSeek += Chr( nKey )
            Else
               Tone( 500, 1 )
               lTrySeek := .F.
            EndIf
         ElseIf ::cOrderType == "C"
            If Len( cSeek ) < nIdxLen
               cSeek += If( ::lUpperSeek, Upper( Chr( nKey ) ), Chr( nKey ) )
            Else
               Tone( 500, 1 )
               lTrySeek := .F.
            EndIf
         EndIf
      EndIf

      If ::cOrderType == "C"
         xSeek := cPrefix + cSeek
      ElseIf ::cOrderType == "N"
         xSeek := Val( cSeek )
      ElseIf ::cOrderType == "D"
         xSeek := cPrefix + DToS( CToD( cSeek ) )
      Else
         xSeek := cPrefix + cSeek
      EndIf

      If ! ( ::cOrderType == "D" .and. ;
         Len( RTrim( cSeek ) ) < Len( DToC( Date() ) ) ) .and. lTrySeek

         nRecNo := ( ::cAlias )->( RecNo() )
         lFound := ( ::cAlias )->( DbSeek( xSeek, .T. ) )
         lEoF   := ( ::cAlias )->( Eof() )

         If lEoF .or. ( ::cOrderType == "C" .and. ! lFound )
           ( ::cAlias )->( DbGoTo( nRecNo ) )
         EndIf

         If ( ::cOrderType == "C" .and. ! lFound ) .or. lEof

            Tone( 500, 1 )
            If ::cOrderType == "D"
               ::cSeek := DateSeek( cSeek, VK_BACK )
            Else
               ::cSeek := Left( cSeek, Len( cSeek ) - 1 )
            EndIf

            Return Self

         ElseIf ! lFound

            If ::cOrderType == "N"
               ( ::cAlias )->( DbSeek( Val( cSeek ) * 10, .T. ) )
               xSeek := ( ::cAlias )->( Eval( &( "{||" + IndexKey() + "}" ) ) )
               xSeek := Val( Right( LTrim( Str( xSeek ) ), Len( cSeek ) + 1 ) )

               If xSeek > ( ( Val( cSeek ) * 10 ) + 9 )
                  Tone( 500, 1 )
                  ( ::cAlias )->( DbGoTo( nRecNo ) )
                  ::cSeek := Left( cSeek, Len( cSeek ) - 1 )
                  Return Self
               EndIf

            EndIf

            ::cSeek := cSeek
            ( ::cAlias )->( DbGoto( nRecNo ) )
            Return Self

         Else

            ::lHitBottom := ::lHitTop := .F.


               If nRecNo != ( ::cAlias )->( RecNo() ) .and. ::nLen > nLines

                  nRecNo := ( ::cAlias )->( RecNo() )

                  ( ::cAlias )->( DbSkip( nLines - ::nRowPos ) )

                  If ( ::cAlias )->( EoF() )

                     Eval( ::bGoBottom )
                     ::nRowPos := nLines

                     While ::nRowPos > 1 .and. ;
                           ( ::cAlias )->( RecNo() ) != nRecNo

                        ::Skip( -1 )
                        ::nRowPos --

                     EndDo

                  Else
                     ( ::cAlias )->( DbGoTo( nRecNo ) )
                  EndIf

                  ::Refresh( .F. )
                  ::ResetBarPos()

               ElseIf nRecNo != ( ::cAlias )->( RecNo() )

                  nRecNo := ( ::cAlias )->( RecNo() )
                  Eval( ::bGoTop )
                  ::nAt := ::nRowPos := 1

                  While nRecNo != ( ::cAlias )->( RecNo() )
                     ::Skip( 1 )
                     ::nRowPos++
                  EndDo

                  ::Refresh( .F. )
                  ::ResetBarPos()

               EndIf


            If ::bChange != Nil
               Eval( ::bChange, Self, 0 )
            EndIf

         EndIf

      EndIf

      ::cSeek := cSeek


      If ::bSeekChange != Nil
         Eval( ::bSeekChange )
      EndIf

   ElseIf ::nColOrder > 0 .and. ::lIsArr

      lTrySeek := .T.
      nIdxLen := Len( cValToChar( ::aArray[ ::nAt, ::nColOrder ] ) )

      If nKey == VK_BACK

         If ::cOrderType == "D"
            cSeek := DateSeek( cSeek, nKey )
         Else
            cSeek := Left( cSeek, Len( cSeek ) - 1 )
         EndIf

      Else

         If ::cOrderType == "D"
            cSeek := DateSeek( cSeek, nKey )
         ElseIf ::cOrderType == "N"
            /* only  0..9, minus and dot*/
            If ( nKey >= 48 .and. nKey <= 57 ) .or. ( nKey >= 45 .or. ;
                 nKey <= 46 )
                cSeek += Chr( nKey )
            Else
               Tone( 500, 1 )
               lTrySeek := .F.
            EndIf
         ElseIf ::cOrderType == "C"
            If Len( cSeek ) < nIdxLen
               cSeek += If( ::lUpperSeek, Upper( Chr( nKey ) ), Chr( nKey ) )
            Else
               Tone( 500, 1 )
               lTrySeek := .F.
            EndIf
         Else
            Tone( 500, 1 )
            lTrySeek := .F.
         EndIf

      EndIf

      If ::cOrderType == "C"
         xSeek := cPrefix + cSeek
      ElseIf ::cOrderType == "N"
         xSeek := Val( cSeek )
      ElseIf ::cOrderType == "D"
         xSeek := cPrefix + DToS( CToD( cSeek ) )
      Else
         xSeek := cPrefix + cSeek
      EndIf

      If ! ( ::cOrderType == "D" .and. ;
             Len( RTrim( cSeek ) ) < Len( DToC( Date() ) ) ) .and. lTrySeek

         nRecNo := ::nAt
         lFound := ASeek( xSeek,, Self )

         If ! lFound
            ::nAt   := nRecNo
         EndIf

         If ::cOrderType == "C" .and. ! lFound

            Tone( 500, 1 )
            ::cSeek := Left( cSeek, Len( cSeek ) - 1 )
            Return Self

         ElseIf ! lFound

            If ::cOrderType == "N"

               ASeek( Val( cSeek ) * 10, .T., Self )
               xSeek := ::aArray[ ::nAt, ::nColOrder ]
               xSeek := Val( Right( LTrim( Str( xSeek ) ), Len( cSeek ) + 1 ) )
               If xSeek > ( ( Val( cSeek ) * 10 ) + 9 )
                  Tone( 500, 1 )
                  ::cSeek := Left( cSeek, Len( cSeek ) - 1 )
                  ::nAt := nRecNo
                  Return Self
               EndIf
            EndIf

            ::cSeek := cSeek
            ::nAt   := nRecNo
            Return Self

         Else

            If nRecNo != ::nAt .and. ::nLen > nLines

               nRecNo := ::nAt

               ::nAt += ( nLines - ::nRowPos )


               If ::nAt > ::nLen

                  Eval( ::bGoBottom )
                  ::nRowPos := nLines

                  While ::nRowPos > 1 .and. ::nAt != nRecNo

                     ::Skip( -1 )
                     ::nRowPos --

                  EndDo

               Else
                  ::nAt := nRecNo
               EndIf

               ::Refresh( .F. )
               ::ResetBarPos()

            ElseIf nRecNo != ::nAt

               nRecNo := ::nAt
               Eval( ::bGoTop )
               ::nAt := ::nRowPos := 1

               While nRecNo != ::nAt
                  ::Skip( 1 )
                  ::nRowPos++
               EndDo

               ::Refresh( .F. )
               ::ResetBarPos()

            EndIf

            If ::bChange != Nil
               Eval( ::bChange, Self, 0 )
            EndIf

         EndIf

      EndIf

      ::cSeek := cSeek

      If ::bSeekChange != Nil
         Eval( ::bSeekChange )
      EndIf

   EndIf

   If ! lTrySeek
      ::ResetSeek()
   EndIf

   If ::lIsArr .and. ::bSetGet != Nil
      If ValType( Eval( ::bSetGet ) ) == "N"
         Eval( ::bSetGet, ::nAt )
      ElseIf ::nLen > 0
         Eval( ::bSetGet, ::aArray[ ::nAt, 1 ] )
      Else
         Eval( ::bSetGet, "" )
      EndIf
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:Set3DText() Version 7.0 Jul/15/2004
* ============================================================================

METHOD Set3DText( lOnOff, lRaised, nColumn, nLevel, nClrLight, ;
                  nClrShadow ) CLASS TSBrowse

   Local nEle

   Default lOnOff     := .T., ;
           lRaised    := .T., ;
           nClrLight  := GetSysColor( COLOR_BTNHIGHLIGHT ), ;
           nClrShadow := GetSysColor( COLOR_BTNSHADOW )

   If Empty( ::aColumns )
      Return Self
   EndIf

   If ! lOnOff
      If Empty( nColumn )
         If Empty( nLevel )
            For nEle := 1 To Len( ::aColumns )
               ::aColumns[ nEle ]:l3DTextCell := Nil
               ::aColumns[ nEle ]:l3DTextHead := Nil
               ::aColumns[ nEle ]:l3DTextFoot := Nil
            Next
         ElseIf nLevel == 1
            For nEle := 1 To Len( ::aColumns )
               ::aColumns[ nEle ]:l3DTextCell := Nil
            Next
         ElseIf nLevel == 2
            For nEle := 1 To Len( ::aColumns )
               ::aColumns[ nEle ]:l3DTextHead := Nil
            Next
         Else
            For nEle := 1 To Len( ::aColumns )
               ::aColumns[ nEle ]:l3DTextFoot := Nil
            Next
         EndIf

      ElseIf Empty( nLevel )
         ::aColumns[ nColumn ]:l3DTextCell := Nil
         ::aColumns[ nColumn ]:l3DTextHead := Nil
         ::aColumns[ nColumn ]:l3DTextFoot := Nil
      ElseIf nLevel == 1
         ::aColumns[ nColumn ]:l3DTextCell := Nil
      ElseIf nLevel == 2
         ::aColumns[ nColumn ]:l3DTextHead := Nil
      Else
         ::aColumns[ nColumn ]:l3DTextFoot := Nil
      EndIf

      Return Self

   EndIf

   If Empty( nColumn )
      If Empty( nLevel )
         For nEle := 1 To Len( ::aColumns )
            ::aColumns[ nEle ]:l3DTextCell  := lRaised
            ::aColumns[ nEle ]:l3DTextHead  := lRaised
            ::aColumns[ nEle ]:l3DTextFoot  := lRaised
            ::aColumns[ nEle ]:nClr3DLCell  := nClrLight
            ::aColumns[ nEle ]:nClr3DLHead  := nClrLight
            ::aColumns[ nEle ]:nClr3DLFoot  := nClrLight
            ::aColumns[ nEle ]:nClr3DSCell  := nClrShadow
            ::aColumns[ nEle ]:nClr3DSHead  := nClrShadow
            ::aColumns[ nEle ]:nClr3DSFoot  := nClrShadow
         Next
      ElseIf nLevel == 1
         For nEle := 1 To Len( ::aColumns )
            ::aColumns[ nEle ]:l3DTextCell  := lRaised
            ::aColumns[ nEle ]:nClr3DLCell  := nClrLight
            ::aColumns[ nEle ]:nClr3DSCell  := nClrShadow
         Next
      ElseIf nLevel == 2
         For nEle := 1 To Len( ::aColumns )
            ::aColumns[ nEle ]:l3DTextHead  := lRaised
            ::aColumns[ nEle ]:nClr3DLHead  := nClrLight
            ::aColumns[ nEle ]:nClr3DSHead  := nClrShadow
         Next

      Else
         For nEle := 1 To Len( ::aColumns )
            ::aColumns[ nEle ]:l3DTextFoot  := lRaised
            ::aColumns[ nEle ]:nClr3DLFoot  := nClrLight
            ::aColumns[ nEle ]:nClr3DSFoot  := nClrShadow
         Next
      EndIf
   Else
      If Empty( nLevel )
         ::aColumns[ nColumn ]:l3DTextCell  := lRaised
         ::aColumns[ nColumn ]:l3DTextHead  := lRaised
         ::aColumns[ nColumn ]:l3DTextFoot  := lRaised
         ::aColumns[ nColumn ]:nClr3DLCell  := nClrLight
         ::aColumns[ nColumn ]:nClr3DLHead  := nClrLight
         ::aColumns[ nColumn ]:nClr3DLFoot  := nClrLight
         ::aColumns[ nColumn ]:nClr3DSCell  := nClrShadow
         ::aColumns[ nColumn ]:nClr3DSHead  := nClrShadow
         ::aColumns[ nColumn ]:nClr3DSFoot  := nClrShadow
      ElseIf nLevel == 1
         ::aColumns[ nColumn ]:l3DTextCell  := lRaised
         ::aColumns[ nColumn ]:nClr3DLCell  := nClrLight
         ::aColumns[ nColumn ]:nClr3DSCell  := nClrShadow
      ElseIf nLevel == 2
         ::aColumns[ nColumn ]:l3DTextHead  := lRaised
         ::aColumns[ nColumn ]:nClr3DLHead  := nClrLight
         ::aColumns[ nColumn ]:nClr3DSHead  := nClrShadow
      Else
         ::aColumns[ nColumn ]:l3DTextFoot  := lRaised
         ::aColumns[ nColumn ]:nClr3DLFoot  := nClrLight
         ::aColumns[ nColumn ]:nClr3DSFoot  := nClrShadow
      EndIf
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:SetAlign() Version 7.0 Jul/15/2004
* ============================================================================

METHOD SetAlign( nColumn, nLevel, nAlign ) CLASS TSBrowse


   Default nColumn := 0, ;
            nLevel := 0, ;
            nAlign := DT_LEFT

   If nColumn > 0
      If nLevel > 0

         Do Case
            Case nLevel = 1
               ::aColumns[ nColumn ]:nAlign  := nAlign
            Case nLevel = 2
               ::aColumns[ nColumn ]:nHAlign := nAlign
            Otherwise
               ::aColumns[ nColumn ]:nFAlign := nAlign
         EndCase
      Else
         ::aColumns[ nColumn ]:nAlign := ::aColumns[ nColumn ]:nHAlign := ;
         ::aColumns[ nColumn ]:nFAlign := nAlign
      EndIf
   Else
      If nLevel > 0
         AEval( ::aColumns, { | oCol | If( nLevel = 1, oCol:nAlign := nAlign, ;
                                       If( nLevel = 2, oCol:nHAlign := nAlign, ;
                                           oCol:nFAlign := nAlign ) ) } )
      Else
         AEval( ::aColumns, { | oCol | oCol:nAlign := nAlign, ;
                                       oCol:nHAlign := nAlign, ;
                                       oCol:nFAlign := nAlign } )
      EndIf
   EndIf

   If ::lPainted
      ::Refresh( .T. )
   EndIf


Return Self

* ============================================================================
* METHOD TSBrowse:SetAppendMode() Version 7.0 Jul/15/2004
* Enables append mode in TSBrowse for DBF's and arrays.
* At least one column in TSBrowse must have oCol:lEdit set to TRUE in order
* to work and like direct cell editing.
* ============================================================================

METHOD SetAppendMode( lMode ) CLASS TSBrowse

   Local lPrevMode := ::lCanAppend

   Default lMode    := ! ::lCanAppend, ;
           ::lIsTxt := "TEXT_" $ ::cAlias

   If ! ::lIsTxt
      ::lCanAppend := lMode
   EndIf

Return lPrevMode

* ============================================================================
* METHOD TSBrowse:SetArray() Version 7.0 Jul/15/2004
* ============================================================================

METHOD SetArray( aArray, lListBox, lLoadArray ) CLASS TSBrowse

   Local nColumns, nI, cType, nMax, nColSize, hFont, nSize, cData, nAlign,;
             cHeading, aAlign := { "LEFT", "CENTER", "RIGHT", "VERT" }

   DEFAULT aArray   := {}, ;
           lListBox := .F.,;
           lLoadArray := .f.

   If Len( aArray ) > 0 .and. ValType( aArray[ 1 ] ) != "A"

      ::aArray := {}

      For nI := 1 To Len( aArray )
         AAdd( ::aArray, { aArray[ nI ] } )
      Next

   Else
      ::aArray := aArray
   EndIf

   //            default values for array elements used during append mode
   //            The user MUST AIns() as element no. 1 to ::aDefValue
   //            a nil value when using the actual elemnt no (::nAt)
   //            when browsing arrays like this:
   //            AIns( ASize( ::aDefValue, Len( ::aDefValue ) + 1 ), 1 )
   //            AFTER calling ::SetArray()

   nColumns    := If( ! Empty( ::aArray ), Len( ::aArray[ 1 ] ), 0 )
   ::aDefValue := Array( nColumns )

   For nI := 1 To nColumns
      cType := ValType( ::aArray[ 1, nI ] )
      If cType $ "CM"
         ::aDefValue[ nI ] := Space( Len( ::aArray[ 1, nI ] ) )
      ElseIf cType == "N"
         ::aDefValue[ nI ] := 0
      ElseIf cType == "D"
         ::aDefValue[ nI ] := CToD( "" )
      ElseIf cType == "L"
         ::aDefValue[ nI ] := .F.
      Else                                // arrays, objects and codeblocks not allowed
         ::aDefValue[ nI ] := "???"       // not user editable data type
      EndIf
   Next

   ::nAt       := 1
   ::bKeyNo    := { || ::nAt }
   ::cAlias    := "ARRAY"  // don't change name, used in method Default()
   ::lIsArr    := .T.
   ::nLen      := Eval( ::bLogicLen := { || Len( ::aArray ) + ;
                                            If( ::lAppendMode, 1, 0 ) } )
   ::bGoTop    := { || ::nAt := 1 }
   ::bGoBottom := { || ::nAt := Eval( ::bLogicLen ) }
   ::bSkip     := { | nSkip, nOld | nOld := ::nAt, ::nAt += nSkip,;
                   ::nAt := Min( Max( ::nAt, 1 ), Eval( ::bLogicLen ) ),;
                   ::nAt - nOld }

   ::lHitTop    := .F.
   ::lHitBottom := .F.
   ::nRowPos := 1
   ::nColPos := 1
    ::nCell   := 1
    ::HiliteCell( 1 )

    if Empty( ::aColumns )
        nMax := ( ::nRight - ::nLeft + 1 ) * If( Empty( ::hWnd ), 2, 1 )
        If lListBox
            ::lDrawHeaders := .F.

            ::nLineStyle   := LINES_NONE
            ::lNoHScroll   := .T.
            ::AddColumn( TSColumn():New( , ArrayWBlock( Self, 1 ),,,, ;
                                     nMax,,,,,,,,,,,,, Self, "ArrayWBlock(::oBrw,1)" ) )
        ElseIf lLoadArray
            ::lDrawHeaders := ! ( ::aHeaders == Nil )
            if ::nLineStyle == Nil
               ::nLineStyle := LINES_ALL
            endif
            ::lNoHScroll := .T.
            For nI := 1 To nColumns

               hFont := If( ::hFont != Nil, ::hFont, 0 )
               cData := ::aArray[ 1, nI ]
               cType := ValType( cData )
               If cType == "C"
                  cData := PadR( Trim( cData ), Len(cData)+2, "B" )
                  nSize := GetTextWidth( 0, cData, hFont )
               ElseIf cType == "N"
                  nSize := Len(Trim(Str(cData)))
                  cData := StrZero( cData, nSize, Set( _SET_DECIMALS ) )
                  nSize := GetTextWidth( 0, cData, hFont )
               ElseIf cType == "D"
                  cData := cValToChar( If( ! Empty( cData ), cData, Date() ) )
                  nSize := Int( GetTextWidth( 0, cData, hFont ) * 1.15 )
               Else
                  cData := cValToChar( cData )
                  nSize := GetTextWidth( 0, cData, hFont )
               EndIf

               nColSize := 0
               if len(::aColSizes) >= nI
                  nColSize := ::aColSizes[nI]
               else
                  aadd(::aColSizes,0)
               endif
               if nColSize == 0
                  nColSize := nSize
               endif
               if nI == nColumns
                  if nColSize < nMax
                     nColSize := nMax
                  endif
               endif

               cHeading := If( ! ::aHeaders == Nil .and. Len( ::aHeaders ) >= nColumns, ;
                      ::aHeaders[ nI ], )

               nAlign := If( ::aJustify != Nil .and. Len( ::aJustify ) >= nColumns, ;
                    ::aJustify[ nI ], If( cType == "N", 2, If( cType == "L",    1, 0 ) ) )

               nAlign := If( ValType( nAlign ) == "L", If( nAlign, 2, 0 ), ;
                  If( ValType( nAlign ) == "C", AScan( aAlign, nAlign ) - 1, nAlign ) )

               nMax -= nColSize
               ::aColSizes[nI] := nColSize
               ::AddColumn( TSColumn():New( cHeading, ArrayWBlock( Self, nI ),,;
                  { ::nClrText, ::nClrPane }, { nAlign, DT_CENTER }, ;
                  nColSize,,::lEditable,,,,,,,,,,, Self, "ArrayWBlock(::oBrw,"+alltrim(str(nI))+")" ) )

            next
         EndIf
         IF nMax < 0
            ::lNoHScroll   := .F.
         ENDIF
   EndIf

   ::lNoPaint := .F.
   ::Reset()

Return Self

* ============================================================================
* METHOD TSBrowse:SetBtnGet() Version 7.0 Jul/15/2004
* ============================================================================

METHOD SetBtnGet( nColumn, cResName, bAction, nBmpWidth ) CLASS TSBrowse

   Default nBmpWidth := 16

   If nColumn == Nil .or. nColumn > Len( ::aColumns ) .or. nColumn <= 0
      Return Self
   EndIf

   ::aColumns[ nColumn ]:cResName  := cResName
   ::aColumns[ nColumn ]:bAction   := bAction
   ::aColumns[ nColumn ]:nBmpWidth := nBmpWidth
   ::aColumns[ nColumn ]:lBtnGet   := .t.

Return Self

* ============================================================================
* METHOD TSBrowse:SetColMsg() Version 7.0 Jul/15/2004
* ============================================================================

METHOD SetColMsg( cMsg, cEditMsg, nCol ) CLASS TSBrowse

   If Empty( ::aColumns ) .or. ( cMsg == Nil .and. cEditMsg == Nil )
      Return Self
   EndIf

   If nCol == Nil
      AEval( ::aColumns, { |e| If( cMsg != Nil, e:cMsg := cMsg, Nil ), ;
                               If( cEditMsg != Nil, e:cMsgEdit := cEditMsg, ;
                                   Nil ) } )
   Else
      If cMsg != Nil
         ::aColumns[ nCol ]:cMsg := cMsg
      EndIf

      If cEditMsg != Nil
         ::aColumns[ nCol ]:cMsgEdit := cEditMsg
      EndIf
  EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:SetColor() Version 7.0 Jul/15/2004
* ============================================================================

METHOD SetColor( xColor1, xColor2, nColumn ) CLASS TSBrowse

   Local nEle, nI, nColor

   Default xColor1 := {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19}, ;
           nColumn := 0

   If Empty( ::aColumns ) .and. nColumn > 0
      Return NIL
   End

   If Valtype( xColor1 ) == "N" .and. Valtype( xColor2 ) == "N" .and. nColumn == 0
      Return ::SetColor( xColor1, xColor2 )  // FW SetColor Method only nClrText and nClrPane
   EndIf

   If Len( ::aColumns ) == 0 .and. ::hBrush == Nil
      nColor := If( ValType( xColor2[ 2 ] ) == "B", ;
                    Eval( xColor2[ 2 ], 1, 1, Self ), xColor2[ 2 ] )
      ::hBrush := CreateSolidBrush(GetRed ( nColor ) , GetGreen ( nColor ), GetBlue (nColor ) )
   EndIf

   If nColumn == 0 .and. ValType ( xColor2[ 1 ] ) == "N" .and. ;
      ValType( xColor1 ) == "A" .and. xColor1[ 1 ] == 1 .and. ;
      Len( xColor1 ) > 1 .and. ValType( xColor2 ) == "A" .and. ;
      ValType( xColor2[ 2 ] ) == "N" .and. xColor1[ 2 ] == 2

      nColor := If( ValType( xColor2[ 2 ] ) == "B", ;
                    Eval( xColor2[ 2 ], 1, 1, Self ), xColor2[ 2 ] )
      Super:SetColor( xColor2[ 1 ], nColor )

   EndIf

   If Valtype( xColor1 ) == "N"
      xColor1 := { xColor1 }
      xColor2 := { xcolor2 }
   EndIf

   For nEle := 1 To Len( xColor1 )
      Do Case

         Case xColor1[ nEle ] == 1

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrFore := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrText := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrFore := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 2

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrBack := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrPane := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrBack := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 3

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrHeadFore := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrHeadFore := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrHeadFore := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 4

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrHeadBack := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrHeadBack := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrHeadBack := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 5

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrFocuFore := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrFocuFore := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrFocuFore := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 6

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrFocuBack := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrFocuBack := xColor2[ nEle ]
               EndIf

            Else

               ::aColumns[ nColumn ]:nClrFocuBack := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 7

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrEditFore := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrEditFore := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrEditFore := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 8


            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrEditBack := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrEditBack := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrEditBack := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 9

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrFootFore := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrFootFore := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrFootFore := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 10

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrFootBack := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrFootBack := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrFootBack := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 11

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrSeleFore := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrSeleFore := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrSeleFore := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 12

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrSeleBack := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrSeleBack := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrSeleBack := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 13

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrOrdeFore := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrOrdeFore := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrOrdeFore := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 14

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrOrdeBack := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrOrdeBack := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrOrdeBack := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 16

            If nColumn == 0
               For nI := 1 TO Len( ::aSuperHead )
                   ::aSuperHead[ nI , 5 ] := xColor2[ nEle ]
               Next

            Else
               ::aSuperHead[ nColumn , 5 ] := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 17
            If nColumn == 0

               For nI := 1 TO Len( ::aSuperHead )
                   ::aSuperHead[ nI , 4 ] := xColor2[ nEle ]
               Next

            Else
               ::aSuperHead[ nColumn , 4 ] := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 18

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrSpcHdFore := xColor2[ nEle ]
               Next
               If Empty( ::aColumns )
                  ::nClrSpcHdFore := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrSpcHdFore := xColor2[ nEle ]
            EndIf

         Case xColor1[ nEle ] == 19

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrSpcHdBack := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrSpcHdBack := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrSpcHdBack := xColor2[ nEle ]
            EndIf

       Case xColor1[ nEle ] == 20

            If nColumn == 0

               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrSpcHdActive := xColor2[ nEle ]
               Next

               If Empty( ::aColumns )
                  ::nClrSpcHdActive := xColor2[ nEle ]
               EndIf

            Else
               ::aColumns[ nColumn ]:nClrSpcHdActive := xColor2[ nEle ]
            EndIf

         Otherwise
            ::nClrLine := xColor2[ nEle ]
      EndCase

   Next

   If ::lPainted
      ::Refresh( .T. )
   EndIf

Return 0

* ============================================================================
* METHOD TSBrowse:SetCols() Version 7.0 Jul/15/2004
* ============================================================================

METHOD SetColumns( aData, aHeaders, aColSizes ) CLASS TSBrowse

   Local aFields , nElements, n

   nElements   := Len( aData )

   ::aHeaders  := If( aHeaders  != Nil, aHeaders, ::aHeaders )
   ::aColSizes := If( aColSizes != Nil, aColSizes, {} )
   ::bLine     := {|| _aData( aData ) }
   ::aJustify  := AFill( Array( nElements ), .F. )

   If Len( ::GetColSizes() ) < nElements
      ::aColSizes := AFill( Array( nElements ), 0 )
      aFields := Eval( ::bLine )

      For n := 1 to nElements
          ::aColSizes[ n ] := If( ValType( aFields[ n ] ) != "C",;
                                   15,; // Bitmap handle
                                   GetTextWidth( 0, Replicate( "B", ;
                                   Max( Len( ::aHeaders[ n ] ), ;
                                        Len( aFields[ n ] ) ) + 1 ),;
                                   If( ! Empty( ::hFont ), ::hFont, 0 ) ) )
      Next
   EndIf

   If ::oHScroll != nil
      ::oHScroll:nMax := ::GetColSizes()
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:SetColSize() Version 7.0 Jul/15/2004
* ============================================================================

METHOD SetColSize( nCol, nWidth ) CLASS TSBrowse

   Local nI, nSize

   If ValType( nCol ) == "A"
      For nI := 1 To Len( nCol )
          nSize := If( ValType( nWidth ) == "A", nWidth[ nI ], nWidth )
          ::aColumns[ nCol[ nI ] ]:nWidth := nSize
          ::aColSizes[ nCol[ nI ] ] := IF(::aColumns[ nCol[ nI ] ]:lVisible ,::aColumns[ nCol[ nI ] ]:nWidth ,0)
      Next
   Else
      ::aColumns[ nCol ]:nWidth := nWidth
      ::aColSizes[ nCol ] := IF(::aColumns[ nCol ]:lVisible,::aColumns[ nCol ]:nWidth,0)
   EndIf

   If ::lPainted
      ::Refresh( .T. )
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:SetData() Version 7.0 Jul/15/2004
* ============================================================================

METHOD SetData( nColumn, bData, aList ) CLASS TSBrowse

   If Valtype( nColumn ) != "N" .or. nColumn <= 0
      Return Nil
   EndIf

   If aList != Nil

      If ValType( aList[ 1 ] ) == "A"
         ::aColumns[ nColumn ]:aItems := aList[ 1 ]
         ::aColumns[ nColumn ]:aData := aList[ 2 ]
         ::aColumns[ nColumn ]:cDataType := ValType( aList[ 2, 1 ] )
      Else
         ::aColumns[ nColumn ]:aItems := aList
      EndIf

      ::aColumns[ nColumn ]:lComboBox := .T.

   EndIf

   If bData != Nil

      If Valtype( bData ) == "B"
         ::aColumns[ nColumn ]:bData := bData
      Else
         ::aColumns[ nColumn ]:bData := {||(bData)}
      EndIf

   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:SetDeleteMode() Version 7.0 Jul/15/2004
* ============================================================================

METHOD SetDeleteMode( lOnOff, lConfirm, bDelete, bPostDel ) CLASS TSBrowse

   Default lOnOff   := .T., ;
           lConfirm := .T.

   ::lCanDelete := lOnOff
   ::lConfirm   := lConfirm
   ::bDelete    := bDelete
   ::bPostDel   := bPostDel

Return Self

* ============================================================================
* METHOD TSBrowse:SetFilter() Version 7.0 Jul/15/2004
* ============================================================================

METHOD SetFilter( cField, uVal1, uVal2 ) CLASS TSBrowse

   Local cIndexType, cAlias, ;
         lWasFiltered := ::lFilterMode

   Default uVal2 := uVal1

   If ValType( uVal2 ) == "A"
      ::bFilter := uVal2[ 2 ]
      uVal2 := uVal2[ 1 ]
   EndIf

   ::cField      := cField
   ::uValue1     := uVal1
   ::uValue2     := uVal2
   ::lFilterMode := ! Empty( cField )

   cAlias := ::cAlias

   If ::lFilterMode
      ::lDescend := ( ::uValue2 < ::uValue1 )

      cIndexType := ( cAlias )->( ValType( &( IndexKey() ) ) )

      If ( ::cAlias )->( ValType( &cField ) ) != cIndexType .or. ;
         ValType( uVal1 ) != cIndexType .or. ;
         ValType( uVal2 ) != cIndexType

         MsgInfo( ::aMsg[ 27 ], ::aMsg[ 28 ] )

         ::lFilterMode := .F.

      EndIf

   EndIf

   // Posibility of using FILTERs based on INDEXES!!!

   ::bGoTop := If( ::lFilterMode, {|| BrwGoTop( Self ) },;
                                      {|| ( cAlias )->( DbGoTop() ) } )

   ::bGoBottom := If( ::lFilterMode, {|| BrwGoBottom( uVal2, Self ) },;
                                      {|| ( cAlias )->( DbGoBottom() ) } )

   ::bSkip := If( ::lFilterMode, BuildSkip( ::cAlias, cField, uVal1, uVal2, Self ), ;
                                           {| n | ::dbSkipper( n ) } )

   If ::bLogicLen != Nil
      ::nLen := If( ::lIsDbf, ( ::cAlias )->( Eval( ::bLogicLen ) ), ;
                    Eval( ::bLogicLen ) )
   EndIf

   ::ResetBarPos( .T. )

   ::lHitTop    := .F.
   ::lHitBottom := .F.

   If ::lFilterMode .or. lWasFiltered
      ::GoTop()
   EndIf

Return Nil

* ============================================================================
* METHOD TSBrowse:SetFont() Version 7.0 Jul/15/2004
* ============================================================================

METHOD SetFont( hFont ) CLASS TSBrowse

   If hFont != Nil
      ::hFont = hFont
   EndIf

Return 0

* ============================================================================
* METHOD TSBrowse:SetHeaders() Version 7.0 Jul/15/2004
* ============================================================================

METHOD SetHeaders( nHeight, aCols, aTitles, aAlign , al3DLook, aFonts, ;
                   aActions ) CLASS TSBrowse

   Local nI

   If nHeight != Nil
      ::nHeightHead := nHeight
   EndIf

   If aCols == Nil

      aCols := {}

      Do Case

         Case aTitles != Nil
            For nI := 1 TO Len( aTitles )
                AAdd( aCols, nI )
            Next

         Case aAlign != Nil
            For nI := 1 TO Len( aAlign )
                AAdd( aCols, nI )
            Next

         Case al3DLook != Nil
            For nI := 1 TO Len( al3DLook )
                AAdd( aCols, nI )
            Next

         Case aFonts != Nil
            For nI := 1 TO Len( aFonts )
                AAdd( aCols, nI )
            Next

         Case aActions != Nil
            For nI := 1 TO Len( aActions )
                AAdd( aCols, nI )
            Next

         Otherwise
            Return Nil
      EndCase

   EndIf

   For nI := 1 TO Len( aCols )

      If aTitles != Nil
         ::aColumns[ aCols[ nI ] ]:cHeading := aTitles[ nI ]
      EndIf

      If aAlign != Nil
         ::aColumns[ aCols[ nI ] ]:nHAlign := aAlign[ nI ]
      EndIf

      If al3DLook != Nil
         ::aColumns[ aCols[ nI ] ]:l3DLookHead := al3DLook[ nI ]
      EndIf

      If aFonts != Nil
         ::aColumns[ aCols[ nI ] ]:cHeading := aFonts[ nI ]
      EndIf

      If aActions != Nil
         ::aColumns[ aCols[ nI ] ]:bAction := aActions[ nI ]
      EndIf

   Next

   ::DrawHeaders()

Return Self

* ============================================================================
* METHOD TSBrowse:SetIndexCols() Version 7.0 Jul/15/2004
* ============================================================================

METHOD SetIndexCols( nCol1, nCol2, nCol3, nCol4, nCol5 ) CLASS TSBrowse

   Local aCol

   Default nCol2 := 0, nCol3 := 0, nCol4 := 0, nCol5 := 0

   If Valtype( nCol1 ) == "A"
      AEval( nCol1, { | nCol | ::aColumns[ nCol ]:lIndexCol := .T. } )
   Else
      aCol := { nCol1, nCol2, nCol3, nCol4, nCol5 }
      AEval( aCol, { | nCol | If( nCol > 0, ;
                                 ::aColumns[ nCol ]:lIndexCol := .T., Nil ) } )
   EndIf

Return Nil

* ============================================================================
* METHOD TSBrowse:SetDbf() Version 7.0 Jul/15/2004
* ============================================================================

METHOD SetDbf( ) CLASS TSBrowse

   ::nRowPos    := 1  // reinitialize for multiple calls to this method
   ::nColPos    := 1
   ::nCell      := 1
   ::lHitTop    := .F.
   ::lHitBottom := .F.
   ::HiliteCell( 1 )

   ::bLogicLen := {|| RecCount() }
   ::bGoTop    := {|| dbGoTop() }
   ::bGoBottom := {|| dbGoBottom() }
   ::bSkip     := {| nSkip | ::dbSkipper( nSkip ) }

Return Self

* ============================================================================
* METHOD TSBrowse:SetOrder() Version 7.0 Jul/15/2004
* ============================================================================

METHOD SetOrder( nColumn, cPrefix, lDescend ) CLASS TSBrowse

   Local nDotPos, cAlias, ;
         lReturn := .F., ;
         oColumn := If( ::lIsDbf, ::aColumns[ nColumn ], Nil )

   Default ::lIsArr := ::cAlias == "ARRAY"
   HB_SYMBOL_UNUSED( lDescend )

   If nColumn == Nil .or. nColumn > Len( ::aColumns )
      Return .F.
   EndIf

   ::lNoPaint := .F.

   If ::lIsDbf .and. ! Empty( oColumn:cOrder ) .and. nColumn != ::nColOrder

      cAlias := ::cAlias

      If ::cDriver == Nil
         ::ResetBarPos( .T. )     // dialogs initialize differently from windows!?
      EndIf

      If ( nDotPos := At( ".", oColumn:cOrder ) ) > 0 // in case TAG has an extension (ie .NTX)
         oColumn:cOrder := SubStr( oColumn:cOrder, 1, nDotPos - 1 )
      EndIf

#ifdef HB_C52_STRICT
      If ::cDriver == "NTX"
         ::uLastTag := If( ValType( oColumn:cOrder ) == "C", ;
                           Val( oColumn:cOrder ), oColumn:cOrder )
         ( cAlias )->( Eval( ::bTagOrder, Max( 1, ::uLastTag ) ) )
         ::uLastTag := oColumn:cOrder
      Else
#endif
         ::uLastTag := oColumn:cOrder
         ( cAlias )->( Eval( ::bTagOrder, oColumn:cOrder ) )
#ifdef HB_C52_STRICT
      EndIf
#endif

      If Empty( ( cAlias )->( IndexKey() ) )
           ::cOrderType := ""
        Else
         ::cOrderType := ( cAlias )->( ValType( &( IndexKey() ) ) )
      EndIf

      If  ::lPainted
         ::UpStable()    // ::UpStable() won't work with DBFOBJECT
      endif
      ::ResetBarPos()
      ::nColOrder := nColumn
      ::ResetSeek()

      If ::bSetOrder != Nil
         Eval( ::bSetOrder, Self, ( cAlias )->( Eval( ::bTagOrder ) ), nColumn )
      EndIf

      If ::oWnd:hCtlFocus == Nil .or. ::oWnd:hCtlFocus != ::hWnd
         ::SetFocus()
      EndIf

      lReturn := .T.

      If cPrefix != Nil
         ::cPrefix := cPrefix
      EndIf

      ::aColumns[ nColumn ]:lSeek := ::lSeek  // GF 1.71

   ElseIf ::lIsArr

      if ValType( ::aColumns[ nColumn ]:bArraySort ) == "B" .and. nColumn == ::nColOrder
      else

         If ::cDriver == Nil
            ::ResetBarPos( .T. )
         EndIf

         If nColumn <= Len( ::aArray[ 1 ] )
            ::cOrderType := ValType( ::aArray[ ::nAt, nColumn ] )
            If ::nColOrder != 0
               ::aColumns[ ::nColOrder ]:lSeek := .F.
            EndIf
            ::nColOrder := nColumn
            ::SortArray()
            ::Refresh()
            ::ResetBarPos()
            ::aColumns[ nColumn ]:lSeek := ::lSeek  // GF 1.71
         EndIf

         ::ResetSeek()
         lReturn := .T.

         If cPrefix != Nil
            ::cPrefix := cPrefix
         EndIf

         If ::bSetGet != Nil
            If ValType( Eval( ::bSetGet ) ) == "N"
               Eval( ::bSetGet, ::nAt )
            ElseIf ::nLen > 0
               Eval( ::bSetGet, ::aArray[ ::nAt, 1 ] )
            Else
               Eval( ::bSetGet, "" )
            EndIf
         EndIf
      endif

   EndIf

   ::lHitTop := ::lHitBottom := .F.

Return lReturn

* ============================================================================
* METHOD TSBrowse:SetSpinner() Version 7.0 Jul/15/2004
* ============================================================================

METHOD SetSpinner( nColumn, lOnOff, bUp, bDown, bMin, bMax ) CLASS TSBrowse

   Default lOnOff := .T., ;
           bUp := { | oGet | oGet++ }, ;
           bDown := { | oGet | oGet++ }

   If nColumn == Nil .or. nColumn > Len( ::aColumns ) .or. nColumn <= 0
      Return Self
   EndIf

   ::aColumns[ nColumn ]:lSpinner := lOnOff
   ::aColumns[ nColumn ]:bUp      := bUp
   ::aColumns[ nColumn ]:bDown    := bDown
   ::aColumns[ nColumn ]:bMin     := bMin
   ::aColumns[ nColumn ]:bMax     := bMax
   ::aColumns[ nColumn ]:lBtnGet  := .t.

Return Self

* ============================================================================
* METHOD TSBrowse:ShowSizes() Version 7.0 Jul/15/2004
* ============================================================================

METHOD ShowSizes() CLASS TSBrowse

   Local cText  := "", ;
         nTotal := 0, ;
         aTemp  := ::GetColSizes()

   AEval( aTemp, ;
          { | e, n | nTotal += e, ;
                     cText += ( If( ValType( ::aColumns[ n ]:cHeading ) == "C", ;
                     ::aColumns[ n ]:cHeading, ::aMsg[ 24 ] + Space( 1 ) + ;
                     Ltrim( Str( n ) ) ) + ": " + Str( e, 3 ) + ;
                     " Pixels" + CRLF ) } )

   cText += CRLF + "Total " + Str( nTotal, 4 ) + " Pixels" + CRLF + ;
            ::aMsg[ 25 ] + Space( 1) + Str( ::nWidth(), 4 ) + " Pixels" + CRLF

   MsgInfo( cText, ::aMsg[ 26 ] )

Return Self

* ============================================================================
* METHOD TSBrowse:Skip() Version 7.0 Jul/15/2004
* ============================================================================

METHOD Skip( n ) CLASS TSBrowse

   Local nSkipped

   If ::bSkip != Nil
      nSkipped := Eval( ::bSkip, n )
   Else
      nSkipped := ::dbSkipper( n )
   EndIf

   If ::lIsDbf
      ::nLastPos := ( ::cAlias )->( RecNo() )
   EndIf

   ::nLastnAt := ::nAt

   If ::lIsArr .and. ::bSetGet != Nil
      If ValType( Eval( ::bSetGet ) ) == "N"
         Eval( ::bSetGet, ::nAt )
      ElseIf ::nLen > 0
         Eval( ::bSetGet, ::aArray[ ::nAt, 1 ] )
      Else
         Eval( ::bSetGet, "" )
      EndIf
   EndIf

Return nSkipped

* ============================================================================
* METHOD TSBrowse:SortArray() Version 7.0 Jul/15/2004
* ============================================================================

METHOD SortArray( nCol, lDescend ) CLASS TSBrowse

   Local aArray := ::aArray

   Default nCol := ::nColOrder

   IF ValType(lDescend) == 'U'
      IF Abs(::nSortColDir) == nCol
         lDescend := ( ::nSortColDir > 0 )
      ELSE
         ::nSortColDir := 0
         lDescend := .F.
      ENDIF
   ENDIF

   CursorWait()

   if Len(::aSelected) > 0
      AEval( aArray, { | x,nAt | AAdd(x, IF( AScan( ::aSelected, nAt ) > 0, .t., .f. )) } )
   endif

   if ValType(::aColumns[ nCol ]:bArraySort) == "B"
      ::SetArray( ASort( aArray,,, ::aColumns[ nCol ]:bArraySort ) )
   else
      If lDescend
         ::SetArray( ASort( aArray,,, { |x,y| x[nCol] > y[nCol] } ) )
         ::nSortColDir := ( - nCol )
     Else
         ::SetArray( ASort( aArray,,, { |x,y| x[nCol] < y[nCol] } ) )
         ::nSortColDir := nCol
      Endif
   endif

   if Len(::aSelected) > 0
      ::aSelected := {}
      AEval( aArray, { | x,nAt | IF( ATail(x), AAdd(::aSelected, nAt), Nil), ASize(x, Len(x)-1 ) } )
   endif

   Eval( ::bGoTop )

   CursorArrow()

Return Self

* ============================================================================
* METHOD TSBrowse:SwitchCols() Version 7.0 Jul/15/2004
* This method is dedicated to John Stolte by the 'arry
* ============================================================================

METHOD SwitchCols( nCol1, nCol2 ) CLASS TSBrowse

   Local oHolder, nHolder, nMaxCol := Len(::aColumns)

   If nCol1 > ::nFreeze .and. nCol2 > ::nFreeze .and. ;
      nCol1 <= nMaxCol .and. nCol2 <= nMaxCol

      oHolder := ::aColumns[ nCol1 ]
      nHolder := ::aColSizes[ nCol1 ]

      ::aColumns[ nCol1 ]  := ::aColumns[ nCol2 ]
      ::aColSizes[ nCol1 ] := ::aColSizes[ nCol2 ]

      ::aColumns[ nCol2 ]  := oHolder
      ::aColSizes[ nCol2 ] := nHolder

      If ::nColOrder == nCol1
         ::nColOrder := nCol2
      EndIf

   EndIf

   If ::lPainted
      ::Refresh( .F. )
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:SyncChild() Version 7.0 Jul/15/2004
* ============================================================================

METHOD SyncChild( aoChildBrw, abAction ) CLASS TSBrowse

   If aoChildBrw != Nil
      If ValType( aoChildBrw ) == "O"
         aoChildBrw := { aoChildBrw }
      EndIf

      Default abAction := Array( Len( aoChildBrw ) )

      If ValType( abAction ) == "B"
         abAction := { abAction }
      EndIf

      ::bChange := {|| ;
                       AEval( aoChildBrw, {|oChild,nI| If( ! Empty( oChild:cAlias ),;
                       ( oChild:lHitTop := .F., oChild:goTop(),;
                       If( abAction[nI] != Nil, Eval( abAction[nI], Self, oChild ), Nil ),;
                       oChild:reset() ), Nil ) } ) }
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:UpStable() Version 7.0 Jul/15/2004
* ============================================================================

METHOD UpStable() CLASS TSBrowse

   Local nRow     := ::nRowPos, ;
         nRecNo   := ( ::cAlias )->( RecNo() ), ;
         nRows    := ::nRowCount(), ;
         n        := 1, ;
         lSkip    := .T., ;
         bChange  := ::bChange, ;
         nLastPos := ::nLastPos

   If ::nLen > nRows

      ( ::cAlias )->( DbSkip( nRows - nRow ) )

      If ( ::cAlias )->( EoF() )
         Eval( ::bGoBottom )
         ::nRowPos := nRows

         While ::nRowPos > 1 .and. ( ::cAlias )->( RecNo() ) != nRecNo
            ::Skip( -1 )
            ::nRowPos --
         EndDo

         ::Refresh( .F. )
         ::ResetBarPos()
         Return Self
      Else
         ( ::cAlias )->( DbGoto( nRecNo ) )
      EndIf

   EndIf

   ::bChange    := Nil
   ::lHitTop    := .F.
   ::lHitBottom := .F.
   ::GoTop()

   While ! ( ::cAlias )->( EoF() )

      If n > nRows
         ::nRowPos := nRow
         lSkip     := .F.
         Exit
      EndIf

      If nRecNo == ( ::cAlias )->( RecNo() )
         ::nRowPos := n
         Exit
      Else
         ::Skip( 1 )
      EndIf

      n++

   Enddo

   If lSkip
      ::Skip( -::nRowPos )
   EndIf

   ( ::cAlias )->( DbGoTo( nRecNo ) )                // restores Record position
   ::nLastPos := nLastPos
   ::nAt      := ::nLogicPos()
   ::lHitTop  := ( ::nAt == 1 )                      // Alen Uzelac <solvox@bbm.hr>

   If ::oVScroll != Nil .and. ! Empty( ::bKeyNo )    // restore scrollbar thumb
      ::oVScroll:SetPos( ::RelPos( ( ::cAlias )->( Eval( ::bKeyNo ) ) ) )
   EndIf

   ::bChange := bChange

   If ::lPainted
      ::Refresh( If( ::nLen < nRows, .T., .F. ) )
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:VertLine() Version 7.0 Jul/15/2004
* Thanks to Gianni Santamarina
* ============================================================================

METHOD VertLine( nColPixPos, nColInit, nGapp ) CLASS TSBrowse

   Local aRect := ::GetRect(), ;
         bDestroy := {||Nil}

   ::GetDC()

   If nColInit != Nil
      nsCol := nColInit
      nsWidth := nColPixPos
      nsOldPixPos := 0
      nGap := If( ! Empty( nGapp ), nGapp, 0)
      _InvertRect( ::hDC, { 0, nsWidth - ::aColSizes[ nsCol ] - 2, aRect[4], nsWidth - ::aColSizes[ nsCol ] + 2 } )
   EndIf

   If nColPixPos == Nil .and. nColInit == Nil   // We have finish draging
      ::aColSizes[ nsCol ] -= ( nsWidth - nsOldPixPos )
      ::aColumns[ nsCol ]:nWidth -= ( nsWidth - nsOldPixPos )
      ::Refresh( .F. )
   EndIf

   aRect := ::GetRect()

   If nsOldPixPos != 0 .and. nColPixPos != Nil .and. nColPixPos != nsOldPixPos
      _InvertRect( ::hDC, { 0, nsOldPixPos - 2, aRect[4], nsOldPixPos + 2 } )
      nsOldPixPos := 0
   EndIf

   If nColPixPos != Nil .and. nColPixPos != nsOldPixPos
      nColPixPos := Max( nColPixPos, 10 )
      If nColInit == Nil
         Eval( bDestroy, Self )
      EndIf
      _InvertRect( ::hDC, { 0, nColPixPos - 2 + nGap, aRect[4], nColPixPos + 2 + nGap } )
      nsOldPixPos := nColPixPos + nGap
   EndIf

   ::ReleaseDC()

Return Nil

* ============================================================================
* METHOD TSBrowse:VScroll() Version 7.0 Jul/15/2004
* ============================================================================

METHOD VScroll( nWParam, nLParam ) CLASS TSBrowse

   Local nBottomPos, oCol,;
         nLines := Min( ::nLen, ::nRowCount() )

   ::lNoPaint := .F.
   If ::oWnd:hCtlFocus != Nil .and. ::oWnd:hCtlFocus != ::hWnd
      oCol := ::oWnd:aColumns[ ::oWnd:nCell ]
      If oCol:oEdit != Nil .and. nLParam == 0
        if "TBTNBOX" $ Upper( oCol:oEdit:ClassName() )
           Eval( oCol:oEdit:bKeyDown , VK_ESCAPE, 0, .t. )
        endif
      EndIf
   EndIf
   If GetFocus() != ::hWnd
      SetFocus( ::hWnd )
   EndIf

   Do Case
      Case nWParam == SB_LINEUP
         ::GoUp()

      Case nWParam == SB_LINEDOWN
         If ! ::lHitBottom
            ::GoDown()
         EndIf

      Case nWParam == SB_PAGEUP
         ::PageUp()

      Case nWParam == SB_PAGEDOWN
         ::PageDown()

      Case nWParam == SB_TOP
         ::GoTop()

      Case nWParam == SB_BOTTOM
         ::GoBottom()

      Case nWParam == SB_THUMBPOSITION

         nBottomPos := nLParam + ::oVScroll:nPgStep - 1

         If ::nLen == 0
            ::nLen := If( ::lIsDbf, ( ::cAlias )->( Eval( ::bLogicLen ) ), ;
                          Eval( ::bLogicLen ) )
         EndIf

         If ::nLen < 1
            Return 0
         EndIf

         If nLParam == 1
            ::GoTop()
            Return 0
         ElseIf nBottomPos >= ::oVScroll:GetRange()[ 2 ]
            ::GoBottom()
            Return 0
         Else
            CursorWait()
            If ::bGoToPos != Nil
               ( ::cAlias )->( Eval( ::bGoToPos, ::GetRealPos( nLParam ) ) )
//            Else
//               nSkipped := ::Skip( ( ::GetRealPos( nLParam ) - ;
//                                     ::GetRealPos( ::oVScroll:GetPos() ) ) )
            EndIf
            CursorArrow()
            ::lHitTop := .F.
            ::lHitBottom := .F.
         EndIf

         If ::lIsDbf
            ::nLastPos := ( ::cAlias )->( RecNo() )
         EndIf

         ::nAt := ::nLogicPos()
         ::oVScroll:SetPos( ::RelPos( ::nLogicPos() ) )

         If ( nBottomPos - ::oVScroll:nMin ) < nLines
              ::nRowPos := 1
         EndIf

         If ( ::oVScroll:nMax - nLParam ) < Min( nLines, ::nLen )
            ::nRowPos := Min( nLines, ::nLen ) - ( ::oVScroll:nMax - nLParam )
         EndIf

         ::Refresh( .F. )

         If ::bChange != nil
            Eval( ::bChange, Self, 0 )
         EndIf

      Otherwise
         Return Nil
   Endcase

Return 0

* ============================================================================
* METHOD TSBrowse:Enabled() Version 7.0 Adaptation Version
* ============================================================================

METHOD Enabled(lEnab)  CLASS TSBrowse

   Local nI

   Default lEnab := .t.

   IF ValType( lEnab ) == "L"
      IF !lEnab
         IF ::lEnabled
            For nI := 1 TO Len( ::aColumns )
               ::aColumns[ nI ]:SaveColor()
            Next
         ENDIF
         ::lEnabled := .F.
         ::SetColor( { 2 }, { CLR_HGRAY  } )
         ::SetColor( { 3, 4 }, { CLR_GRAY, CLR_HGRAY  } )
      ELSE
         IF !::lEnabled
            For nI := 1 TO Len( ::aColumns )
               ::aColumns[ nI ]:RestColor()
               SetColor( ,::aColumns[ nI ]:aColors, nI )
            Next
         ENDIF
         ::lEnabled := .T.
      ENDIF
   ENDIF

RETURN 0

* ============================================================================
* METHOD TSBrowse:HideColumns() Version 7.0 Adaptation Version
* ============================================================================

METHOD HideColumns( nColumn , lHide) CLASS TSBrowse

   Local aColumn, nI,nJ,lPaint:=.f.

   Default lHide := .t.

   If ( Empty( ::aColumns ) .and. nColumn > 0 )
      Return nil
   End

   If ValType( nColumn ) == "N"
      aColumn := {nColumn}
   ELSE
      aColumn:= nColumn
   EndIf
   FOR nI :=1 TO Len(aColumn)
      nJ := aColumn[nI]
      IF nJ <= Len(::aColumns)
         IF lHide
            ::aColSizes[ nJ ] := 0
            ::aColumns[ nJ ]:lVisible :=.f.
            lPaint :=.t.
         else
            ::aColSizes[ nJ ] := ::aColumns[ nJ ]:nWidth
            ::aColumns[ nJ ]:lVisible :=.T.
            lPaint :=.t.
         endif
      endif
   NEXT
   ::Refresh( lPaint )

RETURN 0


* ============================================================================
*                    TSBrowse   Functions
* ============================================================================


* ============================================================================
* FUNCTION TSBrowse _aData() Version 7.0 Jul/15/2004
* Called from METHOD SetCols()
* ============================================================================

Static Function _aData( aFields )

  Local aFld, nFor, nLen

  nLen := Len( aFields )
  aFld := Array( nLen )

  For nFor := 1 To nLen
     aFld[ nFor ] := Eval( aFields[ nFor ] )
  Next

Return aFld

* ============================================================================
* FUNCTION TSBrowse ASeek() Version 7.0 Jul/15/2004
* Incremental searching in arrays
* ============================================================================

Static Function ASeek( uSeek, lSoft, oBrw )

   Local nEle, uData, ;
         lFound := .F., ;
         aArray := oBrw:aArray, ;
         nCol   := oBrw:nColOrder, ;
         nRecNo := oBrw:nAt

   Default lSoft := .F.

   For nEle := Max( 1, nNewEle ) To Len( aArray )

      uData := aArray[ nEle, nCol ]
      uData := If( oBrw:lUpperSeek .and. Valtype( uData ) == "C", Upper( uData ), uData )

      If ! lSoft
         If uData = uSeek
            lFound := .T.
            Exit
         EndIf
      Else
         If uData >= uSeek
            lFound := .T.
            Exit
         EndIf
      EndIf

   Next

   If lFound .and. nEle <= oBrw:nLen
      oBrw:nAt := nEle
      nNewEle  := nEle
   Else
      oBrw:nAt := nRecNo
   EndIf

Return lFound

* ============================================================================
* FUNCTION TSBrowse BrwGoBottom() Version 7.0 Jul/15/2004
* Used by METHOD SetFilter() to set the bottom limit in an "Index Based"
* filtered database
* ============================================================================

Static Function BrwGoBottom( uExpr, oBrw )

   If ValType( uExpr ) == "C"
      ( oBrw:cAlias )->( DbSeek( SubStr( uExpr, 1, Len( uExpr ) - 1 ) + ;
              Chr( Asc( SubStr( uExpr, Len( uExpr ) ) ) + ;
              If( ! oBrw:lDescend, 1, - 1 ) ), .T. ) )
   Else
      ( oBrw:cAlias )->( DbSeek( uExpr + ;
                                 If( ! oBrw:lDescend, 1, - 1 ), .T. ) )
   EndIf

   If ( oBrw:cAlias )->( EoF() )
      ( oBrw:cAlias )->( DbGoBottom() )
   Else
      ( oBrw:cAlias )->( DbSkip( -1 ) )
   EndIf

   While oBrw:bFilter != Nil .and. ! Eval( oBrw:bFilter ) .and. ! ( oBrw:cAlias )->( BoF() )
      ( oBrw:cAlias )->( DbSkip( -1 ) )
   EndDo

Return Nil

* ============================================================================
* FUNCTION TSBrowse BrwGoTop() Version 7.0 Jul/15/2004
* Used by METHOD SetFilter() to set the top limit in an "Index Based"
* filtered database
* ============================================================================

Static Function BrwGoTop( oBrw )

   ( oBrw:cAlias )->( DbSeek( oBrw:uValue1, .T. ) )

   While oBrw:bFilter != Nil .and. ! Eval( oBrw:bFilter ) .and. ! ( oBrw:cAlias )->( EoF() )
      ( oBrw:cAlias )->( DbSkip( 1 ) )
   EndDo

Return Nil

* ============================================================================
* FUNCTION TSBrowse BuildSkip() Version 7.0 Jul/15/2004
* Used by METHOD SetFilter(). Returns a block to be used on skipping records
* in an "Index Based" filtered database
* ============================================================================

Static Function BuildSkip( cAlias, cField, uValue1, uValue2, oTb )

   Local bSkipBlock, lDescend := oTb:lDescend, ;
         cType := ValType( uValue1 )

   Do Case
      Case cType == "C"
           If ! lDescend
              bSkipBlock := &( "{|| " + cField + ">= '" + uValue1 + "' .and. " + ;
              cField + "<= '" + uValue2 + "' }" )
           Else
              bSkipBlock := &( "{|| " + cField + "<= '" + uValue1 + "' .and. " + ;
              cField + ">= '" + uValue2 + "' }" )
           EndIf
      Case cType == "D"
           If ! lDescend
              bSkipBlock := &( "{|| " + cField + ">= CToD( '" + DToC( uValue1 ) + "') .and. " + ;
              cField + "<= CToD( '" + DToC( uValue2 ) + "') }" )
           Else
              bSkipBlock := &( "{|| " + cField + "<= CToD( '" + DToC( uValue1 ) + "') .and. " + ;
              cField + ">= CToD( '" + DToC( uValue2 ) + "') }" )
           EndIf

      Case cType == "N"
           If ! lDescend
              bSkipBlock := &( "{|| " + cField + ">= " + cValToChar( uValue1 ) + " .and. " + ;
              cField + "<= " + cValToChar( uValue2 ) + " }" )
           Else
              bSkipBlock := &( "{|| " + cField + "<= " + cValToChar( uValue1 ) + " .and. " + ;
              cField + ">= " + cValToChar( uValue2 ) + " }" )
           EndIf

      Case cType == "L"
           If ! lDescend
              bSkipBlock := &( "{|| " + cField + ">= " + cValToChar( uValue1 ) + " .and. " + ;
              cField + "<= " + cValToChar( uValue2 ) + " }" )
           Else
              bSkipBlock := &( "{|| " + cField + "<= " + cValToChar( uValue1 ) + " .and. " + ;
              cField + ">= " + cValToChar( uValue2 ) + " }" )
           EndIf
   Endcase

Return { | n | ( cAlias )->( BrwGoTo( n, bSkipBlock, oTb ) ) }

* ============================================================================
* FUNCTION TSBrowse BuildFiltr() Version 1.47 Adaption HMG
* Used in Report by Function dbSetFilter. Returns a string used for create bBlock of Filter
* ============================================================================

Static Function BuildFiltr( cField, uValue1, uValue2, oTb )

   Local cFiltrBlock, lDescend := oTb:lDescend, ;
         cType := ValType( uValue1 )

   Do Case
      Case cType == "C"
           If ! lDescend
              cFiltrBlock := "{||" + cField + ">= '" + uValue1 + "' .and." + ;
              cField + "<= '" + uValue2 + "' }"
           Else
              cFiltrBlock := "{||" + cField + "<= '" + uValue1 + "' .and." + ;
              cField + ">= '" + uValue2 + "' }"
           EndIf
      Case cType == "D"
           If ! lDescend
              cFiltrBlock := "{||" + cField + ">= CToD( '" + DToC( uValue1 ) + "') .and." + ;
              cField + "<= CToD( '" + DToC( uValue2 ) + "') }"
           Else
              cFiltrBlock := "{||" + cField + "<= CToD( '" + DToC( uValue1 ) + "') .and." + ;
              cField + ">= CToD( '" + DToC( uValue2 ) + "') }"
           EndIf

      Case cType == "N"
           If ! lDescend
              cFiltrBlock := "{||" + cField + ">= " + cValToChar( uValue1 ) + " .and." + ;
              cField + "<= " + cValToChar( uValue2 ) + " }"
           Else
              cFiltrBlock := "{||" + cField + "<= " + cValToChar( uValue1 ) + " .and." + ;
              cField + ">= " + cValToChar( uValue2 ) + " }"
           EndIf

      Case cType == "L"
           If ! lDescend
              cFiltrBlock := "{||" + cField + ">= " + cValToChar( uValue1 ) + " .and." + ;
              cField + "<= " + cValToChar( uValue2 ) + " }"
           Else
              cFiltrBlock := "{||" + cField + "<= " + cValToChar( uValue1 ) + " .and." + ;
              cField + ">= " + cValToChar( uValue2 ) + " }"
           EndIf
   Endcase

Return cFiltrBlock

* ============================================================================
* FUNCTION TSBrowse BuildAutoSeek() Version 1.47 Adaption HMG
* Used in AutoSeek by Functions SpecHeader. Returns a string used for create bBlock of Locate
* ============================================================================

Static Function BuildAutoSeek( oTb )

   Local nCol, nLen, cType, uValue, cField, cLocateBlock := ""

   IF oTb:lIsArr
      FOR nCol:=1 TO  Len( oTb:aColumns )
         uValue := oTb:aColumns[ nCol ]:cSpcHeading
         cType := ValType( uValue )
         IF !Empty(uValue)
            IF Empty(cLocateBlock)
               DO CASE
               CASE cType == "C"
                  uValue := RTrim(uValue)
                  nLen   := Len(uValue)
                  cLocateBlock := "{|oTb|Ascan ( oTb:aArray, {|x,y| substr(x["+lTrim(Str(nCol))+"],1,"+;
                        lTrim(Str(nLen))+" ) == '"+uValue+"'"
               CASE cType == "N" .or. cType == "L"
                  cLocateBlock := "{|oTb|Ascan ( oTb:aArray, {|x,y| x["+lTrim(Str(nCol))+"] == "+;
                        cValToChar( uValue )
               CASE cType == "D"
                  cLocateBlock := "{|oTb|Ascan ( oTb:aArray, {|x,y| x["+lTrim(Str(nCol))+"] == "+;
                        "CToD( '" +DToC( uValue )+"' )"
               endcase
            ELSE
               DO CASE
               CASE cType == "C"
                  uValue := RTrim(uValue)
                  nLen   := Len(uValue)
                  cLocateBlock += " .and. substr(x["+lTrim(Str(nCol))+"],1,"+;
                        lTrim(Str(nLen))+" ) == '"+uValue+"'"
               CASE cType == "N" .or. cType == "L"
                  cLocateBlock = " .and. x["+lTrim(Str(nCol))+"] == "+;
                        cValToChar( uValue )
               CASE cType == "D"
                  cLocateBlock += " .and. x["+lTrim(Str(nCol))+"] == "+;
                        "CToD( '" +DToC( uValue )+"' )"
               endcase
            ENDIF
         ENDIF
      next
      cLocateBlock +=IF(!Empty(cLocateBlock), " },oTB:nAT+1) } ","")
   endif
   If oTb:lIsDbf
      FOR nCol:=1 TO  Len( oTb:aColumns )
         uValue := oTb:aColumns[ nCol ]:cSpcHeading
         cField := oTb:aColumns[ nCol ]:cData
         if oTb:cDriver == "ADO" .and. At( '->', cField ) > 0
            cField := SubStr( cField, At( '->', cField )+ 2)
         endif
         cType := ValType( uValue )
         IF !Empty(uValue)
            IF Empty(cLocateBlock)
               DO CASE
               CASE cType == "C"
                  uValue := RTrim(uValue)
                  nLen   := Len(uValue)
                  if oTb:cDriver == "ADO"
                     cLocateBlock :=  cField + " == '" + uValue + "'"
                  else
                     cLocateBlock :=  " substr("+cField +",1,"+;
                        lTrim(Str(nLen))+" ) == '" + uValue + "'"
                  endif
               CASE cType == "N" .or. cType == "L"
                  cLocateBlock := cField + " == "+ cValToChar( uValue )
               CASE cType == "D"
                  cLocateBlock := cField + " == "+ "CToD( '" +DToC( uValue )+"' )"
               endcase
            ELSE
               if oTb:cDriver != "ADO"
                  DO CASE
                  CASE cType == "C"
                     uValue := RTrim(uValue)
                     nLen   := Len(uValue)
                     cLocateBlock += " .and. substr(" + cField + ",1," +;
                           lTrim(Str(nLen))+" ) == '"+uValue+"'"
                  CASE cType == "N" .or. cType == "L"
                     cLocateBlock += " .and. " + cField + " == " + cValToChar( uValue )
                  CASE cType == "D"
                     cLocateBlock = " .and. " + cField + " == "+ "CToD( '" +DToC( uValue )+"' )"
                  ENDCASE
               ENDIF
            ENDIF
         ENDIF
      next
   endif

Return cLocateBlock

* ============================================================================
* FUNCTION TSBrowse BuildAutoFiltr() Version 1.47 Adaption HMG
* Used in AutoFilter by Functions SpecHeader. Returns a string used for create bBlock of Filter
* ============================================================================

Static Function BuildAutoFilter( oTb )

   Local nCol, nLen, cType, uValue, cField, cFilterBlock := ""
//   IF oTb:lIsArr
//   endif
   If oTb:lIsDbf
      FOR nCol:=1 TO  Len( oTb:aColumns )
         uValue := oTb:aColumns[ nCol ]:cSpcHeading
         cField := oTb:aColumns[ nCol ]:cData
         if oTb:cDriver == "ADO" .and. At( '->', cField ) > 0
            cField := SubStr( cField, At( '->', cField )+ 2)
         endif
         cType := ValType( uValue )
         IF !Empty(uValue)
            IF Empty(cFilterBlock)
               DO CASE
               CASE cType == "C"
                  uValue := RTrim(uValue)
                  nLen   := Len(uValue)
                  if oTb:cDriver == "ADO"
                     cFilterBlock :=  cField + " == '" + uValue + "'"
                  else
                     cFilterBlock :=  " substr("+cField +",1,"+;
                        lTrim(Str(nLen))+" ) == '" + uValue + "'"
                  endif
               CASE cType == "N" .or. cType == "L"
                  cFilterBlock := cField + " == "+ cValToChar( uValue )
               CASE cType == "D"
                  cFilterBlock := cField + " == "+ "CToD( '" +DToC( uValue )+"' )"
               endcase
            ELSE
               if oTb:cDriver != "ADO"
                  DO CASE
                  CASE cType == "C"
                     uValue := RTrim(uValue)
                     nLen   := Len(uValue)
                     cFilterBlock += " .and. substr(" + cField + ",1," +;
                           lTrim(Str(nLen))+" ) == '"+uValue+"'"
                  CASE cType == "N" .or. cType == "L"
                     cFilterBlock += " .and. " + cField + " == " + cValToChar( uValue )
                  CASE cType == "D"
                     cFilterBlock = " .and. " + cField + " == "+ "CToD( '" +DToC( uValue )+"' )"
                  ENDCASE
               ENDIF
            ENDIF
         ENDIF
      next
   endif

Return cFilterBlock

* ============================================================================
* FUNCTION TSBrowse BrwGoto() Version 7.0 Jul/15/2004
* Executes the action defined into the block created with FUNCTION BuildSkip()
* ============================================================================

Static Function BrwGoTo( n, bWhile, oTb )

   Local nSkipped := 0, ;
         nDirection := If( n > 0, 1, -1 )

   While nSkipped != n .and. Eval( bWhile ) .and. ! ( oTb:cAlias )->( EoF() ) .and. ! ( oTb:cAlias )->( BoF() )
      ( oTb:cAlias )->( DbSkip( nDirection ) )
      nSkipped += nDirection

      If oTb:bFilter != Nil
         While ! Eval( oTb:bFilter ) .and. ! ( oTb:cAlias )->( EoF() ) .and. ! ( oTb:cAlias )->( BoF() )
            ( oTb:cAlias )->( DbSkip( nDirection ) )
         EndDo
      EndIf

   EndDo

   Do Case
      Case ( oTb:cAlias )->( EoF() )
          ( oTb:cAlias )->( DbSkip( -1 ) )

         While oTb:bFilter != Nil .and. ! Eval( oTb:bFilter ) .and. ! ( oTb:cAlias )->( BoF() )
            ( oTb:cAlias )->( DbSkip( -1 ) )
         EndDo

         If ! oTb:lAppendMode
             nSkipped += -nDirection
            Else
                If oTb:nPrevRec == Nil
                    oTb:nPrevRec := ( oTb:cAlias )->( RecNo() )
            EndIf
                ( oTb:cAlias )->( DbGoTo( 0 ) )       // phantom record
         EndIf

      Case ( oTb:cAlias )->( BoF() )
         ( oTb:cAlias )->( DbGoTo( ( oTb:cAlias )->( RecNo() ) ) )

         While oTb:bFilter != Nil .and. ! Eval( oTb:bFilter ) .and. ! ( oTb:cAlias )->( EoF() )
            ( oTb:cAlias )->( DbSkip( 1 ) )
         EndDo

         nSkipped++

      Case ! Eval( bWhile )
         If nDirection == 1 .and. oTb:lAppendMode
             If oTb:nPrevRec == Nil
                ( oTb:cAlias )->( DbSkip( -1 ) )
                oTb:nPrevRec := ( oTb:cAlias )->( RecNo() )
             EndIf
             ( oTb:cAlias )->( DbGoTo( 0 ) )       // phantom record
         Else
             ( oTb:cAlias )->( DbSkip( -nDirection ) )
             While oTb:bFilter != Nil .and. ! Eval( oTb:bFilter ) .and. ;
                 ! ( oTb:cAlias )->( BoF() ) .and. ! ( oTb:cAlias )->( EoF() )
                ( oTb:cAlias )->( DbSkip( -nDirection ) )
             EndDo

             nSkipped += -nDirection
         EndIf
   Endcase

Return nSkipped

* ============================================================================
* FUNCTION TSBrowse:DateSeek() Version 7.0 Jul/15/2004
* ============================================================================

Static Function DateSeek( cSeek, nKey )

    Local cChar  := Chr( nKey ), ;
          nSpace := At( " ", cSeek ), ;
          cTemp  := ""

    /* only  0..9 */
    If nKey >= 48 .and. nKey <= 57
       If nSpace <> 0
          cTemp := Left( cSeek, nSpace - 1 )
          cTemp += cChar
          cTemp += SubStr( cSeek, nSpace + 1, Len( cSeek ) )
          cSeek := cTemp
       Else
          cSeek := cSeek
          Tone(500, 1)
       EndIf
    ElseIf nKey == VK_BACK
        If nSpace == 4 .or. nSpace == 7
           cTemp := Left( cSeek, nSpace - 3 )
           cTemp += " "
           cTemp += SubStr( cSeek, nSpace - 1, Len( cSeek ) )
        ElseIf nSpace == 0
           cTemp := Left( cSeek, Len( cSeek ) - 1 )
        ElseIf nSpace == 1
           cTemp := cSeek
        Else
            cTemp := Left( cSeek, nSpace - 2 )
            cTemp += " "
            cTemp += SubStr( cSeek, nSpace, Len( cSeek ) )
        EndIf
        cSeek := PadR( cTemp, 10 )
    Else
       Tone( 500, 1 )
    EndIf

Return cSeek

* ============================================================================
* METHOD TSBrowse:SetSelectMode() Version 7.0 Jul/15/2004
* ============================================================================

METHOD SetSelectMode( lOnOff, bSelected, uBmpSel, nColSel, nAlign ) CLASS TSBrowse

   Default lOnOff  := .T., ;
           nColSel := 1, ;
           nAlign  := DT_RIGHT

   ::lCanSelect := lOnOff
   ::bSelected  := bSelected
   ::aSelected  := {}

   If ::lCanSelect .and. ;
      ( uBmpSel == Nil .or. Empty( nColSel ) .or. nColSel > Len( ::aColumns ) )
      Return Self
   EndIf

   If ::lCanSelect .and. uBmpSel != Nil

      If ValType( uBmpSel ) != "C"
         ::uBmpSel  := uBmpSel
      Else
         ::uBmpSel := LoadImage (uBmpSel)
      EndIf

      ::nColSel  := nColSel
      ::nAligBmp := nAlign

   ElseIf ::uBmpSel != Nil
      ::lDestroy := .F.
      ::uBmpSel  := Nil
      ::nCoSel   := 0
      ::nAligBmp := 0

   EndIf

Return Self

* ============================================================================
* FUNCTION TSBrowse EmptyAlias() Version 7.0 Jul/15/2004
* Returns .T. if cAlias is not a constant "ARRAY" (browsing an array),
* or a constant "TEXT_" (browsing a text file), or an active database alias.
* ============================================================================

Static Function EmptyAlias( cAlias )

   Local bErrorBlock, ;
         lEmpty := .T.

   If ! Empty( cAlias )

      If cAlias == "ARRAY" .or. "TEXT_" $ cAlias
         lEmpty:= .F.
      Else
         bErrorBlock:= ErrorBlock( {|| Break( Nil ) } )
         BEGIN SEQUENCE
            If (cAlias)->( Used() )
               lEmpty:= .F.
            EndIf
         END SEQUENCE
         ErrorBlock( bErrorBlock )
      EndIf

    EndIf

Return lEmpty

* ============================================================================
* FUNCTION TSBrowse FieldSetGetBlock() Version 7.0 Jul/15/2004
* Called from METHOD LoadFields() to assign data to columns
* ============================================================================

Static Function FieldSetGetBlock( cAlias, n )

Return { | u | If( PCount() == 0,;
                 ( cAlias )->( FieldGet( n ) ),;
                 ( cAlias )->( FieldPut( n, u ) ) ) }

* ============================================================================
* FUNCTION TSBrowse GenData() Version 7.0 Jul/15/2004
* ============================================================================

Static Function GenData( aArray, nPos )

   Local b1, b2, cPart1, cPart2, aData, nAt, ;
         cData := aArray[ nPos ]:cData, ;
         cType := ValType( Eval( aArray[ nPos ]:bData ) )

   cData := If( cData != Nil, ;
                AllTrim( Upper( StrTran( aArray[ nPos ]:cData, " " ) ) ), ;
                "" )

   If cType == "U"

      aData := { {||""} }

   ElseIf cType == "C" .and. ;
          ( nAt := At( "+CHR(13)+CHR(10)", cData ) ) > 0 .and. ;
          At( "{", cData ) == 0

      cPart1 := SubStr( cData, 1, nAt - 1 )
      cPart2 := SubStr( cData, nAt + 17 )

      b1 := &( '{||' + cPart1 + '}' )
      b2 := &( '{||' + cPart2 + '}' )
      aData := { b1, b2 }

   Else
      aData := { aArray[ nPos ]:bData }
   EndIf

Return aData

* ============================================================================
* FUNCTION TSBrowse GenFoot() Version 7.0 Jul/15/2004
* ============================================================================

Static Function GenFoot( aArray, nPos )

Return {|| aArray[nPos]:cFooting }

* ============================================================================
* FUNCTION TSBrowse GenHead() Version 7.0 Jul/15/2004
* ============================================================================

Static Function GenHead( aArray, nPos )

   Local cPart1, cPart2, aHead, b1, b2, ;
         cHead := aArray[ nPos ]:cHeading, ;
         nAt := At( CRLF, aArray[ nPos ]:cHeading )

   If ValType( cHead ) == "B"
      cHead := Eval( cHead )
   EndIf

   cPart1 := If( nAt > 0, SubStr( cHead, 1, nAt - 1 ), "" )
   cPart2 := If( nAt > 0, SubStr( cHead, nAt + 2 ), "" )

   If ! Empty( cPart2 )
      b1 := &('{||"' + cPart1 + '"}' )
      b2 := &('{||"' + cPart2 + '"}' )
      aHead := { b1, b2 }
   Else
      b1 := &( '{||"' + AllTrim( cHead ) + '"}' )
      aHead := { b1 }
   EndIf

Return aHead

* ============================================================================
* FUNCTION TSBrowse GetUniqueName( cName ) Version 7.0 Jul/15/2004
* ============================================================================

Static Function GetUniqueName( cName )

Return ( "TSB_" + cName + Ltrim( Str( _GetId() ) ) )

* ============================================================================
* FUNCTION TSBrowse IsChar() Version 7.0 Jul/15/2004
* Used by METHOD KeyChar() to filter keys according to the field type
* Clipper's function IsAlpha() doesn't fit the purpose in some cases
* ============================================================================

Static Function _IsChar( nKey )

Return ( nKey >= 32 .and. nKey <= 255 )

* ============================================================================
* FUNCTION TSBrowse IsNumeric() Version 7.0 Jul/15/2004
* Function used by METHOD KeyChar() to filter keys according to the field type
* Clipper's function IsDigit() doesn't fit the purpose in some cases
* ============================================================================

STATIC FUNCTION _IsNumeric( nKey )

Return ( Chr( nKey ) $ ".+-0123456789" )

* ============================================================================
* FUNCTION TSBrowse MakeBlock() Version 7.0 Jul/15/2004
* Called from METHOD Default() to assign data to columns
* ============================================================================

Static Function MakeBlock( Self, nI )

   Local bBlock, cFld, nAt

   IF  ::lIsDbf
      cFld := ::aLine[ nI ]
      IF ( nAt := At( '>', cFld ) ) == 0
         IF FieldPos( cFld ) > 0
            bBlock := FieldWBlock( cFld, Select() )
         ELSE
            bBlock := {|| Eval(::bLine)[ nI ] }
         endif
      ELSE
         IF FieldPos( Right( cFld , Len(cFld) - nAt ) ) > 0
            bBlock := FieldWBlock( Right( cFld , Len(cFld) - nAt ), ;
                  Select( Left( cFld , nAt - 2 ) ) )
         ELSE
            bBlock := {|| Eval(::bLine)[ nI ] }
         endif

      ENDIF
   ELSE
      bBlock := {|| Eval(::bLine)[ nI ] }
   ENDIF

Return bBlock

* ============================================================================
* FUNCTION TSBrowse SetHeights() Version 7.0 Jul/15/2004
* ============================================================================

Static Function SetHeights( oBrw )

   Local nEle, nHeight, nHHeight, oColumn, nAt, cHeading, cRest, nOcurs, ;
         hFont, ;
         lDrawFooters := If( oBrw:lDrawFooters != Nil, oBrw:lDrawFooters, .F. )

   Default oBrw:nLineStyle := LINES_ALL

   If oBrw:lDrawHeaders

      nHHeight := oBrw:nHeightHead

      For nEle := 1 TO Len( oBrw:aColumns )

         oColumn := oBrw:aColumns[ nEle ]
         cHeading := If( Valtype( oColumn:cHeading ) == "B", ;
                          Eval( oColumn:cHeading ), oColumn:cHeading )
         hFont := If( oColumn:hFontHead != Nil, oColumn:hFontHead, ;
                      oBrw:hFont )
         hFont := If( ValType( hFont ) == "B", Eval( hFont, 0, nEle, oBrw ), hFont )

         If Valtype( cHeading ) == "C" .and. ;
            ( nAt := At( Chr( 13 ), cHeading ) ) > 0

            nOcurs := 1
            cRest := Substr( cHeading, nAt + 2 )

            While ( nAt := At( Chr( 13 ), cRest ) ) > 0
               nOcurs++
               cRest := Substr( cRest, nAt + 2 )
            EndDo

            nHeight := SBGetHeight( oBrw:hWnd, hFont, 0 )
            nHeight *= ( nOcurs + 1 )

            If ( nHeight + 1 ) > nHHeight
               nHHeight := nHeight + 1
            EndIf

         ElseIf Valtype( cHeading ) == "C" .and. ;
            LoWord( oBrw:aColumns[ nEle ]:nHAlign ) == DT_VERT

            nHeight := GetTextWidth( oBrw:hDC, cHeading, hFont )

            If nHeight > nHHeight
               nHHeight := nHeight
            EndIf

         EndIf

      Next

      oBrw:nHeightHead := nHHeight
   Else
      oBrw:nHeightHead := 0
   EndIf

   If oBrw:lFooting .and. lDrawFooters

      nHHeight := oBrw:nHeightFoot

      For nEle := 1 TO Len( oBrw:aColumns )

         oColumn := oBrw:aColumns[ nEle ]
         cHeading := If( Valtype( oColumn:cFooting ) == "B", ;
                         Eval( oColumn:cFooting ), oColumn:cFooting )
         hFont := If( oColumn:hFontFoot != Nil, oColumn:hFontFoot, ;
                  If( oBrw:hFont != Nil, oBrw:hFont, 0 ) )

         hFont := If( ValType( hFont ) == "B", Eval( hFont, 0, nEle, oBrw ), hFont )

         If Valtype( cHeading ) == "C" .and. ;
            ( nAt := At( Chr( 13 ), cHeading ) ) > 0

            nOcurs := 1
            cRest := Substr( cHeading, nAt + 2 )

            While ( nAt := At( Chr( 13 ), cRest ) ) > 0
               nOcurs++
               cRest := Substr( cRest, nAt + 2 )
            EndDo

            nHeight := SBGetHeight( oBrw:hWnd, hFont, 0 )
            nHeight *= ( nOcurs + 1 )

            If ( nHeight + 1 ) > nHHeight
               nHHeight := nHeight + 1
            EndIf

         EndIf

      Next

      oBrw:nHeightFoot := nHHeight
   Else
      oBrw:nHeightFoot := 0
   EndIf

   // Now for cells

   nHHeight := oBrw:nHeightCell

   For nEle := 1 TO Len( oBrw:aColumns )

      oColumn := oBrw:aColumns[ nEle ]
      cHeading := Eval( oColumn:bData )
      hFont := If( oColumn:hFont != Nil, oColumn:hFont, oBrw:hFont )
      hFont := If( ValType( hFont ) == "B", Eval( hFont, 1, nEle, oBrw ), hFont )

      If ( Valtype( cHeading ) == "C"  .and. ;
           At( Chr( 13 ), cHeading ) > 0 ) .or. ;
         ValType( cHeading ) == "M" .or. ;
         ( oColumn:cDataType != Nil .and. oColumn:cDataType == "M" )

         Default oBrw:nMemoHV := 2
         nHeight := SBGetHeight( oBrw:hWnd, hFont, 0 )
         nHeight *= oBrw:nMemoHV
         nHeight += If( oBrw:nLineStyle != 0 .and. ;
                        oBrw:nLineStyle != 2, 1, 0 )
      Else
         nHeight := SBGetHeight( oBrw:hWnd, hFont, 0 )
         nHeight += If( oBrw:nLineStyle != 0 .and. ;
                        oBrw:nLineStyle != 2, 1, 0 )
      EndIf

      nHHeight := Max( nHeight, nHHeight )

   Next

   oBrw:nHeightCell := nHHeight

Return Nil

* ============================================================================
* FUNCTION TSBrowse FileRename() Version 7.0 Jul/15/2004
* ============================================================================

Static Function FileRename( oBrw, cOldName, cNewName, lErase )

   Local nRet, lNew := File( cNewName )

   Default lErase := .T.

   If ! File( cOldName )
      MsgStop( oBrw:aMsg[ 29 ] + CRLF + AllTrim( cOldName ) + ;
               oBrw:aMsg[ 30 ], oBrw:aMsg[ 28 ] )
      Return -1
   EndIf

   If lErase .and. lNew

      If FErase(  cNewName  ) < 0
         MsgStop( oBrw:aMsg[ 11 ] + Space( 1 ) + AllTrim( cNewName ), ;
                  oBrw:aMsg[ 28 ] + Space( 1 ) + LTrim( Str( FError() ) ) )
         Return -1
      EndIf

   ElseIf ! lErase .and. lNew
      Return -1
   EndIf

   nRet := MoveFile( cOldName, cNewName )

   If File( cOldName ) .and. File( cNewName )
      FErase( cOldName  )
   EndIf

Return nRet

* ============================================================================
* FUNCTION TSBrowse IdentSuper() Version 7.0
* ============================================================================

Static Function IdentSuper( aHeaders )

   Local nI := 1, cSuper, cOldSuper := '', nFromCol := 1, nToCol
   Local aSuperHeaders := {}

   While nI <= Len( aHeaders )
      If Valtype( aHeaders[ nI ] ) == "C"  .and. At( '~', aHeaders[ nI ] ) > 0
         cSuper := SubStr(aHeaders[ nI ], At( '~', aHeaders[ nI ] )+1)
         aHeaders [nI] := SubStr( aHeaders[ nI ], 1, At( '~', aHeaders[ nI ] )-1 )
      Else
         cSuper := ''
      EndIf
      If !(cOldSuper == cSuper)
         nToCol := nI-1
         AAdd( aSuperHeaders, {cOldSuper, nFromCol, nToCol} )
         cOldSuper := cSuper
         nFromCol := nI
      ElseIf nI == Len( aHeaders )
         AAdd( aSuperHeaders, {cOldSuper, nFromCol, nI} )
      Endif
      nI++
   EndDo

Return aSuperHeaders
